﻿

function mapLibrary(n, p, v) {
    var index = n.indexOf('.');
    if (index == -1) {
        var r = p[n];
        if (!r) {
            r = v;
            p[n] = r;
        }
        return r;
    }
    var r = mapLibrary(n.substr(0, index), p, {});
    return mapLibrary(n.substr(index + 1), r, v);
};

function classCreator(name, basePrototype, classConstructor, classPrototype, classProperties, thisPrototype, thisProperties) {
    var baseClass = basePrototype ? basePrototype.constructor: null;
    var old = classConstructor || (function(){});
    var f = null;
    if (baseClass) {
        if (classProperties) {
            f = function () {
                baseClass.apply(this, arguments);
                this.__typeName = name;
                var cp = Atom.clone(classProperties);
                for (var k in cp) {
                    this["_" + k] = cp[k];
                }
                old.apply(this, arguments);
            };
        } else {
            f = function () {
                baseClass.apply(this, arguments);
                this.__typeName = name;
                old.apply(this, arguments);
            };
        }

        var bpt = baseClass.prototype;

        // extend
        for (var k in bpt) {
            if (classPrototype[k])
                continue;
            if (bpt.hasOwnProperty(k)) {
                classPrototype[k] = bpt[k];
            }
        }

    } else {
        if (classProperties) {
            f = function () {
                this.__typeName = name;
                var cp = Atom.clone(classProperties);
                for (var k in cp) {
                    this["_" + k] = cp[k];
                }
                old.apply(this, arguments);
            };
        } else {
            f = function () {
                this.__typeName = name;
                old.apply(this, arguments);
            };
        }
    }

    if (classProperties) {
        for (var k in classProperties) {
            if (!classPrototype["get_" + k]) {
                var fg = new Function("return this._" + k + ";");
                classPrototype["get_" + k] = fg;
            }
            if (!classPrototype["set_" + k]) {
                var fs = new Function("v","this._" + k + " = v;");
                classPrototype["set_" + k] = fs;
            }
        }
    }

    f.__typeName = name;

	if(baseClass){
		f.__baseType = baseClass;
	}

    f.prototype = classPrototype;
    f.prototype.constructor = f;
    if (!classPrototype.hasOwnProperty("toString")) {
        f.prototype.toString = function () {
            return name;
        };
    }

    mapLibrary(name, window, f);

    return f;
};

function classCreatorEx(objDef) {
    return classCreator(objDef.name, objDef.base, objDef.start, objDef.methods, objDef.properties);
}

// Global...
var WebAtoms = {};

(function(w){

	var WebAtoms = w;

	var window = this;
	var Templates = { jsonML: {} };

	window.Templates = Templates;
Templates.jsonML["WebAtoms.AtomAutoCompleteBox.template"] = 
[["span",
{ "style": "position: relative" }
,["input",
{ "atom-presenter": "inputBox", "atom-placeholder": "[$owner.placeholder]", "type": "text", "atom-value": "$[owner.displayLabel](keyup)" }
], ["div",
{ "atom-presenter": "itemsPresenter", "style": "position: absolute; z-index: 100;", "style-left": "[($owner.offsetLeft + 2) + 'px']", "style-top": "[($owner.offsetTop + 24) + 'px']", "style-display": "[$owner.isPopupOpen ? 'block' : 'none']" }
]]]
;
Templates.jsonML["WebAtoms.AtomCheckBoxList.itemTemplate"] = 
[["div",
{ "atom-template": "itemTemplate" }
,["input",
{ "type": "checkbox", "atom-checked": "$[scope.itemSelected]" }
], ["span",
{ "atom-text": "{$data[$owner.templateParent.labelPath]}" }
]]]
;
Templates.jsonML["WebAtoms.AtomDataPager.template"] = 
[
["button",
{ "class": "atom-pager-first-button", "atom-is-enabled": "[$owner.pages.length > 1 && $owner.currentPage]", "event-click": "{$owner.goFirstCommand}", "style": "float:left" }
,"\nFirst\n"], ["span",
{ "style": "text-align:left" }
,["button",
{ "class": "atom-pager-prev-button", "event-click": "{$owner.goPrevCommand}", "atom-is-enabled": "[$owner.currentPage]" }
,"\nPrev\n"], ["span",
{  }
,"Goto: Page"], ["select",
{ "atom-type": "AtomComboBox", "atom-items": "[$owner.atomParent.pages]", "atom-value": "$[owner.atomParent.currentPage]" }
], ["button",
{ "class": "atom-pager-next-button", "event-click": "{$owner.goNextCommand}", "atom-is-enabled": "[$owner.currentPage < $owner.pages.length -1 ]" }
,"\nNext\n"]], ["button",
{ "class": "atom-pager-last-button", "event-click": "{$owner.goLastCommand}", "atom-is-enabled": "[$owner.pages.length > 1 && $owner.currentPage < $owner.pages.length -1 ]", "style": "float:right" }
,"\nLast\n"]
]
;
Templates.jsonML["WebAtoms.AtomDateField.popupTemplate"] = 
[["div",
{ "class": "popup", "atom-class": "[$owner.isOpen ? 'popup-open' : 'popup-closed' ]" }
,["div",
{ "class": "atom-date-list-box-calendar", "atom-presenter": "calendarPresenter" }
,["select",
{ "atom-type": "AtomComboBox", "class": "atom-date-list-box-month", "atom-items": "{AtomDate.monthList}", "atom-value": "$[owner.templateParent.month]" }
], ["select",
{ "atom-type": "AtomNumberComboBox", "class": "atom-date-list-box-year", "atom-start-number": "[ $owner.templateParent.currentYear + $owner.templateParent.startYear]", "atom-end-number": "[ $owner.templateParent.currentYear + $owner.templateParent.endYear]", "atom-value": "$[owner.templateParent.year]" }
], ["div",
{ "class": "atom-date-list-box-days" }
,["span",
{ "class": "atom-date-list-box-weekend-header" }
,"S"], ["span",
{  }
,"M"], ["span",
{  }
,"T"], ["span",
{  }
,"W"], ["span",
{  }
,"T"], ["span",
{  }
,"F"], ["span",
{ "class": "atom-date-list-box-weekend-header" }
,"S"]], ["div",
{ "class": "atom-date-list-box-day-list", "atom-type": "AtomItemsControl", "atom-items": "[$owner.templateParent.items]", "atom-presenter": "itemsPresenter" }
,["div",
{ "event-click": "{ $owner.templateParent.templateParent.toggleDateCommand }", "atom-class": "[ ($owner.templateParent.templateParent).getItemClass($data,$owner.templateParent.templateParent.value) ]", "atom-template": "itemTemplate" }
,["span",
{ "atom-text": "[$data.label]" }
]]]]]]
;
Templates.jsonML["WebAtoms.AtomDateField.template"] = 
[["div",
{ "class": "date-label", "atom-class": "[$owner.isOpen ? 'date-label-open' : 'date-label-closed']", "atom-event-click": "[ { owner: { isOpen: ! $owner.isOpen } } ]", "atom-text": "[ $owner.selectedItem ? $owner.selectedItem.dateLabel : 'SELECT' ]" }
]]
;
Templates.jsonML["WebAtoms.AtomDateListBox.template"] = 
[["div",
{ "class": "atom-date-list-box" }
,["div",
{ "class": "atom-date-list-box-calendar" }
,["select",
{ "atom-type": "AtomComboBox", "class": "atom-date-list-box-month", "atom-items": "{AtomDate.monthList}", "atom-value": "$[owner.templateParent.month]" }
], ["select",
{ "atom-type": "AtomComboBox", "class": "atom-date-list-box-year", "atom-items": "[ Atom.range( $owner.value + $owner.templateParent.startYear, $owner.value + $owner.templateParent.endYear) ]", "atom-value": "$[owner.templateParent.year]" }
], ["div",
{ "class": "atom-date-list-box-days" }
,["span",
{ "class": "atom-date-list-box-weekend-header" }
,"S"], ["span",
{  }
,"M"], ["span",
{  }
,"T"], ["span",
{  }
,"W"], ["span",
{  }
,"T"], ["span",
{  }
,"F"], ["span",
{ "class": "atom-date-list-box-weekend-header" }
,"S"]], ["div",
{ "class": "atom-date-list-box-day-list", "atom-presenter": "itemsPresenter" }
,["div",
{ "event-click": "{ $owner.templateParent.toggleDateCommand }", "atom-data": "[$owner.templateParent.items[$scope.item_index]]", "atom-class": "[ ($owner.templateParent).getItemClass($data,$owner.templateParent.value) ]", "atom-template": "itemTemplate" }
,["span",
{ "atom-text": "[$data.label]" }
]]]], ["div",
{ "class": "atom-date-list-box-list", "atom-type": "AtomListBox", "atom-items": "[$owner.templateParent.selectedItems]", "atom-label-path": "dateLabel", "atom-value-path": "date", "atom-value": "$[$owner.templateParent.visibleDate]" }
,["div",
{ "atom-template": "itemTemplate", "atom-text": "{$data.dateLabel}" }
]]]]
;
Templates.jsonML["WebAtoms.AtomFileUploader.template"] = 
[["div",
{ "atom-dock": "Fill", "atom-type": "AtomViewStack", "atom-selected-index": "[$owner.atomParent.displayMode]", "atom-presenter": "viewStack" }
,["div",
{  }
,["input",
{ "atom-presenter": "filePresenter", "type": "file", "value": "Browse", "style": "position: absolute; width: 100%; height: 25px" }
]], ["div",
{ "atom-presenter": "flashPresenter", "style": "min-height: 25px", "atom-type": "AtomViewBox" }
], ["div",
{ "style": "color: #000" }
,["span",
{ "atom-text": "[' Uploading (' + $owner.atomParent.progress + '%)']" }
]], ["div",
{ "style": "color: red" }
,"\nError\n"], ["div",
{  }
,"\nConverting\n"]]]
;
Templates.jsonML["WebAtoms.AtomItemsControl.itemTemplate"] = 
[["span",
{ "atom-text": "[$data[$owner.atomParent.labelPath]]" }
,"Item"]]
;
Templates.jsonML["WebAtoms.AtomLinkBar.itemTemplate"] = 
[["a",
{ "atom-href": "{$data[$owner.atomParent.valuePath]}", "atom-target": "{$data[$owner.atomParent.targetPath]}", "atom-class": "{$data[$owner.templateParent.itemsPath] ? (($data[$owner.templateParent.itemsPath]).length ? 'atom-link-bar-down-image' : '' ) : '' }" }
,["span",
{ "atom-text": "{$data[$owner.atomParent.labelPath]}" }
]]]
;
Templates.jsonML["WebAtoms.AtomLinkBar.menuTemplate"] = 
[["div",
{ "class": "menu", "atom-type": "AtomLinkBar", "atom-items": "[$data[$owner.templateParent.itemsPath]]", "atom-menu-template": "{$owner.templateParent.menuTemplate}", "atom-menu-direction": "vertical" }
,["div",
{ "atom-presenter": "itemsPresenter" }
,["div",
{ "atom-template": "itemTemplate" }
,["a",
{ "atom-href": "{$data[$owner.templateParent.valuePath]}", "atom-text": "{$data[$owner.templateParent.labelPath]}", "atom-target": "{$data.target}", "atom-event-click": "{$data.action}" }
]]]]]
;
Templates.jsonML["WebAtoms.AtomNavigatorList.detailTemplate"] = 
[["iframe",
{ "class": "atom-navigator-list-iframe", "atom-template": "detailTemplate", "atom-src": "[$owner.templateParent.displayMode == 1 ?( $owner.templateParent.displayMode == 2 ? $owner.templateParent.newUrl : $owner.templateParent.detailUrl ): 'about:none']" }
]]
;
Templates.jsonML["WebAtoms.AtomNavigatorList.template"] = 
[["div",
{ "atom-type": "AtomViewStack", "atom-selected-index": "[$owner.atomParent.displayMode]" }
,["div",
{ "atom-type": "AtomDockPanel", "atom-presenter": "gridPanel" }
,["div",
{ "atom-dock": "Fill", "atom-presenter": "gridPresenter", "class": "atom-navigator-list-grid" }
]], ["div",
{ "atom-data": "[$owner.templateParent.selectedItem]", "atom-presenter": "detailView", "atom-type": "AtomDockPanel" }
,["div",
{ "atom-dock": "Top", "atom-presenter": "detailHeaderToolbar" }
,["input",
{ "type": "button", "event-click": "[$owner.templateParent.backCommand]", "value": "Back", "style": "float: left" }
], ["span",
{ "atom-presenter": "detailHeaderPresenter" }
]], ["div",
{ "atom-dock": "Fill", "atom-type": "AtomViewBox", "atom-presenter": "detailPresenter" }
]], ["div",
{ "atom-data": "[$owner.templateParent.newItemCopy]", "atom-presenter": "newView", "atom-type": "AtomDockPanel" }
,["div",
{ "atom-dock": "Top", "atom-presenter": "newHeaderToolbar" }
,["input",
{ "type": "button", "event-click": "[$owner.templateParent.cancelAddCommand]", "value": "Back", "style": "float: left" }
], ["span",
{ "atom-presenter": "newHeaderPresenter" }
]], ["div",
{ "atom-dock": "Fill", "atom-type": "AtomViewBox", "atom-presenter": "newPresenter" }
]]]]
;
Templates.jsonML["WebAtoms.AtomSortableColumn.template"] = 
[["span",
{ "atom-text": "[$owner.label]" }
]]
;
Templates.jsonML["WebAtoms.AtomTabControl.template"] = 
[["div",
{ "atom-type": "AtomDockPanel" }
,["span",
{ "atom-dock": "Top", "atom-type": "AtomToggleButtonBar", "atom-label-path": "[$owner.templateParent.labelPath]", "atom-items": "[$owner.templateParent.items]", "atom-selected-index": "$[owner.templateParent.selectedIndex]", "style": "height: 30px; text-align:center; display:inline-block" }
,["span",
{ "atom-template": "itemTemplate", "atom-text": "[$data]" }
]], ["div",
{ "atom-dock": "Fill", "atom-type": "AtomViewStack", "atom-selected-index": "[$owner.templateParent.selectedIndex]", "atom-presenter": "itemsPresenter" }
]]]
;
Templates.jsonML["WebAtoms.AtomToggleButtonBar.template"] = 
[["span",
{ "class": "items-presenter", "atom-presenter": "itemsPresenter" }
]]
;
Templates.jsonML["WebAtoms.AtomWizard.template"] = 
[
["div",
{ "atom-dock": "Fill", "atom-type": "AtomViewStack", "atom-selected-index": "$[owner.templateParent.currentStep]", "atom-presenter": "viewPresenter" }
], ["div",
{ "atom-dock": "Bottom", "class": "atom-wizard-command-bar" }
,["button",
{ "class": "atom-wizard-back-button", "atom-is-enabled": "[$owner.canMoveBack]", "atom-event-click": "{$owner.goPrevCommand}", "style-visibility": "[$owner.currentStep ? 'visible' : 'hidden']" }
,["span",
{ "atom-text": "[$owner.prevLabel]" }
]], ["button",
{ "atom-class": "[($owner.isLastStep ? 'atom-wizard-finish-button' : 'atom-wizard-next-button')]", "atom-event-click": "{$owner.nextCommand}", "atom-is-enabled": "[$owner.nextCommand]" }
,["span",
{ "atom-text": "[$owner.isLastStep ? $owner.finishLabel : $owner.nextLabel]" }
]]]
]
;
Templates.jsonML["WebAtoms.AtomYesNoCustom.template"] = 
[
["span",
{ "atom-type": "AtomYesNoControl", "atom-presenter": "yesNo", "atom-value": "$[owner.templateParent.hasValue]" }
], ["input",
{ "style": "vertical-align:top", "type": "text", "atom-is-enabled": "[$owner.hasValue]", "atom-presenter": "input", "atom-placeholder": "[$owner.placeholder]" }
]
]
;
Templates.jsonML["WebAtoms.AtomApplication.busyTemplate"] = 
[["div",
{ "style": "position:absolute;left:0px;top:0px;z-index:10000; visibility:hidden", "style-width": "[$owner.appWidth + 'px']", "style-height": "[$owner.appHeight + 'px']", "style-visibility": "[$owner.isBusy ? 'inherit' : 'hidden']" }
,["div",
{ "class": "atom-busy-window", "style": "position:absolute", "style-left": "[(($owner.appWidth/2)-100) + 'px']", "style-top": "[(($owner.appHeight/2)-25) + 'px']" }
,["div",
{ "atom-abs-pos": "12,12,36,36", "class": "atom-busy-image" }
], ["div",
{ "atom-abs-pos": "56,24,145,null", "atom-text": "[$owner.busyMessage || 'Loading...']" }
], ["div",
{ "atom-abs-pos": "0,48", "style": "height:3px; background-color:green", "style-display": "[$owner.isBusy && $owner.progress ? 'block' : 'none']", "style-width": "[$owner.progress + '%']" }
]]]]
;
Templates.jsonML["WebAtoms.AtomFormGridLayout.fieldTemplate"] = 
[["table",
{ "class": "atom-form-grid-row", "atom-type": "AtomFormField", "atom-class": "[$owner.fieldClass]", "style-display": "[$owner.fieldVisible ? '' : 'none']" }
,["tbody",
{  }
,["tr",
{  }
,["td",
{ "class": "atom-form-grid-label", "atom-text": "[$owner.label]", "style-min-width": "[$owner.atomParent.minLabelWidth ? ($owner.atomParent.minLabelWidth + 'px') : undefined]" }
], ["td",
{ "class": "atom-form-grid-required", "atom-class": "[$owner.required ? 'atom-form-grid-required' : 'atom-form-grid-not-required']" }
,"*"], ["td",
{ "class": "atom-form-grid-content", "atom-class": "[$owner.error ? 'atom-data-error' : '']", "atom-presenter": "contentPresenter" }
], ["td",
{ "atom-class": "[$owner.error ? 'atom-data-error' : '']", "atom-text": "[$owner.error || '']", "style-display": "[$owner.error ? '' : 'none']" }
]]]]]
;
Templates.jsonML["WebAtoms.AtomFormLayout.fieldTemplate"] = 
[["tr",
{ "atom-type": "AtomFormField", "atom-class": "[$owner.fieldClass]", "style-display": "[$owner.fieldVisible ? '' : 'none']" }
,["td",
{ "class": "atom-form-label", "atom-text": "[$owner.label]", "style-min-width": "[$owner.atomParent.minLabelWidth || undefined]" }
], ["td",
{ "class": "atom-form-required", "atom-text": "[$owner.required ? '*' : '']" }
], ["td",
{ "class": "atom-form-content", "atom-class": "[$owner.error ? 'atom-data-error' : '']", "atom-presenter": "contentPresenter" }
,["span",
{ "class": "atom-form-error", "atom-text": "[$owner.error || '']" }
]]]]
;
Templates.jsonML["WebAtoms.AtomFormVerticalLayout.fieldTemplate"] = 
[["tr",
{ "atom-type": "AtomFormField" }
,["td",
{  }
,["div",
{  }
,["span",
{ "class": "atom-form-label", "atom-text": "[$owner.label]" }
], ["span",
{ "class": "atom-form-required", "atom-text": "[$owner.required ? '*' : '']" }
]], ["div",
{ "class": "atom-form-content", "atom-class": "[$owner.error ? 'atom-data-error' : '']", "atom-presenter": "contentPresenter" }
], ["div",
{ "class": "atom-form-error", "atom-text": "[$owner.error || '']" }
]]]]
;
Templates.jsonML["WebAtoms.AtomPhotoPlayer.template"] = 
[
["img",
{ "atom-presenter": "img", "style": "max-width:100%;max-height:100%; text-align:center; vertical-align:middle" }
], ["img",
{ "atom-presenter": "loading", "style": "position:absolute;visibility:hidden;", "style-left": "[(($owner.width/2)-32) + 'px']", "style-top": "[(($owner.height/2)-32) + 'px']" }
]
]
;
Templates.jsonML["WebAtoms.AtomWindow.frameTemplate"] = 
[["div",
{ "style": "position:absolute;left:0px;top:0px;", "style-width": "[$appScope.owner.appWidth + 'px']", "style-height": "[$appScope.owner.appHeight + 'px']", "style-display": "[$owner.isOpen ? 'block' : 'none']" }
,["div",
{ "class": "atom-window", "atom-presenter": "windowDiv", "style": "position:absolute", "style-width": "[$owner.atomParent.windowWidth + 'px']", "style-height": "[$owner.atomParent.windowHeight + 'px']", "style-left": "[(($appScope.owner.bodyWidth-$owner.atomParent.windowWidth)/2) + 'px']", "style-top": "[(($appScope.owner.bodyHeight-$owner.atomParent.windowHeight)/2) + 'px']", "atom-type": "AtomDockPanel" }
,["div",
{ "class": "atom-window-title", "atom-dock": "Top", "atom-presenter": "windowTitleDiv", "atom-text": "[$owner.atomParent.title]" }
], ["div",
{ "class": "atom-window-close-button", "atom-presenter": "windowCloseButton", "atom-event-click": "{$owner.atomParent.closeCommand}" }
]]]]
;
Templates.jsonML["WebAtoms.AtomWindow.windowTemplate"] = 
[["iframe",
{ "class": "atom-window-frame", "atom-presenter": "iframe", "atom-src": "{$owner.templateParent.url}" }
]]
;

		/*Line 0 - 'AtomBrowser.js' */var AtomConfig = {
/*Line 1 - 'AtomBrowser.js' */    debug: false,
/*Line 2 - 'AtomBrowser.js' */    baseUrl: "",
/*Line 3 - 'AtomBrowser.js' */    log: "",
/*Line 4 - 'AtomBrowser.js' */    ajax: {
/*Line 5 - 'AtomBrowser.js' */        versionUrl: true,
/*Line 6 - 'AtomBrowser.js' */        versionKey: "__wav",
/*Line 7 - 'AtomBrowser.js' */        version: ((new Date()).toDateString()),
/*Line 8 - 'AtomBrowser.js' */        headers: {
/*Line 9 - 'AtomBrowser.js' */        }
/*Line 10 - 'AtomBrowser.js' */    }
/*Line 11 - 'AtomBrowser.js' */};

/*Line 13 - 'AtomBrowser.js' */window.AtomConfig = AtomConfig;


/*Line 16 - 'AtomBrowser.js' */var log = function log(s) {

/*Line 18 - 'AtomBrowser.js' */    if (window.console) {
/*Line 19 - 'AtomBrowser.js' */        console.log(s);
/*Line 20 - 'AtomBrowser.js' */    }

/*Line 22 - 'AtomBrowser.js' */    AtomConfig.log += s + "\r\n";

/*Line 24 - 'AtomBrowser.js' */}

/*Line 26 - 'AtomBrowser.js' */window.log = log;

/*Line 28 - 'AtomBrowser.js' */var AtomBrowser = {
/*Line 29 - 'AtomBrowser.js' */    browserName: "",
/*Line 30 - 'AtomBrowser.js' */    version: "1.0",
/*Line 31 - 'AtomBrowser.js' */    majorVersion: 1,
/*Line 32 - 'AtomBrowser.js' */    isMobile: false,
/*Line 33 - 'AtomBrowser.js' */    userAgent:'',
/*Line 34 - 'AtomBrowser.js' */    detect: function () {
/*Line 35 - 'AtomBrowser.js' */        var nVer = navigator.appVersion;
/*Line 36 - 'AtomBrowser.js' */        var nAgt = navigator.userAgent;
/*Line 37 - 'AtomBrowser.js' */        this.userAgent = nAgt;
/*Line 38 - 'AtomBrowser.js' */        var browserName = navigator.appName;
/*Line 39 - 'AtomBrowser.js' */        var fullVersion = "" + parseFloat(navigator.appVersion);
/*Line 40 - 'AtomBrowser.js' */        var majorVersion = parseInt(navigator.appVersion, 10);
/*Line 41 - 'AtomBrowser.js' */        var nameOffset, verOffset, ix;

/*Line 43 - 'AtomBrowser.js' */        // In Opera, the true version is after "Opera" or after "Version"
/*Line 44 - 'AtomBrowser.js' */        if ((verOffset = nAgt.indexOf("Opera")) != -1) {
/*Line 45 - 'AtomBrowser.js' */            browserName = "Opera";
/*Line 46 - 'AtomBrowser.js' */            fullVersion = nAgt.substring(verOffset + 6);
/*Line 47 - 'AtomBrowser.js' */            if ((verOffset = nAgt.indexOf("Version")) != -1) {
/*Line 48 - 'AtomBrowser.js' */                fullVersion = nAgt.substring(verOffset + 8);
/*Line 49 - 'AtomBrowser.js' */            }
/*Line 50 - 'AtomBrowser.js' */        }
/*Line 51 - 'AtomBrowser.js' */            // In MSIE, the true version is after "MSIE" in userAgent
/*Line 52 - 'AtomBrowser.js' */        else if ((verOffset = nAgt.indexOf("MSIE")) != -1) {
/*Line 53 - 'AtomBrowser.js' */            browserName = "Microsoft Internet Explorer";
/*Line 54 - 'AtomBrowser.js' */            fullVersion = nAgt.substring(verOffset + 5);
/*Line 55 - 'AtomBrowser.js' */        }
/*Line 56 - 'AtomBrowser.js' */                // In Chrome, the true version is after "Chrome"
/*Line 57 - 'AtomBrowser.js' */        else if ((verOffset = nAgt.indexOf("Chrome")) != -1) {
/*Line 58 - 'AtomBrowser.js' */            browserName = "Chrome";
/*Line 59 - 'AtomBrowser.js' */            fullVersion = nAgt.substring(verOffset + 7);
/*Line 60 - 'AtomBrowser.js' */        }
/*Line 61 - 'AtomBrowser.js' */                // In Safari, the true version is after "Safari" or after "Version"
/*Line 62 - 'AtomBrowser.js' */        else if ((verOffset = nAgt.indexOf("Safari")) != -1) {
/*Line 63 - 'AtomBrowser.js' */            browserName = "Safari";
/*Line 64 - 'AtomBrowser.js' */            this.isMobile = nAgt.indexOf("iPhone") != -1;
/*Line 65 - 'AtomBrowser.js' */            fullVersion = nAgt.substring(verOffset + 7);
/*Line 66 - 'AtomBrowser.js' */            if ((verOffset = nAgt.indexOf("Version")) != -1) {
/*Line 67 - 'AtomBrowser.js' */                fullVersion = nAgt.substring(verOffset + 8);
/*Line 68 - 'AtomBrowser.js' */            }
/*Line 69 - 'AtomBrowser.js' */        }
/*Line 70 - 'AtomBrowser.js' */                // In Firefox, the true version is after "Firefox"
/*Line 71 - 'AtomBrowser.js' */        else if ((verOffset = nAgt.indexOf("Firefox")) != -1) {
/*Line 72 - 'AtomBrowser.js' */            browserName = "Firefox";
/*Line 73 - 'AtomBrowser.js' */            fullVersion = nAgt.substring(verOffset + 8);
/*Line 74 - 'AtomBrowser.js' */        }
/*Line 75 - 'AtomBrowser.js' */                // In most other browsers, "name/version" is at the end of userAgent
/*Line 76 - 'AtomBrowser.js' */        else if ((nameOffset = nAgt.lastIndexOf(' ') + 1) <
/*Line 77 - 'AtomBrowser.js' */              (verOffset = nAgt.lastIndexOf('/'))) {
/*Line 78 - 'AtomBrowser.js' */                  browserName = nAgt.substring(nameOffset, verOffset);
/*Line 79 - 'AtomBrowser.js' */                  fullVersion = nAgt.substring(verOffset + 1);
/*Line 80 - 'AtomBrowser.js' */                  if (browserName.toLowerCase() == browserName.toUpperCase()) {
/*Line 81 - 'AtomBrowser.js' */                      browserName = navigator.appName;
/*Line 82 - 'AtomBrowser.js' */                  }
/*Line 83 - 'AtomBrowser.js' */              }
/*Line 84 - 'AtomBrowser.js' */        // trim the fullVersion string at semicolon/space if present
/*Line 85 - 'AtomBrowser.js' */        if ((ix = fullVersion.indexOf(";")) != -1) {
/*Line 86 - 'AtomBrowser.js' */            fullVersion = fullVersion.substring(0, ix);
/*Line 87 - 'AtomBrowser.js' */        }
/*Line 88 - 'AtomBrowser.js' */        if ((ix = fullVersion.indexOf(" ")) != -1) {
/*Line 89 - 'AtomBrowser.js' */            fullVersion = fullVersion.substring(0, ix);
/*Line 90 - 'AtomBrowser.js' */        }

/*Line 92 - 'AtomBrowser.js' */        majorVersion = parseInt('' + fullVersion, 10);
/*Line 93 - 'AtomBrowser.js' */        if (isNaN(majorVersion)) {
/*Line 94 - 'AtomBrowser.js' */            fullVersion = '' + parseFloat(navigator.appVersion);
/*Line 95 - 'AtomBrowser.js' */            majorVersion = parseInt(navigator.appVersion, 10);
/*Line 96 - 'AtomBrowser.js' */        }

/*Line 98 - 'AtomBrowser.js' */        this.browserName = browserName;
/*Line 99 - 'AtomBrowser.js' */        this.majorVersion = majorVersion;
/*Line 100 - 'AtomBrowser.js' */    },

/*Line 102 - 'AtomBrowser.js' */    isFF: false,
/*Line 103 - 'AtomBrowser.js' */    isChrome: false,
/*Line 104 - 'AtomBrowser.js' */    isIE: false,
/*Line 105 - 'AtomBrowser.js' */    isSafari: false,
/*Line 106 - 'AtomBrowser.js' */    isMac : false,

/*Line 108 - 'AtomBrowser.js' */    initialize: function () {

/*Line 110 - 'AtomBrowser.js' */        this.isMac = /mac os x/gi.test(this.userAgent) && !(/iphone|ipad/gi.test(this.userAgent));

/*Line 112 - 'AtomBrowser.js' */        switch (this.browserName) {
/*Line 113 - 'AtomBrowser.js' */            case "Firefox":
/*Line 114 - 'AtomBrowser.js' */                this.supportsUpload = this.majorVersion >= 4;
/*Line 115 - 'AtomBrowser.js' */                this.isFF = true;
/*Line 116 - 'AtomBrowser.js' */                break;
/*Line 117 - 'AtomBrowser.js' */            case "Chrome":
/*Line 118 - 'AtomBrowser.js' */                this.supportsUpload = this.majorVersion >= 6;
/*Line 119 - 'AtomBrowser.js' */                this.isChrome = true;
/*Line 120 - 'AtomBrowser.js' */                break;
/*Line 121 - 'AtomBrowser.js' */            case "Microsoft Internet Explorer":
/*Line 122 - 'AtomBrowser.js' */                this.supportsUpload = this.majorVersion >= 10;
/*Line 123 - 'AtomBrowser.js' */                this.isIE = true;
/*Line 124 - 'AtomBrowser.js' */                break;
/*Line 125 - 'AtomBrowser.js' */            case "Safari":
/*Line 126 - 'AtomBrowser.js' */                this.isSafari = true;
/*Line 127 - 'AtomBrowser.js' */                if (!this.isMobile) {
/*Line 128 - 'AtomBrowser.js' */                    this.supportsUpload = this.majorVersion >= 5;
/*Line 129 - 'AtomBrowser.js' */                }
/*Line 130 - 'AtomBrowser.js' */                break;
/*Line 131 - 'AtomBrowser.js' */        }

/*Line 133 - 'AtomBrowser.js' */        // is it ios??
/*Line 134 - 'AtomBrowser.js' */        this.supportsFlash = !this.isMobile;
/*Line 135 - 'AtomBrowser.js' */    }

/*Line 137 - 'AtomBrowser.js' */};

/*Line 139 - 'AtomBrowser.js' */window.AtomBrowser = AtomBrowser;

/*Line 141 - 'AtomBrowser.js' */AtomBrowser.detect();
/*Line 142 - 'AtomBrowser.js' */AtomBrowser.initialize();
/*Line 0 - 'Atom.js' */
/*Line 1 - 'Atom.js' */
/*Line 2 - 'Atom.js' */
/*Line 3 - 'Atom.js' */
/*Line 4 - 'Atom.js' */


/*Line 7 - 'Atom.js' */// TypeScript Copied...
/*Line 8 - 'Atom.js' *///var __extends = this.__extends || function (d, b) {
/*Line 9 - 'Atom.js' *///    function __() { this.constructor = d; }
/*Line 10 - 'Atom.js' *///    __.prototype = b.prototype;
/*Line 11 - 'Atom.js' *///    d.prototype = new __();
/*Line 12 - 'Atom.js' *///};




/*Line 17 - 'Atom.js' *///if (!Function.prototype.registerClass) {

/*Line 19 - 'Atom.js' *///    Function.__typeName = 'Function';
/*Line 20 - 'Atom.js' *///    Function.__class = true;
/*Line 21 - 'Atom.js' *///    Function.createDelegate = function Function$createDelegate(instance, method) {
/*Line 22 - 'Atom.js' *///        return function () {
/*Line 23 - 'Atom.js' *///            return method.apply(instance, arguments);
/*Line 24 - 'Atom.js' *///        };
/*Line 25 - 'Atom.js' *///    };

/*Line 27 - 'Atom.js' *///    //window.Sys = {};

/*Line 29 - 'Atom.js' *///    //Sys.EventArgs = {};
/*Line 30 - 'Atom.js' *///    //Sys.EventArgs.Empty = {};

/*Line 32 - 'Atom.js' *///    window.zEvalProp = function (t, p) {
/*Line 33 - 'Atom.js' *///        var i = p.indexOf('.');
/*Line 34 - 'Atom.js' *///        if (i == -1)
/*Line 35 - 'Atom.js' *///            return t[p];
/*Line 36 - 'Atom.js' *///        var n = p.substr(0, i);
/*Line 37 - 'Atom.js' *///        p = p.substr(i + 1);
/*Line 38 - 'Atom.js' *///        return window.zEvalProp(t[n], p);
/*Line 39 - 'Atom.js' *///    };

/*Line 41 - 'Atom.js' *///    // This class registers a prototype along with base Type
/*Line 42 - 'Atom.js' *///    // This must be called in inheirtence order only
/*Line 43 - 'Atom.js' *///    Function.prototype.registerClass = function (name, baseType) {
/*Line 44 - 'Atom.js' *///        var pname = window.zEvalProp(window,name);
/*Line 45 - 'Atom.js' *///        if (pname !== this)
/*Line 46 - 'Atom.js' *///            throw new Error("Type " + name + " does not exist");
/*Line 47 - 'Atom.js' *///        this.__typeName = name;
/*Line 48 - 'Atom.js' *///        if (baseType) {
/*Line 49 - 'Atom.js' *///            this.__baseType = baseType;
/*Line 50 - 'Atom.js' *///            this.baseType = baseType.prototype;
/*Line 51 - 'Atom.js' *///            //this.prototype = baseType;
/*Line 52 - 'Atom.js' *///            this.prototype.constructor = this;
/*Line 53 - 'Atom.js' *///            for (var m in baseType.prototype) {
/*Line 54 - 'Atom.js' *///                if (this.prototype[m])
/*Line 55 - 'Atom.js' *///                    continue;
/*Line 56 - 'Atom.js' *///                this.prototype[m] =  baseType.prototype[m];
/*Line 57 - 'Atom.js' *///            }
/*Line 58 - 'Atom.js' *///        }
/*Line 59 - 'Atom.js' *///    };

/*Line 61 - 'Atom.js' *///    // Should be used in constructor to call base class constructor
/*Line 62 - 'Atom.js' *///    Function.prototype.initializeBase = function (instance, baseArguements) {
/*Line 63 - 'Atom.js' *///        if (baseArguements) {
/*Line 64 - 'Atom.js' *///            this.__baseType.apply(instance, baseArguements);
/*Line 65 - 'Atom.js' *///        }else {
/*Line 66 - 'Atom.js' *///            this.__baseType.apply(instance);
/*Line 67 - 'Atom.js' *///        }
/*Line 68 - 'Atom.js' *///    };

/*Line 70 - 'Atom.js' *///    Function.prototype.callBaseMethod = function (instance, name, baseArguements) {
/*Line 71 - 'Atom.js' *///        var baseType = this.__baseType;
/*Line 72 - 'Atom.js' *///        var method = baseType.prototype[name];
/*Line 73 - 'Atom.js' *///        if (method) {
/*Line 74 - 'Atom.js' *///            if (baseArguements) {
/*Line 75 - 'Atom.js' *///                return method.apply(instance, baseArguements);
/*Line 76 - 'Atom.js' *///            }else {
/*Line 77 - 'Atom.js' *///                return method.apply(instance);
/*Line 78 - 'Atom.js' *///            }
/*Line 79 - 'Atom.js' *///        }else {
/*Line 80 - 'Atom.js' *///            return baseType.callBaseMethod(instance, name, baseArguements);
/*Line 81 - 'Atom.js' *///        }
/*Line 82 - 'Atom.js' *///    };

/*Line 84 - 'Atom.js' *///    Function.prototype.isNamespace = function (name) {
/*Line 85 - 'Atom.js' *///        return window[name];
/*Line 86 - 'Atom.js' *///    };

/*Line 88 - 'Atom.js' *///    Function.prototype.registerNamespace = function (name) {
/*Line 89 - 'Atom.js' *///        var ns = name.split('.');
/*Line 90 - 'Atom.js' *///        var root = window;
/*Line 91 - 'Atom.js' *///        for (var i = 0; i < ns.length; i++) {
/*Line 92 - 'Atom.js' *///            var n = ns[i];
/*Line 93 - 'Atom.js' *///            var type = root[n];
/*Line 94 - 'Atom.js' *///            if (!type) {
/*Line 95 - 'Atom.js' *///                type = {};
/*Line 96 - 'Atom.js' *///                root[n] = type;
/*Line 97 - 'Atom.js' *///            }
/*Line 98 - 'Atom.js' *///            root = type;
/*Line 99 - 'Atom.js' *///        }
/*Line 100 - 'Atom.js' *///    };

/*Line 102 - 'Atom.js' *///    window.Type = Function;
/*Line 103 - 'Atom.js' *///}



/*Line 107 - 'Atom.js' */var AtomEnumerator = (function (name, base) {
/*Line 108 - 'Atom.js' */    return classCreator(name, base,
/*Line 109 - 'Atom.js' */    function (array) {
/*Line 110 - 'Atom.js' */        this._array = array;
/*Line 111 - 'Atom.js' */        this.i = -1;
/*Line 112 - 'Atom.js' */    },
/*Line 113 - 'Atom.js' */    {
/*Line 114 - 'Atom.js' */        next: function () {
/*Line 115 - 'Atom.js' */            this.i = this.i + 1;
/*Line 116 - 'Atom.js' */            return this.i < this._array.length;
/*Line 117 - 'Atom.js' */        },
/*Line 118 - 'Atom.js' */        current: function () {
/*Line 119 - 'Atom.js' */            return this._array[this.i];
/*Line 120 - 'Atom.js' */        },
/*Line 121 - 'Atom.js' */        currentIndex: function () {
/*Line 122 - 'Atom.js' */            return this.i;
/*Line 123 - 'Atom.js' */        },
/*Line 124 - 'Atom.js' */        isFirst: function () {
/*Line 125 - 'Atom.js' */            return this.i == 0;
/*Line 126 - 'Atom.js' */        },
/*Line 127 - 'Atom.js' */        isLast: function () {
/*Line 128 - 'Atom.js' */            return this.i == this._array.length - 1;
/*Line 129 - 'Atom.js' */        },
/*Line 130 - 'Atom.js' */        reset: function () {
/*Line 131 - 'Atom.js' */            this.i = -1;
/*Line 132 - 'Atom.js' */        }
/*Line 133 - 'Atom.js' */    });
/*Line 134 - 'Atom.js' */})("AtomEnumerator",null);
    

/*Line 137 - 'Atom.js' */var Atom = {

/*Line 139 - 'Atom.js' */    refreshWindowCommand: function () {
/*Line 140 - 'Atom.js' */        location.href = location.pathname + "?_v=" + (new Date()).getTime() + location.hash;
/*Line 141 - 'Atom.js' */    },

/*Line 143 - 'Atom.js' */    time: function () {
/*Line 144 - 'Atom.js' */        return (new Date()).getTime();
/*Line 145 - 'Atom.js' */    },

/*Line 147 - 'Atom.js' */    get: function (obj, path) {
/*Line 148 - 'Atom.js' */        var index = path.indexOf('.');
/*Line 149 - 'Atom.js' */        if (index != -1) {
/*Line 150 - 'Atom.js' */            var f = path.substr(0, index);
/*Line 151 - 'Atom.js' */            obj = AtomBinder.getValue(obj, f);
/*Line 152 - 'Atom.js' */            path = path.substr(index + 1);
/*Line 153 - 'Atom.js' */            return Atom.get(obj, path);
/*Line 154 - 'Atom.js' */        }
/*Line 155 - 'Atom.js' */        return AtomBinder.getValue(obj, path);
/*Line 156 - 'Atom.js' */    },

/*Line 158 - 'Atom.js' */    set: function (obj, path, val) {
/*Line 159 - 'Atom.js' */        var index = path.indexOf('.');
/*Line 160 - 'Atom.js' */        if (index != -1) {
/*Line 161 - 'Atom.js' */            var f = path.substr(0, index);
/*Line 162 - 'Atom.js' */            obj = AtomBinder.getValue(obj, f);
/*Line 163 - 'Atom.js' */            path = path.substr(index + 1);
/*Line 164 - 'Atom.js' */            return Atom.set(obj, path,val);
/*Line 165 - 'Atom.js' */        }
/*Line 166 - 'Atom.js' */        AtomBinder.setValue(obj, path, val);
/*Line 167 - 'Atom.js' */    },

/*Line 169 - 'Atom.js' */    csv: function (a, path, s) {
/*Line 170 - 'Atom.js' */        if (!s) {
/*Line 171 - 'Atom.js' */            s = ", ";
/*Line 172 - 'Atom.js' */        }
/*Line 173 - 'Atom.js' */        var l = [];
/*Line 174 - 'Atom.js' */        var ae = new AtomEnumerator(a);
/*Line 175 - 'Atom.js' */        while (ae.next()) {
/*Line 176 - 'Atom.js' */            var item = ae.current();
/*Line 177 - 'Atom.js' */            l.push(item[path]);
/*Line 178 - 'Atom.js' */        }
/*Line 179 - 'Atom.js' */        return l.join(s);
/*Line 180 - 'Atom.js' */    },

/*Line 182 - 'Atom.js' */    range: function (start, end, step) {
/*Line 183 - 'Atom.js' */        var a = [];
/*Line 184 - 'Atom.js' */        step = step || 1;
/*Line 185 - 'Atom.js' */        for (var i = start; i <= end; i+=step) {
/*Line 186 - 'Atom.js' */            a.push({ label: i, value: i });
/*Line 187 - 'Atom.js' */        }
/*Line 188 - 'Atom.js' */        return a;
/*Line 189 - 'Atom.js' */    },

/*Line 191 - 'Atom.js' */    merge: function (x, y, update) {
/*Line 192 - 'Atom.js' */        var c = AtomBinder.getClone(y);
/*Line 193 - 'Atom.js' */        if (update) {
/*Line 194 - 'Atom.js' */            for (var k in c) {
/*Line 195 - 'Atom.js' */                //x[k] = c[k];
/*Line 196 - 'Atom.js' */                AtomBinder.setValue(x, k, AtomBinder.getValue(c, k));
/*Line 197 - 'Atom.js' */            }
/*Line 198 - 'Atom.js' */        } else {
/*Line 199 - 'Atom.js' */            for (var k in c) {
/*Line 200 - 'Atom.js' */                x[k] = c[k];
/*Line 201 - 'Atom.js' */            }
/*Line 202 - 'Atom.js' */        }
/*Line 203 - 'Atom.js' */        return x;
/*Line 204 - 'Atom.js' */    },

/*Line 206 - 'Atom.js' */    url: function (url, q, lq) {
/*Line 207 - 'Atom.js' */        var finalUrl = url;
/*Line 208 - 'Atom.js' */        var plist = [];
/*Line 209 - 'Atom.js' */        if (q) {
/*Line 210 - 'Atom.js' */            for (var i in q) {
/*Line 211 - 'Atom.js' */                if (q.hasOwnProperty(i)) {
/*Line 212 - 'Atom.js' */                    var val = q[i];
/*Line 213 - 'Atom.js' */                    if (val === undefined)
/*Line 214 - 'Atom.js' */                        continue;
/*Line 215 - 'Atom.js' */                    if (val === null)
/*Line 216 - 'Atom.js' */                        continue;
/*Line 217 - 'Atom.js' */                    if (val && (val.constructor != String) && (typeof val) == 'object') {
/*Line 218 - 'Atom.js' */                        val = JSON.stringify(val);
/*Line 219 - 'Atom.js' */                    }
/*Line 220 - 'Atom.js' */                    plist.push(i + '=' + encodeURIComponent(val));
/*Line 221 - 'Atom.js' */                }
/*Line 222 - 'Atom.js' */            }

/*Line 224 - 'Atom.js' */            if (plist.length) {
/*Line 225 - 'Atom.js' */                var index = finalUrl.indexOf('?');
/*Line 226 - 'Atom.js' */                if (index == -1) {
/*Line 227 - 'Atom.js' */                    finalUrl += "?";
/*Line 228 - 'Atom.js' */                } else {
/*Line 229 - 'Atom.js' */                    finalUrl += '&';
/*Line 230 - 'Atom.js' */                }
/*Line 231 - 'Atom.js' */            }

/*Line 233 - 'Atom.js' */            finalUrl += plist.join('&');
/*Line 234 - 'Atom.js' */        }

/*Line 236 - 'Atom.js' */        if (lq) {
/*Line 237 - 'Atom.js' */            plist = [];
/*Line 238 - 'Atom.js' */            for (var i in lq) {
/*Line 239 - 'Atom.js' */                if (lq.hasOwnProperty(i)) {
/*Line 240 - 'Atom.js' */                    var val = lq[i];
/*Line 241 - 'Atom.js' */                    if (val === undefined || val === null)
/*Line 242 - 'Atom.js' */                        continue;
/*Line 243 - 'Atom.js' */                    plist.push(i + '=' + encodeURIComponent(val));
/*Line 244 - 'Atom.js' */                }
/*Line 245 - 'Atom.js' */            }
/*Line 246 - 'Atom.js' */            if (plist.length) {
/*Line 247 - 'Atom.js' */                finalUrl += '#' + plist.join("&");
/*Line 248 - 'Atom.js' */            }
/*Line 249 - 'Atom.js' */        }

/*Line 251 - 'Atom.js' */        return finalUrl;
/*Line 252 - 'Atom.js' */    },

/*Line 254 - 'Atom.js' */    encodeParameters: function (q) {
/*Line 255 - 'Atom.js' */        var plist = [];
/*Line 256 - 'Atom.js' */        for (var i in q) {
/*Line 257 - 'Atom.js' */            if (i.indexOf('_') == 0)
/*Line 258 - 'Atom.js' */                continue;
/*Line 259 - 'Atom.js' */            var val = q[i];
/*Line 260 - 'Atom.js' */            if (val === undefined)
/*Line 261 - 'Atom.js' */                continue;
/*Line 262 - 'Atom.js' */            if (val === null)
/*Line 263 - 'Atom.js' */                continue;
/*Line 264 - 'Atom.js' */            var t = typeof(val);
/*Line 265 - 'Atom.js' */            if (t != 'string' && t != 'number' && t != 'boolean') {
/*Line 266 - 'Atom.js' */                continue;
/*Line 267 - 'Atom.js' */            }
/*Line 268 - 'Atom.js' */            plist.push(i + '=' + encodeURIComponent(val));
/*Line 269 - 'Atom.js' */        }
/*Line 270 - 'Atom.js' */        return plist.join('&');
/*Line 271 - 'Atom.js' */    },

/*Line 273 - 'Atom.js' */    tableLayout: function (columns, cellWidth, cellHeight) {
/*Line 274 - 'Atom.js' */        return new WebAtoms.AtomTableLayout(columns, cellWidth, cellHeight);
/*Line 275 - 'Atom.js' */    },

/*Line 277 - 'Atom.js' */    toDash: function(text){
/*Line 278 - 'Atom.js' */        return text.replace(/([A-Z])/g, function($1){return "-"+$1.toLowerCase();});
/*Line 279 - 'Atom.js' */    },

/*Line 281 - 'Atom.js' */    secureUrl: function () {
/*Line 282 - 'Atom.js' */        var u = "";
/*Line 283 - 'Atom.js' */        for (var i = 0; i < arguments.length; i++) {
/*Line 284 - 'Atom.js' */            var ui = arguments[i];
/*Line 285 - 'Atom.js' */            if (ui === null || ui === undefined) {
/*Line 286 - 'Atom.js' */                return undefined;
/*Line 287 - 'Atom.js' */            }
/*Line 288 - 'Atom.js' */            u += ui;
/*Line 289 - 'Atom.js' */        }
/*Line 290 - 'Atom.js' */        if ('https:' == document.location.protocol) {
/*Line 291 - 'Atom.js' */            u = u.replace(/http\:\/\//, "https://");
/*Line 292 - 'Atom.js' */        }
/*Line 293 - 'Atom.js' */        return u;
/*Line 294 - 'Atom.js' */    }
/*Line 295 - 'Atom.js' */};

/*Line 297 - 'Atom.js' */window.Atom = Atom;

/*Line 299 - 'Atom.js' */(function () {
/*Line 300 - 'Atom.js' */    var e,
/*Line 301 - 'Atom.js' */        a = /\+/g,  
/*Line 302 - 'Atom.js' */        r = /([^&=]+)=?([^&]*)/g,
/*Line 303 - 'Atom.js' */        d = function (s) { return decodeURIComponent(s.replace(a, " ")); },
/*Line 304 - 'Atom.js' */        q = window.location.search.substring(1);

/*Line 306 - 'Atom.js' */    var urlParams = {};
/*Line 307 - 'Atom.js' */    while (e = r.exec(q))
/*Line 308 - 'Atom.js' */        urlParams[d(e[1])] = d(e[2]);
/*Line 309 - 'Atom.js' */    Atom.pageQuery = urlParams;
/*Line 310 - 'Atom.js' */})();

/*Line 312 - 'Atom.js' */var AtomDate = {

/*Line 314 - 'Atom.js' */    zoneOffset: (new Date()).getTimezoneOffset() * 60 * 1000,

/*Line 316 - 'Atom.js' */    toLocalTime: function (d) {
/*Line 317 - 'Atom.js' */        return (new Date(d.getTime() - AtomDate.zoneOffset)).toJSON();
/*Line 318 - 'Atom.js' */    },

/*Line 320 - 'Atom.js' */    m_names: new Array("Jan", "Feb", "Mar", 
/*Line 321 - 'Atom.js' */"Apr", "May", "Jun", "Jul", "Aug", "Sep", 
/*Line 322 - 'Atom.js' */"Oct", "Nov", "Dec"),

/*Line 324 - 'Atom.js' */    toMMDDYY: function (dt) {
/*Line 325 - 'Atom.js' */        var m = dt.getMonth() + 1;
/*Line 326 - 'Atom.js' */        var y = dt.getFullYear();
/*Line 327 - 'Atom.js' */        var d = dt.getDate();

/*Line 329 - 'Atom.js' */        var str = "";
/*Line 330 - 'Atom.js' */        str +=  ((m > 9) ? m : ("0" + m));
/*Line 331 - 'Atom.js' */        str += "/" + ((d > 9) ? d : ("0" + d));
/*Line 332 - 'Atom.js' */        str += "/" + y;
/*Line 333 - 'Atom.js' */        return str;
/*Line 334 - 'Atom.js' */    },

/*Line 336 - 'Atom.js' */    toShortDateString: function (val) {
/*Line 337 - 'Atom.js' */        if (!val)
/*Line 338 - 'Atom.js' */            return "";
/*Line 339 - 'Atom.js' */        if (val.constructor == String) {
/*Line 340 - 'Atom.js' */            if (/^\/date\(/gi.test(val)) {
/*Line 341 - 'Atom.js' */                val = val.substr(6);
/*Line 342 - 'Atom.js' */                val = new Date(parseInt(val,10));
/*Line 343 - 'Atom.js' */            } else {
/*Line 344 - 'Atom.js' */                throw new Error("Invalid date format " + val);
/*Line 345 - 'Atom.js' */            }
/*Line 346 - 'Atom.js' */        }
/*Line 347 - 'Atom.js' */        //var dt = new Date();
        
/*Line 349 - 'Atom.js' */        return this.m_names[val.getMonth()] + " " + val.getDate() + ", " + val.getFullYear();
/*Line 350 - 'Atom.js' */    },
/*Line 351 - 'Atom.js' */    toDateTimeString: function (val) {
/*Line 352 - 'Atom.js' */        if (!val)
/*Line 353 - 'Atom.js' */            return "";
/*Line 354 - 'Atom.js' */        if (val.constructor == String) {
/*Line 355 - 'Atom.js' */            val = val.substr(6);
/*Line 356 - 'Atom.js' */            val = new Date(parseInt(val,10));
/*Line 357 - 'Atom.js' */        }
/*Line 358 - 'Atom.js' */        var dt = AtomDate.toShortDateString(val);
/*Line 359 - 'Atom.js' */        return dt + " - " + AtomDate.toTimeString(val);
/*Line 360 - 'Atom.js' */    },

/*Line 362 - 'Atom.js' */    toTimeString: function(d){
/*Line 363 - 'Atom.js' */        var h = d.getHours();
/*Line 364 - 'Atom.js' */        var s = "AM";
/*Line 365 - 'Atom.js' */        if (h > 12) {
/*Line 366 - 'Atom.js' */            h = h - 12;
/*Line 367 - 'Atom.js' */            s = "PM";
/*Line 368 - 'Atom.js' */        }
/*Line 369 - 'Atom.js' */        var m = d.getMinutes();
/*Line 370 - 'Atom.js' */        if (m < 10) {
/*Line 371 - 'Atom.js' */            m = "0" + m;
/*Line 372 - 'Atom.js' */        } else {
/*Line 373 - 'Atom.js' */            m = m + "";
/*Line 374 - 'Atom.js' */            if (m.length == 1) {
/*Line 375 - 'Atom.js' */                m = m + "0";
/*Line 376 - 'Atom.js' */            }
/*Line 377 - 'Atom.js' */        }
/*Line 378 - 'Atom.js' */        return h + ":" + m + " " + s;
/*Line 379 - 'Atom.js' */    },

/*Line 381 - 'Atom.js' */    smartDate: function (v) {
/*Line 382 - 'Atom.js' */        var d = AtomDate.parse(v);
/*Line 383 - 'Atom.js' */        var now = new Date();

/*Line 385 - 'Atom.js' */        if (now.getFullYear() == d.getFullYear()
/*Line 386 - 'Atom.js' */            && now.getMonth() == d.getMonth()) {
/*Line 387 - 'Atom.js' */            var diff = now.getDate() - d.getDate();
/*Line 388 - 'Atom.js' */            switch(diff){
/*Line 389 - 'Atom.js' */                case -1:
/*Line 390 - 'Atom.js' */                    return "Tomorrow (" + AtomDate.toTimeString(d) + ")";
/*Line 391 - 'Atom.js' */                case 0:
/*Line 392 - 'Atom.js' */                    return "Today (" + AtomDate.toTimeString(d) + ")";
/*Line 393 - 'Atom.js' */                case 1:
/*Line 394 - 'Atom.js' */                    return "Yesterday (" + AtomDate.toTimeString(d) + ")";
/*Line 395 - 'Atom.js' */            }
/*Line 396 - 'Atom.js' */        }
/*Line 397 - 'Atom.js' */        return AtomDate.toDateTimeString(d);
/*Line 398 - 'Atom.js' */    },

/*Line 400 - 'Atom.js' */    smartDateUTC: function (v) {
/*Line 401 - 'Atom.js' */        var d = AtomDate.parse(v);
/*Line 402 - 'Atom.js' */        var i = d.getTime();
/*Line 403 - 'Atom.js' */        var z = d.getTimezoneOffset() * 60 * 1000;
/*Line 404 - 'Atom.js' */        i = i - z;
/*Line 405 - 'Atom.js' */        return AtomDate.smartDate(new Date(i));
/*Line 406 - 'Atom.js' */    },

/*Line 408 - 'Atom.js' */    parse: function (v) {
/*Line 409 - 'Atom.js' */        if (!v)
/*Line 410 - 'Atom.js' */            return null;
/*Line 411 - 'Atom.js' */        if (!(v.constructor == String))
/*Line 412 - 'Atom.js' */            return v;
/*Line 413 - 'Atom.js' */        if (/^\/date\([\-0-9]+\)\//gi.test(v)) {
/*Line 414 - 'Atom.js' */            v = new Date(parseInt(v.substr(6),10));
/*Line 415 - 'Atom.js' */        } else {
/*Line 416 - 'Atom.js' */            v = Date.parse(v);
/*Line 417 - 'Atom.js' */        }
/*Line 418 - 'Atom.js' */        return v;
/*Line 419 - 'Atom.js' */    }
/*Line 420 - 'Atom.js' */};

/*Line 422 - 'Atom.js' */window.AtomDate = AtomDate;

/*Line 424 - 'Atom.js' */AtomDate.monthList = [
/*Line 425 - 'Atom.js' */    { label: "January", value: 1 },
/*Line 426 - 'Atom.js' */    { label: "February", value: 2 },
/*Line 427 - 'Atom.js' */    { label: "March", value: 3 },
/*Line 428 - 'Atom.js' */    { label: "April", value: 4 },
/*Line 429 - 'Atom.js' */    { label: "May", value: 5 },
/*Line 430 - 'Atom.js' */    { label: "June", value: 6 },
/*Line 431 - 'Atom.js' */    { label: "July", value: 7 },
/*Line 432 - 'Atom.js' */    { label: "August", value: 8 },
/*Line 433 - 'Atom.js' */    { label: "September", value: 9 },
/*Line 434 - 'Atom.js' */    { label: "October", value: 10 },
/*Line 435 - 'Atom.js' */    { label: "November", value: 11 },
/*Line 436 - 'Atom.js' */    { label: "December", value: 12 }
/*Line 437 - 'Atom.js' */];


/*Line 440 - 'Atom.js' */var AtomFileSize = {
/*Line 441 - 'Atom.js' */    toFileSize: function (val) {
/*Line 442 - 'Atom.js' */        if (!val)
/*Line 443 - 'Atom.js' */            return "";
/*Line 444 - 'Atom.js' */        if (val.constructor == String)
/*Line 445 - 'Atom.js' */            val = parseInt(val, 10);
/*Line 446 - 'Atom.js' */        if (val > 1073741824) {
/*Line 447 - 'Atom.js' */            return Math.round(val / 1073741824) + " GB";
/*Line 448 - 'Atom.js' */        }
/*Line 449 - 'Atom.js' */        if (val > 1048576) {
/*Line 450 - 'Atom.js' */            return Math.round(val / 1048576) + " MB";
/*Line 451 - 'Atom.js' */        }
/*Line 452 - 'Atom.js' */        if (val > 1024) {
/*Line 453 - 'Atom.js' */            return Math.round(val / 1024) + " KB";
/*Line 454 - 'Atom.js' */        }
/*Line 455 - 'Atom.js' */        return val + " B";
/*Line 456 - 'Atom.js' */    }
/*Line 457 - 'Atom.js' */};

/*Line 459 - 'Atom.js' */window.AtomFileSize = AtomFileSize;

/*Line 461 - 'Atom.js' */var AtomPhone = {
/*Line 462 - 'Atom.js' */    toSmallPhoneString: function (val) {
/*Line 463 - 'Atom.js' */        if (!val)
/*Line 464 - 'Atom.js' */            return "";
/*Line 465 - 'Atom.js' */        var tokens = val.split(":", 6);
/*Line 466 - 'Atom.js' */        var cc = tokens[2];
/*Line 467 - 'Atom.js' */        cc = "(" + (/^\+/.test(cc) ? '' : '+') + tokens[2] + ") ";
/*Line 468 - 'Atom.js' */        var phone = tokens[3];
/*Line 469 - 'Atom.js' */        var ext = tokens[4];
/*Line 470 - 'Atom.js' */        var msg = tokens[5];
/*Line 471 - 'Atom.js' */        if (!phone)
/*Line 472 - 'Atom.js' */            return "";
/*Line 473 - 'Atom.js' */        return cc + phone;
/*Line 474 - 'Atom.js' */    },
/*Line 475 - 'Atom.js' */    toPhoneString: function (val) {
/*Line 476 - 'Atom.js' */        if (!val)
/*Line 477 - 'Atom.js' */            return "";
/*Line 478 - 'Atom.js' */        var tokens = val.split(":", 6);
/*Line 479 - 'Atom.js' */        var cc = "(+" + tokens[2] + ") ";
/*Line 480 - 'Atom.js' */        var phone = tokens[3];
/*Line 481 - 'Atom.js' */        var ext = tokens[4];
/*Line 482 - 'Atom.js' */        var msg = tokens[5];
/*Line 483 - 'Atom.js' */        if (!phone)
/*Line 484 - 'Atom.js' */            return "";
/*Line 485 - 'Atom.js' */        var txt = cc + phone;
/*Line 486 - 'Atom.js' */        if (ext)
/*Line 487 - 'Atom.js' */            txt += " (ext: " + ext + ")";
/*Line 488 - 'Atom.js' */        if (msg)
/*Line 489 - 'Atom.js' */            txt += " (" + msg + ")";
/*Line 490 - 'Atom.js' */        return txt;
/*Line 491 - 'Atom.js' */    }
/*Line 492 - 'Atom.js' */};

/*Line 494 - 'Atom.js' */window.AtomPhone = AtomPhone;


/*Line 2 - 'AtomEvaluator.js' */var AtomEvaluator = {

/*Line 4 - 'AtomEvaluator.js' */    ecache: {},

/*Line 6 - 'AtomEvaluator.js' */    becache: {},

/*Line 8 - 'AtomEvaluator.js' */    parse: function (txt) {

/*Line 10 - 'AtomEvaluator.js' */        // http://jsfiddle.net/A3vg6/44/ (recommended)
/*Line 11 - 'AtomEvaluator.js' */        // http://jsfiddle.net/A3vg6/45/ (working)
/*Line 12 - 'AtomEvaluator.js' */        // http://jsfiddle.net/A3vg6/51/ (including $ sign)

/*Line 14 - 'AtomEvaluator.js' */        var be = this.becache[txt];
/*Line 15 - 'AtomEvaluator.js' */        if (be)
/*Line 16 - 'AtomEvaluator.js' */            return be;

/*Line 18 - 'AtomEvaluator.js' */        var regex = /(?:(\$)(window|appScope|scope|data|owner|localScope))(?:\.[a-zA-Z_][a-zA-Z_0-9]*)*/gi;

/*Line 20 - 'AtomEvaluator.js' */        var keywords = /(window|appScope|scope|data|owner|localScope)/gi;

/*Line 22 - 'AtomEvaluator.js' */        var path = [];
/*Line 23 - 'AtomEvaluator.js' */        var vars = [];

/*Line 25 - 'AtomEvaluator.js' */        var found = {};

/*Line 27 - 'AtomEvaluator.js' */        var ms = txt.replace(regex,
/*Line 28 - 'AtomEvaluator.js' */            function (match) {
/*Line 29 - 'AtomEvaluator.js' */                var nv = "v" + (path.length + 1);
/*Line 30 - 'AtomEvaluator.js' */                if (match.indexOf("$owner.") == 0) {
/*Line 31 - 'AtomEvaluator.js' */                    match = match.substr(7);
/*Line 32 - 'AtomEvaluator.js' */                } else
/*Line 33 - 'AtomEvaluator.js' */                {
/*Line 34 - 'AtomEvaluator.js' */                    if (match.indexOf("owner.") == 0) {
/*Line 35 - 'AtomEvaluator.js' */                        match = match.substr(6);
/*Line 36 - 'AtomEvaluator.js' */                    } else {
/*Line 37 - 'AtomEvaluator.js' */                        match = match.substr(1);
/*Line 38 - 'AtomEvaluator.js' */                    }
/*Line 39 - 'AtomEvaluator.js' */                }
/*Line 40 - 'AtomEvaluator.js' */                path.push(match);
/*Line 41 - 'AtomEvaluator.js' */                vars.push(nv);
/*Line 42 - 'AtomEvaluator.js' */                return nv;
/*Line 43 - 'AtomEvaluator.js' */            }
/*Line 44 - 'AtomEvaluator.js' */            );


/*Line 47 - 'AtomEvaluator.js' */        var method = "return " + ms + ";";
/*Line 48 - 'AtomEvaluator.js' */        var methodString = method;
/*Line 49 - 'AtomEvaluator.js' */        try {
/*Line 50 - 'AtomEvaluator.js' */            method = AtomEvaluator.compile(vars, method);
/*Line 51 - 'AtomEvaluator.js' */        } catch (e) {
/*Line 52 - 'AtomEvaluator.js' */            alert("Error executing \n" + methodString + "\nOriginal: " + txt);
/*Line 53 - 'AtomEvaluator.js' */            throw e;
/*Line 54 - 'AtomEvaluator.js' */        }

/*Line 56 - 'AtomEvaluator.js' */        be = { length: vars.length, method: method, path: path, original: ms };
/*Line 57 - 'AtomEvaluator.js' */        this.becache[txt] = be;
/*Line 58 - 'AtomEvaluator.js' */        return be;
/*Line 59 - 'AtomEvaluator.js' */    },
/*Line 60 - 'AtomEvaluator.js' */    compile: function (vars, method) {
/*Line 61 - 'AtomEvaluator.js' */        var k = vars.join("-") + ":" + method;
/*Line 62 - 'AtomEvaluator.js' */        var e = this.ecache[k];
/*Line 63 - 'AtomEvaluator.js' */        if (e)
/*Line 64 - 'AtomEvaluator.js' */            return e;

/*Line 66 - 'AtomEvaluator.js' */        vars.push("Atom");
/*Line 67 - 'AtomEvaluator.js' */        vars.push("AtomPromise");

/*Line 69 - 'AtomEvaluator.js' */        e = new Function(vars,method);
/*Line 70 - 'AtomEvaluator.js' */        this.ecache[k] = e;
/*Line 71 - 'AtomEvaluator.js' */        return e;
/*Line 72 - 'AtomEvaluator.js' */    }
/*Line 73 - 'AtomEvaluator.js' */};

/*Line 75 - 'AtomEvaluator.js' */window.AtomEvaluator = AtomEvaluator;
/*Line 0 - 'ChildEnumerator.js' */

/*Line 2 - 'ChildEnumerator.js' */var ChildEnumerator = null;

/*Line 4 - 'ChildEnumerator.js' */if (AtomBrowser.isIE && AtomBrowser.majorVersion < 9) {
/*Line 5 - 'ChildEnumerator.js' */    ChildEnumerator = function (e) {
/*Line 6 - 'ChildEnumerator.js' */        this.index = -1;
/*Line 7 - 'ChildEnumerator.js' */        this.nextItem = e.firstChild;
/*Line 8 - 'ChildEnumerator.js' */        this.findNext();
/*Line 9 - 'ChildEnumerator.js' */        this.item = null;
/*Line 10 - 'ChildEnumerator.js' */    };

/*Line 12 - 'ChildEnumerator.js' */    ChildEnumerator.prototype ={

/*Line 14 - 'ChildEnumerator.js' */        findNext: function () {
/*Line 15 - 'ChildEnumerator.js' */            var ne = this.nextItem;
/*Line 16 - 'ChildEnumerator.js' */            while (ne && ne.nodeType != 1) {
/*Line 17 - 'ChildEnumerator.js' */                ne = ne.nextSibling;
/*Line 18 - 'ChildEnumerator.js' */            }
/*Line 19 - 'ChildEnumerator.js' */            this.nextItem = ne;
/*Line 20 - 'ChildEnumerator.js' */            this.index++;
/*Line 21 - 'ChildEnumerator.js' */        },

/*Line 23 - 'ChildEnumerator.js' */        isFirst: function () {
/*Line 24 - 'ChildEnumerator.js' */            return this.index == 1;
/*Line 25 - 'ChildEnumerator.js' */        },

/*Line 27 - 'ChildEnumerator.js' */        isLast: function () {
/*Line 28 - 'ChildEnumerator.js' */            return this.item && !this.nextItem;
/*Line 29 - 'ChildEnumerator.js' */        },

/*Line 31 - 'ChildEnumerator.js' */        next: function () {
/*Line 32 - 'ChildEnumerator.js' */            this.item = this.nextItem;
/*Line 33 - 'ChildEnumerator.js' */            if (!this.item)
/*Line 34 - 'ChildEnumerator.js' */                return false;
/*Line 35 - 'ChildEnumerator.js' */            this.nextItem = this.item.nextSibling;
/*Line 36 - 'ChildEnumerator.js' */            this.findNext();
/*Line 37 - 'ChildEnumerator.js' */            return this.item ? true : false;
/*Line 38 - 'ChildEnumerator.js' */        },

/*Line 40 - 'ChildEnumerator.js' */        current: function () {
/*Line 41 - 'ChildEnumerator.js' */            return this.item;
/*Line 42 - 'ChildEnumerator.js' */        }

/*Line 44 - 'ChildEnumerator.js' */    };

/*Line 46 - 'ChildEnumerator.js' */    window.ChildEnumerator = ChildEnumerator;
/*Line 47 - 'ChildEnumerator.js' */}
/*Line 48 - 'ChildEnumerator.js' */else {
/*Line 49 - 'ChildEnumerator.js' */    ChildEnumerator = function (e) {
/*Line 50 - 'ChildEnumerator.js' */        this.nextItem = e.firstElementChild;
/*Line 51 - 'ChildEnumerator.js' */        this.item = null;
/*Line 52 - 'ChildEnumerator.js' */        this.first = true;
/*Line 53 - 'ChildEnumerator.js' */    };

/*Line 55 - 'ChildEnumerator.js' */    ChildEnumerator.prototype = {
/*Line 56 - 'ChildEnumerator.js' */        isFirst: function () {
/*Line 57 - 'ChildEnumerator.js' */            return !this.item.previousElementSibling;
/*Line 58 - 'ChildEnumerator.js' */        },
/*Line 59 - 'ChildEnumerator.js' */        isLast: function () {
/*Line 60 - 'ChildEnumerator.js' */            return this.item && !this.nextItem;
/*Line 61 - 'ChildEnumerator.js' */        },
/*Line 62 - 'ChildEnumerator.js' */        next: function () {
/*Line 63 - 'ChildEnumerator.js' */            this.item = this.nextItem;
/*Line 64 - 'ChildEnumerator.js' */            if (!this.item)
/*Line 65 - 'ChildEnumerator.js' */                return false;
/*Line 66 - 'ChildEnumerator.js' */            this.nextItem = this.item.nextElementSibling;
/*Line 67 - 'ChildEnumerator.js' */            return this.item ? true : false;
/*Line 68 - 'ChildEnumerator.js' */        },
/*Line 69 - 'ChildEnumerator.js' */        current: function () {
/*Line 70 - 'ChildEnumerator.js' */            return this.item;
/*Line 71 - 'ChildEnumerator.js' */        }

/*Line 73 - 'ChildEnumerator.js' */    };

/*Line 75 - 'ChildEnumerator.js' */    window.ChildEnumerator = ChildEnumerator;
/*Line 76 - 'ChildEnumerator.js' */}



/*Line 0 - 'AtomPopup.js' */

/*Line 2 - 'AtomPopup.js' */var AtomPopup = {

/*Line 4 - 'AtomPopup.js' */    stack: [],

/*Line 6 - 'AtomPopup.js' */    startOrder: 2000,


    
/*Line 10 - 'AtomPopup.js' */    show: function (parent, element, pos, removeHandler) {

/*Line 12 - 'AtomPopup.js' */        // post =  { 0: bottom left, 1: bottom right, 2: top left, 3: top right }

/*Line 14 - 'AtomPopup.js' */        // set logical parent
/*Line 15 - 'AtomPopup.js' */        element.style.zOrder = this.startOrder++;

/*Line 17 - 'AtomPopup.js' */        if (pos == 0) {

/*Line 19 - 'AtomPopup.js' */            var p = $(parent).offset();
/*Line 20 - 'AtomPopup.js' */            element.style.position = "absolute";
/*Line 21 - 'AtomPopup.js' */            element.style.left =   p.left + "px";
/*Line 22 - 'AtomPopup.js' */            element.style.top = (p.top + $(parent).outerHeight(true)) + "px";
/*Line 23 - 'AtomPopup.js' */        }

/*Line 25 - 'AtomPopup.js' */        element.style.visibility = "visible";

/*Line 27 - 'AtomPopup.js' */        this.stack.push({ parent: parent, element: element, removeHandler: removeHandler });

/*Line 29 - 'AtomPopup.js' */    },

/*Line 31 - 'AtomPopup.js' */    peek: function () {
/*Line 32 - 'AtomPopup.js' */        var l = null;
/*Line 33 - 'AtomPopup.js' */        if (this.stack.length > 0)
/*Line 34 - 'AtomPopup.js' */            l = this.stack[this.stack.length - 1];
/*Line 35 - 'AtomPopup.js' */        return l;
/*Line 36 - 'AtomPopup.js' */    },

/*Line 38 - 'AtomPopup.js' */    hide: function (element) {

/*Line 40 - 'AtomPopup.js' */        // only hide top most element
/*Line 41 - 'AtomPopup.js' */        // otherwise it may have been removed
/*Line 42 - 'AtomPopup.js' */        // by clicked function
/*Line 43 - 'AtomPopup.js' */        var pk = this.peek();
/*Line 44 - 'AtomPopup.js' */        if (!pk)
/*Line 45 - 'AtomPopup.js' */            return;
/*Line 46 - 'AtomPopup.js' */        if (pk.element !== element)
/*Line 47 - 'AtomPopup.js' */            return;

/*Line 49 - 'AtomPopup.js' */        element.style.visibility = "hidden";
/*Line 50 - 'AtomPopup.js' */        var item = this.stack.pop();
/*Line 51 - 'AtomPopup.js' */        if (item.removeHandler) {
/*Line 52 - 'AtomPopup.js' */            item.removeHandler(item.element);
/*Line 53 - 'AtomPopup.js' */        }
/*Line 54 - 'AtomPopup.js' */    },

/*Line 56 - 'AtomPopup.js' */    clicked: function (e) {

/*Line 58 - 'AtomPopup.js' */        var target = e.target;

/*Line 60 - 'AtomPopup.js' */        // lets see if target is outside the topmost popup...
/*Line 61 - 'AtomPopup.js' */        var pk = AtomPopup.peek();
/*Line 62 - 'AtomPopup.js' */        if (!pk)
/*Line 63 - 'AtomPopup.js' */            return;
/*Line 64 - 'AtomPopup.js' */        while (target && target != pk.element && target != pk.parent) {
/*Line 65 - 'AtomPopup.js' */            target = target.parentNode;
/*Line 66 - 'AtomPopup.js' */        }
/*Line 67 - 'AtomPopup.js' */        if (target == pk.element || target == pk.parent) {
/*Line 68 - 'AtomPopup.js' */            return;
/*Line 69 - 'AtomPopup.js' */        }

/*Line 71 - 'AtomPopup.js' */        //AtomPopup.hide(pk);
/*Line 72 - 'AtomPopup.js' */        pk.element.style.visibility = "hidden";
/*Line 73 - 'AtomPopup.js' */        this.stack.pop();
/*Line 74 - 'AtomPopup.js' */        if (pk.removeHandler) {
/*Line 75 - 'AtomPopup.js' */            pk.removeHandler(pk.element);
/*Line 76 - 'AtomPopup.js' */        }
/*Line 77 - 'AtomPopup.js' */    }


/*Line 80 - 'AtomPopup.js' */};

/*Line 82 - 'AtomPopup.js' */window.AtomPopup = AtomPopup;

/*Line 84 - 'AtomPopup.js' */$(window).click(function (e) {
/*Line 85 - 'AtomPopup.js' */    AtomPopup.clicked(e);
/*Line 86 - 'AtomPopup.js' */});
/*Line 0 - 'AtomQuery.js' */

/*Line 2 - 'AtomQuery.js' */var QueryCompiler = {

/*Line 4 - 'AtomQuery.js' */    helpers: {
/*Line 5 - 'AtomQuery.js' */        any: function (lv, v) {
/*Line 6 - 'AtomQuery.js' */            if (!lv)
/*Line 7 - 'AtomQuery.js' */                return false;
/*Line 8 - 'AtomQuery.js' */            return Atom.query(lv).any(v);
/*Line 9 - 'AtomQuery.js' */        },
/*Line 10 - 'AtomQuery.js' */        "in" : function (lv, v) {
/*Line 11 - 'AtomQuery.js' */            var ae = new AtomEnumerator(v);
/*Line 12 - 'AtomQuery.js' */            while (ae.next()) {
/*Line 13 - 'AtomQuery.js' */                if (lv == ae.current())
/*Line 14 - 'AtomQuery.js' */                    return true;
/*Line 15 - 'AtomQuery.js' */            }
/*Line 16 - 'AtomQuery.js' */            return false;
/*Line 17 - 'AtomQuery.js' */        },
/*Line 18 - 'AtomQuery.js' */        equals: function (lv, v) {
/*Line 19 - 'AtomQuery.js' */            if (!lv) {
/*Line 20 - 'AtomQuery.js' */                if (!v)
/*Line 21 - 'AtomQuery.js' */                    return true;
/*Line 22 - 'AtomQuery.js' */                return false;
/*Line 23 - 'AtomQuery.js' */            }
/*Line 24 - 'AtomQuery.js' */            return lv.toLowerCase() == v.toLowerCase();
/*Line 25 - 'AtomQuery.js' */        },
/*Line 26 - 'AtomQuery.js' */        contains: function (lv, v) {
/*Line 27 - 'AtomQuery.js' */            if (!lv)
/*Line 28 - 'AtomQuery.js' */                return false;
/*Line 29 - 'AtomQuery.js' */            if (!v)
/*Line 30 - 'AtomQuery.js' */                return false;
/*Line 31 - 'AtomQuery.js' */            return lv.toLowerCase().indexOf(v.toLowerCase()) != -1;
/*Line 32 - 'AtomQuery.js' */        },
/*Line 33 - 'AtomQuery.js' */        startswith: function (lv, v) {
/*Line 34 - 'AtomQuery.js' */            if (!lv)
/*Line 35 - 'AtomQuery.js' */                return false;
/*Line 36 - 'AtomQuery.js' */            if (!v)
/*Line 37 - 'AtomQuery.js' */                return false;
/*Line 38 - 'AtomQuery.js' */            return lv.toLowerCase().indexOf(v.toLowerCase()) == 0;
/*Line 39 - 'AtomQuery.js' */        },
/*Line 40 - 'AtomQuery.js' */        endswith: function (lv, v) {
/*Line 41 - 'AtomQuery.js' */            if (!lv)
/*Line 42 - 'AtomQuery.js' */                return false;
/*Line 43 - 'AtomQuery.js' */            if (!v)
/*Line 44 - 'AtomQuery.js' */                return false;
/*Line 45 - 'AtomQuery.js' */            return lv.toLowerCase().lastIndexOf(v.toLowerCase()) == (lv.length - v.length);
/*Line 46 - 'AtomQuery.js' */        },
/*Line 47 - 'AtomQuery.js' */        containscs: function (lv, v) {
/*Line 48 - 'AtomQuery.js' */            if (!lv)
/*Line 49 - 'AtomQuery.js' */                return false;
/*Line 50 - 'AtomQuery.js' */            return lv.indexOf(v) != -1;
/*Line 51 - 'AtomQuery.js' */        },
/*Line 52 - 'AtomQuery.js' */        startswithcs: function (lv, v) {
/*Line 53 - 'AtomQuery.js' */            if (!lv)
/*Line 54 - 'AtomQuery.js' */                return false;
/*Line 55 - 'AtomQuery.js' */            return lv.indexOf(v) == 0;
/*Line 56 - 'AtomQuery.js' */        },
/*Line 57 - 'AtomQuery.js' */        endswithcs: function (lv, v) {
/*Line 58 - 'AtomQuery.js' */            if (!lv)
/*Line 59 - 'AtomQuery.js' */                return false;
/*Line 60 - 'AtomQuery.js' */            return lv.lastIndexOf(v) == (lv.length - v.length);
/*Line 61 - 'AtomQuery.js' */        }
/*Line 62 - 'AtomQuery.js' */    },


/*Line 65 - 'AtomQuery.js' */    compileList: function (qseg, q, sep) {
/*Line 66 - 'AtomQuery.js' */        if (!sep)
/*Line 67 - 'AtomQuery.js' */            sep = " && ";
/*Line 68 - 'AtomQuery.js' */        var list = [];
/*Line 69 - 'AtomQuery.js' */        for (var i in qseg) {
/*Line 70 - 'AtomQuery.js' */            var v = qseg[i];
/*Line 71 - 'AtomQuery.js' */            // skip condition 
/*Line 72 - 'AtomQuery.js' */            // if value is undefined
/*Line 73 - 'AtomQuery.js' */            if (v === undefined)
/*Line 74 - 'AtomQuery.js' */                continue;
/*Line 75 - 'AtomQuery.js' */            v = JSON.stringify(v);

/*Line 77 - 'AtomQuery.js' */            switch (v) {
/*Line 78 - 'AtomQuery.js' */                case "$and":
/*Line 79 - 'AtomQuery.js' */                    list.push(QueryCompiler.compileList(v, q, " && "));
/*Line 80 - 'AtomQuery.js' */                    break;
/*Line 81 - 'AtomQuery.js' */                case "$or":
/*Line 82 - 'AtomQuery.js' */                    list.push( QueryCompiler.compileList(v, q, " || " ));
/*Line 83 - 'AtomQuery.js' */                    break;
/*Line 84 - 'AtomQuery.js' */                case "$not":
/*Line 85 - 'AtomQuery.js' */                    list.push("!(" + QueryCompiler.compileList(v, q, sep ) + ")");
/*Line 86 - 'AtomQuery.js' */                    break;
/*Line 87 - 'AtomQuery.js' */                default:
/*Line 88 - 'AtomQuery.js' */            }


/*Line 91 - 'AtomQuery.js' */            var opi = i.indexOf(':');
/*Line 92 - 'AtomQuery.js' */            var p = i;
/*Line 93 - 'AtomQuery.js' */            var op = "==";
/*Line 94 - 'AtomQuery.js' */            if (opi != -1) {
/*Line 95 - 'AtomQuery.js' */                p = i.substr(0, opi);
/*Line 96 - 'AtomQuery.js' */                op = i.substr(opi + 1).toLowerCase();
/*Line 97 - 'AtomQuery.js' */            }
/*Line 98 - 'AtomQuery.js' */            var n1 = "";
/*Line 99 - 'AtomQuery.js' */            if (/^\!/gi.test(op)) {
/*Line 100 - 'AtomQuery.js' */                n1 = "!";
/*Line 101 - 'AtomQuery.js' */                op = op.substr(1);
/*Line 102 - 'AtomQuery.js' */            }
/*Line 103 - 'AtomQuery.js' */            p = JSON.stringify(p);
/*Line 104 - 'AtomQuery.js' */            var subq = null;
/*Line 105 - 'AtomQuery.js' */            var opq = QueryCompiler.helpers[op];
/*Line 106 - 'AtomQuery.js' */            if (op === "any") {

/*Line 108 - 'AtomQuery.js' */                if (v == "{}")
/*Line 109 - 'AtomQuery.js' */                    continue;
/*Line 110 - 'AtomQuery.js' */                subq = n1 + " QueryCompiler.helpers.any(Atom.get(item, " + p + " ), " + v + ")";
/*Line 111 - 'AtomQuery.js' */            }else{
/*Line 112 - 'AtomQuery.js' */                if (opq) {
/*Line 113 - 'AtomQuery.js' */                    subq = n1 + "QueryCompiler.helpers['" + op +"'](Atom.get(item," + p + "), " + v + ")";
/*Line 114 - 'AtomQuery.js' */                } else {
/*Line 115 - 'AtomQuery.js' */                    subq = "Atom.get(item," + p + ") " + n1 + op + " " + v + "";
/*Line 116 - 'AtomQuery.js' */                }
/*Line 117 - 'AtomQuery.js' */            }
/*Line 118 - 'AtomQuery.js' */            list.push(subq);
/*Line 119 - 'AtomQuery.js' */        }
/*Line 120 - 'AtomQuery.js' */        if (list.length > 0) {
/*Line 121 - 'AtomQuery.js' */            return list;
/*Line 122 - 'AtomQuery.js' */        }
/*Line 123 - 'AtomQuery.js' */        return [ "true" ];
/*Line 124 - 'AtomQuery.js' */    },

/*Line 126 - 'AtomQuery.js' */    compiled: {

/*Line 128 - 'AtomQuery.js' */    },

/*Line 130 - 'AtomQuery.js' */    compile: function(q){
/*Line 131 - 'AtomQuery.js' */        if(!q){
/*Line 132 - 'AtomQuery.js' */            return function(item) { 
/*Line 133 - 'AtomQuery.js' */                return true;
/*Line 134 - 'AtomQuery.js' */            };
/*Line 135 - 'AtomQuery.js' */        }

/*Line 137 - 'AtomQuery.js' */        var qs = JSON.stringify(q);
/*Line 138 - 'AtomQuery.js' */        var qsc = QueryCompiler.compiled[qs];
/*Line 139 - 'AtomQuery.js' */        if (qsc)
/*Line 140 - 'AtomQuery.js' */            return qsc;

/*Line 142 - 'AtomQuery.js' */        var el = QueryCompiler.compileList(q, "item", "q");

/*Line 144 - 'AtomQuery.js' */        var ej = el.join(" && ");
/*Line 145 - 'AtomQuery.js' */        log(ej);
/*Line 146 - 'AtomQuery.js' */        var f = new Function(["item", "q"], " return " + ej + ";");
/*Line 147 - 'AtomQuery.js' */        qsc = function (item) {
/*Line 148 - 'AtomQuery.js' */            return f(item, q);
/*Line 149 - 'AtomQuery.js' */        };

/*Line 151 - 'AtomQuery.js' */        QueryCompiler.compiled[qs] = qsc;
/*Line 152 - 'AtomQuery.js' */        return qsc;
/*Line 153 - 'AtomQuery.js' */    },

/*Line 155 - 'AtomQuery.js' */    selectCompiled: {

/*Line 157 - 'AtomQuery.js' */    },

/*Line 159 - 'AtomQuery.js' */    compileSelect: function(s){
/*Line 160 - 'AtomQuery.js' */        if (!s) {
/*Line 161 - 'AtomQuery.js' */            return function (item) {
/*Line 162 - 'AtomQuery.js' */                return item;
/*Line 163 - 'AtomQuery.js' */            };
/*Line 164 - 'AtomQuery.js' */        }

/*Line 166 - 'AtomQuery.js' */        var js = JSON.stringify(s);
/*Line 167 - 'AtomQuery.js' */        var jsq = QueryCompiler.selectCompiled[js];
/*Line 168 - 'AtomQuery.js' */        if (jsq)
/*Line 169 - 'AtomQuery.js' */            return jsq;

/*Line 171 - 'AtomQuery.js' */        var list = [];
/*Line 172 - 'AtomQuery.js' */        for (var i in s) {
/*Line 173 - 'AtomQuery.js' */            var item = s[i];
/*Line 174 - 'AtomQuery.js' */            i = JSON.stringify(i);
/*Line 175 - 'AtomQuery.js' */            if (!item) {
/*Line 176 - 'AtomQuery.js' */                list.push( i + ": Atom.get(item," + i + ")" );
/*Line 177 - 'AtomQuery.js' */            } else {
/*Line 178 - 'AtomQuery.js' */                item = JSON.stringify(item);
/*Line 179 - 'AtomQuery.js' */                list.push(i + ":Atom.get(item," + item + ")");
/*Line 180 - 'AtomQuery.js' */            }
/*Line 181 - 'AtomQuery.js' */        }

/*Line 183 - 'AtomQuery.js' */        var rs = "return {" + list.join(",") + "};";
/*Line 184 - 'AtomQuery.js' */        jsq = new Function("item", rs);
/*Line 185 - 'AtomQuery.js' */        QueryCompiler.selectCompiled[js] = jsq;
/*Line 186 - 'AtomQuery.js' */        return jsq;
/*Line 187 - 'AtomQuery.js' */    }
/*Line 188 - 'AtomQuery.js' */};

/*Line 190 - 'AtomQuery.js' */var AtomQuery = {

/*Line 192 - 'AtomQuery.js' */    firstOrDefault:function (q) {
/*Line 193 - 'AtomQuery.js' */        var f = QueryCompiler.compile(q);
/*Line 194 - 'AtomQuery.js' */        while (this.next()) {
/*Line 195 - 'AtomQuery.js' */            var item = this.current();
/*Line 196 - 'AtomQuery.js' */            if (f(item)) {
/*Line 197 - 'AtomQuery.js' */                return item;
/*Line 198 - 'AtomQuery.js' */            }
/*Line 199 - 'AtomQuery.js' */        }
/*Line 200 - 'AtomQuery.js' */        return null;
/*Line 201 - 'AtomQuery.js' */    },

/*Line 203 - 'AtomQuery.js' */    first: function (q) {
/*Line 204 - 'AtomQuery.js' */        var f = QueryCompiler.compile(q);
/*Line 205 - 'AtomQuery.js' */        while (this.next()) {
/*Line 206 - 'AtomQuery.js' */            var item = this.current();
/*Line 207 - 'AtomQuery.js' */            if (f(item)) {
/*Line 208 - 'AtomQuery.js' */                return item;
/*Line 209 - 'AtomQuery.js' */            }
/*Line 210 - 'AtomQuery.js' */        }
/*Line 211 - 'AtomQuery.js' */        throw new Error("Item not found in collection");
/*Line 212 - 'AtomQuery.js' */    },

/*Line 214 - 'AtomQuery.js' */    where: function (q) {
/*Line 215 - 'AtomQuery.js' */        var f = QueryCompiler.compile(q);
/*Line 216 - 'AtomQuery.js' */        var r = [];
/*Line 217 - 'AtomQuery.js' */        while (this.next()) {
/*Line 218 - 'AtomQuery.js' */            var item = this.current();
/*Line 219 - 'AtomQuery.js' */            if (f(item)) {
/*Line 220 - 'AtomQuery.js' */                r.push(item);
/*Line 221 - 'AtomQuery.js' */            }
/*Line 222 - 'AtomQuery.js' */        }
/*Line 223 - 'AtomQuery.js' */        return new AtomEnumerator(r);
/*Line 224 - 'AtomQuery.js' */    },

/*Line 226 - 'AtomQuery.js' */    toArray: function(){
/*Line 227 - 'AtomQuery.js' */        var r = [];
/*Line 228 - 'AtomQuery.js' */        while (this.next()) {
/*Line 229 - 'AtomQuery.js' */            r.push(this.current());
/*Line 230 - 'AtomQuery.js' */        }
/*Line 231 - 'AtomQuery.js' */        return r;
/*Line 232 - 'AtomQuery.js' */    },

/*Line 234 - 'AtomQuery.js' */    any: function(q){
/*Line 235 - 'AtomQuery.js' */        if (this.firstOrDefault(q))
/*Line 236 - 'AtomQuery.js' */            return true;
/*Line 237 - 'AtomQuery.js' */        return false;
/*Line 238 - 'AtomQuery.js' */    },

/*Line 240 - 'AtomQuery.js' */    select: function (q) {

/*Line 242 - 'AtomQuery.js' */        var f = QueryCompiler.compileSelect(q);
/*Line 243 - 'AtomQuery.js' */        var r = [];
/*Line 244 - 'AtomQuery.js' */        while (this.next()) {
/*Line 245 - 'AtomQuery.js' */            var item = this.current();
/*Line 246 - 'AtomQuery.js' */            r.push(f(item));
/*Line 247 - 'AtomQuery.js' */        }
/*Line 248 - 'AtomQuery.js' */        return new AtomEnumerator(r);
/*Line 249 - 'AtomQuery.js' */    },

/*Line 251 - 'AtomQuery.js' */    join: function (s) {
/*Line 252 - 'AtomQuery.js' */        var r = [];
/*Line 253 - 'AtomQuery.js' */        while (this.next()) {
/*Line 254 - 'AtomQuery.js' */            r.push(this.current());
/*Line 255 - 'AtomQuery.js' */        }
/*Line 256 - 'AtomQuery.js' */        return r.join(s);
/*Line 257 - 'AtomQuery.js' */    },

/*Line 259 - 'AtomQuery.js' */    count: function(s){
/*Line 260 - 'AtomQuery.js' */        if (s) {
/*Line 261 - 'AtomQuery.js' */            return this.where(s).count();
/*Line 262 - 'AtomQuery.js' */        }
/*Line 263 - 'AtomQuery.js' */        var n = 0;
/*Line 264 - 'AtomQuery.js' */        while (this.next()) n++;
/*Line 265 - 'AtomQuery.js' */        return n;
/*Line 266 - 'AtomQuery.js' */    },

/*Line 268 - 'AtomQuery.js' */    sum: function (s) {
/*Line 269 - 'AtomQuery.js' */        var n = 0;
/*Line 270 - 'AtomQuery.js' */        var ae = this;
/*Line 271 - 'AtomQuery.js' */        while (ae.next()) {
/*Line 272 - 'AtomQuery.js' */            var item = ae.current();
/*Line 273 - 'AtomQuery.js' */            if (s) {
/*Line 274 - 'AtomQuery.js' */                item = AtomBinder.getValue(item,s);
/*Line 275 - 'AtomQuery.js' */            }
/*Line 276 - 'AtomQuery.js' */            n += +(item || 0);
/*Line 277 - 'AtomQuery.js' */        }
/*Line 278 - 'AtomQuery.js' */        return n;
/*Line 279 - 'AtomQuery.js' */    }

/*Line 281 - 'AtomQuery.js' */};

/*Line 283 - 'AtomQuery.js' */window.AtomQuery = AtomQuery;

/*Line 285 - 'AtomQuery.js' */window.QueryCompiler = QueryCompiler;


/*Line 288 - 'AtomQuery.js' */for (var i in AtomQuery) {
/*Line 289 - 'AtomQuery.js' */    AtomEnumerator.prototype[i] = AtomQuery[i];
/*Line 290 - 'AtomQuery.js' */}


/*Line 293 - 'AtomQuery.js' */Atom.query = function (a) {
/*Line 294 - 'AtomQuery.js' */    if (a.length !== undefined) {
/*Line 295 - 'AtomQuery.js' */        return new AtomEnumerator(a);
/*Line 296 - 'AtomQuery.js' */    }
/*Line 297 - 'AtomQuery.js' */    return a;
/*Line 298 - 'AtomQuery.js' */};

/*Line 0 - 'AtomUI.js' */
/*Line 1 - 'AtomUI.js' */
/*Line 2 - 'AtomUI.js' */
/*Line 3 - 'AtomUI.js' */

/*Line 5 - 'AtomUI.js' */var AtomUI =
/*Line 6 - 'AtomUI.js' */{
/*Line 7 - 'AtomUI.js' */    nodeValue: (AtomBrowser.isIE && AtomBrowser.majorVersion < 9) ? "nodeValue" : "value",

/*Line 9 - 'AtomUI.js' */    attributeMap: function (e, r) {
/*Line 10 - 'AtomUI.js' */        var item;
/*Line 11 - 'AtomUI.js' */        var map = {};
/*Line 12 - 'AtomUI.js' */        var ae = new AtomEnumerator(e.attributes);
/*Line 13 - 'AtomUI.js' */        if (r) {
/*Line 14 - 'AtomUI.js' */            while (ae.next()) {
/*Line 15 - 'AtomUI.js' */                item = ae.current();
/*Line 16 - 'AtomUI.js' */                if (r.test(item.nodeName)) {
/*Line 17 - 'AtomUI.js' */                    r.lastIndex = 0;
/*Line 18 - 'AtomUI.js' */                    map[item.nodeName] = { value: item[AtomUI.nodeValue], node: item };
/*Line 19 - 'AtomUI.js' */                }
/*Line 20 - 'AtomUI.js' */            }
/*Line 21 - 'AtomUI.js' */            return map;
/*Line 22 - 'AtomUI.js' */        }

/*Line 24 - 'AtomUI.js' */        while (ae.next()) {
/*Line 25 - 'AtomUI.js' */            item = ae.current();
/*Line 26 - 'AtomUI.js' */            map[item.nodeName] = { value: item[AtomUI.nodeValue], node: item };
/*Line 27 - 'AtomUI.js' */        }
/*Line 28 - 'AtomUI.js' */        return map;
/*Line 29 - 'AtomUI.js' */    },

/*Line 31 - 'AtomUI.js' */    cloneNode: ((AtomBrowser.isIE && AtomBrowser.majorVersion < 8) ? (function (e) {

/*Line 33 - 'AtomUI.js' */        var document = window.document;

/*Line 35 - 'AtomUI.js' */        var r = document.createElement(e.nodeName);
/*Line 36 - 'AtomUI.js' */        var ae = new AtomEnumerator(e.attributes);
/*Line 37 - 'AtomUI.js' */        while (ae.next()) {
/*Line 38 - 'AtomUI.js' */            var a = ae.current();
/*Line 39 - 'AtomUI.js' */            try{
/*Line 40 - 'AtomUI.js' */                var name = a.nodeName;
/*Line 41 - 'AtomUI.js' */                var v = a[AtomUI.nodeValue];
/*Line 42 - 'AtomUI.js' */                if (!v)
/*Line 43 - 'AtomUI.js' */                    continue;
/*Line 44 - 'AtomUI.js' */                r.setAttribute(name, v);
/*Line 45 - 'AtomUI.js' */            }catch(ex){}
/*Line 46 - 'AtomUI.js' */        }

/*Line 48 - 'AtomUI.js' */        var firstChild = e.firstChild;
/*Line 49 - 'AtomUI.js' */        while (firstChild) {

/*Line 51 - 'AtomUI.js' */            if (firstChild.nodeType == 3) {
/*Line 52 - 'AtomUI.js' */                var n = document.createTextNode(firstChild.nodeValue);
/*Line 53 - 'AtomUI.js' */                r.appendChild(n);
/*Line 54 - 'AtomUI.js' */            } else if (firstChild.nodeType == 1) {
/*Line 55 - 'AtomUI.js' */                r.appendChild(AtomUI.cloneNode(firstChild));
/*Line 56 - 'AtomUI.js' */            }
/*Line 57 - 'AtomUI.js' */            firstChild = firstChild.nextSibling;
/*Line 58 - 'AtomUI.js' */        }

/*Line 60 - 'AtomUI.js' */        return r;
/*Line 61 - 'AtomUI.js' */    }) : function (e) {
/*Line 62 - 'AtomUI.js' */        return e.cloneNode(true);
/*Line 63 - 'AtomUI.js' */    }),

/*Line 65 - 'AtomUI.js' */    findPresenter: function (e) {
/*Line 66 - 'AtomUI.js' */        //if (!(AtomBrowser.isIE && AtomBrowser.majorVersion < 8)) {
/*Line 67 - 'AtomUI.js' */        //    return $(e).find("[atom-presenter]").get(0);
/*Line 68 - 'AtomUI.js' */        //}
/*Line 69 - 'AtomUI.js' */        var ae = new ChildEnumerator(e);
/*Line 70 - 'AtomUI.js' */        while (ae.next()) {
/*Line 71 - 'AtomUI.js' */            var item = ae.current();
/*Line 72 - 'AtomUI.js' */            var ap = $(item).attr("atom-presenter");
/*Line 73 - 'AtomUI.js' */            if (ap)
/*Line 74 - 'AtomUI.js' */                return item;
/*Line 75 - 'AtomUI.js' */            var c = AtomUI.findPresenter(item);
/*Line 76 - 'AtomUI.js' */            if (c)
/*Line 77 - 'AtomUI.js' */                return c;
/*Line 78 - 'AtomUI.js' */        }
/*Line 79 - 'AtomUI.js' */        return null;
/*Line 80 - 'AtomUI.js' */    },

/*Line 82 - 'AtomUI.js' */    parseUrl: function (url) {
/*Line 83 - 'AtomUI.js' */        var r = {};

/*Line 85 - 'AtomUI.js' */        var plist = url.split('&');

/*Line 87 - 'AtomUI.js' */        var ae = new AtomEnumerator(plist);
/*Line 88 - 'AtomUI.js' */        while (ae.next()) {
/*Line 89 - 'AtomUI.js' */            var p = ae.current().split('=');
/*Line 90 - 'AtomUI.js' */            var key = p[0];
/*Line 91 - 'AtomUI.js' */            var val = p[1];
/*Line 92 - 'AtomUI.js' */            if (val) {
/*Line 93 - 'AtomUI.js' */                val = decodeURIComponent(val);
/*Line 94 - 'AtomUI.js' */            }
/*Line 95 - 'AtomUI.js' */            val = AtomUI.parseValue(val);
/*Line 96 - 'AtomUI.js' */            r[key] = val;
/*Line 97 - 'AtomUI.js' */        }
/*Line 98 - 'AtomUI.js' */        return r;
/*Line 99 - 'AtomUI.js' */    },

/*Line 101 - 'AtomUI.js' */    parseValue: function (val) {
/*Line 102 - 'AtomUI.js' */        var n;
/*Line 103 - 'AtomUI.js' */        if (/^[0-9]+$/.test(val)) {
/*Line 104 - 'AtomUI.js' */            n = parseInt(val, 10);
/*Line 105 - 'AtomUI.js' */            if (!isNaN(n)) {
/*Line 106 - 'AtomUI.js' */                val = n;
/*Line 107 - 'AtomUI.js' */            }
/*Line 108 - 'AtomUI.js' */            return val;
/*Line 109 - 'AtomUI.js' */        }
/*Line 110 - 'AtomUI.js' */        if (/^[0-9]+\.[0-9]+/gi.test(val)) {
/*Line 111 - 'AtomUI.js' */            n = parseFloat(val);
/*Line 112 - 'AtomUI.js' */            if (!isNaN(n)) {
/*Line 113 - 'AtomUI.js' */                val = n;
/*Line 114 - 'AtomUI.js' */            }
/*Line 115 - 'AtomUI.js' */            return val;
/*Line 116 - 'AtomUI.js' */        }

/*Line 118 - 'AtomUI.js' */        if (/true/.test(val)) {
/*Line 119 - 'AtomUI.js' */            val = true;
/*Line 120 - 'AtomUI.js' */            return val;
/*Line 121 - 'AtomUI.js' */        }
/*Line 122 - 'AtomUI.js' */        if (/false/.test(val)) {
/*Line 123 - 'AtomUI.js' */            val = false;
/*Line 124 - 'AtomUI.js' */            return val;
/*Line 125 - 'AtomUI.js' */        }
/*Line 126 - 'AtomUI.js' */        return val;
/*Line 127 - 'AtomUI.js' */    },

/*Line 129 - 'AtomUI.js' */    cancelEvent: function (e) {

/*Line 131 - 'AtomUI.js' */        var t = e.target;
/*Line 132 - 'AtomUI.js' */        if (t && /input/gi.test(t.nodeName))
/*Line 133 - 'AtomUI.js' */            return;

/*Line 135 - 'AtomUI.js' */        if (e.preventDefault) { e.preventDefault(); }
/*Line 136 - 'AtomUI.js' */        else { e.stop(); }

/*Line 138 - 'AtomUI.js' */        e.returnValue = false;
/*Line 139 - 'AtomUI.js' */        e.stopPropagation();
/*Line 140 - 'AtomUI.js' */        return false;
/*Line 141 - 'AtomUI.js' */    },

/*Line 143 - 'AtomUI.js' */    assignID: function (element) {
/*Line 144 - 'AtomUI.js' */        if (!element.id) {
/*Line 145 - 'AtomUI.js' */            element.id = "__waID" + AtomUI.getNewIndex();
/*Line 146 - 'AtomUI.js' */        }
/*Line 147 - 'AtomUI.js' */        return element.id;
/*Line 148 - 'AtomUI.js' */    },

/*Line 150 - 'AtomUI.js' */    atomParent: function (element) {
/*Line 151 - 'AtomUI.js' */        if (element.atomControl) {
/*Line 152 - 'AtomUI.js' */            return element.atomControl;
/*Line 153 - 'AtomUI.js' */        }
/*Line 154 - 'AtomUI.js' */        if (element === document || element === window || !element.parentNode)
/*Line 155 - 'AtomUI.js' */            return null;
/*Line 156 - 'AtomUI.js' */        return AtomUI.atomParent(element._logicalParent || element.parentNode);
/*Line 157 - 'AtomUI.js' */    },
/*Line 158 - 'AtomUI.js' */    //startsWith: function (text, part) {
/*Line 159 - 'AtomUI.js' */    //    if (!text || text.constructor != String)
/*Line 160 - 'AtomUI.js' */    //        return false;
/*Line 161 - 'AtomUI.js' */    //    return text.indexOf(part) == 0;
/*Line 162 - 'AtomUI.js' */    //},
/*Line 163 - 'AtomUI.js' */    //endsWith: function (text, part) {
/*Line 164 - 'AtomUI.js' */    //    if (!text || text.constructor != String)
/*Line 165 - 'AtomUI.js' */    //        return false;
/*Line 166 - 'AtomUI.js' */    //    return text.lastIndexOf(part) == (text.length - part.length);
/*Line 167 - 'AtomUI.js' */    //},

/*Line 169 - 'AtomUI.js' */    toNumber: function (text) {
/*Line 170 - 'AtomUI.js' */        if (!text)
/*Line 171 - 'AtomUI.js' */            return 0;
/*Line 172 - 'AtomUI.js' */        if (text.constructor == String)
/*Line 173 - 'AtomUI.js' */            return parseFloat(text);
/*Line 174 - 'AtomUI.js' */        return text;
/*Line 175 - 'AtomUI.js' */    },

/*Line 177 - 'AtomUI.js' */    isNode: function (o) {
/*Line 178 - 'AtomUI.js' */        try {
/*Line 179 - 'AtomUI.js' */            if (window.XMLHttpRequest && o instanceof XMLHttpRequest)
/*Line 180 - 'AtomUI.js' */                return true;
/*Line 181 - 'AtomUI.js' */        } catch (ex) {
/*Line 182 - 'AtomUI.js' */        }
/*Line 183 - 'AtomUI.js' */        //if (o.addEventListener)
/*Line 184 - 'AtomUI.js' */        //    return true;

/*Line 186 - 'AtomUI.js' */        if (o === window || o === document)
/*Line 187 - 'AtomUI.js' */            return true;
/*Line 188 - 'AtomUI.js' */        return (
/*Line 189 - 'AtomUI.js' */        typeof Node === "object" ? o instanceof Node :
/*Line 190 - 'AtomUI.js' */        typeof o === "object" && typeof o.nodeType === "number" && typeof o.nodeName === "string"
/*Line 191 - 'AtomUI.js' */      );
/*Line 192 - 'AtomUI.js' */    },

/*Line 194 - 'AtomUI.js' */    createDelegate: function (instance, methodName) {
/*Line 195 - 'AtomUI.js' */        return this.getDelegate(instance, methodName, true);
/*Line 196 - 'AtomUI.js' */    },
/*Line 197 - 'AtomUI.js' */    getDelegate: function (instance, methodName, create) {
/*Line 198 - 'AtomUI.js' */        if (methodName && methodName.constructor != String)
/*Line 199 - 'AtomUI.js' */            throw new Error("methodName has to be string");
/*Line 200 - 'AtomUI.js' */        var d = instance.__delegates;
/*Line 201 - 'AtomUI.js' */        if (!d) {
/*Line 202 - 'AtomUI.js' */            if (!create)
/*Line 203 - 'AtomUI.js' */                return null;
/*Line 204 - 'AtomUI.js' */            d = {};
/*Line 205 - 'AtomUI.js' */            instance.__delegates = d;
/*Line 206 - 'AtomUI.js' */        }
/*Line 207 - 'AtomUI.js' */        var m = d[methodName];
/*Line 208 - 'AtomUI.js' */        if (!m) {
/*Line 209 - 'AtomUI.js' */            if (!create)
/*Line 210 - 'AtomUI.js' */                return null;
/*Line 211 - 'AtomUI.js' */            var f = instance[methodName];
/*Line 212 - 'AtomUI.js' */            if (!f) {
/*Line 213 - 'AtomUI.js' */                throw new Error("method " + methodName + " not found");
/*Line 214 - 'AtomUI.js' */            }
/*Line 215 - 'AtomUI.js' */            m = function () {
/*Line 216 - 'AtomUI.js' */                return f.apply(instance, arguments);
/*Line 217 - 'AtomUI.js' */            };
/*Line 218 - 'AtomUI.js' */            d[methodName] = m;
/*Line 219 - 'AtomUI.js' */        }
/*Line 220 - 'AtomUI.js' */        return m;
/*Line 221 - 'AtomUI.js' */    },

/*Line 223 - 'AtomUI.js' */    __index: 1000,
/*Line 224 - 'AtomUI.js' */    getNewIndex: function () {
/*Line 225 - 'AtomUI.js' */        this.__index = this.__index + 1;
/*Line 226 - 'AtomUI.js' */        return this.__index;
/*Line 227 - 'AtomUI.js' */    },

/*Line 229 - 'AtomUI.js' */    contains: function (array, item) {
/*Line 230 - 'AtomUI.js' */        var n = array.length;
/*Line 231 - 'AtomUI.js' */        var i = 0;
/*Line 232 - 'AtomUI.js' */        for (i = 0; i < n; i++) {
/*Line 233 - 'AtomUI.js' */            if (array[i] == item)
/*Line 234 - 'AtomUI.js' */                return true;
/*Line 235 - 'AtomUI.js' */        }
/*Line 236 - 'AtomUI.js' */        return false;
/*Line 237 - 'AtomUI.js' */    },

/*Line 239 - 'AtomUI.js' */    removeAllChildren: function (element) {
/*Line 240 - 'AtomUI.js' */        while (element.hasChildNodes()) {
/*Line 241 - 'AtomUI.js' */            var lc = element.lastChild;
/*Line 242 - 'AtomUI.js' */            if (!lc)
/*Line 243 - 'AtomUI.js' */                break;
/*Line 244 - 'AtomUI.js' */            //element.removeChild(lc);
/*Line 245 - 'AtomUI.js' */            if (lc.atomControl) {
/*Line 246 - 'AtomUI.js' */                lc.atomControl.dispose();
/*Line 247 - 'AtomUI.js' */                delete lc.atomControl;
/*Line 248 - 'AtomUI.js' */            }
/*Line 249 - 'AtomUI.js' */            $(lc).remove();
/*Line 250 - 'AtomUI.js' */            //delete lc;
/*Line 251 - 'AtomUI.js' */        }
/*Line 252 - 'AtomUI.js' */    },

/*Line 254 - 'AtomUI.js' */    isWebkit: function () {
/*Line 255 - 'AtomUI.js' */        if (window.navigator.userAgent.toLowerCase().indexOf("webkit") == -1)
/*Line 256 - 'AtomUI.js' */            return false;
/*Line 257 - 'AtomUI.js' */        return true;
/*Line 258 - 'AtomUI.js' */    },

/*Line 260 - 'AtomUI.js' */    isWeirdControl: function (e) {
/*Line 261 - 'AtomUI.js' */        return e.nodeName == "BUTTON" || e.nodeName == "SELECT" || (e.nodeName == "INPUT" && $(e).attr("type") == "submit");
/*Line 262 - 'AtomUI.js' */    },

/*Line 264 - 'AtomUI.js' */    parseCSS: function (e, a) {
/*Line 265 - 'AtomUI.js' */        var p = parseInt($(e).css(a), 10);
/*Line 266 - 'AtomUI.js' */        if (isNaN(p))
/*Line 267 - 'AtomUI.js' */            return 0;
/*Line 268 - 'AtomUI.js' */        return p;
/*Line 269 - 'AtomUI.js' */    },

/*Line 271 - 'AtomUI.js' */    setItemRect: function (e, r) {

/*Line 273 - 'AtomUI.js' */        var isButton = this.isWeirdControl(e);

/*Line 275 - 'AtomUI.js' */        if (r.width) {
/*Line 276 - 'AtomUI.js' */            r.width -= this.parseCSS(e, "marginLeft") + this.parseCSS(e, "marginRight");
/*Line 277 - 'AtomUI.js' */            if (!isButton) {
/*Line 278 - 'AtomUI.js' */                r.width -= this.parseCSS(e, "borderLeftWidth") + this.parseCSS(e, "borderRightWidth");
/*Line 279 - 'AtomUI.js' */                r.width -= this.parseCSS(e, "paddingLeft") + this.parseCSS(e, "paddingRight");
/*Line 280 - 'AtomUI.js' */            }
/*Line 281 - 'AtomUI.js' */            if (r.width < 0)
/*Line 282 - 'AtomUI.js' */                r.width = 0;
/*Line 283 - 'AtomUI.js' */            e.style.width = r.width + "px";
/*Line 284 - 'AtomUI.js' */        }
/*Line 285 - 'AtomUI.js' */        if (r.height) {
/*Line 286 - 'AtomUI.js' */            //r.height -= $(e).outerWidth(true) - $(e).width();
/*Line 287 - 'AtomUI.js' */            r.height -= this.parseCSS(e, "marginTop") + this.parseCSS(e, "marginBottom");
/*Line 288 - 'AtomUI.js' */            if (!isButton) {
/*Line 289 - 'AtomUI.js' */                r.height -= this.parseCSS(e, "borderTopWidth") + this.parseCSS(e, "borderBottomWidth");
/*Line 290 - 'AtomUI.js' */                r.height -= this.parseCSS(e, "paddingTop") + this.parseCSS(e, "paddingBottom");
/*Line 291 - 'AtomUI.js' */            }
/*Line 292 - 'AtomUI.js' */            if (r.height < 0)
/*Line 293 - 'AtomUI.js' */                r.height = 0;
/*Line 294 - 'AtomUI.js' */            e.style.height = r.height + "px";
/*Line 295 - 'AtomUI.js' */        }
/*Line 296 - 'AtomUI.js' */        if (r.left) {
/*Line 297 - 'AtomUI.js' */            e.style.left = r.left + "px";
/*Line 298 - 'AtomUI.js' */        }
/*Line 299 - 'AtomUI.js' */        if (r.top) {
/*Line 300 - 'AtomUI.js' */            e.style.top = r.top + "px";
/*Line 301 - 'AtomUI.js' */        }
/*Line 302 - 'AtomUI.js' */    },

/*Line 304 - 'AtomUI.js' */    getPresenterOwner: function (ctrl, p) {
/*Line 305 - 'AtomUI.js' */        if (ctrl._presenters) {
/*Line 306 - 'AtomUI.js' */            var ae = new AtomEnumerator(ctrl._presenters);
/*Line 307 - 'AtomUI.js' */            while (ae.next()) {
/*Line 308 - 'AtomUI.js' */                var c = ae.current();
/*Line 309 - 'AtomUI.js' */                if (c == p)
/*Line 310 - 'AtomUI.js' */                    return ctrl;
/*Line 311 - 'AtomUI.js' */            }
/*Line 312 - 'AtomUI.js' */        }
/*Line 313 - 'AtomUI.js' */        return this.getPresenterOwner(ctrl.get_atomParent(), p);
/*Line 314 - 'AtomUI.js' */    },

/*Line 316 - 'AtomUI.js' */    createCss: function (o) {
/*Line 317 - 'AtomUI.js' */        if (!o)
/*Line 318 - 'AtomUI.js' */            return "";
/*Line 319 - 'AtomUI.js' */        if (o.constructor == String)
/*Line 320 - 'AtomUI.js' */            return o;
/*Line 321 - 'AtomUI.js' */        var list = [];
/*Line 322 - 'AtomUI.js' */        for (var k in o) {
/*Line 323 - 'AtomUI.js' */            var v = o[k];
/*Line 324 - 'AtomUI.js' */            if (!v)
/*Line 325 - 'AtomUI.js' */                continue;
/*Line 326 - 'AtomUI.js' */            list.push(k);
/*Line 327 - 'AtomUI.js' */        }
/*Line 328 - 'AtomUI.js' */        return list.join(" ");
/*Line 329 - 'AtomUI.js' */    },

/*Line 331 - 'AtomUI.js' */    createControl: function (element, type, data, newScope) {
/*Line 332 - 'AtomUI.js' */        if (element.atomControl)
/*Line 333 - 'AtomUI.js' */            return;
/*Line 334 - 'AtomUI.js' */        if (!type) {
/*Line 335 - 'AtomUI.js' */            type = $(element).attr("atom-type");
/*Line 336 - 'AtomUI.js' */            type = WebAtoms[type];
/*Line 337 - 'AtomUI.js' */        } else {
/*Line 338 - 'AtomUI.js' */            if (type.constructor == String) {
/*Line 339 - 'AtomUI.js' */                type = WebAtoms[type];
/*Line 340 - 'AtomUI.js' */            }
/*Line 341 - 'AtomUI.js' */        }
/*Line 342 - 'AtomUI.js' */        if (type) {
/*Line 343 - 'AtomUI.js' */            var ctrl = new type(element);
/*Line 344 - 'AtomUI.js' */            if (data) {
/*Line 345 - 'AtomUI.js' */                ctrl._data = data;
/*Line 346 - 'AtomUI.js' */            }
/*Line 347 - 'AtomUI.js' */            if (newScope) {
/*Line 348 - 'AtomUI.js' */                ctrl._scope = newScope;
/*Line 349 - 'AtomUI.js' */            }

/*Line 351 - 'AtomUI.js' */            //initializes templates..
/*Line 352 - 'AtomUI.js' */            //ctrl.prepareControl();

/*Line 354 - 'AtomUI.js' */            //initialize templates and creates controls...
/*Line 355 - 'AtomUI.js' */            ctrl.createChildren();

/*Line 357 - 'AtomUI.js' */            if (data) {
/*Line 358 - 'AtomUI.js' */                ctrl.initialize();
/*Line 359 - 'AtomUI.js' */            }
/*Line 360 - 'AtomUI.js' */            //$(element).removeAttr("atom-type");
/*Line 361 - 'AtomUI.js' */            return ctrl;
/*Line 362 - 'AtomUI.js' */        }
/*Line 363 - 'AtomUI.js' */        return null;
/*Line 364 - 'AtomUI.js' */    }

/*Line 366 - 'AtomUI.js' */};

/*Line 368 - 'AtomUI.js' */window.AtomUI = AtomUI;

/*Line 370 - 'AtomUI.js' */AtomUI.isIE7 = window.navigator.userAgent.indexOf("MSIE 7.0") != -1;
/*Line 371 - 'AtomUI.js' */AtomUI.isIE8 = window.navigator.userAgent.indexOf("MSIE 8.0") != -1;
/*Line 0 - 'AtomBindingHelper.js' */


/*Line 3 - 'AtomBindingHelper.js' */var AtomBinder = {
/*Line 4 - 'AtomBindingHelper.js' */    getClone: function (dupeObj) {
/*Line 5 - 'AtomBindingHelper.js' */        var retObj = {};
/*Line 6 - 'AtomBindingHelper.js' */        if (typeof (dupeObj) == 'object') {
/*Line 7 - 'AtomBindingHelper.js' */            if (typeof (dupeObj.length) != 'undefined')
/*Line 8 - 'AtomBindingHelper.js' */                var retObj = new Array();
/*Line 9 - 'AtomBindingHelper.js' */            for (var objInd in dupeObj) {
/*Line 10 - 'AtomBindingHelper.js' */                var val = dupeObj[objInd];
/*Line 11 - 'AtomBindingHelper.js' */                if (val === undefined)
/*Line 12 - 'AtomBindingHelper.js' */                    continue;
/*Line 13 - 'AtomBindingHelper.js' */                if (val === null) {
/*Line 14 - 'AtomBindingHelper.js' */                    retObj[objInd] = null;
/*Line 15 - 'AtomBindingHelper.js' */                    continue;
/*Line 16 - 'AtomBindingHelper.js' */                }
/*Line 17 - 'AtomBindingHelper.js' */                if (/^\_\$\_/gi.test(objInd))
/*Line 18 - 'AtomBindingHelper.js' */                    continue;
/*Line 19 - 'AtomBindingHelper.js' */                var type = typeof (val);
/*Line 20 - 'AtomBindingHelper.js' */                if (type == 'object') {
/*Line 21 - 'AtomBindingHelper.js' */                    if (val.constructor == Date) {
/*Line 22 - 'AtomBindingHelper.js' */                        retObj[objInd] = "/DateISO(" + AtomDate.toLocalTime(val) + ")/";
/*Line 23 - 'AtomBindingHelper.js' */                    } else {
/*Line 24 - 'AtomBindingHelper.js' */                        retObj[objInd] = AtomBinder.getClone(val);
/*Line 25 - 'AtomBindingHelper.js' */                    }
/*Line 26 - 'AtomBindingHelper.js' */                } else if (type == 'string') {
/*Line 27 - 'AtomBindingHelper.js' */                    retObj[objInd] = val;
/*Line 28 - 'AtomBindingHelper.js' */                } else if (type == 'number') {
/*Line 29 - 'AtomBindingHelper.js' */                    retObj[objInd] = val;
/*Line 30 - 'AtomBindingHelper.js' */                } else if (type == 'boolean') {
/*Line 31 - 'AtomBindingHelper.js' */                    ((val == true) ? retObj[objInd] = true : retObj[objInd] = false);
/*Line 32 - 'AtomBindingHelper.js' */                } else if (type == 'date') {
/*Line 33 - 'AtomBindingHelper.js' */                    retObj[objInd] = val.getTime();
/*Line 34 - 'AtomBindingHelper.js' */                }
/*Line 35 - 'AtomBindingHelper.js' */            }
/*Line 36 - 'AtomBindingHelper.js' */        }
/*Line 37 - 'AtomBindingHelper.js' */        return retObj;
/*Line 38 - 'AtomBindingHelper.js' */    },
/*Line 39 - 'AtomBindingHelper.js' */    setValue: function (target, key, value) {
/*Line 40 - 'AtomBindingHelper.js' */        if (!target && value === undefined)
/*Line 41 - 'AtomBindingHelper.js' */            return;
/*Line 42 - 'AtomBindingHelper.js' */        var oldValue = AtomBinder.getValue(target, key);
/*Line 43 - 'AtomBindingHelper.js' */        if (oldValue === value)
/*Line 44 - 'AtomBindingHelper.js' */            return;
/*Line 45 - 'AtomBindingHelper.js' */        var f = target["set_" + key];
/*Line 46 - 'AtomBindingHelper.js' */        if (f) {
/*Line 47 - 'AtomBindingHelper.js' */            f.apply(target, [value]);
/*Line 48 - 'AtomBindingHelper.js' */        }
/*Line 49 - 'AtomBindingHelper.js' */        else {
/*Line 50 - 'AtomBindingHelper.js' */            target[key] = value;
/*Line 51 - 'AtomBindingHelper.js' */        }
/*Line 52 - 'AtomBindingHelper.js' */        AtomBinder.refreshValue(target, key, oldValue, value);
/*Line 53 - 'AtomBindingHelper.js' */    },
/*Line 54 - 'AtomBindingHelper.js' */    refreshValue: function (target, key) {
/*Line 55 - 'AtomBindingHelper.js' */        var handlers = AtomBinder.get_WatchHandler(target, key);
/*Line 56 - 'AtomBindingHelper.js' */        if (handlers == undefined || handlers == null)
/*Line 57 - 'AtomBindingHelper.js' */            return;
/*Line 58 - 'AtomBindingHelper.js' */        var ae = new AtomEnumerator(handlers);
/*Line 59 - 'AtomBindingHelper.js' */        while (ae.next()) {
/*Line 60 - 'AtomBindingHelper.js' */            var item = ae.current();
/*Line 61 - 'AtomBindingHelper.js' */            item(target, key);
/*Line 62 - 'AtomBindingHelper.js' */        }

/*Line 64 - 'AtomBindingHelper.js' */        if (target._$_watcher) {
/*Line 65 - 'AtomBindingHelper.js' */            target._$_watcher._onRefreshValue(target, key);
/*Line 66 - 'AtomBindingHelper.js' */        }
/*Line 67 - 'AtomBindingHelper.js' */    },
/*Line 68 - 'AtomBindingHelper.js' */    getValue: function (target, key) {
/*Line 69 - 'AtomBindingHelper.js' */        if (target == null)
/*Line 70 - 'AtomBindingHelper.js' */            return null;
/*Line 71 - 'AtomBindingHelper.js' */        var f = target["get_" + key];
/*Line 72 - 'AtomBindingHelper.js' */        if (f) {
/*Line 73 - 'AtomBindingHelper.js' */            return f.apply(target);
/*Line 74 - 'AtomBindingHelper.js' */        }
/*Line 75 - 'AtomBindingHelper.js' */        return target[key];
/*Line 76 - 'AtomBindingHelper.js' */    },
/*Line 77 - 'AtomBindingHelper.js' */    add_WatchHandler: function (target, key, handler) {
/*Line 78 - 'AtomBindingHelper.js' */        if (target == null)
/*Line 79 - 'AtomBindingHelper.js' */            return;
/*Line 80 - 'AtomBindingHelper.js' */        var handlers = AtomBinder.get_WatchHandler(target, key);
/*Line 81 - 'AtomBindingHelper.js' */        handlers.push(handler);
/*Line 82 - 'AtomBindingHelper.js' */    },
/*Line 83 - 'AtomBindingHelper.js' */    get_WatchHandler: function (target, key) {
/*Line 84 - 'AtomBindingHelper.js' */        if (target == null)
/*Line 85 - 'AtomBindingHelper.js' */            return null;
/*Line 86 - 'AtomBindingHelper.js' */        var handlers = target._$_handlers;
/*Line 87 - 'AtomBindingHelper.js' */        if (!handlers) {
/*Line 88 - 'AtomBindingHelper.js' */            handlers = {};
/*Line 89 - 'AtomBindingHelper.js' */            target._$_handlers = handlers;
/*Line 90 - 'AtomBindingHelper.js' */        }
/*Line 91 - 'AtomBindingHelper.js' */        var handlersForKey = handlers[key];
/*Line 92 - 'AtomBindingHelper.js' */        if (handlersForKey == undefined || handlersForKey == null) {
/*Line 93 - 'AtomBindingHelper.js' */            handlersForKey = [];
/*Line 94 - 'AtomBindingHelper.js' */            handlers[key] = handlersForKey;
/*Line 95 - 'AtomBindingHelper.js' */        }
/*Line 96 - 'AtomBindingHelper.js' */        return handlersForKey;
/*Line 97 - 'AtomBindingHelper.js' */    },
/*Line 98 - 'AtomBindingHelper.js' */    remove_WatchHandler: function (target, key, handler) {
/*Line 99 - 'AtomBindingHelper.js' */        if (target == null)
/*Line 100 - 'AtomBindingHelper.js' */            return;
/*Line 101 - 'AtomBindingHelper.js' */        if (target._$_handlers === undefined || target._$_handlers === null)
/*Line 102 - 'AtomBindingHelper.js' */            return;
/*Line 103 - 'AtomBindingHelper.js' */        var handlersForKey = target._$_handlers[key];
/*Line 104 - 'AtomBindingHelper.js' */        if (handlersForKey == undefined || handlersForKey == null)
/*Line 105 - 'AtomBindingHelper.js' */            return;
/*Line 106 - 'AtomBindingHelper.js' */        var ae = new AtomEnumerator(handlersForKey);
/*Line 107 - 'AtomBindingHelper.js' */        while (ae.next()) {
/*Line 108 - 'AtomBindingHelper.js' */            if (ae.current() == handler) {
/*Line 109 - 'AtomBindingHelper.js' */                handlersForKey.splice(ae.currentIndex(), 1);
/*Line 110 - 'AtomBindingHelper.js' */                return;
/*Line 111 - 'AtomBindingHelper.js' */            }
/*Line 112 - 'AtomBindingHelper.js' */        }
/*Line 113 - 'AtomBindingHelper.js' */    },

/*Line 115 - 'AtomBindingHelper.js' */    invokeItemsEvent: function (target, mode, index, item) {
/*Line 116 - 'AtomBindingHelper.js' */        var key = "_items";
/*Line 117 - 'AtomBindingHelper.js' */        var handlers = AtomBinder.get_WatchHandler(target, key);
/*Line 118 - 'AtomBindingHelper.js' */        if (!handlers)
/*Line 119 - 'AtomBindingHelper.js' */            return;
/*Line 120 - 'AtomBindingHelper.js' */        var ae = new AtomEnumerator(handlers);
/*Line 121 - 'AtomBindingHelper.js' */        while (ae.next()) {
/*Line 122 - 'AtomBindingHelper.js' */            var obj = ae.current();
/*Line 123 - 'AtomBindingHelper.js' */            obj(mode, index, item);
/*Line 124 - 'AtomBindingHelper.js' */        }
/*Line 125 - 'AtomBindingHelper.js' */        if (target._$_watcher) {
/*Line 126 - 'AtomBindingHelper.js' */            target._$_watcher._onRefreshItems(target, mode, index, item);
/*Line 127 - 'AtomBindingHelper.js' */        }
/*Line 128 - 'AtomBindingHelper.js' */        AtomBinder.refreshValue(target, "length");
/*Line 129 - 'AtomBindingHelper.js' */    },
/*Line 130 - 'AtomBindingHelper.js' */    clear: function (ary) {
/*Line 131 - 'AtomBindingHelper.js' */        ary.length = 0;
/*Line 132 - 'AtomBindingHelper.js' */        AtomBinder.invokeItemsEvent(ary, "refresh", 0, null);
/*Line 133 - 'AtomBindingHelper.js' */    },
/*Line 134 - 'AtomBindingHelper.js' */    addItem: function (ary, item) {
/*Line 135 - 'AtomBindingHelper.js' */        var l = ary.length;
/*Line 136 - 'AtomBindingHelper.js' */        ary.push(item);
/*Line 137 - 'AtomBindingHelper.js' */        AtomBinder.invokeItemsEvent(ary, "add", l, item);
/*Line 138 - 'AtomBindingHelper.js' */    },
/*Line 139 - 'AtomBindingHelper.js' */    insertItem: function (ary, index, item) {
/*Line 140 - 'AtomBindingHelper.js' */        ary.splice(index, 0, item);
/*Line 141 - 'AtomBindingHelper.js' */        AtomBinder.invokeItemsEvent(ary, "add", index, item);
/*Line 142 - 'AtomBindingHelper.js' */    },
/*Line 143 - 'AtomBindingHelper.js' */    addItems: function (ary, items) {
/*Line 144 - 'AtomBindingHelper.js' */        var ae = new AtomEnumerator(items);
/*Line 145 - 'AtomBindingHelper.js' */        while (ae.next()) {
/*Line 146 - 'AtomBindingHelper.js' */            AtomBinder.addItem(ary, ae.current());
/*Line 147 - 'AtomBindingHelper.js' */        }
/*Line 148 - 'AtomBindingHelper.js' */    },
/*Line 149 - 'AtomBindingHelper.js' */    removeItem: function (ary, item) {
/*Line 150 - 'AtomBindingHelper.js' */        var i = ary.indexOf(item);
/*Line 151 - 'AtomBindingHelper.js' */        if (i == -1)
/*Line 152 - 'AtomBindingHelper.js' */            return;
/*Line 153 - 'AtomBindingHelper.js' */        ary.splice(i, 1);
/*Line 154 - 'AtomBindingHelper.js' */        AtomBinder.invokeItemsEvent(ary, "remove", i, item);
/*Line 155 - 'AtomBindingHelper.js' */    },
/*Line 156 - 'AtomBindingHelper.js' */    removeAtIndex: function (ary, i) {
/*Line 157 - 'AtomBindingHelper.js' */        if (i == -1)
/*Line 158 - 'AtomBindingHelper.js' */            return;
/*Line 159 - 'AtomBindingHelper.js' */        var item = ary[i];
/*Line 160 - 'AtomBindingHelper.js' */        ary.splice(i, 1);
/*Line 161 - 'AtomBindingHelper.js' */        AtomBinder.invokeItemsEvent(ary, "remove", i, item);
/*Line 162 - 'AtomBindingHelper.js' */    },
/*Line 163 - 'AtomBindingHelper.js' */    refreshItems: function (ary) {
/*Line 164 - 'AtomBindingHelper.js' */        AtomBinder.invokeItemsEvent(ary, "refresh", -1, null);
/*Line 165 - 'AtomBindingHelper.js' */    },
/*Line 166 - 'AtomBindingHelper.js' */    add_CollectionChanged: function (target, handler) {
/*Line 167 - 'AtomBindingHelper.js' */        if (target == null)
/*Line 168 - 'AtomBindingHelper.js' */            return;
/*Line 169 - 'AtomBindingHelper.js' */        var key = "_items";
/*Line 170 - 'AtomBindingHelper.js' */        var handlers = AtomBinder.get_WatchHandler(target, key);
/*Line 171 - 'AtomBindingHelper.js' */        handlers.push(handler);
/*Line 172 - 'AtomBindingHelper.js' */    },
/*Line 173 - 'AtomBindingHelper.js' */    remove_CollectionChanged: function (target, handler) {
/*Line 174 - 'AtomBindingHelper.js' */        if (target == null)
/*Line 175 - 'AtomBindingHelper.js' */            return;
/*Line 176 - 'AtomBindingHelper.js' */        if (!target._$_handlers)
/*Line 177 - 'AtomBindingHelper.js' */            return;
/*Line 178 - 'AtomBindingHelper.js' */        var key = "_items";
/*Line 179 - 'AtomBindingHelper.js' */        var handlersForKey = target._$_handlers[key];
/*Line 180 - 'AtomBindingHelper.js' */        if (handlersForKey == undefined || handlersForKey == null)
/*Line 181 - 'AtomBindingHelper.js' */            return;
/*Line 182 - 'AtomBindingHelper.js' */        var ae = new AtomEnumerator(handlersForKey);
/*Line 183 - 'AtomBindingHelper.js' */        while (ae.next()) {
/*Line 184 - 'AtomBindingHelper.js' */            if (ae.current() == handler) {
/*Line 185 - 'AtomBindingHelper.js' */                handlersForKey.splice(ae.currentIndex(), 1);
/*Line 186 - 'AtomBindingHelper.js' */                return;
/*Line 187 - 'AtomBindingHelper.js' */            }
/*Line 188 - 'AtomBindingHelper.js' */        }
/*Line 189 - 'AtomBindingHelper.js' */    },
/*Line 190 - 'AtomBindingHelper.js' */    setError: function (target, key, message) {
/*Line 191 - 'AtomBindingHelper.js' */        var errors = AtomBinder.getValue(target, "__errors");
/*Line 192 - 'AtomBindingHelper.js' */        if (!errors) {
/*Line 193 - 'AtomBindingHelper.js' */            AtomBinder.setValue(target, "__errors", {});
/*Line 194 - 'AtomBindingHelper.js' */        }
/*Line 195 - 'AtomBindingHelper.js' */        AtomBinder.setValue(errors, key, message);
/*Line 196 - 'AtomBindingHelper.js' */    }

/*Line 198 - 'AtomBindingHelper.js' */};

/*Line 200 - 'AtomBindingHelper.js' */window.AtomBinder = AtomBinder;

/*Line 202 - 'AtomBindingHelper.js' */Atom.clone = AtomBinder.getClone;
/*Line 203 - 'AtomBindingHelper.js' */Atom.add = AtomBinder.addItem;
/*Line 204 - 'AtomBindingHelper.js' */Atom.insert = AtomBinder.insertItem;
/*Line 205 - 'AtomBindingHelper.js' */Atom.remove = AtomBinder.removeItem;
/*Line 206 - 'AtomBindingHelper.js' */Atom.refresh = AtomBinder.refreshValue;
/*Line 207 - 'AtomBindingHelper.js' */Atom.refreshArray = AtomBinder.refreshItems;
/*Line 208 - 'AtomBindingHelper.js' */Atom.clearArray = AtomBinder.clear;
/*Line 0 - 'WebAtoms.Core.js' */
/*Line 1 - 'WebAtoms.Core.js' */
/*Line 2 - 'WebAtoms.Core.js' */
/*Line 3 - 'WebAtoms.Core.js' */
/*Line 4 - 'WebAtoms.Core.js' */
/*Line 5 - 'WebAtoms.Core.js' */
/*Line 6 - 'WebAtoms.Core.js' */
/*Line 7 - 'WebAtoms.Core.js' */
/*Line 8 - 'WebAtoms.Core.js' */
/*Line 9 - 'WebAtoms.Core.js' */
/*Line 10 - 'WebAtoms.Core.js' */

/*Line 12 - 'WebAtoms.Core.js' */Array.prototype.enumerator = function () {
/*Line 13 - 'WebAtoms.Core.js' */    return new AtomEnumerator(this);
/*Line 14 - 'WebAtoms.Core.js' */};

/*Line 16 - 'WebAtoms.Core.js' */if (!Array.prototype.indexOf) {
/*Line 17 - 'WebAtoms.Core.js' */    Array.prototype.indexOf = function (item) {
/*Line 18 - 'WebAtoms.Core.js' */        var i = 0;
/*Line 19 - 'WebAtoms.Core.js' */        for (i = 0; i < this.length; i++) {
/*Line 20 - 'WebAtoms.Core.js' */            if (item == this[i])
/*Line 21 - 'WebAtoms.Core.js' */                return i;
/*Line 22 - 'WebAtoms.Core.js' */        }
/*Line 23 - 'WebAtoms.Core.js' */        return -1;
/*Line 24 - 'WebAtoms.Core.js' */    };
/*Line 25 - 'WebAtoms.Core.js' */}

/*Line 27 - 'WebAtoms.Core.js' */var AtomArray = {

/*Line 29 - 'WebAtoms.Core.js' */    split: function (text, sep) {
/*Line 30 - 'WebAtoms.Core.js' */        if (sep && sep.constructor == String) {
/*Line 31 - 'WebAtoms.Core.js' */            sep = $.trim(sep);
/*Line 32 - 'WebAtoms.Core.js' */        }
/*Line 33 - 'WebAtoms.Core.js' */        var ar = text.split(sep);
/*Line 34 - 'WebAtoms.Core.js' */        var r = [];
/*Line 35 - 'WebAtoms.Core.js' */        var ae = new AtomEnumerator(ar);
/*Line 36 - 'WebAtoms.Core.js' */        var item;
/*Line 37 - 'WebAtoms.Core.js' */        while (ae.next()) {
/*Line 38 - 'WebAtoms.Core.js' */            item = ae.current();
/*Line 39 - 'WebAtoms.Core.js' */            if (item && item.constructor == String) {
/*Line 40 - 'WebAtoms.Core.js' */                item = $.trim(item);
/*Line 41 - 'WebAtoms.Core.js' */            }
/*Line 42 - 'WebAtoms.Core.js' */            r.push(item);
/*Line 43 - 'WebAtoms.Core.js' */        }
/*Line 44 - 'WebAtoms.Core.js' */        return r;
/*Line 45 - 'WebAtoms.Core.js' */    },

/*Line 47 - 'WebAtoms.Core.js' */    getValues: function (array, path) {
/*Line 48 - 'WebAtoms.Core.js' */        var item;
/*Line 49 - 'WebAtoms.Core.js' */        var result = array;
/*Line 50 - 'WebAtoms.Core.js' */        if (path) {
/*Line 51 - 'WebAtoms.Core.js' */            result = [];
/*Line 52 - 'WebAtoms.Core.js' */            var ae = new AtomEnumerator(array);
/*Line 53 - 'WebAtoms.Core.js' */            while (ae.next()) {
/*Line 54 - 'WebAtoms.Core.js' */                item = ae.current();
/*Line 55 - 'WebAtoms.Core.js' */                result.push(item[path]);
/*Line 56 - 'WebAtoms.Core.js' */            }
/*Line 57 - 'WebAtoms.Core.js' */        }
/*Line 58 - 'WebAtoms.Core.js' */        return result;
/*Line 59 - 'WebAtoms.Core.js' */    },

/*Line 61 - 'WebAtoms.Core.js' */    intersect: function (array, path, value) {
/*Line 62 - 'WebAtoms.Core.js' */        var result = [];
/*Line 63 - 'WebAtoms.Core.js' */        var ae = new AtomEnumerator(value);
/*Line 64 - 'WebAtoms.Core.js' */        var item;
/*Line 65 - 'WebAtoms.Core.js' */        var match;
/*Line 66 - 'WebAtoms.Core.js' */        while (ae.next()) {
/*Line 67 - 'WebAtoms.Core.js' */            item = ae.current();
/*Line 68 - 'WebAtoms.Core.js' */            match = this.getMatch(array, path, item);
/*Line 69 - 'WebAtoms.Core.js' */            if (match != undefined)
/*Line 70 - 'WebAtoms.Core.js' */                result.push(match);
/*Line 71 - 'WebAtoms.Core.js' */        }
/*Line 72 - 'WebAtoms.Core.js' */        return result;
/*Line 73 - 'WebAtoms.Core.js' */    },

/*Line 75 - 'WebAtoms.Core.js' */    getMatch: function (array, path, value) {
/*Line 76 - 'WebAtoms.Core.js' */        var ae = new AtomEnumerator(array);
/*Line 77 - 'WebAtoms.Core.js' */        var dataItem;
/*Line 78 - 'WebAtoms.Core.js' */        var item;
/*Line 79 - 'WebAtoms.Core.js' */        while (ae.next()) {
/*Line 80 - 'WebAtoms.Core.js' */            dataItem = ae.current();
/*Line 81 - 'WebAtoms.Core.js' */            item = dataItem;
/*Line 82 - 'WebAtoms.Core.js' */            if (path)
/*Line 83 - 'WebAtoms.Core.js' */                item = dataItem[path];
/*Line 84 - 'WebAtoms.Core.js' */            if (item == value)
/*Line 85 - 'WebAtoms.Core.js' */                return dataItem;
/*Line 86 - 'WebAtoms.Core.js' */        }
/*Line 87 - 'WebAtoms.Core.js' */    },

/*Line 89 - 'WebAtoms.Core.js' */    remove: function (array, item) {
/*Line 90 - 'WebAtoms.Core.js' */        var ae = new AtomEnumerator(array);
/*Line 91 - 'WebAtoms.Core.js' */        while (ae.next()) {
/*Line 92 - 'WebAtoms.Core.js' */            var arrayItem = ae.current();
/*Line 93 - 'WebAtoms.Core.js' */            if (arrayItem == item) {
/*Line 94 - 'WebAtoms.Core.js' */                array.splice(ae.currentIndex(), 1);
/*Line 95 - 'WebAtoms.Core.js' */                return;
/*Line 96 - 'WebAtoms.Core.js' */            }
/*Line 97 - 'WebAtoms.Core.js' */        }
/*Line 98 - 'WebAtoms.Core.js' */    }
/*Line 99 - 'WebAtoms.Core.js' */};

/*Line 101 - 'WebAtoms.Core.js' */window.AtomArray = AtomArray;

/*Line 103 - 'WebAtoms.Core.js' *///Creating AtomScope Class
/*Line 104 - 'WebAtoms.Core.js' */var AtomScope = (function (window,name, base) {
/*Line 105 - 'WebAtoms.Core.js' */    return classCreator(name, base,
/*Line 106 - 'WebAtoms.Core.js' */        function (owner,parent,app) {
/*Line 107 - 'WebAtoms.Core.js' */            this.owner = owner;
/*Line 108 - 'WebAtoms.Core.js' */            this.parent = parent;
/*Line 109 - 'WebAtoms.Core.js' */            if (app) {
/*Line 110 - 'WebAtoms.Core.js' */                this.__application = app;
/*Line 111 - 'WebAtoms.Core.js' */            }
/*Line 112 - 'WebAtoms.Core.js' */            if (this.__application == this.owner) {
/*Line 113 - 'WebAtoms.Core.js' */                //this._$_watcher = this.__application;
/*Line 114 - 'WebAtoms.Core.js' */                this._v = 0;
/*Line 115 - 'WebAtoms.Core.js' */                this.refreshCommand = function () {
/*Line 116 - 'WebAtoms.Core.js' */                    appScope._v = appScope._v + 1;
/*Line 117 - 'WebAtoms.Core.js' */                    AtomBinder.refreshValue(appScope, "_v");
/*Line 118 - 'WebAtoms.Core.js' */                };
/*Line 119 - 'WebAtoms.Core.js' */            }
/*Line 120 - 'WebAtoms.Core.js' */            this._refreshValue = function (name) {
/*Line 121 - 'WebAtoms.Core.js' */                AtomBinder.refreshValue(this, name);
/*Line 122 - 'WebAtoms.Core.js' */                if (this.__application === this.owner) {
/*Line 123 - 'WebAtoms.Core.js' */                    this.__application._onRefreshValue(this, name);
/*Line 124 - 'WebAtoms.Core.js' */                }
/*Line 125 - 'WebAtoms.Core.js' */            };

/*Line 127 - 'WebAtoms.Core.js' */        },
/*Line 128 - 'WebAtoms.Core.js' */        {
/*Line 129 - 'WebAtoms.Core.js' */            setValue: function (name, value, forceRefresh) {
/*Line 130 - 'WebAtoms.Core.js' */                if (AtomBinder.getValue(this, name) == value) {
/*Line 131 - 'WebAtoms.Core.js' */                    if (forceRefresh) {
/*Line 132 - 'WebAtoms.Core.js' */                        this._refreshValue(name);
/*Line 133 - 'WebAtoms.Core.js' */                    }
/*Line 134 - 'WebAtoms.Core.js' */                    return;
/*Line 135 - 'WebAtoms.Core.js' */                }
/*Line 136 - 'WebAtoms.Core.js' */                var f = this["set_" + name];
/*Line 137 - 'WebAtoms.Core.js' */                if (f) {
/*Line 138 - 'WebAtoms.Core.js' */                    f.apply(this, [value]);
/*Line 139 - 'WebAtoms.Core.js' */                } else {
/*Line 140 - 'WebAtoms.Core.js' */                    this[name] = value;
/*Line 141 - 'WebAtoms.Core.js' */                }
/*Line 142 - 'WebAtoms.Core.js' */                this._refreshValue(name);
/*Line 143 - 'WebAtoms.Core.js' */            }
/*Line 144 - 'WebAtoms.Core.js' */        });
/*Line 145 - 'WebAtoms.Core.js' */})(window,"WebAtoms.AtomScope", null);
/*Line 0 - 'AtomPromise.js' */


/*Line 3 - 'AtomPromise.js' */var AtomPromise = function () {

/*Line 5 - 'AtomPromise.js' */    this._success = [];
/*Line 6 - 'AtomPromise.js' */    this._failed = [];
/*Line 7 - 'AtomPromise.js' */    this._cached = false;

/*Line 9 - 'AtomPromise.js' */    this._process = null;

/*Line 11 - 'AtomPromise.js' */    this._calls = 0;

/*Line 13 - 'AtomPromise.js' */    this._showProgress = true;
/*Line 14 - 'AtomPromise.js' */    this._showError = true;
/*Line 15 - 'AtomPromise.js' */    var _this = this;
/*Line 16 - 'AtomPromise.js' */    this.success = function () {
/*Line 17 - 'AtomPromise.js' */        _this.onSuccess.apply(_this, arguments);
/*Line 18 - 'AtomPromise.js' */    };

/*Line 20 - 'AtomPromise.js' */    this.error = function () {
/*Line 21 - 'AtomPromise.js' */        _this.onError.apply(_this, arguments);
/*Line 22 - 'AtomPromise.js' */    };
/*Line 23 - 'AtomPromise.js' */}

/*Line 25 - 'AtomPromise.js' */window.AtomPromise = AtomPromise;

/*Line 27 - 'AtomPromise.js' */AtomPromise.prototype = {

/*Line 29 - 'AtomPromise.js' */    onSuccess: function (c) {
/*Line 30 - 'AtomPromise.js' */        this._value = c;
/*Line 31 - 'AtomPromise.js' */        if (this._process) {
/*Line 32 - 'AtomPromise.js' */            this._value = this._process(this._value);
/*Line 33 - 'AtomPromise.js' */        }
/*Line 34 - 'AtomPromise.js' */        var r = this._success;
/*Line 35 - 'AtomPromise.js' */        for (var i = 0; i < r.length ; i++) {
/*Line 36 - 'AtomPromise.js' */            r[i](this);
/*Line 37 - 'AtomPromise.js' */        }
/*Line 38 - 'AtomPromise.js' */    },

/*Line 40 - 'AtomPromise.js' */    onError: function () {
/*Line 41 - 'AtomPromise.js' */        this.errors = arguments;
/*Line 42 - 'AtomPromise.js' */        var r = this._failed;
/*Line 43 - 'AtomPromise.js' */        for (var i = 0; i < r.length; i++) {
/*Line 44 - 'AtomPromise.js' */            r[i](this);
/*Line 45 - 'AtomPromise.js' */        }
/*Line 46 - 'AtomPromise.js' */    },

/*Line 48 - 'AtomPromise.js' */    then: function (t) {
/*Line 49 - 'AtomPromise.js' */        this._success.push(t);
/*Line 50 - 'AtomPromise.js' */        return this;
/*Line 51 - 'AtomPromise.js' */    },

/*Line 53 - 'AtomPromise.js' */    process: function (f) {
/*Line 54 - 'AtomPromise.js' */        this._process = f;
/*Line 55 - 'AtomPromise.js' */        return this;
/*Line 56 - 'AtomPromise.js' */    },

/*Line 58 - 'AtomPromise.js' */    failed: function (f) {
/*Line 59 - 'AtomPromise.js' */        this._failed.push(f);
/*Line 60 - 'AtomPromise.js' */        return this;
/*Line 61 - 'AtomPromise.js' */    },

/*Line 63 - 'AtomPromise.js' */    value: function (v) {

/*Line 65 - 'AtomPromise.js' */        if (v !== undefined) {
/*Line 66 - 'AtomPromise.js' */            this._value = v;
/*Line 67 - 'AtomPromise.js' */            return;
/*Line 68 - 'AtomPromise.js' */        }
/*Line 69 - 'AtomPromise.js' */        return this._value;
/*Line 70 - 'AtomPromise.js' */    },

/*Line 72 - 'AtomPromise.js' */    onInvoke: function (r) {
/*Line 73 - 'AtomPromise.js' */        this._invoke = r;
/*Line 74 - 'AtomPromise.js' */        return this;
/*Line 75 - 'AtomPromise.js' */    },

/*Line 77 - 'AtomPromise.js' */    invoke: function () {
/*Line 78 - 'AtomPromise.js' */        if (!this._persist) {
/*Line 79 - 'AtomPromise.js' */            this.invokePromise();
/*Line 80 - 'AtomPromise.js' */            return this;
/*Line 81 - 'AtomPromise.js' */        }
/*Line 82 - 'AtomPromise.js' */        var _this = this;
/*Line 83 - 'AtomPromise.js' */        this.promiseTimeout = setTimeout(function () {
/*Line 84 - 'AtomPromise.js' */            _this.invokePromise();
/*Line 85 - 'AtomPromise.js' */        }, 100);
/*Line 86 - 'AtomPromise.js' */        return this;
/*Line 87 - 'AtomPromise.js' */    },

/*Line 89 - 'AtomPromise.js' */    invokePromise: function () {
/*Line 90 - 'AtomPromise.js' */        this.promiseTimeout = null;
/*Line 91 - 'AtomPromise.js' */        if (this._showProgress) {
/*Line 92 - 'AtomPromise.js' */            atomApplication.setBusy(true);
/*Line 93 - 'AtomPromise.js' */            if (this._calls == 0) {
/*Line 94 - 'AtomPromise.js' */                var f = function () {
/*Line 95 - 'AtomPromise.js' */                    atomApplication.setBusy(false);
/*Line 96 - 'AtomPromise.js' */                };
/*Line 97 - 'AtomPromise.js' */                this.then(f);
/*Line 98 - 'AtomPromise.js' */                this.failed(f);
/*Line 99 - 'AtomPromise.js' */            }
/*Line 100 - 'AtomPromise.js' */        }
/*Line 101 - 'AtomPromise.js' */        this._calls++;
/*Line 102 - 'AtomPromise.js' */        this._invoke(this);
/*Line 103 - 'AtomPromise.js' */        return this;
/*Line 104 - 'AtomPromise.js' */    },

/*Line 106 - 'AtomPromise.js' */    pushValue: function (v) {
/*Line 107 - 'AtomPromise.js' */        var _this = this;
/*Line 108 - 'AtomPromise.js' */        this._cached = true;
/*Line 109 - 'AtomPromise.js' */        setTimeout(function () {
/*Line 110 - 'AtomPromise.js' */            _this.onSuccess.apply(_this, [v]);
/*Line 111 - 'AtomPromise.js' */        }, 1);
/*Line 112 - 'AtomPromise.js' */    },


/*Line 115 - 'AtomPromise.js' */    showProgress: function (b) {
/*Line 116 - 'AtomPromise.js' */        this._showProgress = b;
/*Line 117 - 'AtomPromise.js' */        return this;
/*Line 118 - 'AtomPromise.js' */    },

/*Line 120 - 'AtomPromise.js' */    showError: function (b) {
/*Line 121 - 'AtomPromise.js' */        this._showError = b;
/*Line 122 - 'AtomPromise.js' */        return this;
/*Line 123 - 'AtomPromise.js' */    },

/*Line 125 - 'AtomPromise.js' */    persist: function (v) {
/*Line 126 - 'AtomPromise.js' */        if (v === undefined)
/*Line 127 - 'AtomPromise.js' */            this._persist = true;
/*Line 128 - 'AtomPromise.js' */        else
/*Line 129 - 'AtomPromise.js' */            this._persist = v;
/*Line 130 - 'AtomPromise.js' */        return this;
/*Line 131 - 'AtomPromise.js' */    },

/*Line 133 - 'AtomPromise.js' */    abort: function () {
/*Line 134 - 'AtomPromise.js' */        if (this.promiseTimeout) {
/*Line 135 - 'AtomPromise.js' */            clearTimeout(this.promiseTimeout);
/*Line 136 - 'AtomPromise.js' */            this.promiseTimeout = null;
/*Line 137 - 'AtomPromise.js' */            return;
/*Line 138 - 'AtomPromise.js' */        }
/*Line 139 - 'AtomPromise.js' */        this._failed.length = 0;
/*Line 140 - 'AtomPromise.js' */        this._success.length = 0;
/*Line 141 - 'AtomPromise.js' */        if (this._showProgress) {
/*Line 142 - 'AtomPromise.js' */            atomApplication.setBusy(false);
/*Line 143 - 'AtomPromise.js' */        }
/*Line 144 - 'AtomPromise.js' */        if (this.handle) {
/*Line 145 - 'AtomPromise.js' */            this.handle.abort();
/*Line 146 - 'AtomPromise.js' */        }
/*Line 147 - 'AtomPromise.js' */    }

/*Line 149 - 'AtomPromise.js' */};

/*Line 151 - 'AtomPromise.js' */AtomPromise.getUrl = function (url) {
/*Line 152 - 'AtomPromise.js' */    var pageUrl = location.href;
/*Line 153 - 'AtomPromise.js' */    var index = pageUrl.indexOf('#');
/*Line 154 - 'AtomPromise.js' */    if (index != -1)
/*Line 155 - 'AtomPromise.js' */        pageUrl = pageUrl.substr(0, index);
/*Line 156 - 'AtomPromise.js' */    if (url) {
/*Line 157 - 'AtomPromise.js' */        index = pageUrl.lastIndexOf('/');
/*Line 158 - 'AtomPromise.js' */        if (index != -1) {
/*Line 159 - 'AtomPromise.js' */            pageUrl = pageUrl.substr(0, index + 1);
/*Line 160 - 'AtomPromise.js' */        }


/*Line 163 - 'AtomPromise.js' */        //if (AtomUI.startsWith(url, "http://") || AtomUI.startsWith(url, "https://")) {
/*Line 164 - 'AtomPromise.js' */        //    return url;
/*Line 165 - 'AtomPromise.js' */        //}
/*Line 166 - 'AtomPromise.js' */        if (/^(http|https)\:\/\//gi.test(url)) {
/*Line 167 - 'AtomPromise.js' */            return url;
/*Line 168 - 'AtomPromise.js' */        }
/*Line 169 - 'AtomPromise.js' */        if (/^\//gi.test(url)) {
/*Line 170 - 'AtomPromise.js' */            return url;
/*Line 171 - 'AtomPromise.js' */        }
/*Line 172 - 'AtomPromise.js' */        if (/^\./gi.test(url)) {
/*Line 173 - 'AtomPromise.js' */            url = url.substr(1);
/*Line 174 - 'AtomPromise.js' */            //if (AtomUI.endsWith(pageUrl, "/") && AtomUI.startsWith(url, "/")) {
/*Line 175 - 'AtomPromise.js' */            //    url = url.substr(1);
/*Line 176 - 'AtomPromise.js' */            //}
/*Line 177 - 'AtomPromise.js' */            if (/\/$/gi.test(pageUrl) && /^\//gi.test(url)) {
/*Line 178 - 'AtomPromise.js' */                url = url.substr(1);
/*Line 179 - 'AtomPromise.js' */            }
/*Line 180 - 'AtomPromise.js' */            return pageUrl + url;
/*Line 181 - 'AtomPromise.js' */        }
/*Line 182 - 'AtomPromise.js' */        return pageUrl + url;
/*Line 183 - 'AtomPromise.js' */    } else {
/*Line 184 - 'AtomPromise.js' */        return pageUrl;
/*Line 185 - 'AtomPromise.js' */    }
/*Line 186 - 'AtomPromise.js' */};

/*Line 188 - 'AtomPromise.js' */AtomPromise.ajax = function (url, query, options, type) {
/*Line 189 - 'AtomPromise.js' */    var p = new AtomPromise();

/*Line 191 - 'AtomPromise.js' */    if (!options) {
/*Line 192 - 'AtomPromise.js' */        options = {
/*Line 193 - 'AtomPromise.js' */            type: "GET",
/*Line 194 - 'AtomPromise.js' */            dataType: "text",
/*Line 195 - 'AtomPromise.js' */            data: null
/*Line 196 - 'AtomPromise.js' */        };
/*Line 197 - 'AtomPromise.js' */    }

/*Line 199 - 'AtomPromise.js' */    if (AtomConfig.ajax.versionUrl)
/*Line 200 - 'AtomPromise.js' */    {
/*Line 201 - 'AtomPromise.js' */        if (options.versionUrl !== undefined && options.versionUrl) {
/*Line 202 - 'AtomPromise.js' */            query = query || {};
/*Line 203 - 'AtomPromise.js' */            query[AtomConfig.ajax.versionKey] = AtomConfig.ajax.version;
/*Line 204 - 'AtomPromise.js' */        }
/*Line 205 - 'AtomPromise.js' */    }


/*Line 208 - 'AtomPromise.js' */    options.success = p.success;
/*Line 209 - 'AtomPromise.js' */    options.error = p.error;

/*Line 211 - 'AtomPromise.js' */    // caching is disabled by default...
/*Line 212 - 'AtomPromise.js' */    if (options.cache === undefined) {
/*Line 213 - 'AtomPromise.js' */        options.cache = false;

/*Line 215 - 'AtomPromise.js' */    }


/*Line 218 - 'AtomPromise.js' */    var u = url;

/*Line 220 - 'AtomPromise.js' */    var dh = AtomConfig.ajax.headers;
/*Line 221 - 'AtomPromise.js' */    if (dh) {
/*Line 222 - 'AtomPromise.js' */        if (!options.headers) {
/*Line 223 - 'AtomPromise.js' */            options.headers = {};
/*Line 224 - 'AtomPromise.js' */        }
/*Line 225 - 'AtomPromise.js' */        for (var k in dh) {
/*Line 226 - 'AtomPromise.js' */            var v = dh[k];
/*Line 227 - 'AtomPromise.js' */            options.headers[k] = v;
/*Line 228 - 'AtomPromise.js' */            if (AtomConfig.debug) {
/*Line 229 - 'AtomPromise.js' */                log("Header set: " + k + "=" + v);
/*Line 230 - 'AtomPromise.js' */            }
/*Line 231 - 'AtomPromise.js' */        }
/*Line 232 - 'AtomPromise.js' */    }


/*Line 235 - 'AtomPromise.js' */    var sc = AtomConfig.ajax.statusCode;
/*Line 236 - 'AtomPromise.js' */    if (sc) {
/*Line 237 - 'AtomPromise.js' */        var osc = options.statusCode || {};
/*Line 238 - 'AtomPromise.js' */        for (var k in sc) {
/*Line 239 - 'AtomPromise.js' */            var v = sc[k];
/*Line 240 - 'AtomPromise.js' */            if (!osc[k]) {
/*Line 241 - 'AtomPromise.js' */                osc[k] = v;
/*Line 242 - 'AtomPromise.js' */            }
/*Line 243 - 'AtomPromise.js' */        }
/*Line 244 - 'AtomPromise.js' */        options.statusCode = osc;
/*Line 245 - 'AtomPromise.js' */    }

/*Line 247 - 'AtomPromise.js' */    var o = options;

/*Line 249 - 'AtomPromise.js' */    var data = o.data;

/*Line 251 - 'AtomPromise.js' */    if (data) {
/*Line 252 - 'AtomPromise.js' */        data = AtomBinder.getClone(data);
/*Line 253 - 'AtomPromise.js' */        var e = AtomConfig.ajax.jsonPostEncode;
/*Line 254 - 'AtomPromise.js' */        if (e) {
/*Line 255 - 'AtomPromise.js' */            data = e(data);
/*Line 256 - 'AtomPromise.js' */        } else {
/*Line 257 - 'AtomPromise.js' */            data = { formModel: JSON.stringify(data) };
/*Line 258 - 'AtomPromise.js' */        }
/*Line 259 - 'AtomPromise.js' */        o.data = data;
/*Line 260 - 'AtomPromise.js' */    }

/*Line 262 - 'AtomPromise.js' */    var attachments = o.attachments;
/*Line 263 - 'AtomPromise.js' */    if (attachments && attachments.length) {
/*Line 264 - 'AtomPromise.js' */        var fd = new FormData();
/*Line 265 - 'AtomPromise.js' */        var ae = new AtomEnumerator(attachments);
/*Line 266 - 'AtomPromise.js' */        while (ae.next()) {
/*Line 267 - 'AtomPromise.js' */            fd.append("file" + ae.currentIndex(), ae.current());
/*Line 268 - 'AtomPromise.js' */        }
/*Line 269 - 'AtomPromise.js' */        if (data) {
/*Line 270 - 'AtomPromise.js' */            for (var k in data) {
/*Line 271 - 'AtomPromise.js' */                fd.append(k, data[k]);
/*Line 272 - 'AtomPromise.js' */            }
/*Line 273 - 'AtomPromise.js' */        }
/*Line 274 - 'AtomPromise.js' */        o.type = "POST";
/*Line 275 - 'AtomPromise.js' */        o.xhr = function () {
/*Line 276 - 'AtomPromise.js' */            var myXhr = $.ajaxSettings.xhr();
/*Line 277 - 'AtomPromise.js' */            if (myXhr.upload) {
/*Line 278 - 'AtomPromise.js' */                myXhr.upload.addEventListener('progress', function (e) {
/*Line 279 - 'AtomPromise.js' */                    if (e.lengthComputable) {
/*Line 280 - 'AtomPromise.js' */                        var percentComplete = Math.round(e.loaded * 100 / e.total);
/*Line 281 - 'AtomPromise.js' */                        AtomBinder.setValue(atomApplication, 'progress', percentComplete);
/*Line 282 - 'AtomPromise.js' */                    }
/*Line 283 - 'AtomPromise.js' */                }, false);
/*Line 284 - 'AtomPromise.js' */            }
/*Line 285 - 'AtomPromise.js' */            return myXhr;
/*Line 286 - 'AtomPromise.js' */        };
/*Line 287 - 'AtomPromise.js' */        o.cache = false;
/*Line 288 - 'AtomPromise.js' */        o.contentType = false;
/*Line 289 - 'AtomPromise.js' */        o.processData = false;
/*Line 290 - 'AtomPromise.js' */    }

/*Line 292 - 'AtomPromise.js' */    if (query) {
/*Line 293 - 'AtomPromise.js' */        var q = {};
/*Line 294 - 'AtomPromise.js' */        if (!o.sendRawQueryString) {
/*Line 295 - 'AtomPromise.js' */            for (var k in query) {
/*Line 296 - 'AtomPromise.js' */                var v = query[k];
/*Line 297 - 'AtomPromise.js' */                if (v && ((typeof v) == "object")) {
/*Line 298 - 'AtomPromise.js' */                    v = JSON.stringify(AtomBinder.getClone(v));
/*Line 299 - 'AtomPromise.js' */                    if (v === undefined)
/*Line 300 - 'AtomPromise.js' */                        continue;
/*Line 301 - 'AtomPromise.js' */                    if (v === null)
/*Line 302 - 'AtomPromise.js' */                        continue;
/*Line 303 - 'AtomPromise.js' */                }
/*Line 304 - 'AtomPromise.js' */                q[k] = v;
/*Line 305 - 'AtomPromise.js' */            }
/*Line 306 - 'AtomPromise.js' */        }
/*Line 307 - 'AtomPromise.js' */        u = Atom.url(url, q);
/*Line 308 - 'AtomPromise.js' */    }

/*Line 310 - 'AtomPromise.js' */    if (url) {
/*Line 311 - 'AtomPromise.js' */        p.onInvoke(function () {
/*Line 312 - 'AtomPromise.js' */            p.handle = $.ajax(u, o);
/*Line 313 - 'AtomPromise.js' */        });
/*Line 314 - 'AtomPromise.js' */    }

/*Line 316 - 'AtomPromise.js' */    p.failed(function () {

/*Line 318 - 'AtomPromise.js' */        var res = p.errors[0].responseText;
/*Line 319 - 'AtomPromise.js' */        if (!res || p.errors[2] != 'Internal Server Error') {
/*Line 320 - 'AtomPromise.js' */            res = p.errors[2];
/*Line 321 - 'AtomPromise.js' */        }

/*Line 323 - 'AtomPromise.js' */        p.error = {
/*Line 324 - 'AtomPromise.js' */            msg : res
/*Line 325 - 'AtomPromise.js' */        };

/*Line 327 - 'AtomPromise.js' */        if (p._showError) {
/*Line 328 - 'AtomPromise.js' */            if (p.error.msg) alert(p.error.msg);
/*Line 329 - 'AtomPromise.js' */        }
/*Line 330 - 'AtomPromise.js' */    });

/*Line 332 - 'AtomPromise.js' */    p.then(function (p) {
/*Line 333 - 'AtomPromise.js' */        var v = p.value();
/*Line 334 - 'AtomPromise.js' */        if (v && v.items && v.merge) {
/*Line 335 - 'AtomPromise.js' */            v.items.total = v.total;
/*Line 336 - 'AtomPromise.js' */            v = v.items;
/*Line 337 - 'AtomPromise.js' */            p.value(v);
/*Line 338 - 'AtomPromise.js' */        }
/*Line 339 - 'AtomPromise.js' */    });

/*Line 341 - 'AtomPromise.js' */    p.showError(true);
/*Line 342 - 'AtomPromise.js' */    p.showProgress(true);

/*Line 344 - 'AtomPromise.js' */    return p;
/*Line 345 - 'AtomPromise.js' */};

/*Line 347 - 'AtomPromise.js' */AtomPromise.get = function (url, query, options) {
/*Line 348 - 'AtomPromise.js' */    options = options || {};
/*Line 349 - 'AtomPromise.js' */    options.type = options.type || "get";
/*Line 350 - 'AtomPromise.js' */    options.dataType = options.dataType || "text";
/*Line 351 - 'AtomPromise.js' */    return AtomPromise.ajax(url, query, options, "get");
/*Line 352 - 'AtomPromise.js' */};

/*Line 354 - 'AtomPromise.js' */AtomPromise.json = function (url, query, options) {
/*Line 355 - 'AtomPromise.js' */    options = options || {};
/*Line 356 - 'AtomPromise.js' */    options.type = options.type || "get";
/*Line 357 - 'AtomPromise.js' */    options.dataType = options.dataType || "json";
/*Line 358 - 'AtomPromise.js' */    return AtomPromise.ajax(url, query, options, "json");
/*Line 359 - 'AtomPromise.js' */};

/*Line 361 - 'AtomPromise.js' */AtomPromise.cache = {
/*Line 362 - 'AtomPromise.js' */};

/*Line 364 - 'AtomPromise.js' */AtomPromise.cacheInProgress = {
/*Line 365 - 'AtomPromise.js' */};

/*Line 367 - 'AtomPromise.js' */AtomPromise.cachedPromise = function (key, p) {
/*Line 368 - 'AtomPromise.js' */    var c = AtomPromise.cache[key];

/*Line 370 - 'AtomPromise.js' */    if (!c && window.sessionStorage) {
/*Line 371 - 'AtomPromise.js' */        c = window.sessionStorage["__AP" + key];
/*Line 372 - 'AtomPromise.js' */        if (c) {
/*Line 373 - 'AtomPromise.js' */            c = JSON.parse(c);
/*Line 374 - 'AtomPromise.js' */            AtomPromise.cache[key] = c;
/*Line 375 - 'AtomPromise.js' */        }
/*Line 376 - 'AtomPromise.js' */    }

/*Line 378 - 'AtomPromise.js' */    if (c) {
/*Line 379 - 'AtomPromise.js' */        p.onInvoke(function () {
/*Line 380 - 'AtomPromise.js' */            p.pushValue(c);
/*Line 381 - 'AtomPromise.js' */        });
/*Line 382 - 'AtomPromise.js' */        return p;
/*Line 383 - 'AtomPromise.js' */    }

/*Line 385 - 'AtomPromise.js' */    p.then(function (p1) {
/*Line 386 - 'AtomPromise.js' */        AtomPromise.cache[key] = p1.value();
/*Line 387 - 'AtomPromise.js' */        if (window.sessionStorage) {
/*Line 388 - 'AtomPromise.js' */            window.sessionStorage["__AP" + key] = JSON.stringify( p1.value() );
/*Line 389 - 'AtomPromise.js' */        }
/*Line 390 - 'AtomPromise.js' */    });

/*Line 392 - 'AtomPromise.js' */    return p;
/*Line 393 - 'AtomPromise.js' */};

/*Line 395 - 'AtomPromise.js' */AtomPromise.cachedJson = function (url, query, options) {

/*Line 397 - 'AtomPromise.js' */    var vd = new Date();

/*Line 399 - 'AtomPromise.js' */    var v = AtomConfig.ajax.version;
/*Line 400 - 'AtomPromise.js' */    var vk = AtomConfig.ajax.versionKey + '=' + v;

/*Line 402 - 'AtomPromise.js' */    if (url.indexOf('?') == -1) {
/*Line 403 - 'AtomPromise.js' */        vk = '?' + vk;
/*Line 404 - 'AtomPromise.js' */    } else {
/*Line 405 - 'AtomPromise.js' */        if (!/\&$/.test(url)) {
/*Line 406 - 'AtomPromise.js' */            vk = '&' + vk;
/*Line 407 - 'AtomPromise.js' */        }
/*Line 408 - 'AtomPromise.js' */    }
/*Line 409 - 'AtomPromise.js' */    url += vk;

/*Line 411 - 'AtomPromise.js' */    options = options || {};
/*Line 412 - 'AtomPromise.js' */    // caching must be true everywhere
/*Line 413 - 'AtomPromise.js' */    options.cache = true;
/*Line 414 - 'AtomPromise.js' */    options.ifModified = true;
/*Line 415 - 'AtomPromise.js' */    options.versionUrl = false;

/*Line 417 - 'AtomPromise.js' */    var ap = AtomPromise.ajax(url, query, options, "json");
/*Line 418 - 'AtomPromise.js' */    return AtomPromise.cachedPromise(url, ap);
/*Line 419 - 'AtomPromise.js' */};

/*Line 421 - 'AtomPromise.js' */AtomPromise.configCache = {};

/*Line 423 - 'AtomPromise.js' */AtomPromise.configLabel = function (url, value, options) {

/*Line 425 - 'AtomPromise.js' */    if (value === null || value === undefined)
/*Line 426 - 'AtomPromise.js' */        return "";

/*Line 428 - 'AtomPromise.js' */    options = options || {};

/*Line 430 - 'AtomPromise.js' */    var valuePath = options.valuePath || "value";
/*Line 431 - 'AtomPromise.js' */    var labelPath = options.labelPath || "label";
/*Line 432 - 'AtomPromise.js' */    var isNumber = options.isNumber || false;

/*Line 434 - 'AtomPromise.js' */    if (isNumber) {
/*Line 435 - 'AtomPromise.js' */        if (typeof value !== "number") {
/*Line 436 - 'AtomPromise.js' */            value = parseFloat(value);
/*Line 437 - 'AtomPromise.js' */        }
/*Line 438 - 'AtomPromise.js' */    }

/*Line 440 - 'AtomPromise.js' */    var p = new AtomPromise();
/*Line 441 - 'AtomPromise.js' */    p.onInvoke(function () {

/*Line 443 - 'AtomPromise.js' */        var cf = AtomPromise.configCache[url];
/*Line 444 - 'AtomPromise.js' */        if (cf) {
/*Line 445 - 'AtomPromise.js' */            cf = cf[value];
/*Line 446 - 'AtomPromise.js' */            cf = cf ? cf[labelPath] : "";
/*Line 447 - 'AtomPromise.js' */            p.pushValue(cf);
/*Line 448 - 'AtomPromise.js' */            return;
/*Line 449 - 'AtomPromise.js' */        }

/*Line 451 - 'AtomPromise.js' */        var ap = AtomPromise.cachedJson(url);


/*Line 454 - 'AtomPromise.js' */        ap.then(function (a) {
/*Line 455 - 'AtomPromise.js' */            var v = "";

/*Line 457 - 'AtomPromise.js' */            var nv = {};

/*Line 459 - 'AtomPromise.js' */            var ae = new AtomEnumerator(a.value());
/*Line 460 - 'AtomPromise.js' */            while (ae.next()) {
/*Line 461 - 'AtomPromise.js' */                var item = ae.current();
/*Line 462 - 'AtomPromise.js' */                v = item[valuePath];
/*Line 463 - 'AtomPromise.js' */                if (isNumber) {
/*Line 464 - 'AtomPromise.js' */                    if (typeof v !== "number") {
/*Line 465 - 'AtomPromise.js' */                        v = parseFloat(v);
/*Line 466 - 'AtomPromise.js' */                    }
/*Line 467 - 'AtomPromise.js' */                }
/*Line 468 - 'AtomPromise.js' */                nv[v] = item;
/*Line 469 - 'AtomPromise.js' */            }
/*Line 470 - 'AtomPromise.js' */            AtomPromise.configCache[url] = nv;
/*Line 471 - 'AtomPromise.js' */            nv = nv[value];
/*Line 472 - 'AtomPromise.js' */            nv = nv ? nv[labelPath] : "";
/*Line 473 - 'AtomPromise.js' */            p.pushValue(nv);
/*Line 474 - 'AtomPromise.js' */        });

/*Line 476 - 'AtomPromise.js' */        ap.invoke();
/*Line 477 - 'AtomPromise.js' */    });

/*Line 479 - 'AtomPromise.js' */    return p;
/*Line 480 - 'AtomPromise.js' */};

/*Line 482 - 'AtomPromise.js' */AtomPromise.prototype.insertItem = function (index, item, arrayPath) {
/*Line 483 - 'AtomPromise.js' */    return this.then(function (p) {
/*Line 484 - 'AtomPromise.js' */        var v = p.value();
/*Line 485 - 'AtomPromise.js' */        if (v._$_itemInserted)
/*Line 486 - 'AtomPromise.js' */            return;
/*Line 487 - 'AtomPromise.js' */        if (arrayPath) {
/*Line 488 - 'AtomPromise.js' */            v = v[arrayPath];
/*Line 489 - 'AtomPromise.js' */        }
/*Line 490 - 'AtomPromise.js' */        if (index == -1) {
/*Line 491 - 'AtomPromise.js' */            v.push(item);
/*Line 492 - 'AtomPromise.js' */        } else {
/*Line 493 - 'AtomPromise.js' */            v.splice(index || 0, 0, item);
/*Line 494 - 'AtomPromise.js' */        }
/*Line 495 - 'AtomPromise.js' */        v._$_itemInserted = true;        
/*Line 496 - 'AtomPromise.js' */    });
/*Line 497 - 'AtomPromise.js' */};
/*Line 498 - 'AtomPromise.js' *///$setValue = AtomBinder.setValue;
/*Line 499 - 'AtomPromise.js' *///$getValue = AtomBinder.getValue;


/*Line 502 - 'AtomPromise.js' *///Object.prototype.setValue = function (key, value) {
/*Line 503 - 'AtomPromise.js' *///    
/*Line 504 - 'AtomPromise.js' *///    AtomBinder.setValue(this, key, value);
/*Line 505 - 'AtomPromise.js' *///};

/*Line 507 - 'AtomPromise.js' *///Object.prototype.getValue = function (key) {
/*Line 508 - 'AtomPromise.js' *///    return AtomBinder.getValue(this, key);
/*Line 509 - 'AtomPromise.js' *///};

/*Line 511 - 'AtomPromise.js' *///Object.prototype.add_WatchHandler = function(key,handler){
/*Line 512 - 'AtomPromise.js' *///    AtomBinder.add_WatchHandler(this,key,handler);
/*Line 513 - 'AtomPromise.js' *///};

/*Line 515 - 'AtomPromise.js' *///Object.prototype.remove_WatchHandler = function(key,handler){
/*Line 516 - 'AtomPromise.js' *///    AtomBinder.remove_WatchHandler(this,key,handler);
/*Line 517 - 'AtomPromise.js' *///};

/*Line 519 - 'AtomPromise.js' *///Array.prototype.add = function (item) {
/*Line 520 - 'AtomPromise.js' *///    AtomBinder.addItem(this, item);
/*Line 521 - 'AtomPromise.js' *///};

/*Line 523 - 'AtomPromise.js' *///Array.prototype.remove = function (item) {
/*Line 524 - 'AtomPromise.js' *///    AtomBinder.removeItem(this, item);
/*Line 525 - 'AtomPromise.js' *///};

/*Line 527 - 'AtomPromise.js' *///Array.prototype.add_CollectionHandler= function(handler){
/*Line 528 - 'AtomPromise.js' *///    AtomBinder.add_CollectionHandler(this,handler);
/*Line 529 - 'AtomPromise.js' *///};

/*Line 531 - 'AtomPromise.js' *///Array.prototype.remove_CollectionHandler= function(handler){
/*Line 532 - 'AtomPromise.js' *///    AtomBinder.remove_CollectionHandler(this,handler);
/*Line 533 - 'AtomPromise.js' *///};

/*Line 0 - 'AtomComponent.js' */
/*Line 1 - 'AtomComponent.js' */
/*Line 2 - 'AtomComponent.js' */

/*Line 4 - 'AtomComponent.js' */(function(window,name,base){
/*Line 5 - 'AtomComponent.js' */    return classCreator(name,base,
/*Line 6 - 'AtomComponent.js' */        function () {
/*Line 7 - 'AtomComponent.js' */            this._eventHandlers = [];
/*Line 8 - 'AtomComponent.js' */        },
/*Line 9 - 'AtomComponent.js' */        {
/*Line 10 - 'AtomComponent.js' */            bindEvent: function (element, name, methodName, key, method) {
/*Line 11 - 'AtomComponent.js' */                if (element == null)
/*Line 12 - 'AtomComponent.js' */                    return;
/*Line 13 - 'AtomComponent.js' */                if (typeof methodName == 'function') {
/*Line 14 - 'AtomComponent.js' */                    method = methodName;
/*Line 15 - 'AtomComponent.js' */                }
/*Line 16 - 'AtomComponent.js' */                method = method || AtomUI.createDelegate(this, methodName);
/*Line 17 - 'AtomComponent.js' */                var be = {
/*Line 18 - 'AtomComponent.js' */                    element: element,
/*Line 19 - 'AtomComponent.js' */                    name: name,
/*Line 20 - 'AtomComponent.js' */                    methodName: methodName,
/*Line 21 - 'AtomComponent.js' */                    handler: method
/*Line 22 - 'AtomComponent.js' */                };
/*Line 23 - 'AtomComponent.js' */                if (key) {
/*Line 24 - 'AtomComponent.js' */                    be.key = key;
/*Line 25 - 'AtomComponent.js' */                }
/*Line 26 - 'AtomComponent.js' */                if (AtomUI.isNode(element)) {
/*Line 27 - 'AtomComponent.js' */                    $(element).bind(name, null, method);
/*Line 28 - 'AtomComponent.js' */                } else {
/*Line 29 - 'AtomComponent.js' */                    if (element.addEventListener) {
/*Line 30 - 'AtomComponent.js' */                        element.addEventListener(name, method, false);
/*Line 31 - 'AtomComponent.js' */                    } else {
/*Line 32 - 'AtomComponent.js' */                        var f = element["add_" + name];
/*Line 33 - 'AtomComponent.js' */                        if (f == null) {
/*Line 34 - 'AtomComponent.js' */                            // try atom binder...
/*Line 35 - 'AtomComponent.js' */                            f = AtomBinder["add_" + name];
/*Line 36 - 'AtomComponent.js' */                            if (key) {
/*Line 37 - 'AtomComponent.js' */                                f.apply(AtomBinder, [element, key, method]);
/*Line 38 - 'AtomComponent.js' */                            }
/*Line 39 - 'AtomComponent.js' */                            else {
/*Line 40 - 'AtomComponent.js' */                                f.apply(AtomBinder, [element, method]);
/*Line 41 - 'AtomComponent.js' */                            }
/*Line 42 - 'AtomComponent.js' */                        } else {
/*Line 43 - 'AtomComponent.js' */                            f.apply(element, [method]);
/*Line 44 - 'AtomComponent.js' */                        }
/*Line 45 - 'AtomComponent.js' */                    }
/*Line 46 - 'AtomComponent.js' */                }
/*Line 47 - 'AtomComponent.js' */                this._eventHandlers.push(be);
/*Line 48 - 'AtomComponent.js' */            },

/*Line 50 - 'AtomComponent.js' */            unbindEvent: function (element, name, methodName, key) {
/*Line 51 - 'AtomComponent.js' */                var ae = new AtomEnumerator(this._eventHandlers);
/*Line 52 - 'AtomComponent.js' */                var removed = [];
/*Line 53 - 'AtomComponent.js' */                while (ae.next()) {
/*Line 54 - 'AtomComponent.js' */                    var be = ae.current();
/*Line 55 - 'AtomComponent.js' */                    if (element && element !== be.element)
/*Line 56 - 'AtomComponent.js' */                        continue;
/*Line 57 - 'AtomComponent.js' */                    if (name && name !== be.name)
/*Line 58 - 'AtomComponent.js' */                        continue;
/*Line 59 - 'AtomComponent.js' */                    if (methodName && methodName !== be.methodName)
/*Line 60 - 'AtomComponent.js' */                        continue;
/*Line 61 - 'AtomComponent.js' */                    if (key && key !== be.key)
/*Line 62 - 'AtomComponent.js' */                        continue;
/*Line 63 - 'AtomComponent.js' */                    if (AtomUI.isNode(be.element)) {
/*Line 64 - 'AtomComponent.js' */                        $(be.element).unbind(be.name, be.handler);
/*Line 65 - 'AtomComponent.js' */                    } else {
/*Line 66 - 'AtomComponent.js' */                        if (be.element.removeEventListener) {
/*Line 67 - 'AtomComponent.js' */                            // dont do any thing..
/*Line 68 - 'AtomComponent.js' */                            be.element.removeEventListener(name, be.handler, false);
/*Line 69 - 'AtomComponent.js' */                        } else {
/*Line 70 - 'AtomComponent.js' */                            var f = be.element["remove_" + be.name];
/*Line 71 - 'AtomComponent.js' */                            if (f == null) {
/*Line 72 - 'AtomComponent.js' */                                f = AtomBinder["remove_" + be.name];
/*Line 73 - 'AtomComponent.js' */                                if (be.key) {
/*Line 74 - 'AtomComponent.js' */                                    f.apply(AtomBinder, [be.element, be.key, be.handler]);
/*Line 75 - 'AtomComponent.js' */                                }
/*Line 76 - 'AtomComponent.js' */                                else {
/*Line 77 - 'AtomComponent.js' */                                    f.apply(AtomBinder, [be.element, be.handler]);
/*Line 78 - 'AtomComponent.js' */                                }
/*Line 79 - 'AtomComponent.js' */                            } else {
/*Line 80 - 'AtomComponent.js' */                                f.apply(be.element, [be.handler]);
/*Line 81 - 'AtomComponent.js' */                            }
/*Line 82 - 'AtomComponent.js' */                        }
/*Line 83 - 'AtomComponent.js' */                    }
/*Line 84 - 'AtomComponent.js' */                    removed.push(be);
/*Line 85 - 'AtomComponent.js' */                }

/*Line 87 - 'AtomComponent.js' */                if (removed.length == this._eventHandlers.length) {
/*Line 88 - 'AtomComponent.js' */                    this._eventHandlers.length = 0;
/*Line 89 - 'AtomComponent.js' */                } else {
/*Line 90 - 'AtomComponent.js' */                    ae = new AtomEnumerator(removed);
/*Line 91 - 'AtomComponent.js' */                    while (ae.next()) {
/*Line 92 - 'AtomComponent.js' */                        var be = ae.current();
/*Line 93 - 'AtomComponent.js' */                        AtomArray.remove(this._eventHandlers, be);
/*Line 94 - 'AtomComponent.js' */                    }
/*Line 95 - 'AtomComponent.js' */                }
/*Line 96 - 'AtomComponent.js' */            },


/*Line 99 - 'AtomComponent.js' */            initialize: function () {
/*Line 100 - 'AtomComponent.js' */            },
/*Line 101 - 'AtomComponent.js' */            dispose: function () {
/*Line 102 - 'AtomComponent.js' */                // remove all event handlers...
/*Line 103 - 'AtomComponent.js' */                this.unbindEvent(null, null, null);

/*Line 105 - 'AtomComponent.js' */                // also remove __delegates..
/*Line 106 - 'AtomComponent.js' */                if (this.__delegates)
/*Line 107 - 'AtomComponent.js' */                    this.__delegates = null;
/*Line 108 - 'AtomComponent.js' */            }
/*Line 109 - 'AtomComponent.js' */        });
/*Line 110 - 'AtomComponent.js' */})(this,"WebAtoms.AtomComponent",null);
/*Line 0 - 'AtomBinding.js' */
/*Line 1 - 'AtomBinding.js' */

/*Line 3 - 'AtomBinding.js' */(function (window, baseType) {
/*Line 4 - 'AtomBinding.js' */    return classCreatorEx({
/*Line 5 - 'AtomBinding.js' */        name: "WebAtoms.AtomBinding",
/*Line 6 - 'AtomBinding.js' */        base: baseType,
/*Line 7 - 'AtomBinding.js' */        start: function (control, element, key, path, twoWays, jq, vf, events) {
/*Line 8 - 'AtomBinding.js' */            this.element = element;
/*Line 9 - 'AtomBinding.js' */            this.control = control;
/*Line 10 - 'AtomBinding.js' */            this.vf = vf;
/*Line 11 - 'AtomBinding.js' */            this.key = key;
/*Line 12 - 'AtomBinding.js' */            this.events = events;

/*Line 14 - 'AtomBinding.js' */            if (path && path.constructor != String) {
/*Line 15 - 'AtomBinding.js' */                this.pathList = [];
/*Line 16 - 'AtomBinding.js' */                this.path = null;

/*Line 18 - 'AtomBinding.js' */                var ae = new AtomEnumerator(path);
/*Line 19 - 'AtomBinding.js' */                while (ae.next()) {
/*Line 20 - 'AtomBinding.js' */                    var pe = new AtomEnumerator(ae.current().split("."));
/*Line 21 - 'AtomBinding.js' */                    var p = [];
/*Line 22 - 'AtomBinding.js' */                    while (pe.next()) {
/*Line 23 - 'AtomBinding.js' */                        p.push({ path: pe.current(), value: null });
/*Line 24 - 'AtomBinding.js' */                    }
/*Line 25 - 'AtomBinding.js' */                    this.pathList.push(p);
/*Line 26 - 'AtomBinding.js' */                }

/*Line 28 - 'AtomBinding.js' */            } else {
/*Line 29 - 'AtomBinding.js' */                var ae = new AtomEnumerator(path.split("."));
/*Line 30 - 'AtomBinding.js' */                this.path = [];
/*Line 31 - 'AtomBinding.js' */                while (ae.next()) {
/*Line 32 - 'AtomBinding.js' */                    this.path.push({ path: ae.current(), value: null });
/*Line 33 - 'AtomBinding.js' */                }
/*Line 34 - 'AtomBinding.js' */            }
/*Line 35 - 'AtomBinding.js' */            this.twoWays = twoWays;
/*Line 36 - 'AtomBinding.js' */            this.jq = jq;
/*Line 37 - 'AtomBinding.js' */            this._isUpdating = false;
/*Line 38 - 'AtomBinding.js' */        },
/*Line 39 - 'AtomBinding.js' */        methods: {
/*Line 40 - 'AtomBinding.js' */            onPropChanged: function (sender, key) {
/*Line 41 - 'AtomBinding.js' */                // update target....
/*Line 42 - 'AtomBinding.js' */                // most like end of path...
/*Line 43 - 'AtomBinding.js' */                if (this.path == null || this.path.length == 0)
/*Line 44 - 'AtomBinding.js' */                    return;
/*Line 45 - 'AtomBinding.js' */                var ae = new AtomEnumerator(this.path);
/*Line 46 - 'AtomBinding.js' */                var obj = this.control;
/*Line 47 - 'AtomBinding.js' */                var objKey = null;
/*Line 48 - 'AtomBinding.js' */                while (ae.next()) {
/*Line 49 - 'AtomBinding.js' */                    objKey = ae.current();
/*Line 50 - 'AtomBinding.js' */                    objKey.value = obj;
/*Line 51 - 'AtomBinding.js' */                    if (!obj)
/*Line 52 - 'AtomBinding.js' */                        return;
/*Line 53 - 'AtomBinding.js' */                    if (!ae.isLast())
/*Line 54 - 'AtomBinding.js' */                        obj = AtomBinder.getValue(obj, objKey.path);
/*Line 55 - 'AtomBinding.js' */                }
/*Line 56 - 'AtomBinding.js' */                var value = null;
/*Line 57 - 'AtomBinding.js' */                if (this.jq) {
/*Line 58 - 'AtomBinding.js' */                    switch (this.key) {
/*Line 59 - 'AtomBinding.js' */                        case "valueAsDate":
/*Line 60 - 'AtomBinding.js' */                            value = this.element.valueAsDate;
/*Line 61 - 'AtomBinding.js' */                            break;
/*Line 62 - 'AtomBinding.js' */                        case "checked":
/*Line 63 - 'AtomBinding.js' */                            value = this.element.checked ? true : false;
/*Line 64 - 'AtomBinding.js' */                            break;
/*Line 65 - 'AtomBinding.js' */                        default:
/*Line 66 - 'AtomBinding.js' */                            value = $(this.element).val();
/*Line 67 - 'AtomBinding.js' */                    }
/*Line 68 - 'AtomBinding.js' */                } else {
/*Line 69 - 'AtomBinding.js' */                    value = AtomBinder.getValue(this.control, this.key);
/*Line 70 - 'AtomBinding.js' */                }
/*Line 71 - 'AtomBinding.js' */                AtomBinder.setValue(obj, objKey.path, value);
/*Line 72 - 'AtomBinding.js' */            },
/*Line 73 - 'AtomBinding.js' */            onDataChanged: function (sender, key) {
/*Line 74 - 'AtomBinding.js' */                if (this._isUpdating)
/*Line 75 - 'AtomBinding.js' */                    return;

/*Line 77 - 'AtomBinding.js' */                // called by jquery while posting an ajax request...
/*Line 78 - 'AtomBinding.js' */                if (arguments === undefined || arguments.length == 0)
/*Line 79 - 'AtomBinding.js' */                    return;

/*Line 81 - 'AtomBinding.js' */                var ae;
/*Line 82 - 'AtomBinding.js' */                var target = this.control;
/*Line 83 - 'AtomBinding.js' */                if (this.pathList) {
/*Line 84 - 'AtomBinding.js' */                    var newTarget = [];
/*Line 85 - 'AtomBinding.js' */                    ae = new AtomEnumerator(this.pathList);
/*Line 86 - 'AtomBinding.js' */                    while (ae.next()) {
/*Line 87 - 'AtomBinding.js' */                        newTarget.push(this.evaluate(target, ae.current()));
/*Line 88 - 'AtomBinding.js' */                    }
/*Line 89 - 'AtomBinding.js' */                    ae = new AtomEnumerator(newTarget);
/*Line 90 - 'AtomBinding.js' */                    while (ae.next()) {
/*Line 91 - 'AtomBinding.js' */                        if (ae.current() === undefined)
/*Line 92 - 'AtomBinding.js' */                            return;
/*Line 93 - 'AtomBinding.js' */                    }
/*Line 94 - 'AtomBinding.js' */                    this.setValue(newTarget);
/*Line 95 - 'AtomBinding.js' */                } else {
/*Line 96 - 'AtomBinding.js' */                    var path = this.path;
/*Line 97 - 'AtomBinding.js' */                    var newTarget = this.evaluate(target, path);
/*Line 98 - 'AtomBinding.js' */                    if (newTarget !== undefined)
/*Line 99 - 'AtomBinding.js' */                        this.setValue(newTarget);
/*Line 100 - 'AtomBinding.js' */                }
/*Line 101 - 'AtomBinding.js' */            },

/*Line 103 - 'AtomBinding.js' */            evaluate: function (target, path) {
/*Line 104 - 'AtomBinding.js' */                var newTarget = null;
/*Line 105 - 'AtomBinding.js' */                var property = null;
/*Line 106 - 'AtomBinding.js' */                var ae = new AtomEnumerator(path);

/*Line 108 - 'AtomBinding.js' */                // first remove old handlers...
/*Line 109 - 'AtomBinding.js' */                var remove = false;
/*Line 110 - 'AtomBinding.js' */                while (target && ae.next()) {
/*Line 111 - 'AtomBinding.js' */                    property = ae.current();
/*Line 112 - 'AtomBinding.js' */                    newTarget = AtomBinder.getValue(target, property.path);

/*Line 114 - 'AtomBinding.js' */                    if (!(/scope|appScope|owner|atomParent|templateParent|localScope/gi.test(property.path))) {
/*Line 115 - 'AtomBinding.js' */                        var _this = this;
/*Line 116 - 'AtomBinding.js' */                        if (!property.value) {
/*Line 117 - 'AtomBinding.js' */                            this.bindEvent(target, "WatchHandler", "onDataChanged", property.path);
/*Line 118 - 'AtomBinding.js' */                            //this.bindEvent(target, "WatchHandler", function () {
/*Line 119 - 'AtomBinding.js' */                            //    _this.onDataChanged.apply(_this, arguments);
/*Line 120 - 'AtomBinding.js' */                            //}, property.path);
/*Line 121 - 'AtomBinding.js' */                        } else if (property.value != target) {
/*Line 122 - 'AtomBinding.js' */                            this.unbindEvent(property.value, "WatchHandler", null, property.path);
/*Line 123 - 'AtomBinding.js' */                            this.bindEvent(target, "WatchHandler", "onDataChanged", property.path);
/*Line 124 - 'AtomBinding.js' */                            //this.bindEvent(target, "WatchHandler", function () {
/*Line 125 - 'AtomBinding.js' */                            //    _this.onDataChanged.apply(_this, arguments);
/*Line 126 - 'AtomBinding.js' */                            //}, property.path);
/*Line 127 - 'AtomBinding.js' */                        }
/*Line 128 - 'AtomBinding.js' */                    }

/*Line 130 - 'AtomBinding.js' */                    property.value = target;
/*Line 131 - 'AtomBinding.js' */                    target = newTarget;
/*Line 132 - 'AtomBinding.js' */                }
/*Line 133 - 'AtomBinding.js' */                if (newTarget === undefined && AtomConfig.debug) {
/*Line 134 - 'AtomBinding.js' */                    log('Undefined:' + this.control._element.id + ' -> ' + ($.map(path, function (a) { return a.path; })).join('.'));
/*Line 135 - 'AtomBinding.js' */                }
/*Line 136 - 'AtomBinding.js' */                return newTarget;
/*Line 137 - 'AtomBinding.js' */            },

/*Line 139 - 'AtomBinding.js' */            onValChanged: function () {
/*Line 140 - 'AtomBinding.js' */                this.onPropChanged(null, null);
/*Line 141 - 'AtomBinding.js' */            },
/*Line 142 - 'AtomBinding.js' */            setup: function () {
/*Line 143 - 'AtomBinding.js' */                if (this.twoWays) {
/*Line 144 - 'AtomBinding.js' */                    if (this.jq) {
/*Line 145 - 'AtomBinding.js' */                        this.bindEvent(this.element, "change", "onValChanged");
/*Line 146 - 'AtomBinding.js' */                        if (this.events) {
/*Line 147 - 'AtomBinding.js' */                            var list = new AtomEnumerator(this.events.split(","));
/*Line 148 - 'AtomBinding.js' */                            while (list.next()) {
/*Line 149 - 'AtomBinding.js' */                                this.bindEvent(this.element, list.current(), "onValChanged");
/*Line 150 - 'AtomBinding.js' */                            }
/*Line 151 - 'AtomBinding.js' */                        }
/*Line 152 - 'AtomBinding.js' */                    } else {
/*Line 153 - 'AtomBinding.js' */                        this.bindEvent(this.control, "WatchHandler", "onPropChanged", this.key);
/*Line 154 - 'AtomBinding.js' */                    }
/*Line 155 - 'AtomBinding.js' */                }

/*Line 157 - 'AtomBinding.js' */                this.onDataChanged(this, null);

/*Line 159 - 'AtomBinding.js' */            },

/*Line 161 - 'AtomBinding.js' */            setValue: function (value) {

/*Line 163 - 'AtomBinding.js' */                if (!this.pathList && this.vf) {
/*Line 164 - 'AtomBinding.js' */                    value = [value];
/*Line 165 - 'AtomBinding.js' */                }

/*Line 167 - 'AtomBinding.js' */                if (this.vf) {
/*Line 168 - 'AtomBinding.js' */                    value.push(Atom);
/*Line 169 - 'AtomBinding.js' */                    value.push(AtomPromise);
/*Line 170 - 'AtomBinding.js' */                    value = this.vf.apply(this, value);
/*Line 171 - 'AtomBinding.js' */                }

/*Line 173 - 'AtomBinding.js' */                if (value instanceof AtomPromise) {
/*Line 174 - 'AtomBinding.js' */                    value._persist = true;
/*Line 175 - 'AtomBinding.js' */                }

/*Line 177 - 'AtomBinding.js' */                this._lastValue = value;
/*Line 178 - 'AtomBinding.js' */                this._isUpdating = true;
/*Line 179 - 'AtomBinding.js' */                this.control.setLocalValue(this.key, value, this.element, true);
/*Line 180 - 'AtomBinding.js' */                this._isUpdating = false;
/*Line 181 - 'AtomBinding.js' */            }


/*Line 184 - 'AtomBinding.js' */        }
/*Line 185 - 'AtomBinding.js' */    });
/*Line 186 - 'AtomBinding.js' */})(window, WebAtoms.AtomComponent.prototype);
/*Line 0 - 'AtomDispatcher.js' */

/*Line 2 - 'AtomDispatcher.js' */this.allControls = {
/*Line 3 - 'AtomDispatcher.js' */};

/*Line 5 - 'AtomDispatcher.js' */(function (name, base) {
/*Line 6 - 'AtomDispatcher.js' */    return classCreator(name, base,
/*Line 7 - 'AtomDispatcher.js' */        function () {
/*Line 8 - 'AtomDispatcher.js' */            this._paused = false;
/*Line 9 - 'AtomDispatcher.js' */            this.queue = [];
/*Line 10 - 'AtomDispatcher.js' */            this.onTimeout = function () {
/*Line 11 - 'AtomDispatcher.js' */                if (this._paused)
/*Line 12 - 'AtomDispatcher.js' */                    return;
/*Line 13 - 'AtomDispatcher.js' */                if (this.queue.length == 0) {
/*Line 14 - 'AtomDispatcher.js' */                    var app = atomApplication._element;
/*Line 15 - 'AtomDispatcher.js' */                    if (app.style.visibility == "hidden" || $(app).css("visibility") == "hidden") {
/*Line 16 - 'AtomDispatcher.js' */                        app.style.visibility = "visible";

/*Line 18 - 'AtomDispatcher.js' */                        app.atomControl.updateUI();
/*Line 19 - 'AtomDispatcher.js' */                    }
/*Line 20 - 'AtomDispatcher.js' */                    return;
/*Line 21 - 'AtomDispatcher.js' */                }
/*Line 22 - 'AtomDispatcher.js' */                var item = this.queue.shift();
/*Line 23 - 'AtomDispatcher.js' */                //try{
/*Line 24 - 'AtomDispatcher.js' */                item();
/*Line 25 - 'AtomDispatcher.js' */                //} catch (ex) {

/*Line 27 - 'AtomDispatcher.js' */                //    if (window.console) {
/*Line 28 - 'AtomDispatcher.js' */                //        window.console.log(item.toString());
/*Line 29 - 'AtomDispatcher.js' */                //        window.console.log(JSON.stringify(ex));
/*Line 30 - 'AtomDispatcher.js' */                //    }
/*Line 31 - 'AtomDispatcher.js' */                //}
/*Line 32 - 'AtomDispatcher.js' */                window.setTimeout(this._onTimeout, 1);
/*Line 33 - 'AtomDispatcher.js' */            };
/*Line 34 - 'AtomDispatcher.js' */            //this._onTimeout = Function.createDelegate(this, this.onTimeout);
/*Line 35 - 'AtomDispatcher.js' */            var _this = this;
/*Line 36 - 'AtomDispatcher.js' */            this._onTimeout = function () {
/*Line 37 - 'AtomDispatcher.js' */                _this.onTimeout();
/*Line 38 - 'AtomDispatcher.js' */            };
/*Line 39 - 'AtomDispatcher.js' */        },
/*Line 40 - 'AtomDispatcher.js' */        {
/*Line 41 - 'AtomDispatcher.js' */            pause: function () {
/*Line 42 - 'AtomDispatcher.js' */                this._paused = true;
/*Line 43 - 'AtomDispatcher.js' */            },
/*Line 44 - 'AtomDispatcher.js' */            start: function () {
/*Line 45 - 'AtomDispatcher.js' */                this._paused = false;
/*Line 46 - 'AtomDispatcher.js' */                window.setTimeout(this._onTimeout, 1);
/*Line 47 - 'AtomDispatcher.js' */            },
/*Line 48 - 'AtomDispatcher.js' */            callLater: function (fn) {
/*Line 49 - 'AtomDispatcher.js' */                this.queue.push(fn);
/*Line 50 - 'AtomDispatcher.js' */                if (!this._paused)
/*Line 51 - 'AtomDispatcher.js' */                    this.start();
/*Line 52 - 'AtomDispatcher.js' */            },
/*Line 53 - 'AtomDispatcher.js' */            setupControls: function () {

/*Line 55 - 'AtomDispatcher.js' */                //if (window.console) {
/*Line 56 - 'AtomDispatcher.js' */                //    window.console.log("Starting Web Atoms");
/*Line 57 - 'AtomDispatcher.js' */                //}

/*Line 59 - 'AtomDispatcher.js' */                var a = $('[atom-type]').first()[0];
/*Line 60 - 'AtomDispatcher.js' */                if (a.atomControl != undefined && a.atomControl != null)
/*Line 61 - 'AtomDispatcher.js' */                    return;
/*Line 62 - 'AtomDispatcher.js' */                var ct = $(a).attr("atom-type");
/*Line 63 - 'AtomDispatcher.js' */                $(a).removeAttr("atom-type");
/*Line 64 - 'AtomDispatcher.js' */                var ctrl = new (WebAtoms[ct])(a);
/*Line 65 - 'AtomDispatcher.js' */                ctrl.setup();

/*Line 67 - 'AtomDispatcher.js' */            }
/*Line 68 - 'AtomDispatcher.js' */        }
/*Line 69 - 'AtomDispatcher.js' */        );
/*Line 70 - 'AtomDispatcher.js' */})("WebAtoms.AtomDispatcher",null);

/*Line 72 - 'AtomDispatcher.js' */WebAtoms.dispatcher = new WebAtoms.AtomDispatcher();

/*Line 0 - 'AtomUIComponent.js' */

/*Line 2 - 'AtomUIComponent.js' */(function (window, name, base) {
/*Line 3 - 'AtomUIComponent.js' */    return classCreator(name, base,
/*Line 4 - 'AtomUIComponent.js' */        function () {
/*Line 5 - 'AtomUIComponent.js' */        },
/*Line 6 - 'AtomUIComponent.js' */        {
/*Line 7 - 'AtomUIComponent.js' */            get_owner: function () {
/*Line 8 - 'AtomUIComponent.js' */                return this;
/*Line 9 - 'AtomUIComponent.js' */            },

/*Line 11 - 'AtomUIComponent.js' */            get_appScope: function () {
/*Line 12 - 'AtomUIComponent.js' */                return appScope;
/*Line 13 - 'AtomUIComponent.js' */            },

/*Line 15 - 'AtomUIComponent.js' */            get_scope: function () {
/*Line 16 - 'AtomUIComponent.js' */                if (this._scope === undefined) {
/*Line 17 - 'AtomUIComponent.js' */                    var ap = this.get_atomParent(this._element._logicalParent || this._element.parentNode);
/*Line 18 - 'AtomUIComponent.js' */                    if (ap) {
/*Line 19 - 'AtomUIComponent.js' */                        return ap._localScope || ap.get_scope();
/*Line 20 - 'AtomUIComponent.js' */                    }
/*Line 21 - 'AtomUIComponent.js' */                    else {
/*Line 22 - 'AtomUIComponent.js' */                        return appScope;
/*Line 23 - 'AtomUIComponent.js' */                    }
/*Line 24 - 'AtomUIComponent.js' */                }
/*Line 25 - 'AtomUIComponent.js' */                return this._scope;
/*Line 26 - 'AtomUIComponent.js' */            },

/*Line 28 - 'AtomUIComponent.js' */            get_localScope: function () {
/*Line 29 - 'AtomUIComponent.js' */                if (this._localScope === undefined) {
/*Line 30 - 'AtomUIComponent.js' */                    var ap = this.get_atomParent(this._element.parentNode);
/*Line 31 - 'AtomUIComponent.js' */                    if (ap) {
/*Line 32 - 'AtomUIComponent.js' */                        return ap.get_localScope();
/*Line 33 - 'AtomUIComponent.js' */                    } else {
/*Line 34 - 'AtomUIComponent.js' */                        throw new Error("Local Scope does not exist");
/*Line 35 - 'AtomUIComponent.js' */                    }
/*Line 36 - 'AtomUIComponent.js' */                }
/*Line 37 - 'AtomUIComponent.js' */                return this._localScope;
/*Line 38 - 'AtomUIComponent.js' */            },
/*Line 39 - 'AtomUIComponent.js' */            set_scope: function (v) {
/*Line 40 - 'AtomUIComponent.js' */                var scope = this.get_scope();
/*Line 41 - 'AtomUIComponent.js' */                for (var k in v) {
/*Line 42 - 'AtomUIComponent.js' */                    if (/^(application|owner|app|parent)$/gi.test(k))
/*Line 43 - 'AtomUIComponent.js' */                        throw new Error("Invalid name for the scope property");
/*Line 44 - 'AtomUIComponent.js' */                    // if value is already set...
/*Line 45 - 'AtomUIComponent.js' */                    if (scope[k])
/*Line 46 - 'AtomUIComponent.js' */                        continue;
/*Line 47 - 'AtomUIComponent.js' */                    scope[k] = v[k];
/*Line 48 - 'AtomUIComponent.js' */                }
/*Line 49 - 'AtomUIComponent.js' */            },

/*Line 51 - 'AtomUIComponent.js' */            get_name: function () {
/*Line 52 - 'AtomUIComponent.js' */                return this._name;
/*Line 53 - 'AtomUIComponent.js' */            },

/*Line 55 - 'AtomUIComponent.js' */            get_isVisible: function () {
/*Line 56 - 'AtomUIComponent.js' */                return this._isVisible;
/*Line 57 - 'AtomUIComponent.js' */            },
/*Line 58 - 'AtomUIComponent.js' */            set_isVisible: function (v) {
/*Line 59 - 'AtomUIComponent.js' */                var element = this.get_element();
/*Line 60 - 'AtomUIComponent.js' */                this._isVisible = v;
/*Line 61 - 'AtomUIComponent.js' */                if (!this._isVisible) {
/*Line 62 - 'AtomUIComponent.js' */                    $(element).hide();
/*Line 63 - 'AtomUIComponent.js' */                } else {
/*Line 64 - 'AtomUIComponent.js' */                    $(element).show();
/*Line 65 - 'AtomUIComponent.js' */                }
/*Line 66 - 'AtomUIComponent.js' */            },

/*Line 68 - 'AtomUIComponent.js' */            getTemplate: function (k) {

/*Line 70 - 'AtomUIComponent.js' */                var t = this["_" + k];
/*Line 71 - 'AtomUIComponent.js' */                if (t !== undefined && t !== null)
/*Line 72 - 'AtomUIComponent.js' */                    return t;

/*Line 74 - 'AtomUIComponent.js' */                // resolve...
/*Line 75 - 'AtomUIComponent.js' */                t = Templates.get(this.constructor, k);
/*Line 76 - 'AtomUIComponent.js' */                if (!t) {
/*Line 77 - 'AtomUIComponent.js' */                    return null;
/*Line 78 - 'AtomUIComponent.js' */                }
/*Line 79 - 'AtomUIComponent.js' */                this["_" + k] = t;
/*Line 80 - 'AtomUIComponent.js' */                return t;
/*Line 81 - 'AtomUIComponent.js' */            }
/*Line 82 - 'AtomUIComponent.js' */        },
/*Line 83 - 'AtomUIComponent.js' */        {
/*Line 84 - 'AtomUIComponent.js' */            next: null,
/*Line 85 - 'AtomUIComponent.js' */            value: undefined
/*Line 86 - 'AtomUIComponent.js' */        });
/*Line 87 - 'AtomUIComponent.js' */})(window, "WebAtoms.AtomUIComponent", WebAtoms.AtomComponent.prototype);


/*Line 90 - 'AtomUIComponent.js' */Templates.compiled = {
/*Line 91 - 'AtomUIComponent.js' */};

/*Line 93 - 'AtomUIComponent.js' */var document = window.document;

/*Line 95 - 'AtomUIComponent.js' */Templates.compileElement = function (e) {
/*Line 96 - 'AtomUIComponent.js' */    var ae = new AtomEnumerator(e);
/*Line 97 - 'AtomUIComponent.js' */    ae.next();
/*Line 98 - 'AtomUIComponent.js' */    var a = ae.current();
/*Line 99 - 'AtomUIComponent.js' */    var e1 = document.createElement(a);
/*Line 100 - 'AtomUIComponent.js' */    if (!ae.next())
/*Line 101 - 'AtomUIComponent.js' */        return e1;
/*Line 102 - 'AtomUIComponent.js' */    a = ae.current();
/*Line 103 - 'AtomUIComponent.js' */    if (a) {
/*Line 104 - 'AtomUIComponent.js' */        for (var k in a) {
/*Line 105 - 'AtomUIComponent.js' */            e1.setAttribute(k, a[k]);
/*Line 106 - 'AtomUIComponent.js' */        }
/*Line 107 - 'AtomUIComponent.js' */    }
    
/*Line 109 - 'AtomUIComponent.js' */    while (ae.next()) {
/*Line 110 - 'AtomUIComponent.js' */        a = ae.current();
/*Line 111 - 'AtomUIComponent.js' */        if (!a)
/*Line 112 - 'AtomUIComponent.js' */            break;
/*Line 113 - 'AtomUIComponent.js' */        if (a.constructor == String) {
/*Line 114 - 'AtomUIComponent.js' */            e1.appendChild(document.createTextNode(a));
/*Line 115 - 'AtomUIComponent.js' */        } else {
/*Line 116 - 'AtomUIComponent.js' */            e1.appendChild(Templates.compileElement(a));
/*Line 117 - 'AtomUIComponent.js' */        }
/*Line 118 - 'AtomUIComponent.js' */    }
/*Line 119 - 'AtomUIComponent.js' */    return e1;
/*Line 120 - 'AtomUIComponent.js' */};

/*Line 122 - 'AtomUIComponent.js' */Templates.compileJsonML = function (j) {

/*Line 124 - 'AtomUIComponent.js' */    if (j.length == 1)
/*Line 125 - 'AtomUIComponent.js' */        return Templates.compileElement(j[0]);

/*Line 127 - 'AtomUIComponent.js' */    var r = [];
/*Line 128 - 'AtomUIComponent.js' */    var ae = new AtomEnumerator(j);
/*Line 129 - 'AtomUIComponent.js' */    while (ae.next()) {
/*Line 130 - 'AtomUIComponent.js' */        r.push(Templates.compileElement(ae.current()));
/*Line 131 - 'AtomUIComponent.js' */    }
/*Line 132 - 'AtomUIComponent.js' */    return r;
/*Line 133 - 'AtomUIComponent.js' */};

/*Line 135 - 'AtomUIComponent.js' */Templates.compile = function (type, name, t) {

/*Line 137 - 'AtomUIComponent.js' */    var div = document.createElement("div");
/*Line 138 - 'AtomUIComponent.js' */    div.innerHTML = t;

/*Line 140 - 'AtomUIComponent.js' */    if ($(div).children().length == 1) {
/*Line 141 - 'AtomUIComponent.js' */        t = AtomUI.cloneNode((div.firstElementChild || div.children[0]));
/*Line 142 - 'AtomUIComponent.js' */    }

/*Line 144 - 'AtomUIComponent.js' */    return t;
/*Line 145 - 'AtomUIComponent.js' */};

/*Line 147 - 'AtomUIComponent.js' */Templates.get = function (type, k) {
/*Line 148 - 'AtomUIComponent.js' */    //var x = this.compileType(type);
/*Line 149 - 'AtomUIComponent.js' */    //return x[k];

/*Line 151 - 'AtomUIComponent.js' */    var name = type.__typeName + "." + k;
/*Line 152 - 'AtomUIComponent.js' */    var x = this.compiled[name];
/*Line 153 - 'AtomUIComponent.js' */    if (x)
/*Line 154 - 'AtomUIComponent.js' */        return x;
/*Line 155 - 'AtomUIComponent.js' */    x = Templates.jsonML[name];
/*Line 156 - 'AtomUIComponent.js' */    if (!x) {
/*Line 157 - 'AtomUIComponent.js' */        if (type.__baseType) {
/*Line 158 - 'AtomUIComponent.js' */            x = Templates.get(type.__baseType, k);
/*Line 159 - 'AtomUIComponent.js' */        }
/*Line 160 - 'AtomUIComponent.js' */    } else {
/*Line 161 - 'AtomUIComponent.js' */        x = Templates.compileJsonML(x);
/*Line 162 - 'AtomUIComponent.js' */    }
/*Line 163 - 'AtomUIComponent.js' */    if (!x)
/*Line 164 - 'AtomUIComponent.js' */        return null;
/*Line 165 - 'AtomUIComponent.js' */    this.compiled[name] = x;
/*Line 166 - 'AtomUIComponent.js' */    return x;

/*Line 168 - 'AtomUIComponent.js' */};

/*Line 170 - 'AtomUIComponent.js' */Templates.compileType = function (type) {

/*Line 172 - 'AtomUIComponent.js' */    var name = type.__typeName;
/*Line 173 - 'AtomUIComponent.js' */    var shortName = name.split(".");
/*Line 174 - 'AtomUIComponent.js' */    shortName = shortName[shortName.length - 1];

/*Line 176 - 'AtomUIComponent.js' */    var x = this.compiled[name];
/*Line 177 - 'AtomUIComponent.js' */    if (x)
/*Line 178 - 'AtomUIComponent.js' */        return x;

/*Line 180 - 'AtomUIComponent.js' */    x = {
/*Line 181 - 'AtomUIComponent.js' */    };

/*Line 183 - 'AtomUIComponent.js' */    var tl = this[name] || this[shortName];
/*Line 184 - 'AtomUIComponent.js' */    if (tl) {
/*Line 185 - 'AtomUIComponent.js' */        for (var t in tl) {
/*Line 186 - 'AtomUIComponent.js' */            x[t] = this.compile(type, t, tl[t]);
/*Line 187 - 'AtomUIComponent.js' */        }
/*Line 188 - 'AtomUIComponent.js' */    }

/*Line 190 - 'AtomUIComponent.js' */    if (type.__baseType) {
/*Line 191 - 'AtomUIComponent.js' */        var y = this.compileType(type.__baseType);
/*Line 192 - 'AtomUIComponent.js' */        for (var yt in y) {
/*Line 193 - 'AtomUIComponent.js' */            if (!x[yt]) {
/*Line 194 - 'AtomUIComponent.js' */                x[yt] = y[yt];
/*Line 195 - 'AtomUIComponent.js' */            }
/*Line 196 - 'AtomUIComponent.js' */        }
/*Line 197 - 'AtomUIComponent.js' */    }

/*Line 199 - 'AtomUIComponent.js' */    this.compiled[name] = x;

/*Line 201 - 'AtomUIComponent.js' */    var t = this;
/*Line 202 - 'AtomUIComponent.js' */    delete t[name];
/*Line 203 - 'AtomUIComponent.js' */    delete t[shortName];

/*Line 205 - 'AtomUIComponent.js' */    return x;
/*Line 206 - 'AtomUIComponent.js' */};
/*Line 0 - 'AtomControl.js' */
/*Line 1 - 'AtomControl.js' */
/*Line 2 - 'AtomControl.js' */
/*Line 3 - 'AtomControl.js' */


/*Line 6 - 'AtomControl.js' */// Property Handlers
/*Line 7 - 'AtomControl.js' */var AtomProperties = {
/*Line 8 - 'AtomControl.js' */    isEnabled: function(element,value){
/*Line 9 - 'AtomControl.js' */        if (value) {
/*Line 10 - 'AtomControl.js' */            $(element).removeAttr("disabled");
/*Line 11 - 'AtomControl.js' */        } else {
/*Line 12 - 'AtomControl.js' */            $(element).attr("disabled", "disabled");
/*Line 13 - 'AtomControl.js' */        }
/*Line 14 - 'AtomControl.js' */    },
/*Line 15 - 'AtomControl.js' */    checked: function (element, value) {
/*Line 16 - 'AtomControl.js' */        if (element.checked != value) {
/*Line 17 - 'AtomControl.js' */            element.checked = value ? true : false;
/*Line 18 - 'AtomControl.js' */        }
/*Line 19 - 'AtomControl.js' */    },
/*Line 20 - 'AtomControl.js' */    value: function (element, value) {
/*Line 21 - 'AtomControl.js' */        if (/date|datetime/gi.test(element.type)) {
/*Line 22 - 'AtomControl.js' */            element.valueAsDate = AtomDate.parse(value);
/*Line 23 - 'AtomControl.js' */        } else {
/*Line 24 - 'AtomControl.js' */            $(element).val(value);
/*Line 25 - 'AtomControl.js' */        }
/*Line 26 - 'AtomControl.js' */    },
/*Line 27 - 'AtomControl.js' */    valueAsDate: function (element, value) {
/*Line 28 - 'AtomControl.js' */        element.valueAsDate = AtomDate.parse(value);
/*Line 29 - 'AtomControl.js' */    },
/*Line 30 - 'AtomControl.js' */    text: function (element, value) {
/*Line 31 - 'AtomControl.js' */        $(element).text(value);
/*Line 32 - 'AtomControl.js' */    },
/*Line 33 - 'AtomControl.js' */    html: function (element, value) {
/*Line 34 - 'AtomControl.js' */        element.innerHTML = value;
/*Line 35 - 'AtomControl.js' */    },
/*Line 36 - 'AtomControl.js' */    absPos: function (element, value) {
/*Line 37 - 'AtomControl.js' */        AtomProperties.setPosition(true, element, value);
/*Line 38 - 'AtomControl.js' */    },
/*Line 39 - 'AtomControl.js' */    relPos: function (element, value) {
/*Line 40 - 'AtomControl.js' */        AtomProperties.setPosition(false, element, value);
/*Line 41 - 'AtomControl.js' */    },
/*Line 42 - 'AtomControl.js' */    "class": function (element,value) {
/*Line 43 - 'AtomControl.js' */        if (element.atomClass) {
/*Line 44 - 'AtomControl.js' */            $(element).removeClass(element.atomClass);
/*Line 45 - 'AtomControl.js' */        }
/*Line 46 - 'AtomControl.js' */        if (value) {
/*Line 47 - 'AtomControl.js' */            value = AtomUI.createCss(value);
/*Line 48 - 'AtomControl.js' */            if (value) {
/*Line 49 - 'AtomControl.js' */                $(element).addClass(value);
/*Line 50 - 'AtomControl.js' */            }
/*Line 51 - 'AtomControl.js' */            element.atomClass = value;
/*Line 52 - 'AtomControl.js' */        }
/*Line 53 - 'AtomControl.js' */    },
/*Line 54 - 'AtomControl.js' */    setPosition: function (a, e, val) {
/*Line 55 - 'AtomControl.js' */        var l = val;

/*Line 57 - 'AtomControl.js' */        if (l.constructor == String) {
/*Line 58 - 'AtomControl.js' */            l = eval("[" + l + "]");
/*Line 59 - 'AtomControl.js' */        }

/*Line 61 - 'AtomControl.js' */        e.style.position = a ? 'absolute' : 'relative';

/*Line 63 - 'AtomControl.js' */        var left = l[0];
/*Line 64 - 'AtomControl.js' */        var top = l[1];

/*Line 66 - 'AtomControl.js' */        if (left !== null) {
/*Line 67 - 'AtomControl.js' */            e.style.left = left + "px";
/*Line 68 - 'AtomControl.js' */        }
/*Line 69 - 'AtomControl.js' */        if (top !== null) {
/*Line 70 - 'AtomControl.js' */            e.style.top = top + "px";
/*Line 71 - 'AtomControl.js' */        }
/*Line 72 - 'AtomControl.js' */        if (l.length > 2) {
/*Line 73 - 'AtomControl.js' */            var width = l[2];
/*Line 74 - 'AtomControl.js' */            var height = l[3];
/*Line 75 - 'AtomControl.js' */            if (width !== undefined && width !== null) {
/*Line 76 - 'AtomControl.js' */                e.style.width = width + "px";
/*Line 77 - 'AtomControl.js' */            }
/*Line 78 - 'AtomControl.js' */            if (height !== undefined && height !== null) {
/*Line 79 - 'AtomControl.js' */                e.style.height = height + "px";
/*Line 80 - 'AtomControl.js' */            }
/*Line 81 - 'AtomControl.js' */        }
/*Line 82 - 'AtomControl.js' */    }
/*Line 83 - 'AtomControl.js' */};

/*Line 85 - 'AtomControl.js' */window.AtomProperties = AtomProperties;

/*Line 87 - 'AtomControl.js' */(function (window, name, base) {


/*Line 90 - 'AtomControl.js' */    return classCreatorEx({
/*Line 91 - 'AtomControl.js' */        name: name,
/*Line 92 - 'AtomControl.js' */        base: base,
/*Line 93 - 'AtomControl.js' */        start: function (element) {
/*Line 94 - 'AtomControl.js' */            element.atomControl = this;
/*Line 95 - 'AtomControl.js' */            this._element = element;

/*Line 97 - 'AtomControl.js' */            this.dispatcher = WebAtoms.dispatcher;
/*Line 98 - 'AtomControl.js' */            this.bindings = [];
/*Line 99 - 'AtomControl.js' */            this._isVisible = true;

/*Line 101 - 'AtomControl.js' */            AtomUI.assignID(element);

/*Line 103 - 'AtomControl.js' */            allControls[element.id] = this;
/*Line 104 - 'AtomControl.js' */        },
/*Line 105 - 'AtomControl.js' */        properties: {
/*Line 106 - 'AtomControl.js' */            layout: null,
/*Line 107 - 'AtomControl.js' */            loadNext: null,
/*Line 108 - 'AtomControl.js' */            next: null,
/*Line 109 - 'AtomControl.js' */            value: undefined
/*Line 110 - 'AtomControl.js' */        },
/*Line 111 - 'AtomControl.js' */        methods: {
/*Line 112 - 'AtomControl.js' */            invokeAction: function (action, evt) {
/*Line 113 - 'AtomControl.js' */                if (!action)
/*Line 114 - 'AtomControl.js' */                    return;
/*Line 115 - 'AtomControl.js' */                if (action.constructor == String) {
/*Line 116 - 'AtomControl.js' */                    location.href = action;
/*Line 117 - 'AtomControl.js' */                }
/*Line 118 - 'AtomControl.js' */                else {

/*Line 120 - 'AtomControl.js' */                    var f = action;

/*Line 122 - 'AtomControl.js' */                    // is it atomControl?
/*Line 123 - 'AtomControl.js' */                    if (f.atomControl) {
/*Line 124 - 'AtomControl.js' */                        f = f.atomControl;
/*Line 125 - 'AtomControl.js' */                        if (f.refresh) {
/*Line 126 - 'AtomControl.js' */                            f.refresh(this.get_scope(), this);
/*Line 127 - 'AtomControl.js' */                        } else {
/*Line 128 - 'AtomControl.js' */                            alert("no default action defined");
/*Line 129 - 'AtomControl.js' */                        }
/*Line 130 - 'AtomControl.js' */                    } else {
/*Line 131 - 'AtomControl.js' */                        if (f._element) {
/*Line 132 - 'AtomControl.js' */                            f.refresh(this.get_scope(), this);
/*Line 133 - 'AtomControl.js' */                        } else {

/*Line 135 - 'AtomControl.js' */                            //is it function

/*Line 137 - 'AtomControl.js' */                            if ((typeof f) == 'function') {

/*Line 139 - 'AtomControl.js' */                                // invoke method...
/*Line 140 - 'AtomControl.js' */                                f(this.get_scope(), this, evt);
/*Line 141 - 'AtomControl.js' */                            } else {

/*Line 143 - 'AtomControl.js' */                                // it is an array...
/*Line 144 - 'AtomControl.js' */                                if (f.length) {
/*Line 145 - 'AtomControl.js' */                                    var ae = new AtomEnumerator(f);
/*Line 146 - 'AtomControl.js' */                                    while (ae.next()) {
/*Line 147 - 'AtomControl.js' */                                        this.invokeAction(ae.current(), evt);
/*Line 148 - 'AtomControl.js' */                                    }
/*Line 149 - 'AtomControl.js' */                                    return;
/*Line 150 - 'AtomControl.js' */                                }

/*Line 152 - 'AtomControl.js' */                                // identify scope and actions...
/*Line 153 - 'AtomControl.js' */                                var action = (f.timeOut || f.timeout);
/*Line 154 - 'AtomControl.js' */                                if (action) {
/*Line 155 - 'AtomControl.js' */                                    var _this = this;
/*Line 156 - 'AtomControl.js' */                                    var tm = 100;
/*Line 157 - 'AtomControl.js' */                                    if (action.hasOwnProperty("length")) {
/*Line 158 - 'AtomControl.js' */                                        if (action.length > 1) {
/*Line 159 - 'AtomControl.js' */                                            tm = action[0];
/*Line 160 - 'AtomControl.js' */                                            action = action[1];
/*Line 161 - 'AtomControl.js' */                                        }
/*Line 162 - 'AtomControl.js' */                                    }
/*Line 163 - 'AtomControl.js' */                                    setTimeout(function () {
/*Line 164 - 'AtomControl.js' */                                        _this.invokeAction(action);
/*Line 165 - 'AtomControl.js' */                                    }, tm);
/*Line 166 - 'AtomControl.js' */                                    return;
/*Line 167 - 'AtomControl.js' */                                }
/*Line 168 - 'AtomControl.js' */                                action = f.owner;
/*Line 169 - 'AtomControl.js' */                                if (action) {
/*Line 170 - 'AtomControl.js' */                                    Atom.merge(this, action, true);
/*Line 171 - 'AtomControl.js' */                                }
/*Line 172 - 'AtomControl.js' */                                action = f.scope;
/*Line 173 - 'AtomControl.js' */                                if (action) {
/*Line 174 - 'AtomControl.js' */                                    Atom.merge(this.get_scope(), action, true);
/*Line 175 - 'AtomControl.js' */                                }
/*Line 176 - 'AtomControl.js' */                                action = f.appScope;
/*Line 177 - 'AtomControl.js' */                                if (action) {
/*Line 178 - 'AtomControl.js' */                                    Atom.merge(this.get_appScope(), action, true);
/*Line 179 - 'AtomControl.js' */                                }
/*Line 180 - 'AtomControl.js' */                                action = f.data;
/*Line 181 - 'AtomControl.js' */                                if (action) {
/*Line 182 - 'AtomControl.js' */                                    Atom.merge(this.get_data(), action, true);
/*Line 183 - 'AtomControl.js' */                                }
/*Line 184 - 'AtomControl.js' */                                action = f.confirm;
/*Line 185 - 'AtomControl.js' */                                if (action) {
/*Line 186 - 'AtomControl.js' */                                    var msg = "Are you sure?";
/*Line 187 - 'AtomControl.js' */                                    if (action.hasOwnProperty("length")) {
/*Line 188 - 'AtomControl.js' */                                        if (action.length > 1) {
/*Line 189 - 'AtomControl.js' */                                            msg = action[0];
/*Line 190 - 'AtomControl.js' */                                            action = action[1];
/*Line 191 - 'AtomControl.js' */                                        } else {
/*Line 192 - 'AtomControl.js' */                                            action = action[0];
/*Line 193 - 'AtomControl.js' */                                        }
/*Line 194 - 'AtomControl.js' */                                    }
/*Line 195 - 'AtomControl.js' */                                    if (confirm(msg)) {
/*Line 196 - 'AtomControl.js' */                                        this.invokeAction(action, evt);
/*Line 197 - 'AtomControl.js' */                                    }
/*Line 198 - 'AtomControl.js' */                                }
/*Line 199 - 'AtomControl.js' */                                action = f.alert;
/*Line 200 - 'AtomControl.js' */                                if (action) {
/*Line 201 - 'AtomControl.js' */                                    alert(action);
/*Line 202 - 'AtomControl.js' */                                }
/*Line 203 - 'AtomControl.js' */                                action = f.next;
/*Line 204 - 'AtomControl.js' */                                if (action) {
/*Line 205 - 'AtomControl.js' */                                    this.invokeAction(action, evt);
/*Line 206 - 'AtomControl.js' */                                    return;
/*Line 207 - 'AtomControl.js' */                                }
/*Line 208 - 'AtomControl.js' */                                action = f.control;
/*Line 209 - 'AtomControl.js' */                                if (action) {
/*Line 210 - 'AtomControl.js' */                                    allControls[action].refresh();
/*Line 211 - 'AtomControl.js' */                                }

/*Line 213 - 'AtomControl.js' */                            }
/*Line 214 - 'AtomControl.js' */                        }
/*Line 215 - 'AtomControl.js' */                    }
/*Line 216 - 'AtomControl.js' */                }
/*Line 217 - 'AtomControl.js' */            },

/*Line 219 - 'AtomControl.js' */            refresh: function () {
/*Line 220 - 'AtomControl.js' */                // invoke some default action...!!!
/*Line 221 - 'AtomControl.js' */            },

/*Line 223 - 'AtomControl.js' */            get_element: function () {
/*Line 224 - 'AtomControl.js' */                return this._element;
/*Line 225 - 'AtomControl.js' */            },

/*Line 227 - 'AtomControl.js' */            clearBinding: function (element, key) {
/*Line 228 - 'AtomControl.js' */                var ae = new AtomEnumerator(this.bindings);
/*Line 229 - 'AtomControl.js' */                var item;
/*Line 230 - 'AtomControl.js' */                var removed = [];
/*Line 231 - 'AtomControl.js' */                while (ae.next()) {
/*Line 232 - 'AtomControl.js' */                    item = ae.current();
/*Line 233 - 'AtomControl.js' */                    if (element && item.element != element)
/*Line 234 - 'AtomControl.js' */                        continue;
/*Line 235 - 'AtomControl.js' */                    if (key && item.key != key)
/*Line 236 - 'AtomControl.js' */                        continue;
/*Line 237 - 'AtomControl.js' */                    //this.bindings.splice(ae.currentIndex(), 1);
/*Line 238 - 'AtomControl.js' */                    item.dispose();
/*Line 239 - 'AtomControl.js' */                    removed.push(item);
/*Line 240 - 'AtomControl.js' */                }
/*Line 241 - 'AtomControl.js' */                ae = new AtomEnumerator(removed);
/*Line 242 - 'AtomControl.js' */                while (ae.next()) {
/*Line 243 - 'AtomControl.js' */                    AtomArray.remove(this.bindings, ae.current());
/*Line 244 - 'AtomControl.js' */                }
/*Line 245 - 'AtomControl.js' */            },
/*Line 246 - 'AtomControl.js' */            addBinding: function (target, element, key, path, twoWays, jq, valueFunction, events) {
/*Line 247 - 'AtomControl.js' */                this.clearBinding(element, key);
/*Line 248 - 'AtomControl.js' */                var ab = new WebAtoms.AtomBinding(target, element, key, path, twoWays, jq, valueFunction, events);
/*Line 249 - 'AtomControl.js' */                this.bindings.push(ab);
/*Line 250 - 'AtomControl.js' */                ab.setup();
/*Line 251 - 'AtomControl.js' */            },

/*Line 253 - 'AtomControl.js' */            get_atomParent: function (element) {
/*Line 254 - 'AtomControl.js' */                if (element == null) {
/*Line 255 - 'AtomControl.js' */                    if (this._element._logicalParent || this._element.parentNode)
/*Line 256 - 'AtomControl.js' */                        element = this._element._logicalParent || this._element.parentNode;
/*Line 257 - 'AtomControl.js' */                    else
/*Line 258 - 'AtomControl.js' */                        return null;
/*Line 259 - 'AtomControl.js' */                }
/*Line 260 - 'AtomControl.js' */                if (element.atomControl) {
/*Line 261 - 'AtomControl.js' */                    return element.atomControl;
/*Line 262 - 'AtomControl.js' */                }
/*Line 263 - 'AtomControl.js' */                if (element === document || element === window || !element.parentNode)
/*Line 264 - 'AtomControl.js' */                    return null;
/*Line 265 - 'AtomControl.js' */                return this.get_atomParent(element._logicalParent || element.parentNode);
/*Line 266 - 'AtomControl.js' */            },

/*Line 268 - 'AtomControl.js' */            get_templateParent: function (element) {
/*Line 269 - 'AtomControl.js' */                if (!element) {
/*Line 270 - 'AtomControl.js' */                    element = this._element;
/*Line 271 - 'AtomControl.js' */                }
/*Line 272 - 'AtomControl.js' */                if (element._templateParent) {
/*Line 273 - 'AtomControl.js' */                    return element._templateParent;
/*Line 274 - 'AtomControl.js' */                }
/*Line 275 - 'AtomControl.js' */                var p = element._logicalParent || element.parentNode;
/*Line 276 - 'AtomControl.js' */                if (!p)
/*Line 277 - 'AtomControl.js' */                    throw new Error("Could not find templateParent");
/*Line 278 - 'AtomControl.js' */                return this.get_templateParent(element._logicalParent || element.parentNode);
/*Line 279 - 'AtomControl.js' */            },

/*Line 281 - 'AtomControl.js' */            get_data: function () {
/*Line 282 - 'AtomControl.js' */                if (this._data === undefined) {
/*Line 283 - 'AtomControl.js' */                    // get parent...
/*Line 284 - 'AtomControl.js' */                    var ap = this.get_atomParent(this._element._logicalParent || this._element.parentNode);
/*Line 285 - 'AtomControl.js' */                    if (ap)
/*Line 286 - 'AtomControl.js' */                        return ap.get_data();
/*Line 287 - 'AtomControl.js' */                }
/*Line 288 - 'AtomControl.js' */                return this._data;
/*Line 289 - 'AtomControl.js' */            },
/*Line 290 - 'AtomControl.js' */            set_data: function (d) {
/*Line 291 - 'AtomControl.js' */                this._data = d;
/*Line 292 - 'AtomControl.js' */                // update child references...
/*Line 293 - 'AtomControl.js' */                this.updateChildBindings(this._element);
/*Line 294 - 'AtomControl.js' */            },

/*Line 296 - 'AtomControl.js' */            updateChildBindings: function (element) {
/*Line 297 - 'AtomControl.js' */                var ae = new ChildEnumerator(element);
/*Line 298 - 'AtomControl.js' */                while (ae.next()) {
/*Line 299 - 'AtomControl.js' */                    var child = ae.current();
/*Line 300 - 'AtomControl.js' */                    if (child.atomControl && child.atomControl._created) {
/*Line 301 - 'AtomControl.js' */                        var ctrl = child.atomControl;
/*Line 302 - 'AtomControl.js' */                        if (ctrl._data !== undefined)
/*Line 303 - 'AtomControl.js' */                            continue;
/*Line 304 - 'AtomControl.js' */                        AtomBinder.refreshValue(ctrl, "data");
/*Line 305 - 'AtomControl.js' */                    }
/*Line 306 - 'AtomControl.js' */                    this.updateChildBindings(child);
/*Line 307 - 'AtomControl.js' */                }
/*Line 308 - 'AtomControl.js' */            },

/*Line 310 - 'AtomControl.js' */            initializeProperties: function () {

/*Line 312 - 'AtomControl.js' */                if (this._disposed)
/*Line 313 - 'AtomControl.js' */                    return;

/*Line 315 - 'AtomControl.js' */                //// initialize properties...
/*Line 316 - 'AtomControl.js' */                var element = this.get_element();

/*Line 318 - 'AtomControl.js' */                this.setProperties(element);
/*Line 319 - 'AtomControl.js' */                this._created = true;
/*Line 320 - 'AtomControl.js' */                this.onCreationComplete();
/*Line 321 - 'AtomControl.js' */                this.onLoaded();
/*Line 322 - 'AtomControl.js' */            },


/*Line 325 - 'AtomControl.js' */            createChildren: function () {

/*Line 327 - 'AtomControl.js' */                this.onCreateChildren(this._element);

/*Line 329 - 'AtomControl.js' */                var t = this.getTemplate("template");

/*Line 331 - 'AtomControl.js' */                if (t) {
/*Line 332 - 'AtomControl.js' */                    if ($(this._element).children().length == 0) {
/*Line 333 - 'AtomControl.js' */                        if (t.constructor == String) {
/*Line 334 - 'AtomControl.js' */                            this._element.innerHTML = t;
/*Line 335 - 'AtomControl.js' */                            var caller = this;
/*Line 336 - 'AtomControl.js' */                            $(this._element).children().each(function () {
/*Line 337 - 'AtomControl.js' */                                this._templateParent = caller;
/*Line 338 - 'AtomControl.js' */                            });
/*Line 339 - 'AtomControl.js' */                        } else {
/*Line 340 - 'AtomControl.js' */                            //this._element.innerHTML = this._template;
/*Line 341 - 'AtomControl.js' */                            if (AtomUI.isNode(t)) {
/*Line 342 - 'AtomControl.js' */                                t = AtomUI.cloneNode(t);
/*Line 343 - 'AtomControl.js' */                                t._templateParent = this;
/*Line 344 - 'AtomControl.js' */                                this._element.appendChild(t);
/*Line 345 - 'AtomControl.js' */                            } else {
/*Line 346 - 'AtomControl.js' */                                // should be an array...
/*Line 347 - 'AtomControl.js' */                                var ae = new AtomEnumerator(t);
/*Line 348 - 'AtomControl.js' */                                while (ae.next()) {
/*Line 349 - 'AtomControl.js' */                                    var tc = ae.current();
/*Line 350 - 'AtomControl.js' */                                    tc = AtomUI.cloneNode(tc);
/*Line 351 - 'AtomControl.js' */                                    tc._templateParent = this;
/*Line 352 - 'AtomControl.js' */                                    this._element.appendChild(tc);
/*Line 353 - 'AtomControl.js' */                                }
/*Line 354 - 'AtomControl.js' */                            }
/*Line 355 - 'AtomControl.js' */                        }
/*Line 356 - 'AtomControl.js' */                        this.onCreateChildren(this._element);
/*Line 357 - 'AtomControl.js' */                    }
/*Line 358 - 'AtomControl.js' */                }
/*Line 359 - 'AtomControl.js' */            },


/*Line 362 - 'AtomControl.js' */            onCreateChildren: function (element) {

/*Line 364 - 'AtomControl.js' */                var ae = new ChildEnumerator(element);
/*Line 365 - 'AtomControl.js' */                var child;
/*Line 366 - 'AtomControl.js' */                while (ae.next()) {
/*Line 367 - 'AtomControl.js' */                    child = ae.current();

/*Line 369 - 'AtomControl.js' */                    var amap = AtomUI.attributeMap(child, /^atom\-(template|presenter|type|template\-name)$/gi);

/*Line 371 - 'AtomControl.js' */                    var t = amap["atom-template"];
/*Line 372 - 'AtomControl.js' */                    if (t) {
/*Line 373 - 'AtomControl.js' */                        child.removeAttributeNode(t.node);
/*Line 374 - 'AtomControl.js' */                        element.templateOwner = true;
/*Line 375 - 'AtomControl.js' */                        this["_" + t.value] = child;
/*Line 376 - 'AtomControl.js' */                        element.removeChild(child);
/*Line 377 - 'AtomControl.js' */                        continue;
/*Line 378 - 'AtomControl.js' */                    }

/*Line 380 - 'AtomControl.js' */                    var tn = amap["atom-template-name"];
/*Line 381 - 'AtomControl.js' */                    if (tn) {
/*Line 382 - 'AtomControl.js' */                        child.removeAttributeNode(tn.node);
/*Line 383 - 'AtomControl.js' */                        this._scopeTemplates = this._scopeTemplates || {};
/*Line 384 - 'AtomControl.js' */                        this._scopeTemplates[tn.value] = child;
/*Line 385 - 'AtomControl.js' */                        element.removeChild(child);
/*Line 386 - 'AtomControl.js' */                        continue;
/*Line 387 - 'AtomControl.js' */                    }

/*Line 389 - 'AtomControl.js' */                    var p = amap["atom-presenter"];
/*Line 390 - 'AtomControl.js' */                    if (p) {
/*Line 391 - 'AtomControl.js' */                        // search upwords for expected presenter...
/*Line 392 - 'AtomControl.js' */                        var owner = AtomUI.getPresenterOwner(this, p.value);
/*Line 393 - 'AtomControl.js' */                        owner["_" + p.value] = child;
/*Line 394 - 'AtomControl.js' */                    }

/*Line 396 - 'AtomControl.js' */                    var childType = amap["atom-type"];

/*Line 398 - 'AtomControl.js' */                    if (childType) {
/*Line 399 - 'AtomControl.js' */                        AtomUI.createControl(child, childType.value);
/*Line 400 - 'AtomControl.js' */                        //element.removeAttributeNode(childType.node);
/*Line 401 - 'AtomControl.js' */                    } else {
/*Line 402 - 'AtomControl.js' */                        this.onCreateChildren(child);
/*Line 403 - 'AtomControl.js' */                    }
/*Line 404 - 'AtomControl.js' */                }
/*Line 405 - 'AtomControl.js' */            },

/*Line 407 - 'AtomControl.js' */            onLoaded: function () {
/*Line 408 - 'AtomControl.js' */            },

/*Line 410 - 'AtomControl.js' */            onUpdateUI: function () {
/*Line 411 - 'AtomControl.js' */                if (this._layout) {
/*Line 412 - 'AtomControl.js' */                    this._layout.doLayout(this._element);
/*Line 413 - 'AtomControl.js' */                } else {
/*Line 414 - 'AtomControl.js' */                    this.updateChildUI(this.get_element());
/*Line 415 - 'AtomControl.js' */                }
/*Line 416 - 'AtomControl.js' */            },

/*Line 418 - 'AtomControl.js' */            updateUI: function () {
/*Line 419 - 'AtomControl.js' */                var ctrl = this;
/*Line 420 - 'AtomControl.js' */                this.dispatcher.callLater(function () {
/*Line 421 - 'AtomControl.js' */                    ctrl.onUpdateUI();
/*Line 422 - 'AtomControl.js' */                });
/*Line 423 - 'AtomControl.js' */            },

/*Line 425 - 'AtomControl.js' */            updateChildUI: function (parent) {
/*Line 426 - 'AtomControl.js' */                if (!parent)
/*Line 427 - 'AtomControl.js' */                    parent = this._element;
/*Line 428 - 'AtomControl.js' */                var ae = new ChildEnumerator(parent);
/*Line 429 - 'AtomControl.js' */                while (ae.next()) {
/*Line 430 - 'AtomControl.js' */                    var child = ae.current();
/*Line 431 - 'AtomControl.js' */                    if (child.atomControl) {
/*Line 432 - 'AtomControl.js' */                        child.atomControl.updateUI();
/*Line 433 - 'AtomControl.js' */                        continue;
/*Line 434 - 'AtomControl.js' */                    }
/*Line 435 - 'AtomControl.js' */                    this.updateChildUI(child);
/*Line 436 - 'AtomControl.js' */                }
/*Line 437 - 'AtomControl.js' */            },

/*Line 439 - 'AtomControl.js' */            onCreationComplete: function () {
/*Line 440 - 'AtomControl.js' */                this.updateUI();
/*Line 441 - 'AtomControl.js' */            },

/*Line 443 - 'AtomControl.js' */            setProperties: function (element) {


/*Line 446 - 'AtomControl.js' */                var obj;
/*Line 447 - 'AtomControl.js' */                var key;
/*Line 448 - 'AtomControl.js' */                var value;
/*Line 449 - 'AtomControl.js' */                var fn;
/*Line 450 - 'AtomControl.js' */                var at;

/*Line 452 - 'AtomControl.js' */                var attr = element.attributes;
/*Line 453 - 'AtomControl.js' */                var ae = new AtomEnumerator(attr);

/*Line 455 - 'AtomControl.js' */                var remove = [];

/*Line 457 - 'AtomControl.js' */                var nodeValue = "value";
/*Line 458 - 'AtomControl.js' */                if (AtomBrowser.isIE && AtomBrowser.majorVersion < 9) {
/*Line 459 - 'AtomControl.js' */                    nodeValue = "nodeValue";
/*Line 460 - 'AtomControl.js' */                }

/*Line 462 - 'AtomControl.js' */                var bindList = {};

/*Line 464 - 'AtomControl.js' */                while (ae.next()) {
/*Line 465 - 'AtomControl.js' */                    at = ae.current();
/*Line 466 - 'AtomControl.js' */                    key = at.nodeName;
/*Line 467 - 'AtomControl.js' */                    value = at[nodeValue];
/*Line 468 - 'AtomControl.js' */                    if (/^atomControl$/g.test(key)) {
/*Line 469 - 'AtomControl.js' */                        continue;
/*Line 470 - 'AtomControl.js' */                    }
/*Line 471 - 'AtomControl.js' */                    if (/^atom\-type$/.test(key)) {
/*Line 472 - 'AtomControl.js' */                        remove.push(at);
/*Line 473 - 'AtomControl.js' */                        continue;
/*Line 474 - 'AtomControl.js' */                    }
/*Line 475 - 'AtomControl.js' */                    if (!(/^(atom|bind|style|event)\-/g.test(key)))
/*Line 476 - 'AtomControl.js' */                        continue;
/*Line 477 - 'AtomControl.js' */                    if (!(/^(style|event)\-/g.test(key)))
/*Line 478 - 'AtomControl.js' */                        key = key.substr(5);

/*Line 480 - 'AtomControl.js' */                    if (!value)
/*Line 481 - 'AtomControl.js' */                        continue;

/*Line 483 - 'AtomControl.js' */                    if (!/(^style$|dock)/.test(key)) {
/*Line 484 - 'AtomControl.js' */                        remove.push(at);
/*Line 485 - 'AtomControl.js' */                    }

/*Line 487 - 'AtomControl.js' */                    // rename key...
/*Line 488 - 'AtomControl.js' */                    key = $.camelCase(key);

/*Line 490 - 'AtomControl.js' */                    bindList[key] = value;

/*Line 492 - 'AtomControl.js' */                }

/*Line 494 - 'AtomControl.js' */                // Since setValue may add up new attributes
/*Line 495 - 'AtomControl.js' */                // We set value after we have collected attribute list
/*Line 496 - 'AtomControl.js' */                for (key in bindList) {
/*Line 497 - 'AtomControl.js' */                    this.setValue(key, bindList[key], true, element);
/*Line 498 - 'AtomControl.js' */                }

/*Line 500 - 'AtomControl.js' */                ae = new AtomEnumerator(remove);
/*Line 501 - 'AtomControl.js' */                while (ae.next()) {
/*Line 502 - 'AtomControl.js' */                    //$(element).removeAttr(ae.current().nodeName);
/*Line 503 - 'AtomControl.js' */                    element.removeAttributeNode(ae.current());
/*Line 504 - 'AtomControl.js' */                }

/*Line 506 - 'AtomControl.js' */                var child = new ChildEnumerator(element);
/*Line 507 - 'AtomControl.js' */                while (child.next()) {
/*Line 508 - 'AtomControl.js' */                    var childItem = child.current();
/*Line 509 - 'AtomControl.js' */                    if (childItem.atomControl)
/*Line 510 - 'AtomControl.js' */                        continue;
/*Line 511 - 'AtomControl.js' */                    this.setProperties(childItem);
/*Line 512 - 'AtomControl.js' */                }

/*Line 514 - 'AtomControl.js' */            },

/*Line 516 - 'AtomControl.js' */            setValue: function (key, value, bind, element) {
/*Line 517 - 'AtomControl.js' */                if (value && value.constructor == String) {
/*Line 518 - 'AtomControl.js' */                    //if (value.indexOf("@@") == 0 || value.indexOf("##") == 0 || value.indexOf("[[") == 0 || value.indexOf("$$") == 0) {
/*Line 519 - 'AtomControl.js' */                    if (/^(@@|##|\[\[|\$\$)/g.test(value)) {
/*Line 520 - 'AtomControl.js' */                        value = value.substr(1);
/*Line 521 - 'AtomControl.js' */                    } else {
/*Line 522 - 'AtomControl.js' */                        if (bind) {
/*Line 523 - 'AtomControl.js' */                            if (/^\{/g.test(value)) {

/*Line 525 - 'AtomControl.js' */                                value = value.substr(0, value.length - 1);
/*Line 526 - 'AtomControl.js' */                                value = value.substr(1);

/*Line 528 - 'AtomControl.js' */                                var be = AtomEvaluator.parse(value);

/*Line 530 - 'AtomControl.js' */                                if (be.path) {
/*Line 531 - 'AtomControl.js' */                                    var ae = new AtomEnumerator(be.path);
/*Line 532 - 'AtomControl.js' */                                    value = [];
/*Line 533 - 'AtomControl.js' */                                    while (ae.next()) {
/*Line 534 - 'AtomControl.js' */                                        value.push(Atom.get(this, ae.current()));
/*Line 535 - 'AtomControl.js' */                                    }
/*Line 536 - 'AtomControl.js' */                                } else {
/*Line 537 - 'AtomControl.js' */                                    value = [value];
/*Line 538 - 'AtomControl.js' */                                }
/*Line 539 - 'AtomControl.js' */                                value.push(Atom);
/*Line 540 - 'AtomControl.js' */                                value.push(AtomPromise);
/*Line 541 - 'AtomControl.js' */                                value = be.method.apply(null, value);

/*Line 543 - 'AtomControl.js' */                                this.setLocalValue(key, value, element);
/*Line 544 - 'AtomControl.js' */                                return;
/*Line 545 - 'AtomControl.js' */                            }
/*Line 546 - 'AtomControl.js' */                            //if (value.indexOf("@[") == 0 || value.indexOf("$[") == 0) {
/*Line 547 - 'AtomControl.js' */                            if (/^(@\[)|(\$\[)/g.test(value)) {
/*Line 548 - 'AtomControl.js' */                                var l = value.lastIndexOf("]");
/*Line 549 - 'AtomControl.js' */                                var events = null;
/*Line 550 - 'AtomControl.js' */                                if (l < value.length - 1) {
/*Line 551 - 'AtomControl.js' */                                    events = value.substr(l + 2);
/*Line 552 - 'AtomControl.js' */                                    events = events.substr(0, events.length - 1);
/*Line 553 - 'AtomControl.js' */                                }
/*Line 554 - 'AtomControl.js' */                                value = value.substr(0, l);
/*Line 555 - 'AtomControl.js' */                                value = value.substr(2);
/*Line 556 - 'AtomControl.js' */                                if (/^(@|\$)/g.test(value)) {
/*Line 557 - 'AtomControl.js' */                                    value = value.substr(1);
/*Line 558 - 'AtomControl.js' */                                }
/*Line 559 - 'AtomControl.js' */                                this.bind(element, key, value, true, null, events);
/*Line 560 - 'AtomControl.js' */                                return;
/*Line 561 - 'AtomControl.js' */                            }
/*Line 562 - 'AtomControl.js' */                            if (/^\[/g.test(value)) {
/*Line 563 - 'AtomControl.js' */                                value = value.substr(0, value.length - 1);
/*Line 564 - 'AtomControl.js' */                                value = value.substr(1);

/*Line 566 - 'AtomControl.js' */                                var be = AtomEvaluator.parse(value);
/*Line 567 - 'AtomControl.js' */                                if (be.length == 0) {
/*Line 568 - 'AtomControl.js' */                                    value = eval(value);
/*Line 569 - 'AtomControl.js' */                                    AtomBinder.setValue(this, key, value);
/*Line 570 - 'AtomControl.js' */                                } else {
/*Line 571 - 'AtomControl.js' */                                    if (be.length == 1 && be.path[0] == be.original) {
/*Line 572 - 'AtomControl.js' */                                        this.bind(element, key, value, false);
/*Line 573 - 'AtomControl.js' */                                    }
/*Line 574 - 'AtomControl.js' */                                    else {
/*Line 575 - 'AtomControl.js' */                                        this.bind(element, key, be.path, false, be.method);
/*Line 576 - 'AtomControl.js' */                                    }
/*Line 577 - 'AtomControl.js' */                                }
/*Line 578 - 'AtomControl.js' */                                return;
/*Line 579 - 'AtomControl.js' */                            }

/*Line 581 - 'AtomControl.js' */                            if (/^(@|\$)/g.test(value)) {
/*Line 582 - 'AtomControl.js' */                                var i = value.indexOf("[");
/*Line 583 - 'AtomControl.js' */                                value = value.substr(i + 1);
/*Line 584 - 'AtomControl.js' */                                value = value.substr(0, value.length - 1);
/*Line 585 - 'AtomControl.js' */                                var be = AtomEvaluator.parse(value);
/*Line 586 - 'AtomControl.js' */                                this.bind(element, key, be.path, false, be.method);
/*Line 587 - 'AtomControl.js' */                                return;
/*Line 588 - 'AtomControl.js' */                            }

/*Line 590 - 'AtomControl.js' */                        }
/*Line 591 - 'AtomControl.js' */                    }
/*Line 592 - 'AtomControl.js' */                }

/*Line 594 - 'AtomControl.js' */                this.setLocalValue(key, value, element);
/*Line 595 - 'AtomControl.js' */            },

/*Line 597 - 'AtomControl.js' */            setLocalValue: function (key, value, element, refresh) {

/*Line 599 - 'AtomControl.js' */                // undefined can never be set
/*Line 600 - 'AtomControl.js' */                if (value === undefined)
/*Line 601 - 'AtomControl.js' */                    return;

/*Line 603 - 'AtomControl.js' */                if (value && value instanceof AtomPromise) {

/*Line 605 - 'AtomControl.js' */                    element._promisesQueue = element._promisesQueue || {};

/*Line 607 - 'AtomControl.js' */                    var op = element._promisesQueue[key];
/*Line 608 - 'AtomControl.js' */                    if (op) {
/*Line 609 - 'AtomControl.js' */                        op.abort();
/*Line 610 - 'AtomControl.js' */                    }
/*Line 611 - 'AtomControl.js' */                    element._promisesQueue[key] = value;

/*Line 613 - 'AtomControl.js' */                    if (value._persist) {

/*Line 615 - 'AtomControl.js' */                        // is it a promise?
/*Line 616 - 'AtomControl.js' */                        this._promises = this._promises || {};

/*Line 618 - 'AtomControl.js' */                        // cache promise...
/*Line 619 - 'AtomControl.js' */                        this._promises[key] = value;


/*Line 622 - 'AtomControl.js' */                    }

/*Line 624 - 'AtomControl.js' */                    var caller = this;

/*Line 626 - 'AtomControl.js' */                    value.then(function (p) {

/*Line 628 - 'AtomControl.js' */                        if (element._promisesQueue[key] == p) {
/*Line 629 - 'AtomControl.js' */                            element._promisesQueue[key] = null;
/*Line 630 - 'AtomControl.js' */                        }

/*Line 632 - 'AtomControl.js' */                        element._promisesQueue[key] = null;

/*Line 634 - 'AtomControl.js' */                        caller.setLocalValue(key, p.value(), element, true);

/*Line 636 - 'AtomControl.js' */                        if (caller._loadNext) {
/*Line 637 - 'AtomControl.js' */                            caller.invokeAction(caller._loadNext);
/*Line 638 - 'AtomControl.js' */                        }
/*Line 639 - 'AtomControl.js' */                    });

/*Line 641 - 'AtomControl.js' */                    value.failed(function (p) {
/*Line 642 - 'AtomControl.js' */                        if (element._promisesQueue[key] == p) {
/*Line 643 - 'AtomControl.js' */                            element._promisesQueue[key] = null;
/*Line 644 - 'AtomControl.js' */                        }
/*Line 645 - 'AtomControl.js' */                    });

/*Line 647 - 'AtomControl.js' */                    value.invoke();
/*Line 648 - 'AtomControl.js' */                    return;

/*Line 650 - 'AtomControl.js' */                }

/*Line 652 - 'AtomControl.js' */                if (this._element == element) {
/*Line 653 - 'AtomControl.js' */                    var fn = this["set_" + key];
/*Line 654 - 'AtomControl.js' */                    if (fn != null) {
/*Line 655 - 'AtomControl.js' */                        if (refresh) {
/*Line 656 - 'AtomControl.js' */                            // checking old value is necessary
/*Line 657 - 'AtomControl.js' */                            // as two way binding may cause recursive
/*Line 658 - 'AtomControl.js' */                            // updates
/*Line 659 - 'AtomControl.js' */                            var oldValue = AtomBinder.getValue(this, key);
/*Line 660 - 'AtomControl.js' */                            if (oldValue == value)
/*Line 661 - 'AtomControl.js' */                                return;
/*Line 662 - 'AtomControl.js' */                        }
/*Line 663 - 'AtomControl.js' */                        fn.apply(this, [value]);
/*Line 664 - 'AtomControl.js' */                        if (refresh) {
/*Line 665 - 'AtomControl.js' */                            AtomBinder.refreshValue(this, key);
/*Line 666 - 'AtomControl.js' */                        }
/*Line 667 - 'AtomControl.js' */                        return;
/*Line 668 - 'AtomControl.js' */                    }
/*Line 669 - 'AtomControl.js' */                }

/*Line 671 - 'AtomControl.js' */                if (/^style/g.test(key) && key.length > 5) {
/*Line 672 - 'AtomControl.js' */                    var k = key.substr(5);
/*Line 673 - 'AtomControl.js' */                    k = String.fromCharCode(k.charCodeAt(0)).toLowerCase() + k.substr(1);
/*Line 674 - 'AtomControl.js' */                    element.style[k] = value;
/*Line 675 - 'AtomControl.js' */                    return;
/*Line 676 - 'AtomControl.js' */                }

/*Line 678 - 'AtomControl.js' */                if (/^event/g.test(key) && key.length > 5) {
/*Line 679 - 'AtomControl.js' */                    var k = key.substr(5);
/*Line 680 - 'AtomControl.js' */                    k = String.fromCharCode(k.charCodeAt(0)).toLowerCase() + k.substr(1);
/*Line 681 - 'AtomControl.js' */                    var _this = this;
/*Line 682 - 'AtomControl.js' */                    // unbind previous event...
/*Line 683 - 'AtomControl.js' */                    this.unbindEvent(element, k);
/*Line 684 - 'AtomControl.js' */                    this.bindEvent(element, k, null, null, function (evt) {
/*Line 685 - 'AtomControl.js' */                        _this.invokeAction(value, evt);
/*Line 686 - 'AtomControl.js' */                    });
/*Line 687 - 'AtomControl.js' */                    return;
/*Line 688 - 'AtomControl.js' */                }

/*Line 690 - 'AtomControl.js' */                var f = AtomProperties[key];
/*Line 691 - 'AtomControl.js' */                if (f) {
/*Line 692 - 'AtomControl.js' */                    f(element || this._element, value);
/*Line 693 - 'AtomControl.js' */                } else {
/*Line 694 - 'AtomControl.js' */                    $(element).attr(key, value);
/*Line 695 - 'AtomControl.js' */                }

/*Line 697 - 'AtomControl.js' */            },

/*Line 699 - 'AtomControl.js' */            bind: function (element, key, value, twoWays, vf, events) {

/*Line 701 - 'AtomControl.js' */                if (value == null) {
/*Line 702 - 'AtomControl.js' */                    // remove existing binding...
/*Line 703 - 'AtomControl.js' */                    this.clearBinding(element, key);
/*Line 704 - 'AtomControl.js' */                    return;
/*Line 705 - 'AtomControl.js' */                }

/*Line 707 - 'AtomControl.js' */                var target = this;
/*Line 708 - 'AtomControl.js' */                if (value && value.constructor == String && /^window\./g.test(value)) {
/*Line 709 - 'AtomControl.js' */                    target = window;
/*Line 710 - 'AtomControl.js' */                }

/*Line 712 - 'AtomControl.js' */                var thisElement = this.get_element();

/*Line 714 - 'AtomControl.js' */                var jq = thisElement != element;

/*Line 716 - 'AtomControl.js' */                if (!jq) {
/*Line 717 - 'AtomControl.js' */                    var f = this["get_" + key];
/*Line 718 - 'AtomControl.js' */                    if (f == undefined || f == null) {
/*Line 719 - 'AtomControl.js' */                        jq = true;
/*Line 720 - 'AtomControl.js' */                    }
/*Line 721 - 'AtomControl.js' */                }

/*Line 723 - 'AtomControl.js' */                switch (key) {
/*Line 724 - 'AtomControl.js' */                    case "value":
/*Line 725 - 'AtomControl.js' */                        if (/input/gi.test(element.nodeName)) { jq = true; }
/*Line 726 - 'AtomControl.js' */                        this.addBinding(target, element, "value", value, twoWays, jq, vf, events);
/*Line 727 - 'AtomControl.js' */                        break;
/*Line 728 - 'AtomControl.js' */                    case "text":
/*Line 729 - 'AtomControl.js' */                        this.addBinding(target, element, "text", value, false, true, vf, events);
/*Line 730 - 'AtomControl.js' */                        break;
/*Line 731 - 'AtomControl.js' */                    default:
/*Line 732 - 'AtomControl.js' */                        this.addBinding(target, element, key, value, twoWays, jq, vf, events);
/*Line 733 - 'AtomControl.js' */                        break;
/*Line 734 - 'AtomControl.js' */                }

/*Line 736 - 'AtomControl.js' */            },

/*Line 738 - 'AtomControl.js' */            initializationComplete: function () {
/*Line 739 - 'AtomControl.js' */            },

/*Line 741 - 'AtomControl.js' */            initialize: function () {

/*Line 743 - 'AtomControl.js' */                // first remove all templates ...
/*Line 744 - 'AtomControl.js' */                base.initialize.apply(this, arguments);

/*Line 746 - 'AtomControl.js' */                // initialize properties...
/*Line 747 - 'AtomControl.js' */                var element = this.get_element();

/*Line 749 - 'AtomControl.js' */                var amap = AtomUI.attributeMap(element, /^atom\-(name|local\-scope)$/gi);

/*Line 751 - 'AtomControl.js' */                var ls = amap["atom-name"];
/*Line 752 - 'AtomControl.js' */                if (ls) {
/*Line 753 - 'AtomControl.js' */                    if (/^(app|window|owner|scope|localScope|parent)$/gi.test(ls.value))
/*Line 754 - 'AtomControl.js' */                        throw new Error("Invalid Control Name '" + ls.value + "'");
/*Line 755 - 'AtomControl.js' */                    var s = this.get_scope();
/*Line 756 - 'AtomControl.js' */                    AtomBinder.setValue(s, ls.value, this);
/*Line 757 - 'AtomControl.js' */                    this._name = ls.value;
/*Line 758 - 'AtomControl.js' */                    element.removeAttributeNode(ls.node);
/*Line 759 - 'AtomControl.js' */                }


/*Line 762 - 'AtomControl.js' */                ls = amap["atom-local-scope"];
/*Line 763 - 'AtomControl.js' */                if (ls) {
/*Line 764 - 'AtomControl.js' */                    this._localScope = new AtomScope(this, this.get_scope(), atomApplication);
/*Line 765 - 'AtomControl.js' */                    this._scope = this._localScope;
/*Line 766 - 'AtomControl.js' */                    if (this._name) {
/*Line 767 - 'AtomControl.js' */                        this._localScope[this._name] = this;
/*Line 768 - 'AtomControl.js' */                    }
/*Line 769 - 'AtomControl.js' */                    element.removeAttributeNode(ls.node);
/*Line 770 - 'AtomControl.js' */                }

/*Line 772 - 'AtomControl.js' */                // scope is now ready, set scopeTemplates...
/*Line 773 - 'AtomControl.js' */                var st = this._scopeTemplates;
/*Line 774 - 'AtomControl.js' */                if (st) {
/*Line 775 - 'AtomControl.js' */                    var s = this.get_scope();
/*Line 776 - 'AtomControl.js' */                    for (var i in st) {
/*Line 777 - 'AtomControl.js' */                        var t = st[i];
/*Line 778 - 'AtomControl.js' */                        AtomBinder.setValue(s, i, t);
/*Line 779 - 'AtomControl.js' */                    }
/*Line 780 - 'AtomControl.js' */                    //try {
/*Line 781 - 'AtomControl.js' */                    //    delete this._scopeTemplates;
/*Line 782 - 'AtomControl.js' */                    //} catch (exx) {

/*Line 784 - 'AtomControl.js' */                    //}
/*Line 785 - 'AtomControl.js' */                }

/*Line 787 - 'AtomControl.js' */                //var fn = Function.createDelegate(this, this.initializeProperties);
/*Line 788 - 'AtomControl.js' */                var _this = this;
/*Line 789 - 'AtomControl.js' */                WebAtoms.dispatcher.callLater(function () {
/*Line 790 - 'AtomControl.js' */                    _this.initializeProperties();
/*Line 791 - 'AtomControl.js' */                });

/*Line 793 - 'AtomControl.js' */                // initialize every children..
/*Line 794 - 'AtomControl.js' */                this.initializeChildren(this._element);

/*Line 796 - 'AtomControl.js' */                //fn = Function.createDelegate(this, this.initializationComplete);
/*Line 797 - 'AtomControl.js' */                WebAtoms.dispatcher.callLater(function () {
/*Line 798 - 'AtomControl.js' */                    _this.initializationComplete();
/*Line 799 - 'AtomControl.js' */                });
/*Line 800 - 'AtomControl.js' */            },


/*Line 803 - 'AtomControl.js' */            dispose: function () {
/*Line 804 - 'AtomControl.js' */                this._disposed = true;
/*Line 805 - 'AtomControl.js' */                this.disposeChildren(this._element);
/*Line 806 - 'AtomControl.js' */                this.clearBinding();
/*Line 807 - 'AtomControl.js' */                this.bindings.length = 0;
/*Line 808 - 'AtomControl.js' */                //WebAtoms.AtomControl.callBaseMethod(this, "dispose");
/*Line 809 - 'AtomControl.js' */                base.dispose.apply(this, arguments);
/*Line 810 - 'AtomControl.js' */            },

/*Line 812 - 'AtomControl.js' */            disposeChildren: function (e) {
/*Line 813 - 'AtomControl.js' */                var oldIE = AtomBrowser.isIE && AtomBrowser.majorVersion < 9;
/*Line 814 - 'AtomControl.js' */                var ae = new ChildEnumerator(e);
/*Line 815 - 'AtomControl.js' */                while (ae.next()) {
/*Line 816 - 'AtomControl.js' */                    var ce = ae.current();
/*Line 817 - 'AtomControl.js' */                    if (ce.atomControl) {
/*Line 818 - 'AtomControl.js' */                        ce.atomControl.dispose();
/*Line 819 - 'AtomControl.js' */                        if (oldIE) {
/*Line 820 - 'AtomControl.js' */                            ce.atomControl = undefined;
/*Line 821 - 'AtomControl.js' */                        } else {
/*Line 822 - 'AtomControl.js' */                            delete ce.atomControl;
/*Line 823 - 'AtomControl.js' */                        }
/*Line 824 - 'AtomControl.js' */                    } else {
/*Line 825 - 'AtomControl.js' */                        this.clearBinding(ce);
/*Line 826 - 'AtomControl.js' */                        this.unbindEvent(ce);
/*Line 827 - 'AtomControl.js' */                        this.disposeChildren(ce);
/*Line 828 - 'AtomControl.js' */                    }
/*Line 829 - 'AtomControl.js' */                    //$(ce).remove();
/*Line 830 - 'AtomControl.js' */                }
/*Line 831 - 'AtomControl.js' */                // this will and should remove every children..
/*Line 832 - 'AtomControl.js' */                try {
/*Line 833 - 'AtomControl.js' */                    e.innerHTML = "";
/*Line 834 - 'AtomControl.js' */                } catch (ex) {
/*Line 835 - 'AtomControl.js' */                    $(e).html('');
/*Line 836 - 'AtomControl.js' */                }
/*Line 837 - 'AtomControl.js' */            },

/*Line 839 - 'AtomControl.js' */            get_innerTemplate: function () {
/*Line 840 - 'AtomControl.js' */                return this._template;
/*Line 841 - 'AtomControl.js' */            },

/*Line 843 - 'AtomControl.js' */            set_innerTemplate: function (v) {
/*Line 844 - 'AtomControl.js' */                if (this._template === v) {
/*Line 845 - 'AtomControl.js' */                    if (this._created)
/*Line 846 - 'AtomControl.js' */                        return;
/*Line 847 - 'AtomControl.js' */                }
/*Line 848 - 'AtomControl.js' */                if (!this._created) {
/*Line 849 - 'AtomControl.js' */                    var _this = this;
/*Line 850 - 'AtomControl.js' */                    // this is because, sometimes template change occurs while creation
/*Line 851 - 'AtomControl.js' */                    // which creates endless loop
/*Line 852 - 'AtomControl.js' */                    WebAtoms.dispatcher.callLater(function () {
/*Line 853 - 'AtomControl.js' */                        _this.set_innerTemplate(v);
/*Line 854 - 'AtomControl.js' */                    });
/*Line 855 - 'AtomControl.js' */                    return;
/*Line 856 - 'AtomControl.js' */                }
/*Line 857 - 'AtomControl.js' */                this._template = v;
/*Line 858 - 'AtomControl.js' */                // disposing all children...
/*Line 859 - 'AtomControl.js' */                this.disposeChildren(this._element);

/*Line 861 - 'AtomControl.js' */                this.createChildren();
/*Line 862 - 'AtomControl.js' */                this.setProperties(this._element);
/*Line 863 - 'AtomControl.js' */                this.initializeChildren(this._element);
/*Line 864 - 'AtomControl.js' */                this.updateUI();
/*Line 865 - 'AtomControl.js' */            },

/*Line 867 - 'AtomControl.js' */            initializeChildren: function (e) {
/*Line 868 - 'AtomControl.js' */                var ae = new ChildEnumerator(e);
/*Line 869 - 'AtomControl.js' */                var item;
/*Line 870 - 'AtomControl.js' */                var ctrl;

/*Line 872 - 'AtomControl.js' */                var remove = [];

/*Line 874 - 'AtomControl.js' */                while (ae.next()) {
/*Line 875 - 'AtomControl.js' */                    item = ae.current();

/*Line 877 - 'AtomControl.js' */                    if (item.nodeName == "SCRIPT") {

/*Line 879 - 'AtomControl.js' */                        // evalute and set scope...
/*Line 880 - 'AtomControl.js' */                        var s = $.trim(item.innerHTML);
/*Line 881 - 'AtomControl.js' */                        if (/^\(\{/.test(s) && /\}\)$/.test(s)) {
/*Line 882 - 'AtomControl.js' */                            try {
/*Line 883 - 'AtomControl.js' */                                s = (new Function("return " + s + ";"))()
/*Line 884 - 'AtomControl.js' */                                //this.set_scope(s);
/*Line 885 - 'AtomControl.js' */                                var scope = this._localScope || this.get_scope();
/*Line 886 - 'AtomControl.js' */                                for (var k in s) {
/*Line 887 - 'AtomControl.js' */                                    if (scope[k])
/*Line 888 - 'AtomControl.js' */                                        continue;
/*Line 889 - 'AtomControl.js' */                                    scope[k] = s[k];
/*Line 890 - 'AtomControl.js' */                                }
/*Line 891 - 'AtomControl.js' */                            } catch (ex) {
/*Line 892 - 'AtomControl.js' */                                log(JSON.stringify(ex));
/*Line 893 - 'AtomControl.js' */                                alert(JSON.stringify(ex));
/*Line 894 - 'AtomControl.js' */                            }

/*Line 896 - 'AtomControl.js' */                        }
/*Line 897 - 'AtomControl.js' */                        remove.push(item);
/*Line 898 - 'AtomControl.js' */                        continue;

/*Line 900 - 'AtomControl.js' */                    }

/*Line 902 - 'AtomControl.js' */                    ctrl = item.atomControl;
/*Line 903 - 'AtomControl.js' */                    if (ctrl) {
/*Line 904 - 'AtomControl.js' */                        ctrl.initialize();
/*Line 905 - 'AtomControl.js' */                    } else {
/*Line 906 - 'AtomControl.js' */                        this.initializeChildren(item);
/*Line 907 - 'AtomControl.js' */                    }
/*Line 908 - 'AtomControl.js' */                }

/*Line 910 - 'AtomControl.js' */                ae = new AtomEnumerator(remove);
/*Line 911 - 'AtomControl.js' */                while (ae.next()) {
/*Line 912 - 'AtomControl.js' */                    e.removeChild(ae.current());
/*Line 913 - 'AtomControl.js' */                }
/*Line 914 - 'AtomControl.js' */            }
/*Line 915 - 'AtomControl.js' */        }
/*Line 916 - 'AtomControl.js' */    });
/*Line 917 - 'AtomControl.js' */})(window,"WebAtoms.AtomControl",WebAtoms.AtomUIComponent.prototype);
/*Line 0 - 'AtomItemsControl.js' */

/*Line 2 - 'AtomItemsControl.js' */(function (window, base) {
/*Line 3 - 'AtomItemsControl.js' */    return classCreatorEx({
/*Line 4 - 'AtomItemsControl.js' */        name: "WebAtoms.AtomItemsControl",
/*Line 5 - 'AtomItemsControl.js' */        base: base,
/*Line 6 - 'AtomItemsControl.js' */        start: function () {
/*Line 7 - 'AtomItemsControl.js' */            this._selectedItems = [];
/*Line 8 - 'AtomItemsControl.js' */            this._selectedElements = [];
/*Line 9 - 'AtomItemsControl.js' */            this._selectedIndexSet = false;
/*Line 10 - 'AtomItemsControl.js' */            this._onUIChanged = false;
/*Line 11 - 'AtomItemsControl.js' */            this._itemsPresenter = null;
/*Line 12 - 'AtomItemsControl.js' */            this._itemsPanel = null;
/*Line 13 - 'AtomItemsControl.js' */            this._presenters = ["itemsPresenter"];
/*Line 14 - 'AtomItemsControl.js' */        },
/*Line 15 - 'AtomItemsControl.js' */        properties: {
/*Line 16 - 'AtomItemsControl.js' */            allowSelectFirst: false,
/*Line 17 - 'AtomItemsControl.js' */            allowMultipleSelection: false,
/*Line 18 - 'AtomItemsControl.js' */            uiVirtualize: false,
/*Line 19 - 'AtomItemsControl.js' */            defaultValue: null,
/*Line 20 - 'AtomItemsControl.js' */            autoScrollToSelection: false,
/*Line 21 - 'AtomItemsControl.js' */            /* this forces SelectAll Checkbox to ignore value of get_selectAll and forces its own value on click */
/*Line 22 - 'AtomItemsControl.js' */            selectAll: undefined,
/*Line 23 - 'AtomItemsControl.js' */            labelPath: "label",
/*Line 24 - 'AtomItemsControl.js' */            valuePath: "value",
/*Line 25 - 'AtomItemsControl.js' */            sortPath: null,
/*Line 26 - 'AtomItemsControl.js' */            valueSeparator: null,
/*Line 27 - 'AtomItemsControl.js' */            postData: null,
/*Line 28 - 'AtomItemsControl.js' */            postUrl: null,
/*Line 29 - 'AtomItemsControl.js' */            confirm: false,
/*Line 30 - 'AtomItemsControl.js' */            confirmMessage: null,
/*Line 31 - 'AtomItemsControl.js' */            filter: null,
/*Line 32 - 'AtomItemsControl.js' */            items: null,
/*Line 33 - 'AtomItemsControl.js' */            itemTemplate: null
/*Line 34 - 'AtomItemsControl.js' */        },
/*Line 35 - 'AtomItemsControl.js' */        methods: {
/*Line 36 - 'AtomItemsControl.js' */            get_postData: function () {
/*Line 37 - 'AtomItemsControl.js' */                return this._postData || this.get_selectedItem();
/*Line 38 - 'AtomItemsControl.js' */            },
/*Line 39 - 'AtomItemsControl.js' */            get_value: function () {

/*Line 41 - 'AtomItemsControl.js' */                if (this._allowMultipleSelection) {
/*Line 42 - 'AtomItemsControl.js' */                    var items = this._selectedItems;
/*Line 43 - 'AtomItemsControl.js' */                    if (items.length == 0) {
/*Line 44 - 'AtomItemsControl.js' */                        if (this._value !== undefined)
/*Line 45 - 'AtomItemsControl.js' */                            return this._value;
/*Line 46 - 'AtomItemsControl.js' */                        return null;
/*Line 47 - 'AtomItemsControl.js' */                    }
/*Line 48 - 'AtomItemsControl.js' */                    items = AtomArray.getValues(items, this._valuePath);
/*Line 49 - 'AtomItemsControl.js' */                    if (this._valueSeparator)
/*Line 50 - 'AtomItemsControl.js' */                        items = items.join(this._valueSeparator);
/*Line 51 - 'AtomItemsControl.js' */                    return items;
/*Line 52 - 'AtomItemsControl.js' */                }

/*Line 54 - 'AtomItemsControl.js' */                var s = this.get_selectedItem();
/*Line 55 - 'AtomItemsControl.js' */                if (!s) {
/*Line 56 - 'AtomItemsControl.js' */                    if (this._value !== undefined)
/*Line 57 - 'AtomItemsControl.js' */                        return this._value;
/*Line 58 - 'AtomItemsControl.js' */                    return null;
/*Line 59 - 'AtomItemsControl.js' */                }
/*Line 60 - 'AtomItemsControl.js' */                if (this._valuePath) {
/*Line 61 - 'AtomItemsControl.js' */                    s = s[this._valuePath];
/*Line 62 - 'AtomItemsControl.js' */                }
/*Line 63 - 'AtomItemsControl.js' */                return s;
/*Line 64 - 'AtomItemsControl.js' */            },
/*Line 65 - 'AtomItemsControl.js' */            set_value: function (v) {
/*Line 66 - 'AtomItemsControl.js' */                this._value = v;
/*Line 67 - 'AtomItemsControl.js' */                if (v === undefined || v === null) {
/*Line 68 - 'AtomItemsControl.js' */                    // reset...
/*Line 69 - 'AtomItemsControl.js' */                    AtomBinder.clear(this._selectedItems);
/*Line 70 - 'AtomItemsControl.js' */                    return;
/*Line 71 - 'AtomItemsControl.js' */                }
/*Line 72 - 'AtomItemsControl.js' */                var dataItems = this.get_dataItems();
/*Line 73 - 'AtomItemsControl.js' */                if (this._allowMultipleSelection && this._valueSeparator) {
/*Line 74 - 'AtomItemsControl.js' */                    if (v.constructor != String) {
/*Line 75 - 'AtomItemsControl.js' */                        v = "" + v;
/*Line 76 - 'AtomItemsControl.js' */                    }
/*Line 77 - 'AtomItemsControl.js' */                    v = AtomArray.split(v, this._valueSeparator);
/*Line 78 - 'AtomItemsControl.js' */                } else {
/*Line 79 - 'AtomItemsControl.js' */                    v = [v];
/*Line 80 - 'AtomItemsControl.js' */                }
/*Line 81 - 'AtomItemsControl.js' */                var items = AtomArray.intersect(dataItems, this._valuePath, v);
/*Line 82 - 'AtomItemsControl.js' */                this._selectedItems.length = 0;
/*Line 83 - 'AtomItemsControl.js' */                var ae = new AtomEnumerator(items);
/*Line 84 - 'AtomItemsControl.js' */                while (ae.next()) {
/*Line 85 - 'AtomItemsControl.js' */                    //AtomBinder.addItem(this._selectedItems, ae.current());
/*Line 86 - 'AtomItemsControl.js' */                    this._selectedItems.push(ae.current());
/*Line 87 - 'AtomItemsControl.js' */                }
/*Line 88 - 'AtomItemsControl.js' */                AtomBinder.refreshItems(this._selectedItems);
/*Line 89 - 'AtomItemsControl.js' */            },
/*Line 90 - 'AtomItemsControl.js' */            set_sortPath: function (v) {
/*Line 91 - 'AtomItemsControl.js' */                this._sortPath = v;
/*Line 92 - 'AtomItemsControl.js' */                if (v) {
/*Line 93 - 'AtomItemsControl.js' */                    this.onCollectionChangedInternal("refresh", -1, null);
/*Line 94 - 'AtomItemsControl.js' */                }
/*Line 95 - 'AtomItemsControl.js' */            },
/*Line 96 - 'AtomItemsControl.js' */            set_selectAll: function (v) {
/*Line 97 - 'AtomItemsControl.js' */                if (v === undefined || v === null)
/*Line 98 - 'AtomItemsControl.js' */                    return;
/*Line 99 - 'AtomItemsControl.js' */                this._selectedItems.length = 0;
/*Line 100 - 'AtomItemsControl.js' */                var items = this.get_dataItems();
/*Line 101 - 'AtomItemsControl.js' */                if (v && items) {
/*Line 102 - 'AtomItemsControl.js' */                    var ae = new AtomEnumerator(items);
/*Line 103 - 'AtomItemsControl.js' */                    while (ae.next()) {
/*Line 104 - 'AtomItemsControl.js' */                        this._selectedItems.push(ae.current());
/*Line 105 - 'AtomItemsControl.js' */                    }
/*Line 106 - 'AtomItemsControl.js' */                }
/*Line 107 - 'AtomItemsControl.js' */                AtomBinder.refreshItems(this._selectedItems);
/*Line 108 - 'AtomItemsControl.js' */            },
/*Line 109 - 'AtomItemsControl.js' */            refresh: function () {
/*Line 110 - 'AtomItemsControl.js' */                if (this._promises && this._promises.items) {
/*Line 111 - 'AtomItemsControl.js' */                    this._promises.items.invoke();
/*Line 112 - 'AtomItemsControl.js' */                }

/*Line 114 - 'AtomItemsControl.js' */            },

/*Line 116 - 'AtomItemsControl.js' */            set_defaultValue: function (v) {
/*Line 117 - 'AtomItemsControl.js' */                if (this.get_value())
/*Line 118 - 'AtomItemsControl.js' */                    return;
/*Line 119 - 'AtomItemsControl.js' */                AtomBinder.setValue(this, "value", v);
/*Line 120 - 'AtomItemsControl.js' */            },
/*Line 121 - 'AtomItemsControl.js' */            invokePost: function () {
/*Line 122 - 'AtomItemsControl.js' */                if (this._confirm) {
/*Line 123 - 'AtomItemsControl.js' */                    if (!confirm(this._confirmMessage))
/*Line 124 - 'AtomItemsControl.js' */                        return;
/*Line 125 - 'AtomItemsControl.js' */                }

/*Line 127 - 'AtomItemsControl.js' */                if (!this._postUrl) {
/*Line 128 - 'AtomItemsControl.js' */                    this.invokeAction(this._next);
/*Line 129 - 'AtomItemsControl.js' */                    return;
/*Line 130 - 'AtomItemsControl.js' */                }

/*Line 132 - 'AtomItemsControl.js' */                var data = this.get_postData();

/*Line 134 - 'AtomItemsControl.js' */                if (data === null || data === undefined)
/*Line 135 - 'AtomItemsControl.js' */                    return;

/*Line 137 - 'AtomItemsControl.js' */                data = AtomBinder.getClone(data);

/*Line 139 - 'AtomItemsControl.js' */                var caller = this;
/*Line 140 - 'AtomItemsControl.js' */                var p = AtomPromise.json(this._postUrl, null, { type: "POST", data: data });
/*Line 141 - 'AtomItemsControl.js' */                p.then(function () {
/*Line 142 - 'AtomItemsControl.js' */                    caller.invokeNext();
/*Line 143 - 'AtomItemsControl.js' */                });
/*Line 144 - 'AtomItemsControl.js' */                p.invoke();
/*Line 145 - 'AtomItemsControl.js' */            },

/*Line 147 - 'AtomItemsControl.js' */            invokeNext: function () {
/*Line 148 - 'AtomItemsControl.js' */                this.invokeAction(this._next);
/*Line 149 - 'AtomItemsControl.js' */            },

/*Line 151 - 'AtomItemsControl.js' */            set_filter: function (f) {
/*Line 152 - 'AtomItemsControl.js' */                if (f == this._filter)
/*Line 153 - 'AtomItemsControl.js' */                    return;
/*Line 154 - 'AtomItemsControl.js' */                this._filter = f;
/*Line 155 - 'AtomItemsControl.js' */                this._filteredItems = null;
/*Line 156 - 'AtomItemsControl.js' */                this.applyFilter();
/*Line 157 - 'AtomItemsControl.js' */            },

/*Line 159 - 'AtomItemsControl.js' */            applyFilter: function () {

/*Line 161 - 'AtomItemsControl.js' */                if (this._filter && this.hasItems()) {
/*Line 162 - 'AtomItemsControl.js' */                    this.onCollectionChangedInternal("refresh", -1, null);
/*Line 163 - 'AtomItemsControl.js' */                }

/*Line 165 - 'AtomItemsControl.js' */            },

/*Line 167 - 'AtomItemsControl.js' */            isSelected: function (item) {
/*Line 168 - 'AtomItemsControl.js' */                var se = new AtomEnumerator(this._selectedItems);
/*Line 169 - 'AtomItemsControl.js' */                var sitem = null;
/*Line 170 - 'AtomItemsControl.js' */                while (se.next()) {
/*Line 171 - 'AtomItemsControl.js' */                    sitem = se.current();
/*Line 172 - 'AtomItemsControl.js' */                    if (sitem == item) {
/*Line 173 - 'AtomItemsControl.js' */                        return true;
/*Line 174 - 'AtomItemsControl.js' */                    }
/*Line 175 - 'AtomItemsControl.js' */                }
/*Line 176 - 'AtomItemsControl.js' */                return false;
/*Line 177 - 'AtomItemsControl.js' */            },

/*Line 179 - 'AtomItemsControl.js' */            get_dataItems: function () {
/*Line 180 - 'AtomItemsControl.js' */                if (this.hasItems()) {
/*Line 181 - 'AtomItemsControl.js' */                    var f = this._filter;
/*Line 182 - 'AtomItemsControl.js' */                    if (f) {
/*Line 183 - 'AtomItemsControl.js' */                        //if (this._filteredItems)
/*Line 184 - 'AtomItemsControl.js' */                        //    return this._filteredItems;
/*Line 185 - 'AtomItemsControl.js' */                        var a = [];
/*Line 186 - 'AtomItemsControl.js' */                        if (typeof f == 'object') {
/*Line 187 - 'AtomItemsControl.js' */                            a = Atom.query(this._items).where(f).toArray();
/*Line 188 - 'AtomItemsControl.js' */                        } else {
/*Line 189 - 'AtomItemsControl.js' */                            var ae = new AtomEnumerator(this._items);
/*Line 190 - 'AtomItemsControl.js' */                            while (ae.next()) {
/*Line 191 - 'AtomItemsControl.js' */                                var item = ae.current();
/*Line 192 - 'AtomItemsControl.js' */                                if (f(item, ae.currentIndex())) {
/*Line 193 - 'AtomItemsControl.js' */                                    a.push(item);
/*Line 194 - 'AtomItemsControl.js' */                                }
/*Line 195 - 'AtomItemsControl.js' */                            }
/*Line 196 - 'AtomItemsControl.js' */                        }
/*Line 197 - 'AtomItemsControl.js' */                        this._filteredItems = a;
/*Line 198 - 'AtomItemsControl.js' */                        return a;
/*Line 199 - 'AtomItemsControl.js' */                    }
/*Line 200 - 'AtomItemsControl.js' */                    return this._items;
/*Line 201 - 'AtomItemsControl.js' */                }
/*Line 202 - 'AtomItemsControl.js' */                return $(this._itemsPresenter).children();
/*Line 203 - 'AtomItemsControl.js' */            },

/*Line 205 - 'AtomItemsControl.js' */            getIndexOfDataItem: function (item) {
/*Line 206 - 'AtomItemsControl.js' */                if (item == null)
/*Line 207 - 'AtomItemsControl.js' */                    return -1;
/*Line 208 - 'AtomItemsControl.js' */                var array = this.get_dataItems();
/*Line 209 - 'AtomItemsControl.js' */                var ae = new AtomEnumerator(array);
/*Line 210 - 'AtomItemsControl.js' */                while (ae.next()) {
/*Line 211 - 'AtomItemsControl.js' */                    if (ae.current() == item)
/*Line 212 - 'AtomItemsControl.js' */                        return ae.currentIndex();
/*Line 213 - 'AtomItemsControl.js' */                }
/*Line 214 - 'AtomItemsControl.js' */                return -1;
/*Line 215 - 'AtomItemsControl.js' */            },
/*Line 216 - 'AtomItemsControl.js' */            getDataItemAtIndex: function (index) {
/*Line 217 - 'AtomItemsControl.js' */                if (index == -1)
/*Line 218 - 'AtomItemsControl.js' */                    return null;
/*Line 219 - 'AtomItemsControl.js' */                return this.get_dataItems()[index];
/*Line 220 - 'AtomItemsControl.js' */            },

/*Line 222 - 'AtomItemsControl.js' */            get_childAtomControls: function () {
/*Line 223 - 'AtomItemsControl.js' */                var p = this._itemsPresenter || this._element;
/*Line 224 - 'AtomItemsControl.js' */                var r = [];
/*Line 225 - 'AtomItemsControl.js' */                var ce = new ChildEnumerator(p);
/*Line 226 - 'AtomItemsControl.js' */                while (ce.next()) {
/*Line 227 - 'AtomItemsControl.js' */                    var a = ce.current();
/*Line 228 - 'AtomItemsControl.js' */                    a = !a || a.atomControl;
/*Line 229 - 'AtomItemsControl.js' */                    if (!a)
/*Line 230 - 'AtomItemsControl.js' */                        continue;
/*Line 231 - 'AtomItemsControl.js' */                    r.push(a);
/*Line 232 - 'AtomItemsControl.js' */                }
/*Line 233 - 'AtomItemsControl.js' */                return r;
/*Line 234 - 'AtomItemsControl.js' */            },

/*Line 236 - 'AtomItemsControl.js' */            get_selectedChild: function () {
/*Line 237 - 'AtomItemsControl.js' */                var item = this.get_selectedItem();
/*Line 238 - 'AtomItemsControl.js' */                if (!this.hasItems())
/*Line 239 - 'AtomItemsControl.js' */                    return item;
/*Line 240 - 'AtomItemsControl.js' */                var ce = new ChildEnumerator(this._itemsPresenter);
/*Line 241 - 'AtomItemsControl.js' */                while (ce.next()) {
/*Line 242 - 'AtomItemsControl.js' */                    var child = ce.current();
/*Line 243 - 'AtomItemsControl.js' */                    if (child.atomControl.get_data() == item)
/*Line 244 - 'AtomItemsControl.js' */                        return child;
/*Line 245 - 'AtomItemsControl.js' */                }
/*Line 246 - 'AtomItemsControl.js' */                return null;
/*Line 247 - 'AtomItemsControl.js' */            },

/*Line 249 - 'AtomItemsControl.js' */            set_allowSelectFirst: function (b) {
/*Line 250 - 'AtomItemsControl.js' */                b = b ? b != "false" : b;
/*Line 251 - 'AtomItemsControl.js' */                this._allowSelectFirst = b;
/*Line 252 - 'AtomItemsControl.js' */            },

/*Line 254 - 'AtomItemsControl.js' */            get_selectedItem: function () {
/*Line 255 - 'AtomItemsControl.js' */                if (this._selectedItems.length > 0)
/*Line 256 - 'AtomItemsControl.js' */                    return this._selectedItems[0];
/*Line 257 - 'AtomItemsControl.js' */                return null;
/*Line 258 - 'AtomItemsControl.js' */            },
/*Line 259 - 'AtomItemsControl.js' */            set_selectedItem: function (value) {
/*Line 260 - 'AtomItemsControl.js' */                if (value) {
/*Line 261 - 'AtomItemsControl.js' */                    this._selectedItems.length = 1;
/*Line 262 - 'AtomItemsControl.js' */                    this._selectedItems[0] = value;
/*Line 263 - 'AtomItemsControl.js' */                } else {
/*Line 264 - 'AtomItemsControl.js' */                    this._selectedItems.length = 0;
/*Line 265 - 'AtomItemsControl.js' */                }
/*Line 266 - 'AtomItemsControl.js' */                AtomBinder.refreshItems(this._selectedItems);
/*Line 267 - 'AtomItemsControl.js' */            },

/*Line 269 - 'AtomItemsControl.js' */            get_selectedItems: function () {
/*Line 270 - 'AtomItemsControl.js' */                return this._selectedItems;
/*Line 271 - 'AtomItemsControl.js' */            },
/*Line 272 - 'AtomItemsControl.js' */            set_selectedItems: function () {
/*Line 273 - 'AtomItemsControl.js' */                // watching !!!
/*Line 274 - 'AtomItemsControl.js' */                // updating !!!
/*Line 275 - 'AtomItemsControl.js' */                throw new Error("Not yet implemented");
/*Line 276 - 'AtomItemsControl.js' */            },

/*Line 278 - 'AtomItemsControl.js' */            get_selectedIndex: function () {
/*Line 279 - 'AtomItemsControl.js' */                var item = this.get_selectedItem();
/*Line 280 - 'AtomItemsControl.js' */                return this.getIndexOfDataItem(item);
/*Line 281 - 'AtomItemsControl.js' */            },
/*Line 282 - 'AtomItemsControl.js' */            set_selectedIndex: function (value) {
/*Line 283 - 'AtomItemsControl.js' */                AtomBinder.setValue(this, "selectedItem", this.getDataItemAtIndex(value));
/*Line 284 - 'AtomItemsControl.js' */            },

/*Line 286 - 'AtomItemsControl.js' */            updateChildSelections: function (type, index, item) {

/*Line 288 - 'AtomItemsControl.js' */            },

/*Line 290 - 'AtomItemsControl.js' */            bringSelectionIntoView: function () {

/*Line 292 - 'AtomItemsControl.js' */                // do not scroll for first auto select 
/*Line 293 - 'AtomItemsControl.js' */                if (this._allowSelectFirst && this.get_selectedIndex() == 0)
/*Line 294 - 'AtomItemsControl.js' */                    return;

/*Line 296 - 'AtomItemsControl.js' */                //var children = $(this._itemsPresenter).children();
/*Line 297 - 'AtomItemsControl.js' */                var ae = new ChildEnumerator(this._itemsPresenter);
/*Line 298 - 'AtomItemsControl.js' */                while (ae.next()) {
/*Line 299 - 'AtomItemsControl.js' */                    var item = ae.current();
/*Line 300 - 'AtomItemsControl.js' */                    var dataItem = item.atomControl ? item.atomControl.get_data() : item;
/*Line 301 - 'AtomItemsControl.js' */                    if (this.isSelected(dataItem)) {
/*Line 302 - 'AtomItemsControl.js' */                        item.scrollIntoView();
/*Line 303 - 'AtomItemsControl.js' */                        return;
/*Line 304 - 'AtomItemsControl.js' */                    }
/*Line 305 - 'AtomItemsControl.js' */                }
/*Line 306 - 'AtomItemsControl.js' */            },

/*Line 308 - 'AtomItemsControl.js' */            updateSelectionBindings: function () {
/*Line 309 - 'AtomItemsControl.js' */                AtomBinder.refreshValue(this, "value");
/*Line 310 - 'AtomItemsControl.js' */                AtomBinder.refreshValue(this, "selectedItem");
/*Line 311 - 'AtomItemsControl.js' */                AtomBinder.refreshValue(this, "selectedItems");
/*Line 312 - 'AtomItemsControl.js' */                AtomBinder.refreshValue(this, "selectedIndex");
/*Line 313 - 'AtomItemsControl.js' */            },

/*Line 315 - 'AtomItemsControl.js' */            onSelectedItemsChanged: function (type, index, item) {
/*Line 316 - 'AtomItemsControl.js' */                if (!this._onUIChanged) {
/*Line 317 - 'AtomItemsControl.js' */                    this.updateChildSelections(type, index, item);
/*Line 318 - 'AtomItemsControl.js' */                    if (this._autoScrollToSelection) {
/*Line 319 - 'AtomItemsControl.js' */                        this.bringSelectionIntoView();
/*Line 320 - 'AtomItemsControl.js' */                    }
/*Line 321 - 'AtomItemsControl.js' */                }
/*Line 322 - 'AtomItemsControl.js' */                this.updateSelectionBindings();
/*Line 323 - 'AtomItemsControl.js' */                this.updateUI();

/*Line 325 - 'AtomItemsControl.js' */                this.invokePost();
/*Line 326 - 'AtomItemsControl.js' */            },


/*Line 329 - 'AtomItemsControl.js' */            hasItems: function () {
/*Line 330 - 'AtomItemsControl.js' */                return this._items != undefined && this._items != null;
/*Line 331 - 'AtomItemsControl.js' */            },

/*Line 333 - 'AtomItemsControl.js' */            get_items: function () {
/*Line 334 - 'AtomItemsControl.js' */                return this._items;
/*Line 335 - 'AtomItemsControl.js' */            },
/*Line 336 - 'AtomItemsControl.js' */            set_items: function (v) {
/*Line 337 - 'AtomItemsControl.js' */                var _this = this;
/*Line 338 - 'AtomItemsControl.js' */                if (this._items) {
/*Line 339 - 'AtomItemsControl.js' */                    this.unbindEvent(this._items, "CollectionChanged", null);
/*Line 340 - 'AtomItemsControl.js' */                }
/*Line 341 - 'AtomItemsControl.js' */                this._items = v;
/*Line 342 - 'AtomItemsControl.js' */                this._filteredItems = null;
/*Line 343 - 'AtomItemsControl.js' */                // try starting observing....
/*Line 344 - 'AtomItemsControl.js' */                if (v != null) {
/*Line 345 - 'AtomItemsControl.js' */                    this.bindEvent(this._items, "CollectionChanged", function () {
/*Line 346 - 'AtomItemsControl.js' */                        _this.onCollectionChangedInternal.apply(_this, arguments);
/*Line 347 - 'AtomItemsControl.js' */                    });
/*Line 348 - 'AtomItemsControl.js' */                    this.onCollectionChangedInternal("refresh", -1, null);
/*Line 349 - 'AtomItemsControl.js' */                }
/*Line 350 - 'AtomItemsControl.js' */            },
/*Line 351 - 'AtomItemsControl.js' */            set_itemTemplate: function (v) {
/*Line 352 - 'AtomItemsControl.js' */                this._itemTemplate = v;
/*Line 353 - 'AtomItemsControl.js' */                this.onCollectionChangedInternal("refresh", -1, null);
/*Line 354 - 'AtomItemsControl.js' */            },

/*Line 356 - 'AtomItemsControl.js' */            onCollectionChangedInternal: function (mode, index, item) {
/*Line 357 - 'AtomItemsControl.js' */                if (!this._created)
/*Line 358 - 'AtomItemsControl.js' */                    return;

/*Line 360 - 'AtomItemsControl.js' */                var value = this.get_value();

/*Line 362 - 'AtomItemsControl.js' */                if (this.hasItems()) {
/*Line 363 - 'AtomItemsControl.js' */                    this.onCollectionChanged(mode, index, item);
/*Line 364 - 'AtomItemsControl.js' */                    //this._selectedItems.length = 0;
/*Line 365 - 'AtomItemsControl.js' */                    if (!(value || this._allowSelectFirst)) {
/*Line 366 - 'AtomItemsControl.js' */                        AtomBinder.clear(this._selectedItems);
/*Line 367 - 'AtomItemsControl.js' */                    }
/*Line 368 - 'AtomItemsControl.js' */                }


/*Line 371 - 'AtomItemsControl.js' */                if (value != null) {
/*Line 372 - 'AtomItemsControl.js' */                    this.set_value(value);
/*Line 373 - 'AtomItemsControl.js' */                    if (this.get_selectedIndex() != -1)
/*Line 374 - 'AtomItemsControl.js' */                        return;
/*Line 375 - 'AtomItemsControl.js' */                }

/*Line 377 - 'AtomItemsControl.js' */                this.selectDefault();

/*Line 379 - 'AtomItemsControl.js' */            },

/*Line 381 - 'AtomItemsControl.js' */            selectDefault: function () {


/*Line 384 - 'AtomItemsControl.js' */                if (this._allowSelectFirst) {
/*Line 385 - 'AtomItemsControl.js' */                    if (this.get_dataItems().length > 0) {
/*Line 386 - 'AtomItemsControl.js' */                        this.set_selectedIndex(0);
/*Line 387 - 'AtomItemsControl.js' */                        return;
/*Line 388 - 'AtomItemsControl.js' */                    }
/*Line 389 - 'AtomItemsControl.js' */                }

/*Line 391 - 'AtomItemsControl.js' */                this.updateSelectionBindings();
/*Line 392 - 'AtomItemsControl.js' */            },

/*Line 394 - 'AtomItemsControl.js' */            onScroll: function () {
/*Line 395 - 'AtomItemsControl.js' */                if (this.scrollTimeout) {
/*Line 396 - 'AtomItemsControl.js' */                    clearTimeout(this.scrollTimeout);
/*Line 397 - 'AtomItemsControl.js' */                }
/*Line 398 - 'AtomItemsControl.js' */                var _this = this;
/*Line 399 - 'AtomItemsControl.js' */                this.scrollTimeout = setTimeout(function () {
/*Line 400 - 'AtomItemsControl.js' */                    _this.scrollTimeout = 0;
/*Line 401 - 'AtomItemsControl.js' */                    _this.onCollectionChangedInternal("refresh", -1, null);
/*Line 402 - 'AtomItemsControl.js' */                }, 1000);
/*Line 403 - 'AtomItemsControl.js' */            },

/*Line 405 - 'AtomItemsControl.js' */            onCollectionChanged: function (mode, index, item) {
/*Line 406 - 'AtomItemsControl.js' */                // just reset for now...
/*Line 407 - 'AtomItemsControl.js' */                if (/remove/gi.test(mode)) {
/*Line 408 - 'AtomItemsControl.js' */                    // simply delete and remove...
/*Line 409 - 'AtomItemsControl.js' */                    var ce = new ChildEnumerator(this._itemsPresenter);
/*Line 410 - 'AtomItemsControl.js' */                    while (ce.next()) {
/*Line 411 - 'AtomItemsControl.js' */                        var c = ce.current();
/*Line 412 - 'AtomItemsControl.js' */                        if (c.atomControl && c.atomControl.get_data() == item) {
/*Line 413 - 'AtomItemsControl.js' */                            c.atomControl.dispose();
/*Line 414 - 'AtomItemsControl.js' */                            $(c).remove();
/*Line 415 - 'AtomItemsControl.js' */                            break;
/*Line 416 - 'AtomItemsControl.js' */                        }
/*Line 417 - 'AtomItemsControl.js' */                    }
/*Line 418 - 'AtomItemsControl.js' */                    this.updateUI();
/*Line 419 - 'AtomItemsControl.js' */                    return;
/*Line 420 - 'AtomItemsControl.js' */                }

/*Line 422 - 'AtomItemsControl.js' */                if (/add/gi.test(mode)) {
/*Line 423 - 'AtomItemsControl.js' */                    WebAtoms.dispatcher.pause();

/*Line 425 - 'AtomItemsControl.js' */                    var ae = new AtomEnumerator(this._items);
/*Line 426 - 'AtomItemsControl.js' */                    var ce = new ChildEnumerator(this._itemsPresenter);
/*Line 427 - 'AtomItemsControl.js' */                    while (ae.next()) {
/*Line 428 - 'AtomItemsControl.js' */                        ce.next();
/*Line 429 - 'AtomItemsControl.js' */                        var c = ce.current();
/*Line 430 - 'AtomItemsControl.js' */                        if (ae.currentIndex() == index) {
/*Line 431 - 'AtomItemsControl.js' */                            var ctrl = this.createChildElement(this._itemsPresenter, item, ae, c);
/*Line 432 - 'AtomItemsControl.js' */                            this.applyItemStyle(ctrl, item, ae.isFirst(), ae.isLast());
/*Line 433 - 'AtomItemsControl.js' */                            break;
/*Line 434 - 'AtomItemsControl.js' */                        }
/*Line 435 - 'AtomItemsControl.js' */                        if (ae.isLast()) {
/*Line 436 - 'AtomItemsControl.js' */                            var ctrl = this.createChildElement(this._itemsPresenter, item, ae);
/*Line 437 - 'AtomItemsControl.js' */                            this.applyItemStyle(ctrl, item, ae.isFirst(), ae.isLast());
/*Line 438 - 'AtomItemsControl.js' */                            break;
/*Line 439 - 'AtomItemsControl.js' */                        }
/*Line 440 - 'AtomItemsControl.js' */                    }

/*Line 442 - 'AtomItemsControl.js' */                    WebAtoms.dispatcher.start();
/*Line 443 - 'AtomItemsControl.js' */                    this.updateUI();
/*Line 444 - 'AtomItemsControl.js' */                    return;
/*Line 445 - 'AtomItemsControl.js' */                }

/*Line 447 - 'AtomItemsControl.js' */                var element = this._itemsPresenter;

/*Line 449 - 'AtomItemsControl.js' */                var dataItems = this.get_dataItems();

/*Line 451 - 'AtomItemsControl.js' */                var st = element.scrollTop;
/*Line 452 - 'AtomItemsControl.js' */                var sh = element.scrollHeight;

/*Line 454 - 'AtomItemsControl.js' */                //AtomUI.removeAllChildren(element);
/*Line 455 - 'AtomItemsControl.js' */                this.disposeChildren(element);
/*Line 456 - 'AtomItemsControl.js' */                //this._dataElements.length = 0;
/*Line 457 - 'AtomItemsControl.js' */                // rebuild from template...

/*Line 459 - 'AtomItemsControl.js' */                WebAtoms.dispatcher.pause();

/*Line 461 - 'AtomItemsControl.js' */                // implement stock...

/*Line 463 - 'AtomItemsControl.js' */                var items = this.get_dataItems(true);

/*Line 465 - 'AtomItemsControl.js' */                var sp = this._sortPath;
/*Line 466 - 'AtomItemsControl.js' */                if (sp) {
/*Line 467 - 'AtomItemsControl.js' */                    if (sp.constructor == String) {

/*Line 469 - 'AtomItemsControl.js' */                        var desc = false;
/*Line 470 - 'AtomItemsControl.js' */                        var index = sp.indexOf(' ');
/*Line 471 - 'AtomItemsControl.js' */                        if (index != -1) {
/*Line 472 - 'AtomItemsControl.js' */                            var d = sp.substr(index + 1);
/*Line 473 - 'AtomItemsControl.js' */                            sp = sp.substr(0, index);
/*Line 474 - 'AtomItemsControl.js' */                            desc = /desc/gi.test(d);
/*Line 475 - 'AtomItemsControl.js' */                        }

/*Line 477 - 'AtomItemsControl.js' */                        var f = desc ? (function (a, b) {
/*Line 478 - 'AtomItemsControl.js' */                            return b[sp].localeCompare(a[sp]);
/*Line 479 - 'AtomItemsControl.js' */                        }) : (function (a, b) {
/*Line 480 - 'AtomItemsControl.js' */                            return a[sp].localeCompare(b[sp]);
/*Line 481 - 'AtomItemsControl.js' */                        });
/*Line 482 - 'AtomItemsControl.js' */                        items = items.sort(f);
/*Line 483 - 'AtomItemsControl.js' */                    } else {
/*Line 484 - 'AtomItemsControl.js' */                        items = items.sort(sp);
/*Line 485 - 'AtomItemsControl.js' */                    }
/*Line 486 - 'AtomItemsControl.js' */                }

/*Line 488 - 'AtomItemsControl.js' */                //if (this._uiVirtualize) {

/*Line 490 - 'AtomItemsControl.js' */                //    this.unbindEvent(element, "scroll");

/*Line 492 - 'AtomItemsControl.js' */                //    var t = this.getTemplate("itemTemplate");
/*Line 493 - 'AtomItemsControl.js' */                //    var h = $(t).outerHeight(true);
/*Line 494 - 'AtomItemsControl.js' */                //    var w = $(t).outerWidth(true);

/*Line 496 - 'AtomItemsControl.js' */                //    var copy = document.createElement("DIV");
/*Line 497 - 'AtomItemsControl.js' */                //    copy.style.height = h + "px";
/*Line 498 - 'AtomItemsControl.js' */                //    copy.style.width = w + "px";


/*Line 501 - 'AtomItemsControl.js' */                //    var sw = $(element).innerWidth();

/*Line 503 - 'AtomItemsControl.js' */                //    var itemsPerLine = Math.ceil(sw / w);
/*Line 504 - 'AtomItemsControl.js' */                //    var hiddenLines = Math.ceil( st / h );
/*Line 505 - 'AtomItemsControl.js' */                //    var visibleLines = Math.ceil(sh / h);
/*Line 506 - 'AtomItemsControl.js' */                //    var si = hiddenLines * itemsPerLine;

/*Line 508 - 'AtomItemsControl.js' */                //    if (!itemsPerLine) {
/*Line 509 - 'AtomItemsControl.js' */                //        console.log("itemsPerLine is zero");
/*Line 510 - 'AtomItemsControl.js' */                //    }

/*Line 512 - 'AtomItemsControl.js' */                //    var ei = (visibleLines + 1) * itemsPerLine;

/*Line 514 - 'AtomItemsControl.js' */                //    while (ae.next()) {
/*Line 515 - 'AtomItemsControl.js' */                //        var i = ae.currentIndex();
/*Line 516 - 'AtomItemsControl.js' */                //        if (i < si || i > ei) {
/*Line 517 - 'AtomItemsControl.js' */                //            // add a copy...
/*Line 518 - 'AtomItemsControl.js' */                //            element.appendChild(copy.cloneNode(true));
/*Line 519 - 'AtomItemsControl.js' */                //        } else {
/*Line 520 - 'AtomItemsControl.js' */                //            var data = ae.current();
/*Line 521 - 'AtomItemsControl.js' */                //            var elementChild = this.createChildElement(element, data, ae);
/*Line 522 - 'AtomItemsControl.js' */                //            this.applyItemStyle(elementChild, data, ae.isFirst(), ae.isLast());
/*Line 523 - 'AtomItemsControl.js' */                //        }
/*Line 524 - 'AtomItemsControl.js' */                //    }

/*Line 526 - 'AtomItemsControl.js' */                //    element.scrollTop = st;
/*Line 527 - 'AtomItemsControl.js' */                //    var _this = this;
/*Line 528 - 'AtomItemsControl.js' */                //    this.bindEvent(element, "scroll", function () {
/*Line 529 - 'AtomItemsControl.js' */                //        _this.onScroll();
/*Line 530 - 'AtomItemsControl.js' */                //    });


/*Line 533 - 'AtomItemsControl.js' */                //} else {

/*Line 535 - 'AtomItemsControl.js' */                //    while (ae.next()) {
/*Line 536 - 'AtomItemsControl.js' */                //        var data = ae.current();
/*Line 537 - 'AtomItemsControl.js' */                //        var elementChild = this.createChildElement(element, data, ae);
/*Line 538 - 'AtomItemsControl.js' */                //        this.applyItemStyle(elementChild, data, ae.isFirst(), ae.isLast());
/*Line 539 - 'AtomItemsControl.js' */                //    }
/*Line 540 - 'AtomItemsControl.js' */                //}

/*Line 542 - 'AtomItemsControl.js' */                var ae = new AtomEnumerator(items);
/*Line 543 - 'AtomItemsControl.js' */                while (ae.next()) {
/*Line 544 - 'AtomItemsControl.js' */                    var data = ae.current();
/*Line 545 - 'AtomItemsControl.js' */                    var elementChild = this.createChildElement(element, data, ae);
/*Line 546 - 'AtomItemsControl.js' */                    this.applyItemStyle(elementChild, data, ae.isFirst(), ae.isLast());
/*Line 547 - 'AtomItemsControl.js' */                }



/*Line 551 - 'AtomItemsControl.js' */                WebAtoms.dispatcher.start();

/*Line 553 - 'AtomItemsControl.js' */                AtomBinder.refreshValue(this, "childAtomControls");


/*Line 556 - 'AtomItemsControl.js' */            },

/*Line 558 - 'AtomItemsControl.js' */            set_innerTemplate: function (v) {
/*Line 559 - 'AtomItemsControl.js' */                this._itemsPresenter = this._element;
/*Line 560 - 'AtomItemsControl.js' */                base.set_innerTemplate.apply(this, arguments);
/*Line 561 - 'AtomItemsControl.js' */                this.onCollectionChangedInternal("mode", -1, null);
/*Line 562 - 'AtomItemsControl.js' */            },

/*Line 564 - 'AtomItemsControl.js' */            applyItemStyle: function (item, dataItem, first, last) {
/*Line 565 - 'AtomItemsControl.js' */            },

/*Line 567 - 'AtomItemsControl.js' */            createChildElement: function (parentElement, data, ae, before) {
/*Line 568 - 'AtomItemsControl.js' */                //if (!this._template)
/*Line 569 - 'AtomItemsControl.js' */                //    return null;

/*Line 571 - 'AtomItemsControl.js' */                this.getTemplate("itemTemplate");

/*Line 573 - 'AtomItemsControl.js' */                var elementChild = AtomUI.cloneNode(this._itemTemplate);
/*Line 574 - 'AtomItemsControl.js' */                elementChild._templateParent = this;
/*Line 575 - 'AtomItemsControl.js' */                if (before) {
/*Line 576 - 'AtomItemsControl.js' */                    parentElement.insertBefore(elementChild, before);
/*Line 577 - 'AtomItemsControl.js' */                } else {
/*Line 578 - 'AtomItemsControl.js' */                    parentElement.appendChild(elementChild);
/*Line 579 - 'AtomItemsControl.js' */                }

/*Line 581 - 'AtomItemsControl.js' */                var childType = WebAtoms.AtomControl;
/*Line 582 - 'AtomItemsControl.js' */                var parentScope = this.get_scope();
/*Line 583 - 'AtomItemsControl.js' */                var scope = new AtomScope(this, parentScope, parentScope.__application);
/*Line 584 - 'AtomItemsControl.js' */                if (ae) {
/*Line 585 - 'AtomItemsControl.js' */                    scope.itemIsFirst = ae.isFirst();
/*Line 586 - 'AtomItemsControl.js' */                    scope.get_item_isFirst = function () {
/*Line 587 - 'AtomItemsControl.js' */                        log("Depricated, use itemIsFirst Instead");
/*Line 588 - 'AtomItemsControl.js' */                        return scope.itemIsFirst;
/*Line 589 - 'AtomItemsControl.js' */                    };
/*Line 590 - 'AtomItemsControl.js' */                    //scope.item_isLast = ae.isLast();
/*Line 591 - 'AtomItemsControl.js' */                    scope.itemIsLast = ae.isLast();
/*Line 592 - 'AtomItemsControl.js' */                    scope.get_item_isLast = function () {
/*Line 593 - 'AtomItemsControl.js' */                        log("Depricated, use itemIsLast Instead");
/*Line 594 - 'AtomItemsControl.js' */                        return scope.itemIsLast;
/*Line 595 - 'AtomItemsControl.js' */                    };
/*Line 596 - 'AtomItemsControl.js' */                    //scope.item_index = ae.currentIndex();
/*Line 597 - 'AtomItemsControl.js' */                    scope.itemIndex = ae.currentIndex();
/*Line 598 - 'AtomItemsControl.js' */                    scope.get_item_index = function () {
/*Line 599 - 'AtomItemsControl.js' */                        log("Depricated, use itemIndex Instead");
/*Line 600 - 'AtomItemsControl.js' */                        return scope.itemIndex;
/*Line 601 - 'AtomItemsControl.js' */                    };
/*Line 602 - 'AtomItemsControl.js' */                    //scope.item_isOdd = (ae.currentIndex() % 2) > 0;
/*Line 603 - 'AtomItemsControl.js' */                    //scope.item_isEven = (ae.currentIndex() % 2) == 0;
/*Line 604 - 'AtomItemsControl.js' */                    //scope.item_selected = (this.isSelected(data));
/*Line 605 - 'AtomItemsControl.js' */                    //scope.item_expanded = false;
/*Line 606 - 'AtomItemsControl.js' */                    scope.itemExpanded = false;
/*Line 607 - 'AtomItemsControl.js' */                    scope.get_itemSelected = function () {
/*Line 608 - 'AtomItemsControl.js' */                        return scope.owner.isSelected(data);
/*Line 609 - 'AtomItemsControl.js' */                    };
/*Line 610 - 'AtomItemsControl.js' */                    scope.set_itemSelected = function (v) {
/*Line 611 - 'AtomItemsControl.js' */                        scope.owner.toggleSelection(data, true);
/*Line 612 - 'AtomItemsControl.js' */                    };
/*Line 613 - 'AtomItemsControl.js' */                }

/*Line 615 - 'AtomItemsControl.js' */                var ct = $(elementChild).attr("atom-type") || WebAtoms.AtomControl;

/*Line 617 - 'AtomItemsControl.js' */                var ac = AtomUI.createControl(elementChild, ct, data, scope);
/*Line 618 - 'AtomItemsControl.js' */                return elementChild;
/*Line 619 - 'AtomItemsControl.js' */            },

/*Line 621 - 'AtomItemsControl.js' */            toggleSelection: function (data) {
/*Line 622 - 'AtomItemsControl.js' */                this._onUIChanged = true;
/*Line 623 - 'AtomItemsControl.js' */                this._value = undefined;
/*Line 624 - 'AtomItemsControl.js' */                if (this._allowMultipleSelection) {
/*Line 625 - 'AtomItemsControl.js' */                    if (AtomUI.contains(this._selectedItems, data)) {
/*Line 626 - 'AtomItemsControl.js' */                        AtomBinder.removeItem(this._selectedItems, data);
/*Line 627 - 'AtomItemsControl.js' */                    } else {
/*Line 628 - 'AtomItemsControl.js' */                        AtomBinder.addItem(this._selectedItems, data);
/*Line 629 - 'AtomItemsControl.js' */                    }
/*Line 630 - 'AtomItemsControl.js' */                } else {
/*Line 631 - 'AtomItemsControl.js' */                    this._selectedItems.length = 1;
/*Line 632 - 'AtomItemsControl.js' */                    this._selectedItems[0] = data;
/*Line 633 - 'AtomItemsControl.js' */                    AtomBinder.refreshItems(this._selectedItems);
/*Line 634 - 'AtomItemsControl.js' */                }
/*Line 635 - 'AtomItemsControl.js' */                this._onUIChanged = false;
/*Line 636 - 'AtomItemsControl.js' */            },

/*Line 638 - 'AtomItemsControl.js' */            onUpdateUI: function () {
/*Line 639 - 'AtomItemsControl.js' */                base.onUpdateUI.call(this);
/*Line 640 - 'AtomItemsControl.js' */                var ae = new ChildEnumerator(this._itemsPresenter);
/*Line 641 - 'AtomItemsControl.js' */                while (ae.next()) {
/*Line 642 - 'AtomItemsControl.js' */                    var item = ae.current();
/*Line 643 - 'AtomItemsControl.js' */                    if (!item.atomControl)
/*Line 644 - 'AtomItemsControl.js' */                        continue;
/*Line 645 - 'AtomItemsControl.js' */                    var dataItem = item.atomControl.get_data();
/*Line 646 - 'AtomItemsControl.js' */                    AtomBinder.refreshValue(item.atomControl.get_scope(), "itemSelected");
/*Line 647 - 'AtomItemsControl.js' */                    this.applyItemStyle(item, dataItem, ae.isFirst(), ae.isLast());
/*Line 648 - 'AtomItemsControl.js' */                }
/*Line 649 - 'AtomItemsControl.js' */            },

/*Line 651 - 'AtomItemsControl.js' */            onCreationComplete: function () {
/*Line 652 - 'AtomItemsControl.js' */                if (this._items) {
/*Line 653 - 'AtomItemsControl.js' */                    this.onCollectionChangedInternal("refresh", -1, null);
/*Line 654 - 'AtomItemsControl.js' */                }

/*Line 656 - 'AtomItemsControl.js' */                var caller = this;

/*Line 658 - 'AtomItemsControl.js' */                this.dispatcher.callLater(function () {
/*Line 659 - 'AtomItemsControl.js' */                    if (caller._autoScrollToSelection) {
/*Line 660 - 'AtomItemsControl.js' */                        caller.bringSelectionIntoView();
/*Line 661 - 'AtomItemsControl.js' */                    }
/*Line 662 - 'AtomItemsControl.js' */                });

/*Line 664 - 'AtomItemsControl.js' */            },


/*Line 667 - 'AtomItemsControl.js' */            initialize: function () {

/*Line 669 - 'AtomItemsControl.js' */                var element = this.get_element();


/*Line 672 - 'AtomItemsControl.js' */                // set self as Items Presenter..
/*Line 673 - 'AtomItemsControl.js' */                if (!this._itemsPresenter) {
/*Line 674 - 'AtomItemsControl.js' */                    this._itemsPresenter = this._element;
/*Line 675 - 'AtomItemsControl.js' */                }
/*Line 676 - 'AtomItemsControl.js' */                else {
/*Line 677 - 'AtomItemsControl.js' */                    //this._layout = WebAtoms.AtomViewBoxLayout.defaultInstnace;
/*Line 678 - 'AtomItemsControl.js' */                }
/*Line 679 - 'AtomItemsControl.js' */                var _this = this;
/*Line 680 - 'AtomItemsControl.js' */                this.bindEvent(this._selectedItems, "CollectionChanged", function () {
/*Line 681 - 'AtomItemsControl.js' */                    _this.onSelectedItemsChanged.apply(_this, arguments);
/*Line 682 - 'AtomItemsControl.js' */                });
/*Line 683 - 'AtomItemsControl.js' */                base.initialize.apply(this, arguments);


/*Line 686 - 'AtomItemsControl.js' */                var caller = this;

/*Line 688 - 'AtomItemsControl.js' */                this.removeItemCommand = function (scope, sender) {
/*Line 689 - 'AtomItemsControl.js' */                    if (!sender)
/*Line 690 - 'AtomItemsControl.js' */                        return;
/*Line 691 - 'AtomItemsControl.js' */                    var d = sender.get_data();
/*Line 692 - 'AtomItemsControl.js' */                    AtomBinder.removeItem(caller._items, d);
/*Line 693 - 'AtomItemsControl.js' */                };

/*Line 695 - 'AtomItemsControl.js' */                this.removeSelectedCommand = function (scope, sender) {
/*Line 696 - 'AtomItemsControl.js' */                    var s = caller.get_selectedItems();
/*Line 697 - 'AtomItemsControl.js' */                    var ae = new AtomEnumerator(s);
/*Line 698 - 'AtomItemsControl.js' */                    while (ae.next()) {
/*Line 699 - 'AtomItemsControl.js' */                        AtomBinder.removeItem(caller.get_items(), ae.current());
/*Line 700 - 'AtomItemsControl.js' */                    }
/*Line 701 - 'AtomItemsControl.js' */                };

/*Line 703 - 'AtomItemsControl.js' */                this.removeAllCommand = function (scope, sender) {
/*Line 704 - 'AtomItemsControl.js' */                    AtomBinder.clear(caller.get_items());
/*Line 705 - 'AtomItemsControl.js' */                };
/*Line 706 - 'AtomItemsControl.js' */            }
/*Line 707 - 'AtomItemsControl.js' */        }
/*Line 708 - 'AtomItemsControl.js' */    });
/*Line 709 - 'AtomItemsControl.js' */})(window, WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomButton.js' */

/*Line 2 - 'AtomButton.js' */(function (window, base) {
/*Line 3 - 'AtomButton.js' */    return classCreatorEx(
/*Line 4 - 'AtomButton.js' */    {
/*Line 5 - 'AtomButton.js' */        name: "WebAtoms.AtomButton",
/*Line 6 - 'AtomButton.js' */        base: base,
/*Line 7 - 'AtomButton.js' */        start: function (e) {
/*Line 8 - 'AtomButton.js' */            this._sendData = false;
/*Line 9 - 'AtomButton.js' */            $(e).addClass("atom-button");
/*Line 10 - 'AtomButton.js' */        },
/*Line 11 - 'AtomButton.js' */        properties: {
/*Line 12 - 'AtomButton.js' */            sendData: false
/*Line 13 - 'AtomButton.js' */        },
/*Line 14 - 'AtomButton.js' */        methods: {
/*Line 15 - 'AtomButton.js' */            onClickHandler: function (e) {

/*Line 17 - 'AtomButton.js' */                AtomUI.cancelEvent(e);

/*Line 19 - 'AtomButton.js' */                if (this._next) {
/*Line 20 - 'AtomButton.js' */                    if (this._sendData && this._next) {
/*Line 21 - 'AtomButton.js' */                        AtomBinder.setValue(this._next, "data", this.get_data());
/*Line 22 - 'AtomButton.js' */                    }
/*Line 23 - 'AtomButton.js' */                    this.invokeAction(this._next);
/*Line 24 - 'AtomButton.js' */                }
/*Line 25 - 'AtomButton.js' */                return false;
/*Line 26 - 'AtomButton.js' */            },

/*Line 28 - 'AtomButton.js' */            initialize: function () {

/*Line 30 - 'AtomButton.js' */                var element = this._element;
/*Line 31 - 'AtomButton.js' */                this.bindEvent(element, "click", "onClickHandler");
/*Line 32 - 'AtomButton.js' */                base.initialize.apply(this);
/*Line 33 - 'AtomButton.js' */            }
/*Line 34 - 'AtomButton.js' */        }

/*Line 36 - 'AtomButton.js' */    });
/*Line 37 - 'AtomButton.js' */})(window, WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomDockPanel.js' */

/*Line 2 - 'AtomDockPanel.js' */(function (window, base) {

/*Line 4 - 'AtomDockPanel.js' */    var AtomUI = window.AtomUI;

/*Line 6 - 'AtomDockPanel.js' */    return classCreatorEx({
/*Line 7 - 'AtomDockPanel.js' */        name: "WebAtoms.AtomDockPanel",
/*Line 8 - 'AtomDockPanel.js' */        base: base,
/*Line 9 - 'AtomDockPanel.js' */        start: function (e) {
/*Line 10 - 'AtomDockPanel.js' */            $(e).addClass("atom-dock-panel");
/*Line 11 - 'AtomDockPanel.js' */        },
/*Line 12 - 'AtomDockPanel.js' */        properties: {
/*Line 13 - 'AtomDockPanel.js' */            resizeOnChildResized: false
/*Line 14 - 'AtomDockPanel.js' */        },
/*Line 15 - 'AtomDockPanel.js' */        methods: {
/*Line 16 - 'AtomDockPanel.js' */            resizeChild: function (item) {
/*Line 17 - 'AtomDockPanel.js' */                if (item.atomControl) {
/*Line 18 - 'AtomDockPanel.js' */                    item.atomControl.updateUI();
/*Line 19 - 'AtomDockPanel.js' */                } else {
/*Line 20 - 'AtomDockPanel.js' */                    this.updateChildUI(item);
/*Line 21 - 'AtomDockPanel.js' */                }
/*Line 22 - 'AtomDockPanel.js' */            },

/*Line 24 - 'AtomDockPanel.js' */            calculateSize: function () {
/*Line 25 - 'AtomDockPanel.js' */                var element = this.get_element();

/*Line 27 - 'AtomDockPanel.js' */                var size = { width: $(element).width(), height: $(element).height() };

/*Line 29 - 'AtomDockPanel.js' */                //if (AtomBrowser.isIE && AtomBrowser.majorVersion < 10) {
/*Line 30 - 'AtomDockPanel.js' */                //    size = { width: element.offsetWidth, height: element.offsetHeight };
/*Line 31 - 'AtomDockPanel.js' */                //}else {

/*Line 33 - 'AtomDockPanel.js' */                //var s = AtomUI.getComputedStyle(element);

/*Line 35 - 'AtomDockPanel.js' */                //size = { width: AtomUI.parseStyleNumber(s.width), height: AtomUI.parseStyleNumber(s.height) };
/*Line 36 - 'AtomDockPanel.js' */                //}

/*Line 38 - 'AtomDockPanel.js' */                if (!this._resizeOnChildResized)
/*Line 39 - 'AtomDockPanel.js' */                    return size;

/*Line 41 - 'AtomDockPanel.js' */                var desiredHeight = 0;

/*Line 43 - 'AtomDockPanel.js' */                var ae = new ChildEnumerator(element);
/*Line 44 - 'AtomDockPanel.js' */                while (ae.next()) {
/*Line 45 - 'AtomDockPanel.js' */                    var child = ae.current();
/*Line 46 - 'AtomDockPanel.js' */                    var dock = $(child).attr("atom-dock");
/*Line 47 - 'AtomDockPanel.js' */                    switch (dock) {
/*Line 48 - 'AtomDockPanel.js' */                        case "Bottom":
/*Line 49 - 'AtomDockPanel.js' */                        case "Fill":
/*Line 50 - 'AtomDockPanel.js' */                        case "Top":
/*Line 51 - 'AtomDockPanel.js' */                            var h;
/*Line 52 - 'AtomDockPanel.js' */                            if (AtomBrowser.isIE && AtomBrowser.majorVersion < 10) {
/*Line 53 - 'AtomDockPanel.js' */                                h = child.offsetHeight;
/*Line 54 - 'AtomDockPanel.js' */                            } else {
/*Line 55 - 'AtomDockPanel.js' */                                //h = AtomUI.getItemRect(child).height;
/*Line 56 - 'AtomDockPanel.js' */                                h = $(child).outerHeight(true);
/*Line 57 - 'AtomDockPanel.js' */                            }
/*Line 58 - 'AtomDockPanel.js' */                            desiredHeight += h;
/*Line 59 - 'AtomDockPanel.js' */                            break;
/*Line 60 - 'AtomDockPanel.js' */                    }
/*Line 61 - 'AtomDockPanel.js' */                }

/*Line 63 - 'AtomDockPanel.js' */                if (size.height < desiredHeight) {
/*Line 64 - 'AtomDockPanel.js' */                    size.height = desiredHeight;
/*Line 65 - 'AtomDockPanel.js' */                    $(element).height(size.height);
/*Line 66 - 'AtomDockPanel.js' */                }

/*Line 68 - 'AtomDockPanel.js' */                return size;
/*Line 69 - 'AtomDockPanel.js' */            },

/*Line 71 - 'AtomDockPanel.js' */            onUpdateUI: function () {


/*Line 74 - 'AtomDockPanel.js' */                var element = this.get_element();


/*Line 77 - 'AtomDockPanel.js' */                var i;
/*Line 78 - 'AtomDockPanel.js' */                var left = 0;
/*Line 79 - 'AtomDockPanel.js' */                var top = parseInt($(element).css("paddingTop"), 10);

/*Line 81 - 'AtomDockPanel.js' */                var s = this.calculateSize();

/*Line 83 - 'AtomDockPanel.js' */                // is parent of this is body??
/*Line 84 - 'AtomDockPanel.js' */                var height = s.height;
/*Line 85 - 'AtomDockPanel.js' */                var width = s.width;

/*Line 87 - 'AtomDockPanel.js' */                var children = [];
/*Line 88 - 'AtomDockPanel.js' */                var en;
/*Line 89 - 'AtomDockPanel.js' */                var item;

/*Line 91 - 'AtomDockPanel.js' */                var itemRect;
/*Line 92 - 'AtomDockPanel.js' */                var clientRect;

/*Line 94 - 'AtomDockPanel.js' */                var itemHeight;
/*Line 95 - 'AtomDockPanel.js' */                var itemWidth;

/*Line 97 - 'AtomDockPanel.js' */                en = new AtomEnumerator($(element).children("[atom-dock='Top']"));
/*Line 98 - 'AtomDockPanel.js' */                while (en.next()) {
/*Line 99 - 'AtomDockPanel.js' */                    item = en.current();

/*Line 101 - 'AtomDockPanel.js' */                    itemHeight = $(item).outerHeight(true);

/*Line 103 - 'AtomDockPanel.js' */                    AtomUI.setItemRect(item, { top: top, left: left, width: width });

/*Line 105 - 'AtomDockPanel.js' */                    top += itemHeight;
/*Line 106 - 'AtomDockPanel.js' */                    height -= itemHeight;

/*Line 108 - 'AtomDockPanel.js' */                    this.resizeChild(item);
/*Line 109 - 'AtomDockPanel.js' */                }

/*Line 111 - 'AtomDockPanel.js' */                en = new AtomEnumerator($(element).children("[atom-dock='Bottom']").get().reverse());
/*Line 112 - 'AtomDockPanel.js' */                while (en.next()) {
/*Line 113 - 'AtomDockPanel.js' */                    item = en.current();
/*Line 114 - 'AtomDockPanel.js' */                    itemHeight = $(item).outerHeight(true);

/*Line 116 - 'AtomDockPanel.js' */                    height -= itemHeight;

/*Line 118 - 'AtomDockPanel.js' */                    AtomUI.setItemRect(item, { top: (top + height), width: width });

/*Line 120 - 'AtomDockPanel.js' */                    this.resizeChild(item);
/*Line 121 - 'AtomDockPanel.js' */                }

/*Line 123 - 'AtomDockPanel.js' */                en = new AtomEnumerator($(element).children("[atom-dock='Left']"));
/*Line 124 - 'AtomDockPanel.js' */                while (en.next()) {
/*Line 125 - 'AtomDockPanel.js' */                    item = en.current();

/*Line 127 - 'AtomDockPanel.js' */                    var itemWidth = $(item).outerWidth(true);
/*Line 128 - 'AtomDockPanel.js' */                    width -= itemWidth;

/*Line 130 - 'AtomDockPanel.js' */                    AtomUI.setItemRect(item, { top: top, left: left, height: height });
/*Line 131 - 'AtomDockPanel.js' */                    left += itemWidth;

/*Line 133 - 'AtomDockPanel.js' */                    this.resizeChild(item);
/*Line 134 - 'AtomDockPanel.js' */                }

/*Line 136 - 'AtomDockPanel.js' */                en = new AtomEnumerator($(element).children("[atom-dock='Right']").get().reverse());
/*Line 137 - 'AtomDockPanel.js' */                while (en.next()) {
/*Line 138 - 'AtomDockPanel.js' */                    item = en.current();
/*Line 139 - 'AtomDockPanel.js' */                    var itemWidth = $(item).outerWidth(true);
/*Line 140 - 'AtomDockPanel.js' */                    width -= itemWidth;

/*Line 142 - 'AtomDockPanel.js' */                    AtomUI.setItemRect(item, { left: (width + left), top: top, height: height });

/*Line 144 - 'AtomDockPanel.js' */                    this.resizeChild(item);
/*Line 145 - 'AtomDockPanel.js' */                }

/*Line 147 - 'AtomDockPanel.js' */                en = new AtomEnumerator($(element).children("[atom-dock='Fill']"));
/*Line 148 - 'AtomDockPanel.js' */                while (en.next()) {
/*Line 149 - 'AtomDockPanel.js' */                    item = en.current();
/*Line 150 - 'AtomDockPanel.js' */                    itemWidth = $(item).css("max-width");
/*Line 151 - 'AtomDockPanel.js' */                    if (itemWidth) {
/*Line 152 - 'AtomDockPanel.js' */                        itemWidth = parseFloat(itemWidth);
/*Line 153 - 'AtomDockPanel.js' */                        if (itemWidth > 0) {
/*Line 154 - 'AtomDockPanel.js' */                            width = itemWidth;
/*Line 155 - 'AtomDockPanel.js' */                        }
/*Line 156 - 'AtomDockPanel.js' */                    }

/*Line 158 - 'AtomDockPanel.js' */                    AtomUI.setItemRect(item, { left: left, top: top, width: width, height: height });

/*Line 160 - 'AtomDockPanel.js' */                    this.resizeChild(item);
/*Line 161 - 'AtomDockPanel.js' */                }

/*Line 163 - 'AtomDockPanel.js' */            }
/*Line 164 - 'AtomDockPanel.js' */        }
/*Line 165 - 'AtomDockPanel.js' */    });
/*Line 166 - 'AtomDockPanel.js' */})(window, WebAtoms.AtomControl.prototype);

/*Line 0 - 'AtomListBox.js' */

/*Line 2 - 'AtomListBox.js' */(function (window, baseType) {
/*Line 3 - 'AtomListBox.js' */    return classCreatorEx({
/*Line 4 - 'AtomListBox.js' */        name: "WebAtoms.AtomListBox",
/*Line 5 - 'AtomListBox.js' */        base: baseType,
/*Line 6 - 'AtomListBox.js' */        start: function (e) {
/*Line 7 - 'AtomListBox.js' */            this._labelPath = "label";
/*Line 8 - 'AtomListBox.js' */            this._valuePath = "value";

/*Line 10 - 'AtomListBox.js' */            this._autoScrollToSelection = false;

/*Line 12 - 'AtomListBox.js' */            $(e).addClass("atom-list-box");
/*Line 13 - 'AtomListBox.js' */        },
/*Line 14 - 'AtomListBox.js' */        properties: {
/*Line 15 - 'AtomListBox.js' */            autoSelectOnClick: true
/*Line 16 - 'AtomListBox.js' */        },
/*Line 17 - 'AtomListBox.js' */        methods: {
/*Line 18 - 'AtomListBox.js' */            onClick: function (event) {

/*Line 20 - 'AtomListBox.js' */                if (!this._autoSelectOnClick)
/*Line 21 - 'AtomListBox.js' */                    return;

/*Line 23 - 'AtomListBox.js' */                this.onSelectItem(null, null, event);
/*Line 24 - 'AtomListBox.js' */                //return AtomUI.cancelEvent(event);
/*Line 25 - 'AtomListBox.js' */            },

/*Line 27 - 'AtomListBox.js' */            get_itemWidth: function () {
/*Line 28 - 'AtomListBox.js' */                if (!this._items || !this._items.length)
/*Line 29 - 'AtomListBox.js' */                    return 0;
/*Line 30 - 'AtomListBox.js' */                var w = $(this._element).innerWidth();
/*Line 31 - 'AtomListBox.js' */                return w / this._items.length;
/*Line 32 - 'AtomListBox.js' */            },

/*Line 34 - 'AtomListBox.js' */            applyItemStyle: function (item, dataItem, first, last) {
/*Line 35 - 'AtomListBox.js' */                $(item).removeClass("selected-item list-item first-item last-item");
/*Line 36 - 'AtomListBox.js' */                //$(item).removeClass("list-item");
/*Line 37 - 'AtomListBox.js' */                //$(item).removeClass("first-item");
/*Line 38 - 'AtomListBox.js' */                //$(item).removeClass("last-item");
/*Line 39 - 'AtomListBox.js' */                if (!dataItem)
/*Line 40 - 'AtomListBox.js' */                    return;
/*Line 41 - 'AtomListBox.js' */                $(item).addClass("list-item");
/*Line 42 - 'AtomListBox.js' */                if (first) {
/*Line 43 - 'AtomListBox.js' */                    $(item).addClass("first-item");
/*Line 44 - 'AtomListBox.js' */                }
/*Line 45 - 'AtomListBox.js' */                if (last) {
/*Line 46 - 'AtomListBox.js' */                    $(item).addClass("last-item");
/*Line 47 - 'AtomListBox.js' */                }
/*Line 48 - 'AtomListBox.js' */                if (this.isSelected(dataItem)) {
/*Line 49 - 'AtomListBox.js' */                    $(item).addClass("selected-item");
/*Line 50 - 'AtomListBox.js' */                }
/*Line 51 - 'AtomListBox.js' */            },

/*Line 53 - 'AtomListBox.js' */            onCreationComplete: function () {
/*Line 54 - 'AtomListBox.js' */                this.bindEvent(this._itemsPresenter, "click", "onClick");
/*Line 55 - 'AtomListBox.js' */                baseType.onCreationComplete.call(this);
/*Line 56 - 'AtomListBox.js' */            },

/*Line 58 - 'AtomListBox.js' */            invokePost: function () {
/*Line 59 - 'AtomListBox.js' */                if (this.get_selectedIndex() != -1) {
/*Line 60 - 'AtomListBox.js' */                    baseType.invokePost.apply(this, arguments);
/*Line 61 - 'AtomListBox.js' */                }
/*Line 62 - 'AtomListBox.js' */            },

/*Line 64 - 'AtomListBox.js' */            onSelectItem: function (scope, sender, event) {
/*Line 65 - 'AtomListBox.js' */                var target = event ? event.target : null;
/*Line 66 - 'AtomListBox.js' */                var element = this._itemsPresenter;
/*Line 67 - 'AtomListBox.js' */                var childElement = target || sender._element;
/*Line 68 - 'AtomListBox.js' */                while (childElement.parentNode != null && childElement.parentNode != element)
/*Line 69 - 'AtomListBox.js' */                    childElement = childElement.parentNode;
/*Line 70 - 'AtomListBox.js' */                if (childElement == document) {
/*Line 71 - 'AtomListBox.js' */                    //console.log("listbox clicked outside");
/*Line 72 - 'AtomListBox.js' */                    return;
/*Line 73 - 'AtomListBox.js' */                }
/*Line 74 - 'AtomListBox.js' */                var dataItem = childElement;
/*Line 75 - 'AtomListBox.js' */                if (this.hasItems()) {
/*Line 76 - 'AtomListBox.js' */                    dataItem = childElement.atomControl.get_data();
/*Line 77 - 'AtomListBox.js' */                }

/*Line 79 - 'AtomListBox.js' */                this.toggleSelection(dataItem);

/*Line 81 - 'AtomListBox.js' */            },

/*Line 83 - 'AtomListBox.js' */            initialize: function () {


/*Line 86 - 'AtomListBox.js' */                baseType.initialize.call(this);
/*Line 87 - 'AtomListBox.js' */                var _this = this;

/*Line 89 - 'AtomListBox.js' */                this.selectCommand = function () {
/*Line 90 - 'AtomListBox.js' */                    _this.onSelectItem.apply(_this, arguments);
/*Line 91 - 'AtomListBox.js' */                };
/*Line 92 - 'AtomListBox.js' */                this.clearSelectionCommand = function () {
/*Line 93 - 'AtomListBox.js' */                    _this.set_selectedIndex(-1);
/*Line 94 - 'AtomListBox.js' */                };
/*Line 95 - 'AtomListBox.js' */            }
/*Line 96 - 'AtomListBox.js' */        }
/*Line 97 - 'AtomListBox.js' */    });
/*Line 98 - 'AtomListBox.js' */})(window, WebAtoms.AtomItemsControl.prototype);

/*Line 0 - 'AtomCheckBoxList.js' */

/*Line 2 - 'AtomCheckBoxList.js' */(function (window, base) {
/*Line 3 - 'AtomCheckBoxList.js' */    return classCreatorEx(
/*Line 4 - 'AtomCheckBoxList.js' */    {
/*Line 5 - 'AtomCheckBoxList.js' */        name: "WebAtoms.AtomCheckBoxList",
/*Line 6 - 'AtomCheckBoxList.js' */        base: base,
/*Line 7 - 'AtomCheckBoxList.js' */        start: function () {
/*Line 8 - 'AtomCheckBoxList.js' */            this._allowMultipleSelection = true;
/*Line 9 - 'AtomCheckBoxList.js' */            this._valueSeparator = ", ";
/*Line 10 - 'AtomCheckBoxList.js' */            this._dataElements = [];
/*Line 11 - 'AtomCheckBoxList.js' */        },
/*Line 12 - 'AtomCheckBoxList.js' */        methods: {
/*Line 13 - 'AtomCheckBoxList.js' */            initialize: function () {
/*Line 14 - 'AtomCheckBoxList.js' */                base.initialize.call(this);
/*Line 15 - 'AtomCheckBoxList.js' */                $(this._element).addClass("atom-check-box-list");
/*Line 16 - 'AtomCheckBoxList.js' */            }
/*Line 17 - 'AtomCheckBoxList.js' */        }
/*Line 18 - 'AtomCheckBoxList.js' */    });
/*Line 19 - 'AtomCheckBoxList.js' */})(window, WebAtoms.AtomItemsControl.prototype);

/*Line 0 - 'AtomComboBox.js' */
/*Line 1 - 'AtomComboBox.js' */


/*Line 4 - 'AtomComboBox.js' */(function (window, base) {
/*Line 5 - 'AtomComboBox.js' */    return classCreatorEx(
/*Line 6 - 'AtomComboBox.js' */    {
/*Line 7 - 'AtomComboBox.js' */        name: "WebAtoms.AtomComboBox",
/*Line 8 - 'AtomComboBox.js' */        base: base,
/*Line 9 - 'AtomComboBox.js' */        start: function () {
/*Line 10 - 'AtomComboBox.js' */            this._labelPath = "label";
/*Line 11 - 'AtomComboBox.js' */            this._valuePath = "value";
/*Line 12 - 'AtomComboBox.js' */            this._allowSelectFirst = true;
/*Line 13 - 'AtomComboBox.js' */        },
/*Line 14 - 'AtomComboBox.js' */        methods: {
/*Line 15 - 'AtomComboBox.js' */            invokePost: function () {
/*Line 16 - 'AtomComboBox.js' */                if (this.get_selectedIndex() > 0) {
/*Line 17 - 'AtomComboBox.js' */                    base.invokePost.apply(this, arguments);
/*Line 18 - 'AtomComboBox.js' */                }
/*Line 19 - 'AtomComboBox.js' */            },

/*Line 21 - 'AtomComboBox.js' */            invokeNext: function () {
/*Line 22 - 'AtomComboBox.js' */                base.invokeNext.apply(this, arguments);
/*Line 23 - 'AtomComboBox.js' */                if (this._postUrl) {
/*Line 24 - 'AtomComboBox.js' */                    AtomBinder.setValue(this, "selectedIndex", 0);
/*Line 25 - 'AtomComboBox.js' */                    this.updateChildSelections();
/*Line 26 - 'AtomComboBox.js' */                }
/*Line 27 - 'AtomComboBox.js' */            },

/*Line 29 - 'AtomComboBox.js' */            onSelectionChanged: function () {
/*Line 30 - 'AtomComboBox.js' */                this._onUIChanged = true;
/*Line 31 - 'AtomComboBox.js' */                var element = this.get_element();
/*Line 32 - 'AtomComboBox.js' */                this.set_selectedIndex(element.selectedIndex);
/*Line 33 - 'AtomComboBox.js' */                this._onUIChanged = false;

/*Line 35 - 'AtomComboBox.js' */                //this.invokeAction(this._next);
/*Line 36 - 'AtomComboBox.js' */            },

/*Line 38 - 'AtomComboBox.js' */            updateChildSelections: function () {
/*Line 39 - 'AtomComboBox.js' */                var element = this._element;
/*Line 40 - 'AtomComboBox.js' */                element.selectedIndex = this.get_selectedIndex();
/*Line 41 - 'AtomComboBox.js' */            },

/*Line 43 - 'AtomComboBox.js' */            onCollectionChanged: function (mode, index, item) {
/*Line 44 - 'AtomComboBox.js' */                var element = this.get_element();
/*Line 45 - 'AtomComboBox.js' */                var dataItems = this.get_dataItems();
/*Line 46 - 'AtomComboBox.js' */                element.options.length = dataItems.length;
/*Line 47 - 'AtomComboBox.js' */                var ae = new AtomEnumerator(dataItems);

/*Line 49 - 'AtomComboBox.js' */                var lp = this._labelPath;
/*Line 50 - 'AtomComboBox.js' */                var vp = this._valuePath;
/*Line 51 - 'AtomComboBox.js' */                var label = null;
/*Line 52 - 'AtomComboBox.js' */                var value = null;
/*Line 53 - 'AtomComboBox.js' */                var selectedValue = this.get_value();
/*Line 54 - 'AtomComboBox.js' */                while (ae.next()) {
/*Line 55 - 'AtomComboBox.js' */                    var data = ae.current();
/*Line 56 - 'AtomComboBox.js' */                    label = data;
/*Line 57 - 'AtomComboBox.js' */                    value = data;
/*Line 58 - 'AtomComboBox.js' */                    if (lp)
/*Line 59 - 'AtomComboBox.js' */                        label = label[lp];
/*Line 60 - 'AtomComboBox.js' */                    if (vp)
/*Line 61 - 'AtomComboBox.js' */                        value = value[vp];

/*Line 63 - 'AtomComboBox.js' */                    element.options[ae.currentIndex()] = new Option(label, value, false, value == selectedValue);
/*Line 64 - 'AtomComboBox.js' */                }
/*Line 65 - 'AtomComboBox.js' */            },

/*Line 67 - 'AtomComboBox.js' */            verifyTemplates: function () {
/*Line 68 - 'AtomComboBox.js' */            },

/*Line 70 - 'AtomComboBox.js' */            initialize: function () {

/*Line 72 - 'AtomComboBox.js' */                var element = this.get_element();
/*Line 73 - 'AtomComboBox.js' */                this.bindEvent(element, "change", "onSelectionChanged");
/*Line 74 - 'AtomComboBox.js' */                base.initialize.apply(this, arguments);
/*Line 75 - 'AtomComboBox.js' */            }
/*Line 76 - 'AtomComboBox.js' */        }
/*Line 77 - 'AtomComboBox.js' */    });
/*Line 78 - 'AtomComboBox.js' */})(window, WebAtoms.AtomItemsControl.prototype);



/*Line 0 - 'AtomDateListBox.js' */

/*Line 2 - 'AtomDateListBox.js' */(function (window, base) {
/*Line 3 - 'AtomDateListBox.js' */    return classCreatorEx({
/*Line 4 - 'AtomDateListBox.js' */        name: "WebAtoms.AtomDateListBox",
/*Line 5 - 'AtomDateListBox.js' */        base: base,
/*Line 6 - 'AtomDateListBox.js' */        start: function (element) {
/*Line 7 - 'AtomDateListBox.js' */            this._monthList = AtomDate.monthList;

/*Line 9 - 'AtomDateListBox.js' */            var today = new Date();
/*Line 10 - 'AtomDateListBox.js' */            this._month = today.getMonth() + 1;
/*Line 11 - 'AtomDateListBox.js' */            this._year = today.getFullYear();
/*Line 12 - 'AtomDateListBox.js' */            this._selectedItems = [];

/*Line 14 - 'AtomDateListBox.js' */            this._presenters = ['itemsPresenter'];

/*Line 16 - 'AtomDateListBox.js' */            this._startYear = -5;
/*Line 17 - 'AtomDateListBox.js' */            this._endYear = 10;

/*Line 19 - 'AtomDateListBox.js' */            this._currentYear = (new Date()).getFullYear();
/*Line 20 - 'AtomDateListBox.js' */        },
/*Line 21 - 'AtomDateListBox.js' */        properties: {
/*Line 22 - 'AtomDateListBox.js' */            month: 0,
/*Line 23 - 'AtomDateListBox.js' */            year: 0,
/*Line 24 - 'AtomDateListBox.js' */            selectedItems: [],
/*Line 25 - 'AtomDateListBox.js' */            startYear: -5,
/*Line 26 - 'AtomDateListBox.js' */            endYear:0,
/*Line 27 - 'AtomDateListBox.js' */            currentYear: 0,
/*Line 28 - 'AtomDateListBox.js' */            monthList: null,
/*Line 29 - 'AtomDateListBox.js' */            items: undefined,
/*Line 30 - 'AtomDateListBox.js' */            month: null,
/*Line 31 - 'AtomDateListBox.js' */            visibleDate: undefined
/*Line 32 - 'AtomDateListBox.js' */        },
/*Line 33 - 'AtomDateListBox.js' */        methods: {
/*Line 34 - 'AtomDateListBox.js' */            set_month: function (v) {
/*Line 35 - 'AtomDateListBox.js' */                this._month = v;
/*Line 36 - 'AtomDateListBox.js' */                this.updateList();
/*Line 37 - 'AtomDateListBox.js' */            },

/*Line 39 - 'AtomDateListBox.js' */            set_year: function (v) {
/*Line 40 - 'AtomDateListBox.js' */                this._year = v;
/*Line 41 - 'AtomDateListBox.js' */                this.updateList();
/*Line 42 - 'AtomDateListBox.js' */            },

/*Line 44 - 'AtomDateListBox.js' */            set_visibleDate: function (v) {
/*Line 45 - 'AtomDateListBox.js' */                if (!v)
/*Line 46 - 'AtomDateListBox.js' */                    return;
/*Line 47 - 'AtomDateListBox.js' */                this._visibleDate = v;
/*Line 48 - 'AtomDateListBox.js' */                this._year = v.getFullYear();
/*Line 49 - 'AtomDateListBox.js' */                this._month = v.getMonth() + 1;
/*Line 50 - 'AtomDateListBox.js' */                this.updateList();
/*Line 51 - 'AtomDateListBox.js' */                AtomBinder.refreshValue(this, "year");
/*Line 52 - 'AtomDateListBox.js' */                AtomBinder.refreshValue(this, "month");
/*Line 53 - 'AtomDateListBox.js' */            },

/*Line 55 - 'AtomDateListBox.js' */            initialize: function () {
/*Line 56 - 'AtomDateListBox.js' */                base.initialize.apply(this);
/*Line 57 - 'AtomDateListBox.js' */                var _this = this;
/*Line 58 - 'AtomDateListBox.js' */                this.toggleDateCommand = function (scope, sender) {
/*Line 59 - 'AtomDateListBox.js' */                    _this.toggleDate.apply(_this, arguments);
/*Line 60 - 'AtomDateListBox.js' */                };
/*Line 61 - 'AtomDateListBox.js' */            },

/*Line 63 - 'AtomDateListBox.js' */            onLoaded: function () {
/*Line 64 - 'AtomDateListBox.js' */                var t = this.getTemplate("itemTemplate");

/*Line 66 - 'AtomDateListBox.js' */                var s = this.get_scope();

/*Line 68 - 'AtomDateListBox.js' */                var its = this._itemsPresenter;

/*Line 70 - 'AtomDateListBox.js' */                this.updateList();
/*Line 71 - 'AtomDateListBox.js' */                if (!t)
/*Line 72 - 'AtomDateListBox.js' */                    return;
/*Line 73 - 'AtomDateListBox.js' */                var list = this._items;
/*Line 74 - 'AtomDateListBox.js' */                for (var i = 0; i < 42; i++) {
/*Line 75 - 'AtomDateListBox.js' */                    var e = AtomUI.cloneNode(t);
/*Line 76 - 'AtomDateListBox.js' */                    e._templateParent = this;
/*Line 77 - 'AtomDateListBox.js' */                    var sc = new AtomScope(this, s, atomApplication);
/*Line 78 - 'AtomDateListBox.js' */                    sc.item_index = i;
/*Line 79 - 'AtomDateListBox.js' */                    $(its).append(e);
/*Line 80 - 'AtomDateListBox.js' */                    var ac = AtomUI.createControl(e, WebAtoms.AtomControl, list[i], sc);
/*Line 81 - 'AtomDateListBox.js' */                }
/*Line 82 - 'AtomDateListBox.js' */            },

/*Line 84 - 'AtomDateListBox.js' */            toggleDate: function (scope, sender) {
/*Line 85 - 'AtomDateListBox.js' */                var item = sender.get_data();
/*Line 86 - 'AtomDateListBox.js' */                var s = $.inArray(item.value, $.map(this._selectedItems, function (a) { return a.value; }));
/*Line 87 - 'AtomDateListBox.js' */                if (s > -1) {

/*Line 89 - 'AtomDateListBox.js' */                    AtomBinder.removeAtIndex(this._selectedItems, s);
/*Line 90 - 'AtomDateListBox.js' */                } else {
/*Line 91 - 'AtomDateListBox.js' */                    AtomBinder.addItem(this._selectedItems, item);
/*Line 92 - 'AtomDateListBox.js' */                }
/*Line 93 - 'AtomDateListBox.js' */                AtomBinder.refreshValue(this, "value");
/*Line 94 - 'AtomDateListBox.js' */                AtomBinder.refreshValue(this, "selectedItems");
/*Line 95 - 'AtomDateListBox.js' */            },

/*Line 97 - 'AtomDateListBox.js' */            getItemClass: function (item, sv) {
/*Line 98 - 'AtomDateListBox.js' */                var s = $.inArray(item.value, $.map(this._selectedItems, function (a) { return a.value; })) > -1;
/*Line 99 - 'AtomDateListBox.js' */                var d = item.date.getDay();
/*Line 100 - 'AtomDateListBox.js' */                // weekend..
/*Line 101 - 'AtomDateListBox.js' */                var w = d == 0 || d == 6;

/*Line 103 - 'AtomDateListBox.js' */                var cls = "atom-date-list-box-day-list-item ";
/*Line 104 - 'AtomDateListBox.js' */                cls += w ? "atom-date-list-box-weekend " : "";
/*Line 105 - 'AtomDateListBox.js' */                cls += s ? "atom-date-list-box-selected " : "atom-date-list-box-item ";
/*Line 106 - 'AtomDateListBox.js' */                cls += (this._month == item.date.getMonth() + 1) ? "" : "atom-date-list-box-day-list-item-other";

/*Line 108 - 'AtomDateListBox.js' */                return cls;
/*Line 109 - 'AtomDateListBox.js' */            },

/*Line 111 - 'AtomDateListBox.js' */            set_value: function (v) {
/*Line 112 - 'AtomDateListBox.js' */                if (v === undefined) {
/*Line 113 - 'AtomDateListBox.js' */                    return;
/*Line 114 - 'AtomDateListBox.js' */                }
/*Line 115 - 'AtomDateListBox.js' */                this._selectedItems.length = 0;
/*Line 116 - 'AtomDateListBox.js' */                if (v !== null) {
/*Line 117 - 'AtomDateListBox.js' */                    var items = v.split(',');
/*Line 118 - 'AtomDateListBox.js' */                    for (var i = 0; i < items.length; i++) {
/*Line 119 - 'AtomDateListBox.js' */                        var item = items[i];
/*Line 120 - 'AtomDateListBox.js' */                        if (!item) {
/*Line 121 - 'AtomDateListBox.js' */                            continue;
/*Line 122 - 'AtomDateListBox.js' */                        }
/*Line 123 - 'AtomDateListBox.js' */                        var dts = item.split('/');
/*Line 124 - 'AtomDateListBox.js' */                        var d = new Date(parseInt(dts[2], 10), parseInt(dts[0], 10) - 1, parseInt(dts[1], 10));
/*Line 125 - 'AtomDateListBox.js' */                        this._selectedItems.push({ date: d, dateLabel: AtomDate.toShortDateString(d), value: item, label: d.getDate() });
/*Line 126 - 'AtomDateListBox.js' */                    }
/*Line 127 - 'AtomDateListBox.js' */                }
/*Line 128 - 'AtomDateListBox.js' */                if (this._created) {
/*Line 129 - 'AtomDateListBox.js' */                    AtomBinder.refreshItems(this._selectedItems);
/*Line 130 - 'AtomDateListBox.js' */                    AtomBinder.refreshValue(this, "value");
/*Line 131 - 'AtomDateListBox.js' */                    AtomBinder.refreshValue(this, "selectedItems");
/*Line 132 - 'AtomDateListBox.js' */                }
/*Line 133 - 'AtomDateListBox.js' */            },
/*Line 134 - 'AtomDateListBox.js' */            get_value: function (v) {
/*Line 135 - 'AtomDateListBox.js' */                return $.map(this._selectedItems, function (a) { return a.value; }).join(",");
/*Line 136 - 'AtomDateListBox.js' */            },

/*Line 138 - 'AtomDateListBox.js' */            updateList: function () {
/*Line 139 - 'AtomDateListBox.js' */                if (!this._month || !this._year)
/*Line 140 - 'AtomDateListBox.js' */                    return;

/*Line 142 - 'AtomDateListBox.js' */                var d = new Date(this._year, this._month - 1, 1);
/*Line 143 - 'AtomDateListBox.js' */                var first = new Date(this._year, this._month - 1, 1);

/*Line 145 - 'AtomDateListBox.js' */                if (first.getDay()) {
/*Line 146 - 'AtomDateListBox.js' */                    // go to first day of the month...
/*Line 147 - 'AtomDateListBox.js' */                    var start = first.getDay() - 1;
/*Line 148 - 'AtomDateListBox.js' */                    start = -start;

/*Line 150 - 'AtomDateListBox.js' */                    first.setDate(start);
/*Line 151 - 'AtomDateListBox.js' */                }

/*Line 153 - 'AtomDateListBox.js' */                var m = first.getMonth();
/*Line 154 - 'AtomDateListBox.js' */                var y = first.getFullYear();

/*Line 156 - 'AtomDateListBox.js' */                var items = [];

/*Line 158 - 'AtomDateListBox.js' */                var i = 0;

/*Line 160 - 'AtomDateListBox.js' */                for (i = 0; i < 42; i++) {
/*Line 161 - 'AtomDateListBox.js' */                    var cd = i + first.getDate();
/*Line 162 - 'AtomDateListBox.js' */                    var id = new Date(y, m, cd);
/*Line 163 - 'AtomDateListBox.js' */                    items.push({ label: id.getDate(), dateLabel: AtomDate.toShortDateString(id), value: AtomDate.toMMDDYY(id), date: id });
/*Line 164 - 'AtomDateListBox.js' */                }

/*Line 166 - 'AtomDateListBox.js' */                this._items = items;
/*Line 167 - 'AtomDateListBox.js' */                AtomBinder.refreshValue(this, "items");
/*Line 168 - 'AtomDateListBox.js' */                AtomBinder.refreshValue(this, "selectedItems");
/*Line 169 - 'AtomDateListBox.js' */                if (this._created) {
/*Line 170 - 'AtomDateListBox.js' */                    AtomBinder.refreshValue(this, "value");
/*Line 171 - 'AtomDateListBox.js' */                }
/*Line 172 - 'AtomDateListBox.js' */            }
/*Line 173 - 'AtomDateListBox.js' */        }
/*Line 174 - 'AtomDateListBox.js' */    });
/*Line 175 - 'AtomDateListBox.js' */})(window, WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomPostButton.js' */

/*Line 2 - 'AtomPostButton.js' */(function (window, base) {
/*Line 3 - 'AtomPostButton.js' */    return classCreatorEx({
/*Line 4 - 'AtomPostButton.js' */        name: "WebAtoms.AtomPostButton",
/*Line 5 - 'AtomPostButton.js' */        base: base,
/*Line 6 - 'AtomPostButton.js' */        start:function(){
/*Line 7 - 'AtomPostButton.js' */        },
/*Line 8 - 'AtomPostButton.js' */        properties: {
/*Line 9 - 'AtomPostButton.js' */            postData: null,
/*Line 10 - 'AtomPostButton.js' */            postResult: null,
/*Line 11 - 'AtomPostButton.js' */            postUrl: null,
/*Line 12 - 'AtomPostButton.js' */            next: null,
/*Line 13 - 'AtomPostButton.js' */            confirm: false,
/*Line 14 - 'AtomPostButton.js' */            confirmMessage: null,
/*Line 15 - 'AtomPostButton.js' */            mergeData: null
/*Line 16 - 'AtomPostButton.js' */        },
/*Line 17 - 'AtomPostButton.js' */        methods: {
/*Line 18 - 'AtomPostButton.js' */            get_postData: function () {
/*Line 19 - 'AtomPostButton.js' */                return this._postData || this.get_data();
/*Line 20 - 'AtomPostButton.js' */            },

/*Line 22 - 'AtomPostButton.js' */            onClickHandler: function (e) {

/*Line 24 - 'AtomPostButton.js' */                if (this._confirm) {
/*Line 25 - 'AtomPostButton.js' */                    if (!confirm(this._confirmMessage))
/*Line 26 - 'AtomPostButton.js' */                        return;
/*Line 27 - 'AtomPostButton.js' */                }

/*Line 29 - 'AtomPostButton.js' */                if (!this._postUrl) {
/*Line 30 - 'AtomPostButton.js' */                    base.onClickHandler.apply(this, arguments);
/*Line 31 - 'AtomPostButton.js' */                    return;
/*Line 32 - 'AtomPostButton.js' */                }

/*Line 34 - 'AtomPostButton.js' */                var data = this.get_postData();

/*Line 36 - 'AtomPostButton.js' */                if (data === null || data === undefined)
/*Line 37 - 'AtomPostButton.js' */                    return;

/*Line 39 - 'AtomPostButton.js' */                var m = this._mergeData;
/*Line 40 - 'AtomPostButton.js' */                if (m) {
/*Line 41 - 'AtomPostButton.js' */                    for (var i in m) {
/*Line 42 - 'AtomPostButton.js' */                        data[i] = m[i];
/*Line 43 - 'AtomPostButton.js' */                    }
/*Line 44 - 'AtomPostButton.js' */                }

/*Line 46 - 'AtomPostButton.js' */                //data = AtomBinder.getClone(data);

/*Line 48 - 'AtomPostButton.js' */                var caller = this;
/*Line 49 - 'AtomPostButton.js' */                var invokeNext = function (p) {
/*Line 50 - 'AtomPostButton.js' */                    AtomBinder.setValue(caller, "postResult", p.value());
/*Line 51 - 'AtomPostButton.js' */                    caller.invokeAction(caller._next);
/*Line 52 - 'AtomPostButton.js' */                };

/*Line 54 - 'AtomPostButton.js' */                //this.invokeAjax(this._postUrl, { type: "POST", data: data, success: invokeNext });
/*Line 55 - 'AtomPostButton.js' */                AtomPromise.json(this._postUrl, null, { type: "POST", data: data }).then(invokeNext).invoke();

/*Line 57 - 'AtomPostButton.js' */            }
/*Line 58 - 'AtomPostButton.js' */        }
/*Line 59 - 'AtomPostButton.js' */    });
/*Line 60 - 'AtomPostButton.js' */})(window, WebAtoms.AtomButton.prototype);
/*Line 0 - 'AtomToggleButtonBar.js' */

/*Line 2 - 'AtomToggleButtonBar.js' */(function (window, baseType) {
/*Line 3 - 'AtomToggleButtonBar.js' */    return classCreatorEx({
/*Line 4 - 'AtomToggleButtonBar.js' */        name: "WebAtoms.AtomToggleButtonBar",
/*Line 5 - 'AtomToggleButtonBar.js' */        base: baseType,
/*Line 6 - 'AtomToggleButtonBar.js' */        start: function (e) {
/*Line 7 - 'AtomToggleButtonBar.js' */            this._allowSelectFirst = true;
/*Line 8 - 'AtomToggleButtonBar.js' */            this._allowMultipleSelection = false;
/*Line 9 - 'AtomToggleButtonBar.js' */            this._showTabs = false;
/*Line 10 - 'AtomToggleButtonBar.js' */            this._autoScrollToSelection = false;

/*Line 12 - 'AtomToggleButtonBar.js' */            $(e).removeClass("atom-list-box");
/*Line 13 - 'AtomToggleButtonBar.js' */        },
/*Line 14 - 'AtomToggleButtonBar.js' */        properties: {
/*Line 15 - 'AtomToggleButtonBar.js' */            showTabs: false
/*Line 16 - 'AtomToggleButtonBar.js' */        },
/*Line 17 - 'AtomToggleButtonBar.js' */        methods: {
/*Line 18 - 'AtomToggleButtonBar.js' */            initialize: function () {

/*Line 20 - 'AtomToggleButtonBar.js' */                baseType.initialize.call(this);

/*Line 22 - 'AtomToggleButtonBar.js' */                this.setValue("class", "[$owner.showTabs ? 'atom-tab-button-bar' : 'atom-toggle-button-bar']", true, this._element);
/*Line 23 - 'AtomToggleButtonBar.js' */            }
/*Line 24 - 'AtomToggleButtonBar.js' */        }
/*Line 25 - 'AtomToggleButtonBar.js' */    });
/*Line 26 - 'AtomToggleButtonBar.js' */})(window, WebAtoms.AtomListBox.prototype);
/*Line 0 - 'AtomApplication.js' */

/*Line 2 - 'AtomApplication.js' */this.appScope = null;

/*Line 4 - 'AtomApplication.js' */this.atomApplication = null;

/*Line 6 - 'AtomApplication.js' */(function (window, name, base) {

/*Line 8 - 'AtomApplication.js' */    return classCreator(name, base,
/*Line 9 - 'AtomApplication.js' */        function (element) {
/*Line 10 - 'AtomApplication.js' */            $(element).removeClass("atom-dock-panel");
/*Line 11 - 'AtomApplication.js' */            $(element).addClass("atom-application");

/*Line 13 - 'AtomApplication.js' */            this._scope = new AtomScope(this, null, this);
/*Line 14 - 'AtomApplication.js' */            window.appScope = this._scope;

/*Line 16 - 'AtomApplication.js' */            if (window.model) {
/*Line 17 - 'AtomApplication.js' */                window.appScope.model = window.model;
/*Line 18 - 'AtomApplication.js' */                this._data = window.model;
/*Line 19 - 'AtomApplication.js' */            }

/*Line 21 - 'AtomApplication.js' */            window.atomApplication = this;
/*Line 22 - 'AtomApplication.js' */            if (location.hash) {
/*Line 23 - 'AtomApplication.js' */                var url = location.hash.substring(1);
/*Line 24 - 'AtomApplication.js' */                this._urlScope = AtomUI.parseUrl(url);
/*Line 25 - 'AtomApplication.js' */            } else {
/*Line 26 - 'AtomApplication.js' */                this._urlScope = {};
/*Line 27 - 'AtomApplication.js' */            }

/*Line 29 - 'AtomApplication.js' */            // load hash values...
/*Line 30 - 'AtomApplication.js' */            this.onHashChanged();

/*Line 32 - 'AtomApplication.js' */            this.busyCount = 0;
/*Line 33 - 'AtomApplication.js' */        },
/*Line 34 - 'AtomApplication.js' */        {
/*Line 35 - 'AtomApplication.js' */            get_title: function () {
/*Line 36 - 'AtomApplication.js' */                return window.document.title;
/*Line 37 - 'AtomApplication.js' */            },
/*Line 38 - 'AtomApplication.js' */            set_title: function (v) {
/*Line 39 - 'AtomApplication.js' */                window.document.title = v;
/*Line 40 - 'AtomApplication.js' */            },

/*Line 42 - 'AtomApplication.js' */            get_isBusy: function () {
/*Line 43 - 'AtomApplication.js' */                return this.busyCount;
/*Line 44 - 'AtomApplication.js' */            },

/*Line 46 - 'AtomApplication.js' */            setBusy: function (b, msg) {
/*Line 47 - 'AtomApplication.js' */                if (b) {
/*Line 48 - 'AtomApplication.js' */                    this.busyCount++;
/*Line 49 - 'AtomApplication.js' */                } else {
/*Line 50 - 'AtomApplication.js' */                    this.busyCount--;
/*Line 51 - 'AtomApplication.js' */                }
/*Line 52 - 'AtomApplication.js' */                if (msg !== undefined) {
/*Line 53 - 'AtomApplication.js' */                    if (!msg)
/*Line 54 - 'AtomApplication.js' */                        msg = "";
/*Line 55 - 'AtomApplication.js' */                    AtomBinder.setValue(this, "busyMessage", msg);
/*Line 56 - 'AtomApplication.js' */                } else {
/*Line 57 - 'AtomApplication.js' */                    AtomBinder.setValue(this, "busyMessage", "Loading...");
/*Line 58 - 'AtomApplication.js' */                }
/*Line 59 - 'AtomApplication.js' */                AtomBinder.refreshValue(this, "isBusy");
/*Line 60 - 'AtomApplication.js' */            },

/*Line 62 - 'AtomApplication.js' */            updateUI: function () {
/*Line 63 - 'AtomApplication.js' */                //if (!this._renderAsPage) {
/*Line 64 - 'AtomApplication.js' */                //    var element = this.get_element();
/*Line 65 - 'AtomApplication.js' */                //    var ep = element.parentNode;
/*Line 66 - 'AtomApplication.js' */                //    var pw = $(ep).outerWidth();
/*Line 67 - 'AtomApplication.js' */                //    var left = (pw - $(element).width()) / 2;
/*Line 68 - 'AtomApplication.js' */                //    element.style.left = left + "px";
/*Line 69 - 'AtomApplication.js' */                //    element.style.position = "absolute";
/*Line 70 - 'AtomApplication.js' */                //}
/*Line 71 - 'AtomApplication.js' */                base.updateUI.call(this);

/*Line 73 - 'AtomApplication.js' */                AtomBinder.refreshValue(this, "appWidth");
/*Line 74 - 'AtomApplication.js' */                AtomBinder.refreshValue(this, "appHeight");
/*Line 75 - 'AtomApplication.js' */                AtomBinder.refreshValue(this, "bodyWidth");
/*Line 76 - 'AtomApplication.js' */                AtomBinder.refreshValue(this, "bodyHeight");
/*Line 77 - 'AtomApplication.js' */            },

/*Line 79 - 'AtomApplication.js' */            onUpdateUI: function () {
/*Line 80 - 'AtomApplication.js' */                if (!this._renderAsPage) {
/*Line 81 - 'AtomApplication.js' */                    base.onUpdateUI.call(this);
/*Line 82 - 'AtomApplication.js' */                }
/*Line 83 - 'AtomApplication.js' */            },

/*Line 85 - 'AtomApplication.js' */            get_appWidth: function () {
/*Line 86 - 'AtomApplication.js' */                return $(this._element).width();
/*Line 87 - 'AtomApplication.js' */            },
/*Line 88 - 'AtomApplication.js' */            get_appHeight: function () {
/*Line 89 - 'AtomApplication.js' */                return $(this._element).height();
/*Line 90 - 'AtomApplication.js' */            },

/*Line 92 - 'AtomApplication.js' */            get_bodyWidth: function () {
/*Line 93 - 'AtomApplication.js' */                return $(document.body).width();
/*Line 94 - 'AtomApplication.js' */            },
/*Line 95 - 'AtomApplication.js' */            get_bodyHeight: function () {
/*Line 96 - 'AtomApplication.js' */                return $(document.body).height();
/*Line 97 - 'AtomApplication.js' */            },


/*Line 100 - 'AtomApplication.js' */            onHashChanged: function () {

/*Line 102 - 'AtomApplication.js' */                if (this._noHashRefresh)
/*Line 103 - 'AtomApplication.js' */                    return;
/*Line 104 - 'AtomApplication.js' */                var scope = this._scope;

/*Line 106 - 'AtomApplication.js' */                var url = location.hash ? location.hash : this._defaultScope;
/*Line 107 - 'AtomApplication.js' */                if (!url) {
/*Line 108 - 'AtomApplication.js' */                    return;
/*Line 109 - 'AtomApplication.js' */                }

/*Line 111 - 'AtomApplication.js' */                //log("#changed:" + url);

/*Line 113 - 'AtomApplication.js' */                this._noHashRefresh = true;
/*Line 114 - 'AtomApplication.js' */                url = url.substr(1);

/*Line 116 - 'AtomApplication.js' */                var s = AtomUI.parseUrl(url);

/*Line 118 - 'AtomApplication.js' */                if (this._created) {
/*Line 119 - 'AtomApplication.js' */                    for (var key in s) {
/*Line 120 - 'AtomApplication.js' */                        var val = s[key];
/*Line 121 - 'AtomApplication.js' */                        if (scope[key] != val) {
/*Line 122 - 'AtomApplication.js' */                            AtomBinder.setValue(scope, key, val);
/*Line 123 - 'AtomApplication.js' */                        }
/*Line 124 - 'AtomApplication.js' */                    }
/*Line 125 - 'AtomApplication.js' */                } else {
/*Line 126 - 'AtomApplication.js' */                    Atom.merge(scope, s);
/*Line 127 - 'AtomApplication.js' */                }

/*Line 129 - 'AtomApplication.js' */                this._noHashRefresh = false;

/*Line 131 - 'AtomApplication.js' */            },

/*Line 133 - 'AtomApplication.js' */            invokeUpdateUI: function () {
/*Line 134 - 'AtomApplication.js' */                var container = this;
/*Line 135 - 'AtomApplication.js' */                var _this = this;
/*Line 136 - 'AtomApplication.js' */                window.setTimeout(function () {
/*Line 137 - 'AtomApplication.js' */                    return _this.updateUI();
/*Line 138 - 'AtomApplication.js' */                }, 5);
/*Line 139 - 'AtomApplication.js' */            },

/*Line 141 - 'AtomApplication.js' */            onRefreshValue: function (target, key) {
/*Line 142 - 'AtomApplication.js' */                if (this._noHashRefresh)
/*Line 143 - 'AtomApplication.js' */                    return;

/*Line 145 - 'AtomApplication.js' */                var i = key;
/*Line 146 - 'AtomApplication.js' */                if (i.indexOf('_') == 0)
/*Line 147 - 'AtomApplication.js' */                    return;
/*Line 148 - 'AtomApplication.js' */                var val = this._scope[i];
/*Line 149 - 'AtomApplication.js' */                if (val === undefined)
/*Line 150 - 'AtomApplication.js' */                    return;
/*Line 151 - 'AtomApplication.js' */                if (val === null)
/*Line 152 - 'AtomApplication.js' */                    return;
/*Line 153 - 'AtomApplication.js' */                var t = typeof (val);
/*Line 154 - 'AtomApplication.js' */                if (t != 'string' && t != 'number' && t != 'boolean') {
/*Line 155 - 'AtomApplication.js' */                    return;
/*Line 156 - 'AtomApplication.js' */                }


/*Line 159 - 'AtomApplication.js' */                var diff = {};
/*Line 160 - 'AtomApplication.js' */                var src = this._scope;
/*Line 161 - 'AtomApplication.js' */                var dest = this._defaultScopeValues || {};

/*Line 163 - 'AtomApplication.js' */                for (var k in src) {
/*Line 164 - 'AtomApplication.js' */                    var v = src[k];
/*Line 165 - 'AtomApplication.js' */                    if (!this._urlScope[k]) {
/*Line 166 - 'AtomApplication.js' */                        if (v == dest[k])
/*Line 167 - 'AtomApplication.js' */                            continue;
/*Line 168 - 'AtomApplication.js' */                    }
/*Line 169 - 'AtomApplication.js' */                    diff[k] = v;
/*Line 170 - 'AtomApplication.js' */                }

/*Line 172 - 'AtomApplication.js' */                // update hash !!!
/*Line 173 - 'AtomApplication.js' */                var p = Atom.encodeParameters(diff);
/*Line 174 - 'AtomApplication.js' */                if (!p) {
/*Line 175 - 'AtomApplication.js' */                    if (history && history.pushState) {
/*Line 176 - 'AtomApplication.js' */                        history.pushState({}, document.title, location.href.split('#')[0]);
/*Line 177 - 'AtomApplication.js' */                    } else {
/*Line 178 - 'AtomApplication.js' */                        location.hash = "";
/*Line 179 - 'AtomApplication.js' */                    }
/*Line 180 - 'AtomApplication.js' */                    return;
/*Line 181 - 'AtomApplication.js' */                }
/*Line 182 - 'AtomApplication.js' */                p = "#" + p;


/*Line 185 - 'AtomApplication.js' */                if (location.hash != p) {

/*Line 187 - 'AtomApplication.js' */                    this._noHashRefresh = true;
/*Line 188 - 'AtomApplication.js' */                    if (history && history.pushState) {
/*Line 189 - 'AtomApplication.js' */                        history.pushState({}, document.title, (location.href.split('#')[0]) + p);
/*Line 190 - 'AtomApplication.js' */                    } else {
/*Line 191 - 'AtomApplication.js' */                        location.href = p;
/*Line 192 - 'AtomApplication.js' */                    }
/*Line 193 - 'AtomApplication.js' */                    this._noHashRefresh = false;
/*Line 194 - 'AtomApplication.js' */                }
/*Line 195 - 'AtomApplication.js' */            },

/*Line 197 - 'AtomApplication.js' */            initializationComplete: function () {

/*Line 199 - 'AtomApplication.js' */                // To save URL persistance of Scope Values
/*Line 200 - 'AtomApplication.js' */                // We have to remember default scope values set 
/*Line 201 - 'AtomApplication.js' */                // at time of page creation.
/*Line 202 - 'AtomApplication.js' */                var d = {};
/*Line 203 - 'AtomApplication.js' */                var src = this._scope;
/*Line 204 - 'AtomApplication.js' */                for (var k in src) {
/*Line 205 - 'AtomApplication.js' */                    if (k.indexOf('_') == 0)
/*Line 206 - 'AtomApplication.js' */                        continue;
/*Line 207 - 'AtomApplication.js' */                    var val = src[k];
/*Line 208 - 'AtomApplication.js' */                    if (val === undefined)
/*Line 209 - 'AtomApplication.js' */                        continue;
/*Line 210 - 'AtomApplication.js' */                    if (val === null)
/*Line 211 - 'AtomApplication.js' */                        continue;
/*Line 212 - 'AtomApplication.js' */                    var t = typeof (val);
/*Line 213 - 'AtomApplication.js' */                    if (t != 'string' && t != 'number' && t != 'boolean') {
/*Line 214 - 'AtomApplication.js' */                        continue;
/*Line 215 - 'AtomApplication.js' */                    }
/*Line 216 - 'AtomApplication.js' */                    d[k] = val;
/*Line 217 - 'AtomApplication.js' */                }
/*Line 218 - 'AtomApplication.js' */                this._defaultScopeValues = d;


/*Line 221 - 'AtomApplication.js' */                var p = Atom.encodeParameters(this._scope);
/*Line 222 - 'AtomApplication.js' */                if (p) {
/*Line 223 - 'AtomApplication.js' */                    this._defaultScope = "#" + p;
/*Line 224 - 'AtomApplication.js' */                }
/*Line 225 - 'AtomApplication.js' */                base.initializationComplete.call(this);
/*Line 226 - 'AtomApplication.js' */            },

/*Line 228 - 'AtomApplication.js' */            createChildren: function () {
/*Line 229 - 'AtomApplication.js' */                base.createChildren.call(this);

/*Line 231 - 'AtomApplication.js' */                this.getTemplate("busyTemplate");
/*Line 232 - 'AtomApplication.js' */                if (this._busyTemplate) {
/*Line 233 - 'AtomApplication.js' */                    this._element.appendChild(this._busyTemplate);

/*Line 235 - 'AtomApplication.js' */                    this.onCreateChildren(this._busyTemplate);
/*Line 236 - 'AtomApplication.js' */                }
/*Line 237 - 'AtomApplication.js' */            },

/*Line 239 - 'AtomApplication.js' */            onCreationComplete: function () {
/*Line 240 - 'AtomApplication.js' */                base.onCreationComplete.call(this);


/*Line 243 - 'AtomApplication.js' */                if (AtomBrowser.isIE && AtomBrowser.majorVersion < 8) {
/*Line 244 - 'AtomApplication.js' */                    // setup timer...
/*Line 245 - 'AtomApplication.js' */                    var _this = this;
/*Line 246 - 'AtomApplication.js' */                    setInterval(function () {
/*Line 247 - 'AtomApplication.js' */                        _this.onCheckHash();
/*Line 248 - 'AtomApplication.js' */                    }, 1000);
/*Line 249 - 'AtomApplication.js' */                    this._lastHash = location.hash;
/*Line 250 - 'AtomApplication.js' */                } else {
/*Line 251 - 'AtomApplication.js' */                    var eventName = window.onhashchange ? "onhashchange" : "hashchange";
/*Line 252 - 'AtomApplication.js' */                    this.bindEvent(window, eventName, "onHashChanged");
/*Line 253 - 'AtomApplication.js' */                }

/*Line 255 - 'AtomApplication.js' */                if (this._next) {
/*Line 256 - 'AtomApplication.js' */                    WebAtoms.dispatcher.callLater(function () {
/*Line 257 - 'AtomApplication.js' */                        window.atomApplication.invokeAction(window.atomApplication._next);
/*Line 258 - 'AtomApplication.js' */                    });
/*Line 259 - 'AtomApplication.js' */                }
/*Line 260 - 'AtomApplication.js' */            },

/*Line 262 - 'AtomApplication.js' */            onCheckHash: function () {
/*Line 263 - 'AtomApplication.js' */                if (this._lastHash != location.hash) {
/*Line 264 - 'AtomApplication.js' */                    this.onHashChanged();
/*Line 265 - 'AtomApplication.js' */                    this._lastHash = location.hash;
/*Line 266 - 'AtomApplication.js' */                }
/*Line 267 - 'AtomApplication.js' */            },

/*Line 269 - 'AtomApplication.js' */            onCloseCommand: function () {
/*Line 270 - 'AtomApplication.js' */                if (!parent)
/*Line 271 - 'AtomApplication.js' */                    return;
/*Line 272 - 'AtomApplication.js' */                //var iframe = parent.document.getElementById(frameElement.id);
/*Line 273 - 'AtomApplication.js' */                var win = frameElement.atomWindow;
/*Line 274 - 'AtomApplication.js' */                win._value = this._value;
/*Line 275 - 'AtomApplication.js' */                win.onCloseCommand();
/*Line 276 - 'AtomApplication.js' */            },

/*Line 278 - 'AtomApplication.js' */            setup: function () {
/*Line 279 - 'AtomApplication.js' */                this.createChildren();
/*Line 280 - 'AtomApplication.js' */                this.initialize();
/*Line 281 - 'AtomApplication.js' */            },

/*Line 283 - 'AtomApplication.js' */            initializationComplete: function () {
/*Line 284 - 'AtomApplication.js' */                base.initializationComplete.apply(this, arguments);
/*Line 285 - 'AtomApplication.js' */                if (!this._renderAsPage) {
/*Line 286 - 'AtomApplication.js' */                    $(this._element).addClass("atom-dock-application");
/*Line 287 - 'AtomApplication.js' */                }
/*Line 288 - 'AtomApplication.js' */            },

/*Line 290 - 'AtomApplication.js' */            initialize: function () {

/*Line 292 - 'AtomApplication.js' */                this.bindEvent(window, "resize", "invokeUpdateUI");

/*Line 294 - 'AtomApplication.js' */                var _this = this;
/*Line 295 - 'AtomApplication.js' */                this._onRefreshValue = function () {
/*Line 296 - 'AtomApplication.js' */                    _this.onRefreshValue.apply(_this, arguments);
/*Line 297 - 'AtomApplication.js' */                };

/*Line 299 - 'AtomApplication.js' */                this._scope._$_watcher = this;

/*Line 301 - 'AtomApplication.js' */                base.initialize.call(this);


/*Line 304 - 'AtomApplication.js' */                this.closeCommand = function () {
/*Line 305 - 'AtomApplication.js' */                    _this.onCloseCommand.apply(_this, arguments);
/*Line 306 - 'AtomApplication.js' */                };

/*Line 308 - 'AtomApplication.js' */            }
/*Line 309 - 'AtomApplication.js' */        },
/*Line 310 - 'AtomApplication.js' */        {
/*Line 311 - 'AtomApplication.js' */            renderAsPage: false,
/*Line 312 - 'AtomApplication.js' */            busyMessage: "",
/*Line 313 - 'AtomApplication.js' */            progress: 0

/*Line 315 - 'AtomApplication.js' */        });
/*Line 316 - 'AtomApplication.js' */})(window, "WebAtoms.AtomApplication", WebAtoms.AtomDockPanel.prototype);
/*Line 0 - 'AtomForm.js' */

/*Line 2 - 'AtomForm.js' */(function (baseType) {
/*Line 3 - 'AtomForm.js' */    return classCreatorEx({
/*Line 4 - 'AtomForm.js' */        name: "WebAtoms.AtomForm",
/*Line 5 - 'AtomForm.js' */        base: baseType,
/*Line 6 - 'AtomForm.js' */        start: function () {
/*Line 7 - 'AtomForm.js' */            this._success = null;
/*Line 8 - 'AtomForm.js' */            this._submit = null;
/*Line 9 - 'AtomForm.js' */            this._error = null;
/*Line 10 - 'AtomForm.js' */            this._attachments = null;
/*Line 11 - 'AtomForm.js' */        },
/*Line 12 - 'AtomForm.js' */        properties: {
/*Line 13 - 'AtomForm.js' */            result: null,
/*Line 14 - 'AtomForm.js' */            mergeData: null,
/*Line 15 - 'AtomForm.js' */            mergeResult: true,
/*Line 16 - 'AtomForm.js' */            postUrl: null,
/*Line 17 - 'AtomForm.js' */            postData: null,
/*Line 18 - 'AtomForm.js' */            successMessage: null,
/*Line 19 - 'AtomForm.js' */            clearData:false
/*Line 20 - 'AtomForm.js' */        },
/*Line 21 - 'AtomForm.js' */        methods: {
/*Line 22 - 'AtomForm.js' */            createFormLayout: function () {
/*Line 23 - 'AtomForm.js' */            },


/*Line 26 - 'AtomForm.js' */            preparePostData: function () {


/*Line 29 - 'AtomForm.js' */                var element = this.get_element();
/*Line 30 - 'AtomForm.js' */                var data = this._postData || this.get_data();

/*Line 32 - 'AtomForm.js' */                var m = this._mergeData;
/*Line 33 - 'AtomForm.js' */                if (m) {
/*Line 34 - 'AtomForm.js' */                    for (var i in m) {
/*Line 35 - 'AtomForm.js' */                        data[i] = m[i];
/*Line 36 - 'AtomForm.js' */                    }
/*Line 37 - 'AtomForm.js' */                }

/*Line 39 - 'AtomForm.js' */                return data;
/*Line 40 - 'AtomForm.js' */            },

/*Line 42 - 'AtomForm.js' */            onSubmit: function () {

/*Line 44 - 'AtomForm.js' */                if (!this.isValid()) {
/*Line 45 - 'AtomForm.js' */                    return;
/*Line 46 - 'AtomForm.js' */                }

/*Line 48 - 'AtomForm.js' */                var data = this.preparePostData();
/*Line 49 - 'AtomForm.js' */                var url = AtomPromise.getUrl(this._postUrl);
/*Line 50 - 'AtomForm.js' */                AtomPromise.json(url, { _tv: Atom.time() }, { type: "POST", data: data }).then(this._success).invoke();
/*Line 51 - 'AtomForm.js' */            },

/*Line 53 - 'AtomForm.js' */            onSuccess: function (p) {

/*Line 55 - 'AtomForm.js' */                var result = p.value();

/*Line 57 - 'AtomForm.js' */                AtomBinder.setValue(this, "result", result);

/*Line 59 - 'AtomForm.js' */                if (this._mergeResult) {
/*Line 60 - 'AtomForm.js' */                    // merge...
/*Line 61 - 'AtomForm.js' */                    // AtomBinder.setValue(this, "data", result);
/*Line 62 - 'AtomForm.js' */                    var data = this.get_data();
/*Line 63 - 'AtomForm.js' */                    for (var index in result) {
/*Line 64 - 'AtomForm.js' */                        AtomBinder.setValue(data, index, result[index]);
/*Line 65 - 'AtomForm.js' */                    }
/*Line 66 - 'AtomForm.js' */                }

/*Line 68 - 'AtomForm.js' */                if (this._clearData) {
/*Line 69 - 'AtomForm.js' */                    var data = this.get_data();
/*Line 70 - 'AtomForm.js' */                    for (var index in this._clearData) {
/*Line 71 - 'AtomForm.js' */                        AtomBinder.setValue(data, index, result[index]);
/*Line 72 - 'AtomForm.js' */                    }
/*Line 73 - 'AtomForm.js' */                }

/*Line 75 - 'AtomForm.js' */                if (this._successMessage) {
/*Line 76 - 'AtomForm.js' */                    alert(this._successMessage);
/*Line 77 - 'AtomForm.js' */                }

/*Line 79 - 'AtomForm.js' */                this.invokeAction(this._next);

/*Line 81 - 'AtomForm.js' */            },

/*Line 83 - 'AtomForm.js' */            onKeyUp: function (e) {
/*Line 84 - 'AtomForm.js' */                if (e.target && e.target.nodeName && /textarea/gi.test(e.target.nodeName))
/*Line 85 - 'AtomForm.js' */                    return;
/*Line 86 - 'AtomForm.js' */                if (e.keyCode == 13) {
/*Line 87 - 'AtomForm.js' */                    this.onSubmit();
/*Line 88 - 'AtomForm.js' */                }
/*Line 89 - 'AtomForm.js' */            },

/*Line 91 - 'AtomForm.js' */            isValid: function () {
/*Line 92 - 'AtomForm.js' */                var element = this.get_element();
/*Line 93 - 'AtomForm.js' */                var ae = new ChildEnumerator(element);
/*Line 94 - 'AtomForm.js' */                var formValid = true;
/*Line 95 - 'AtomForm.js' */                while (ae.next()) {
/*Line 96 - 'AtomForm.js' */                    var field = ae.current();
/*Line 97 - 'AtomForm.js' */                    if (!this.validate(field))
/*Line 98 - 'AtomForm.js' */                        formValid = false;
/*Line 99 - 'AtomForm.js' */                }
/*Line 100 - 'AtomForm.js' */                return formValid;
/*Line 101 - 'AtomForm.js' */            },


/*Line 104 - 'AtomForm.js' */            validateField: function (e) {
/*Line 105 - 'AtomForm.js' */                var target = e.target;
/*Line 106 - 'AtomForm.js' */                this.validate(target);
/*Line 107 - 'AtomForm.js' */            },

/*Line 109 - 'AtomForm.js' */            validate: function (e, ef) {

/*Line 111 - 'AtomForm.js' */                if (!ef)
/*Line 112 - 'AtomForm.js' */                    ef = $(e).data("field-error");

/*Line 114 - 'AtomForm.js' */                var ctrl = e.atomControl;
/*Line 115 - 'AtomForm.js' */                var val = null;
/*Line 116 - 'AtomForm.js' */                var skip = false;
/*Line 117 - 'AtomForm.js' */                if (!ctrl) {
/*Line 118 - 'AtomForm.js' */                    if ((/input|select|textarea/i).test(e.nodeName)) {
/*Line 119 - 'AtomForm.js' */                        val = $(e).val();
/*Line 120 - 'AtomForm.js' */                    } else {
/*Line 121 - 'AtomForm.js' */                        skip = true;
/*Line 122 - 'AtomForm.js' */                    }
/*Line 123 - 'AtomForm.js' */                } else {
/*Line 124 - 'AtomForm.js' */                    if (ctrl.constructor == WebAtoms.AtomFormField) {
/*Line 125 - 'AtomForm.js' */                        return ctrl.validate();
/*Line 126 - 'AtomForm.js' */                    }
/*Line 127 - 'AtomForm.js' */                    val = AtomBinder.getValue(ctrl, "value");
/*Line 128 - 'AtomForm.js' */                }

/*Line 130 - 'AtomForm.js' */                if (!skip) {

/*Line 132 - 'AtomForm.js' */                    var req = $(e).attr("atom-required");
/*Line 133 - 'AtomForm.js' */                    if (req && !val) {
/*Line 134 - 'AtomForm.js' */                        // error...
/*Line 135 - 'AtomForm.js' */                        $(ef).text("Required");
/*Line 136 - 'AtomForm.js' */                        $(e).addClass("atom-data-error");
/*Line 137 - 'AtomForm.js' */                        return false;
/*Line 138 - 'AtomForm.js' */                    }


/*Line 141 - 'AtomForm.js' */                    var re = $(e).attr("atom-regex");
/*Line 142 - 'AtomForm.js' */                    if (!re) {
/*Line 143 - 'AtomForm.js' */                        var dt = $(e).attr("atom-data-type");
/*Line 144 - 'AtomForm.js' */                        if (dt) {
/*Line 145 - 'AtomForm.js' */                            switch (dt) {
/*Line 146 - 'AtomForm.js' */                                case "email":
/*Line 147 - 'AtomForm.js' */                                    re = /^(([^<>()\[\]\\.,;:\s@\"]+(\.[^<>()\[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
/*Line 148 - 'AtomForm.js' */                                    break;
/*Line 149 - 'AtomForm.js' */                            }
/*Line 150 - 'AtomForm.js' */                        }
/*Line 151 - 'AtomForm.js' */                    } else {
/*Line 152 - 'AtomForm.js' */                        re = eval("(" + re + ")");
/*Line 153 - 'AtomForm.js' */                    }

/*Line 155 - 'AtomForm.js' */                    if (re) {
/*Line 156 - 'AtomForm.js' */                        if (!re.test(val)) {
/*Line 157 - 'AtomForm.js' */                            $(ef).text("Invalid");
/*Line 158 - 'AtomForm.js' */                            $(e).addClass("atom-data-error");
/*Line 159 - 'AtomForm.js' */                            return false;
/*Line 160 - 'AtomForm.js' */                        }
/*Line 161 - 'AtomForm.js' */                    }

/*Line 163 - 'AtomForm.js' */                    $(ef).text("");
/*Line 164 - 'AtomForm.js' */                    $(e).removeClass("atom-data-error");
/*Line 165 - 'AtomForm.js' */                }

/*Line 167 - 'AtomForm.js' */                // return for every children??
/*Line 168 - 'AtomForm.js' */                var ae = new ChildEnumerator(e);
/*Line 169 - 'AtomForm.js' */                var isValid = true;
/*Line 170 - 'AtomForm.js' */                while (ae.next()) {
/*Line 171 - 'AtomForm.js' */                    if (!this.validate(ae.current(), ef)) {
/*Line 172 - 'AtomForm.js' */                        isValid = false;
/*Line 173 - 'AtomForm.js' */                    }
/*Line 174 - 'AtomForm.js' */                }

/*Line 176 - 'AtomForm.js' */                return isValid;
/*Line 177 - 'AtomForm.js' */            },

/*Line 179 - 'AtomForm.js' */            initialize: function () {
/*Line 180 - 'AtomForm.js' */                baseType.initialize.call(this);

/*Line 182 - 'AtomForm.js' */                var _this = this;
/*Line 183 - 'AtomForm.js' */                this._success = function () {
/*Line 184 - 'AtomForm.js' */                    _this.onSuccess.apply(_this, arguments);
/*Line 185 - 'AtomForm.js' */                };

/*Line 187 - 'AtomForm.js' */                this._submit = function () {
/*Line 188 - 'AtomForm.js' */                    _this.onSubmit.apply(_this, arguments);
/*Line 189 - 'AtomForm.js' */                };

/*Line 191 - 'AtomForm.js' */                var element = this.get_element();

/*Line 193 - 'AtomForm.js' */                this.submitCommand = this._submit;

/*Line 195 - 'AtomForm.js' */                this.bindEvent(element, "keyup", "onKeyUp");

/*Line 197 - 'AtomForm.js' */                $(element).find("input[type=submit]").bind("click", null, this._submit);
/*Line 198 - 'AtomForm.js' */                $(element).find("button[type=submit]").bind("click", null, this._submit);


/*Line 201 - 'AtomForm.js' */                var _this = this;
/*Line 202 - 'AtomForm.js' */                this._vh = function () {
/*Line 203 - 'AtomForm.js' */                    _this.validateField.apply(_this, arguments);
/*Line 204 - 'AtomForm.js' */                };

/*Line 206 - 'AtomForm.js' */                $(element).find("input,select,textarea").bind("blur", null, this._vh);



/*Line 210 - 'AtomForm.js' */            }

/*Line 212 - 'AtomForm.js' */        }
/*Line 213 - 'AtomForm.js' */    });
/*Line 214 - 'AtomForm.js' */})(WebAtoms.AtomControl.prototype);

/*Line 0 - 'AtomFormLayout.js' */

/*Line 2 - 'AtomFormLayout.js' */(function (baseType) {
/*Line 3 - 'AtomFormLayout.js' */    return classCreatorEx({
/*Line 4 - 'AtomFormLayout.js' */        name: "WebAtoms.AtomFormLayout",
/*Line 5 - 'AtomFormLayout.js' */        base: baseType,
/*Line 6 - 'AtomFormLayout.js' */        start: function () {
/*Line 7 - 'AtomFormLayout.js' */            this._useTable = true;
/*Line 8 - 'AtomFormLayout.js' */            this._errorItems = [];
/*Line 9 - 'AtomFormLayout.js' */            this._minLabelWidth = 0;
/*Line 10 - 'AtomFormLayout.js' */        },
/*Line 11 - 'AtomFormLayout.js' */        properties: {
/*Line 12 - 'AtomFormLayout.js' */            minLabelWidth: 0
/*Line 13 - 'AtomFormLayout.js' */        },
/*Line 14 - 'AtomFormLayout.js' */        methods: {
/*Line 15 - 'AtomFormLayout.js' */            createField: function (parent, child) {



/*Line 19 - 'AtomFormLayout.js' */                var amap = AtomUI.attributeMap(child, /^(atom\-(type|label|required|regex|data\-type|is\-valid|field\-(value|visible|class)|error))$/i);

/*Line 21 - 'AtomFormLayout.js' */                var at = amap["atom-type"];
/*Line 22 - 'AtomFormLayout.js' */                if (at) {
/*Line 23 - 'AtomFormLayout.js' */                    amap["atom-type"] = null;
/*Line 24 - 'AtomFormLayout.js' */                    switch (at.value) {
/*Line 25 - 'AtomFormLayout.js' */                        case "AtomFormGridLayout":
/*Line 26 - 'AtomFormLayout.js' */                        case "AtomFormTab":
/*Line 27 - 'AtomFormLayout.js' */                            parent.appendChild(child);
/*Line 28 - 'AtomFormLayout.js' */                            var a = AtomUI.createControl(child, at.value);
/*Line 29 - 'AtomFormLayout.js' */                            return a;
/*Line 30 - 'AtomFormLayout.js' */                            break;
/*Line 31 - 'AtomFormLayout.js' */                    }
/*Line 32 - 'AtomFormLayout.js' */                }

/*Line 34 - 'AtomFormLayout.js' */                var field = AtomUI.cloneNode(this._fieldTemplate);

/*Line 36 - 'AtomFormLayout.js' */                var cp = AtomUI.findPresenter(field);
/*Line 37 - 'AtomFormLayout.js' */                if (cp) {
/*Line 38 - 'AtomFormLayout.js' */                    cp.appendChild(child);
/*Line 39 - 'AtomFormLayout.js' */                    $(cp).removeAttr("atom-presenter");
/*Line 40 - 'AtomFormLayout.js' */                } else {
/*Line 41 - 'AtomFormLayout.js' */                    field.contentElement = child;
/*Line 42 - 'AtomFormLayout.js' */                }

/*Line 44 - 'AtomFormLayout.js' */                parent.appendChild(field);

/*Line 46 - 'AtomFormLayout.js' */                for (var k in amap) {
/*Line 47 - 'AtomFormLayout.js' */                    var v = amap[k];
/*Line 48 - 'AtomFormLayout.js' */                    if (!v)
/*Line 49 - 'AtomFormLayout.js' */                        continue;
/*Line 50 - 'AtomFormLayout.js' */                    child.removeAttributeNode(v.node);
/*Line 51 - 'AtomFormLayout.js' */                    field.setAttributeNode(v.node);
/*Line 52 - 'AtomFormLayout.js' */                }

/*Line 54 - 'AtomFormLayout.js' */                amap = AtomUI.attributeMap(field, /^atom\-(field\-value|is\-valid)$/i);

/*Line 56 - 'AtomFormLayout.js' */                if (!(amap["atom-field-value"] || amap["atom-is-valid"])) {
/*Line 57 - 'AtomFormLayout.js' */                    var v = $(child).attr("atom-value");
/*Line 58 - 'AtomFormLayout.js' */                    if (v && /^\$\[/gi.test(v)) {
/*Line 59 - 'AtomFormLayout.js' */                        // must be a two way binding..
/*Line 60 - 'AtomFormLayout.js' */                        v = v.substr(2);
/*Line 61 - 'AtomFormLayout.js' */                        if (!/^\$/gi.test(v)) {
/*Line 62 - 'AtomFormLayout.js' */                            v = "$" + v;
/*Line 63 - 'AtomFormLayout.js' */                        }
/*Line 64 - 'AtomFormLayout.js' */                        v = "[" + v;
/*Line 65 - 'AtomFormLayout.js' */                        var ind = v.indexOf(']');
/*Line 66 - 'AtomFormLayout.js' */                        v = v.substr(0, ind + 1);
/*Line 67 - 'AtomFormLayout.js' */                        $(field).attr("atom-field-value", v);
/*Line 68 - 'AtomFormLayout.js' */                    }
/*Line 69 - 'AtomFormLayout.js' */                }

/*Line 71 - 'AtomFormLayout.js' */                return AtomUI.createControl(field, WebAtoms.AtomFieldType);
/*Line 72 - 'AtomFormLayout.js' */            },

/*Line 74 - 'AtomFormLayout.js' */            createChildren: function () {
/*Line 75 - 'AtomFormLayout.js' */                var element = this._element;
/*Line 76 - 'AtomFormLayout.js' */                $(element).addClass("atom-form");
/*Line 77 - 'AtomFormLayout.js' */                var ae = new AtomEnumerator($(element).children());

/*Line 79 - 'AtomFormLayout.js' */                // add table...
/*Line 80 - 'AtomFormLayout.js' */                var table = document.createElement("TABLE");

/*Line 82 - 'AtomFormLayout.js' */                $(table).addClass("atom-form-table");

/*Line 84 - 'AtomFormLayout.js' */                var tbody = document.createElement("TBODY");

/*Line 86 - 'AtomFormLayout.js' */                AtomUI.removeAllChildren(element);
/*Line 87 - 'AtomFormLayout.js' */                //element.innerHTML = "";

/*Line 89 - 'AtomFormLayout.js' */                element.appendChild(table);
/*Line 90 - 'AtomFormLayout.js' */                table.appendChild(tbody);

/*Line 92 - 'AtomFormLayout.js' */                var child;
/*Line 93 - 'AtomFormLayout.js' */                this.getTemplate("fieldTemplate");

/*Line 95 - 'AtomFormLayout.js' */                while (ae.next()) {
/*Line 96 - 'AtomFormLayout.js' */                    child = ae.current();
/*Line 97 - 'AtomFormLayout.js' */                    if (!child)
/*Line 98 - 'AtomFormLayout.js' */                        continue;

/*Line 100 - 'AtomFormLayout.js' */                    this.createField(tbody, child);

/*Line 102 - 'AtomFormLayout.js' */                }

/*Line 104 - 'AtomFormLayout.js' */            }
/*Line 105 - 'AtomFormLayout.js' */        }
/*Line 106 - 'AtomFormLayout.js' */    });
/*Line 107 - 'AtomFormLayout.js' */})(WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomLayout.js' */

/*Line 2 - 'AtomLayout.js' */(function () {
/*Line 3 - 'AtomLayout.js' */    return classCreatorEx({
/*Line 4 - 'AtomLayout.js' */        name: "WebAtoms.AtomLayout",
/*Line 5 - 'AtomLayout.js' */        start: function () {
/*Line 6 - 'AtomLayout.js' */        },
/*Line 7 - 'AtomLayout.js' */        methods: {
/*Line 8 - 'AtomLayout.js' */            doLayout: function () {
/*Line 9 - 'AtomLayout.js' */            }
/*Line 10 - 'AtomLayout.js' */        }
/*Line 11 - 'AtomLayout.js' */    });
/*Line 12 - 'AtomLayout.js' */})();
/*Line 0 - 'AtomPlayer.js' */


/*Line 3 - 'AtomPlayer.js' */window.__updateFPObject = function __updateFPObject(id) {
/*Line 4 - 'AtomPlayer.js' */    if (allControls.hasOwnProperty(id)) {
/*Line 5 - 'AtomPlayer.js' */        var ctrl = allControls[id];
/*Line 6 - 'AtomPlayer.js' */        if (ctrl.playerUpdated) {
/*Line 7 - 'AtomPlayer.js' */            ctrl.playerUpdated();
/*Line 8 - 'AtomPlayer.js' */        }
/*Line 9 - 'AtomPlayer.js' */    }
/*Line 10 - 'AtomPlayer.js' */};

/*Line 12 - 'AtomPlayer.js' */(function (baseType) {
/*Line 13 - 'AtomPlayer.js' */    return classCreatorEx({
/*Line 14 - 'AtomPlayer.js' */        name: "WebAtoms.AtomPlayer",
/*Line 15 - 'AtomPlayer.js' */        base: baseType,
/*Line 16 - 'AtomPlayer.js' */        properties: {
/*Line 17 - 'AtomPlayer.js' */            url: null
/*Line 18 - 'AtomPlayer.js' */        },
/*Line 19 - 'AtomPlayer.js' */        start: function () { },
/*Line 20 - 'AtomPlayer.js' */        methods: {
/*Line 21 - 'AtomPlayer.js' */            playerUpdated: function () {
/*Line 22 - 'AtomPlayer.js' */            },

/*Line 24 - 'AtomPlayer.js' */            set_url: function (url) {
/*Line 25 - 'AtomPlayer.js' */                this._url = url;
/*Line 26 - 'AtomPlayer.js' */                if (url !== undefined)
/*Line 27 - 'AtomPlayer.js' */                    this.play(url);
/*Line 28 - 'AtomPlayer.js' */            },

/*Line 30 - 'AtomPlayer.js' */            play: function (url) {
/*Line 31 - 'AtomPlayer.js' */            },
/*Line 32 - 'AtomPlayer.js' */            stop: function () {
/*Line 33 - 'AtomPlayer.js' */            }
/*Line 34 - 'AtomPlayer.js' */        }
/*Line 35 - 'AtomPlayer.js' */    });
/*Line 36 - 'AtomPlayer.js' */})(WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomAutoCompleteBox.js' */
/*Line 1 - 'AtomAutoCompleteBox.js' */

/*Line 3 - 'AtomAutoCompleteBox.js' */(function (window, base) {
/*Line 4 - 'AtomAutoCompleteBox.js' */    return classCreatorEx(
/*Line 5 - 'AtomAutoCompleteBox.js' */    {
/*Line 6 - 'AtomAutoCompleteBox.js' */        name: "WebAtoms.AtomAutoCompleteBox",
/*Line 7 - 'AtomAutoCompleteBox.js' */        base: base,
/*Line 8 - 'AtomAutoCompleteBox.js' */        start:
/*Line 9 - 'AtomAutoCompleteBox.js' */            function () {
/*Line 10 - 'AtomAutoCompleteBox.js' */                this._presenters = ["itemsPresenter", "inputBox"];
/*Line 11 - 'AtomAutoCompleteBox.js' */                this._mouseCapture = 0;
/*Line 12 - 'AtomAutoCompleteBox.js' */            },
/*Line 13 - 'AtomAutoCompleteBox.js' */        properties: {
/*Line 14 - 'AtomAutoCompleteBox.js' */            isPopupOpen: false,
/*Line 15 - 'AtomAutoCompleteBox.js' */            autoOpen: false,
/*Line 16 - 'AtomAutoCompleteBox.js' */            placeholder: undefined,
/*Line 17 - 'AtomAutoCompleteBox.js' */            keyPressed: undefined,
/*Line 18 - 'AtomAutoCompleteBox.js' */            displayLabel: undefined
/*Line 19 - 'AtomAutoCompleteBox.js' */        },
/*Line 20 - 'AtomAutoCompleteBox.js' */        methods: {
/*Line 21 - 'AtomAutoCompleteBox.js' */            get_offsetLeft: function () {
/*Line 22 - 'AtomAutoCompleteBox.js' */                //return $(this._element).offset().left - parseInt( $(atomApplication._element).css("left") , 10);
/*Line 23 - 'AtomAutoCompleteBox.js' */                return $(this._element).offset().left;
/*Line 24 - 'AtomAutoCompleteBox.js' */            },
/*Line 25 - 'AtomAutoCompleteBox.js' */            get_offsetTop: function () {
/*Line 26 - 'AtomAutoCompleteBox.js' */                return $(this._element).offset().top;
/*Line 27 - 'AtomAutoCompleteBox.js' */            },

/*Line 29 - 'AtomAutoCompleteBox.js' */            get_offsetWidth: function () {
/*Line 30 - 'AtomAutoCompleteBox.js' */                return $(this._inputBox).offset().width;
/*Line 31 - 'AtomAutoCompleteBox.js' */            },

/*Line 33 - 'AtomAutoCompleteBox.js' */            set_itemsUrl: function (v) {
/*Line 34 - 'AtomAutoCompleteBox.js' */                var url = "[ !$owner.keyPressed ? undefined : AtomPromise.json('" + v + "').showProgress(false) ]";
/*Line 35 - 'AtomAutoCompleteBox.js' */                this.setValue("items", url, true, this._element);
/*Line 36 - 'AtomAutoCompleteBox.js' */            },

/*Line 38 - 'AtomAutoCompleteBox.js' */            set_isPopupOpen: function (v) {
/*Line 39 - 'AtomAutoCompleteBox.js' */                this._isPopupOpen = v;
/*Line 40 - 'AtomAutoCompleteBox.js' */                if (v) {
/*Line 41 - 'AtomAutoCompleteBox.js' */                    AtomBinder.refreshValue(this, "offsetTop");
/*Line 42 - 'AtomAutoCompleteBox.js' */                    AtomBinder.refreshValue(this, "offsetLeft");
/*Line 43 - 'AtomAutoCompleteBox.js' */                    AtomBinder.refreshValue(this, "offsetWidth");
/*Line 44 - 'AtomAutoCompleteBox.js' */                    //this.bindEvent(window, "click", "onWindowClick");
/*Line 45 - 'AtomAutoCompleteBox.js' */                    var _this = this;
/*Line 46 - 'AtomAutoCompleteBox.js' */                    this.bindEvent(window, "click", function () {
/*Line 47 - 'AtomAutoCompleteBox.js' */                        _this.onWindowClick.apply(_this, arguments);
/*Line 48 - 'AtomAutoCompleteBox.js' */                    });
/*Line 49 - 'AtomAutoCompleteBox.js' */                } else {
/*Line 50 - 'AtomAutoCompleteBox.js' */                    //this.unbindEvent(window, "click", "onWindowClick");
/*Line 51 - 'AtomAutoCompleteBox.js' */                    this.unbindEvent(window, "click");
/*Line 52 - 'AtomAutoCompleteBox.js' */                }
/*Line 53 - 'AtomAutoCompleteBox.js' */            },

/*Line 55 - 'AtomAutoCompleteBox.js' */            onClick: function (e) {
/*Line 56 - 'AtomAutoCompleteBox.js' */                base.onClick.apply(this, arguments);
/*Line 57 - 'AtomAutoCompleteBox.js' */                this._backupValue = this.get_value();
/*Line 58 - 'AtomAutoCompleteBox.js' */                this.refreshLabel();
/*Line 59 - 'AtomAutoCompleteBox.js' */                this._backupLabel = this.get_displayLabel();
/*Line 60 - 'AtomAutoCompleteBox.js' */                AtomBinder.setValue(this, "keyPressed", false);
/*Line 61 - 'AtomAutoCompleteBox.js' */                AtomBinder.setValue(this, "isPopupOpen", false);
/*Line 62 - 'AtomAutoCompleteBox.js' */            },

/*Line 64 - 'AtomAutoCompleteBox.js' */            restoreSelection: function () {
/*Line 65 - 'AtomAutoCompleteBox.js' */                AtomBinder.setValue(this, "isPopupOpen", false);
/*Line 66 - 'AtomAutoCompleteBox.js' */                if (this._backupValue) {
/*Line 67 - 'AtomAutoCompleteBox.js' */                    AtomBinder.setValue(this, "value", this._backupValue);
/*Line 68 - 'AtomAutoCompleteBox.js' */                    AtomBinder.setValue(this, "displayLabel", this._backupLabel);
/*Line 69 - 'AtomAutoCompleteBox.js' */                    this._backupValue = null;
/*Line 70 - 'AtomAutoCompleteBox.js' */                } else {
/*Line 71 - 'AtomAutoCompleteBox.js' */                    AtomBinder.setValue(this, "selectedIndex", -1);
/*Line 72 - 'AtomAutoCompleteBox.js' */                }
/*Line 73 - 'AtomAutoCompleteBox.js' */            },

/*Line 75 - 'AtomAutoCompleteBox.js' */            onKeyUp: function (e) {

/*Line 77 - 'AtomAutoCompleteBox.js' */                AtomBinder.setValue(this, "isPopupOpen", true);

/*Line 79 - 'AtomAutoCompleteBox.js' */                switch (e.keyCode) {
/*Line 80 - 'AtomAutoCompleteBox.js' */                    case 27:
/*Line 81 - 'AtomAutoCompleteBox.js' */                        AtomBinder.setValue(this, "keyPressed", false);
/*Line 82 - 'AtomAutoCompleteBox.js' */                        this.restoreSelection();
/*Line 83 - 'AtomAutoCompleteBox.js' */                        return;
/*Line 84 - 'AtomAutoCompleteBox.js' */                    case 13:
/*Line 85 - 'AtomAutoCompleteBox.js' */                        AtomBinder.setValue(this, "keyPressed", false);
/*Line 86 - 'AtomAutoCompleteBox.js' */                        AtomBinder.setValue(this, "isPopupOpen", false);
/*Line 87 - 'AtomAutoCompleteBox.js' */                        this._backupValue = this.get_value();
/*Line 88 - 'AtomAutoCompleteBox.js' */                        this.refreshLabel();
/*Line 89 - 'AtomAutoCompleteBox.js' */                        this._backupLabel = this.get_displayLabel();
/*Line 90 - 'AtomAutoCompleteBox.js' */                        AtomUI.cancelEvent(e);
/*Line 91 - 'AtomAutoCompleteBox.js' */                        return;
/*Line 92 - 'AtomAutoCompleteBox.js' */                    case 37:
/*Line 93 - 'AtomAutoCompleteBox.js' */                        // Left
/*Line 94 - 'AtomAutoCompleteBox.js' */                        break;
/*Line 95 - 'AtomAutoCompleteBox.js' */                    case 38:
/*Line 96 - 'AtomAutoCompleteBox.js' */                        // up
/*Line 97 - 'AtomAutoCompleteBox.js' */                        AtomBinder.setValue(this, "keyPressed", false);
/*Line 98 - 'AtomAutoCompleteBox.js' */                        this.moveSelection(true);
/*Line 99 - 'AtomAutoCompleteBox.js' */                        return;
/*Line 100 - 'AtomAutoCompleteBox.js' */                    case 39:
/*Line 101 - 'AtomAutoCompleteBox.js' */                        // right
/*Line 102 - 'AtomAutoCompleteBox.js' */                        break;
/*Line 103 - 'AtomAutoCompleteBox.js' */                    case 40:
/*Line 104 - 'AtomAutoCompleteBox.js' */                        AtomBinder.setValue(this, "keyPressed", false);
/*Line 105 - 'AtomAutoCompleteBox.js' */                        this.moveSelection(false);
/*Line 106 - 'AtomAutoCompleteBox.js' */                        return;
/*Line 107 - 'AtomAutoCompleteBox.js' */                    default:
/*Line 108 - 'AtomAutoCompleteBox.js' */                        // try selecting complete word...
/*Line 109 - 'AtomAutoCompleteBox.js' */                        var caller = this;
/*Line 110 - 'AtomAutoCompleteBox.js' */                        this.dispatcher.callLater(function () {
/*Line 111 - 'AtomAutoCompleteBox.js' */                            caller.trySelect();
/*Line 112 - 'AtomAutoCompleteBox.js' */                        });
/*Line 113 - 'AtomAutoCompleteBox.js' */                        break;
/*Line 114 - 'AtomAutoCompleteBox.js' */                }

/*Line 116 - 'AtomAutoCompleteBox.js' */                if (this.oldTimeout) {
/*Line 117 - 'AtomAutoCompleteBox.js' */                    clearTimeout(this.oldTimeout);
/*Line 118 - 'AtomAutoCompleteBox.js' */                }
/*Line 119 - 'AtomAutoCompleteBox.js' */                var _this = this;
/*Line 120 - 'AtomAutoCompleteBox.js' */                this.oldTimeout = setTimeout(function () {
/*Line 121 - 'AtomAutoCompleteBox.js' */                    AtomBinder.setValue(_this, "keyPressed", true);
/*Line 122 - 'AtomAutoCompleteBox.js' */                }, 500);

/*Line 124 - 'AtomAutoCompleteBox.js' */            },

/*Line 126 - 'AtomAutoCompleteBox.js' */            trySelect: function () {

/*Line 128 - 'AtomAutoCompleteBox.js' */                if (!this._items || this._items.length == 0)
/*Line 129 - 'AtomAutoCompleteBox.js' */                    return;

/*Line 131 - 'AtomAutoCompleteBox.js' */                if (this.get_selectedIndex() != -1)
/*Line 132 - 'AtomAutoCompleteBox.js' */                    return;

/*Line 134 - 'AtomAutoCompleteBox.js' */                var ae = new AtomEnumerator(this._items);
/*Line 135 - 'AtomAutoCompleteBox.js' */                var lp = this._labelPath;

/*Line 137 - 'AtomAutoCompleteBox.js' */                var cl = this._displayLabel;

/*Line 139 - 'AtomAutoCompleteBox.js' */                if (cl)
/*Line 140 - 'AtomAutoCompleteBox.js' */                    cl = cl.toLowerCase();

/*Line 142 - 'AtomAutoCompleteBox.js' */                while (ae.next()) {
/*Line 143 - 'AtomAutoCompleteBox.js' */                    var item = ae.current();
/*Line 144 - 'AtomAutoCompleteBox.js' */                    var l = item;
/*Line 145 - 'AtomAutoCompleteBox.js' */                    if (lp)
/*Line 146 - 'AtomAutoCompleteBox.js' */                        l = l[lp];
/*Line 147 - 'AtomAutoCompleteBox.js' */                    if (l)
/*Line 148 - 'AtomAutoCompleteBox.js' */                        l = l.toLowerCase();
/*Line 149 - 'AtomAutoCompleteBox.js' */                    if (cl == l) {
/*Line 150 - 'AtomAutoCompleteBox.js' */                        AtomBinder.setValue(this, "selectedItem", item);
/*Line 151 - 'AtomAutoCompleteBox.js' */                        this.refreshLabel();
/*Line 152 - 'AtomAutoCompleteBox.js' */                        return;
/*Line 153 - 'AtomAutoCompleteBox.js' */                    }
/*Line 154 - 'AtomAutoCompleteBox.js' */                }
/*Line 155 - 'AtomAutoCompleteBox.js' */            },

/*Line 157 - 'AtomAutoCompleteBox.js' */            moveSelection: function (up) {
/*Line 158 - 'AtomAutoCompleteBox.js' */                if (!this._items || !this._items.length)
/*Line 159 - 'AtomAutoCompleteBox.js' */                    return;
/*Line 160 - 'AtomAutoCompleteBox.js' */                var i = this.get_selectedIndex();

/*Line 162 - 'AtomAutoCompleteBox.js' */                if (i == -1) {
/*Line 163 - 'AtomAutoCompleteBox.js' */                    this.backupLabel = this.get_displayLabel();
/*Line 164 - 'AtomAutoCompleteBox.js' */                }

/*Line 166 - 'AtomAutoCompleteBox.js' */                i = up ? (i - 1) : (i + 1);
/*Line 167 - 'AtomAutoCompleteBox.js' */                if (up && i == -2) {
/*Line 168 - 'AtomAutoCompleteBox.js' */                    i = this._items.length - 1;
/*Line 169 - 'AtomAutoCompleteBox.js' */                }
/*Line 170 - 'AtomAutoCompleteBox.js' */                if (!up && i == this._items.length) {
/*Line 171 - 'AtomAutoCompleteBox.js' */                    i = -1;
/*Line 172 - 'AtomAutoCompleteBox.js' */                }

/*Line 174 - 'AtomAutoCompleteBox.js' */                AtomBinder.setValue(this, "selectedIndex", i);
/*Line 175 - 'AtomAutoCompleteBox.js' */                if (i == -1) {
/*Line 176 - 'AtomAutoCompleteBox.js' */                    AtomBinder.setValue(this, "displayLabel", this.backupLabel || "");
/*Line 177 - 'AtomAutoCompleteBox.js' */                } else {
/*Line 178 - 'AtomAutoCompleteBox.js' */                    this.refreshLabel();
/*Line 179 - 'AtomAutoCompleteBox.js' */                }
/*Line 180 - 'AtomAutoCompleteBox.js' */            },

/*Line 182 - 'AtomAutoCompleteBox.js' */            refreshLabel: function () {
/*Line 183 - 'AtomAutoCompleteBox.js' */                var item = this.get_selectedItem();
/*Line 184 - 'AtomAutoCompleteBox.js' */                var l = item;
/*Line 185 - 'AtomAutoCompleteBox.js' */                if (l && this._labelPath) {
/*Line 186 - 'AtomAutoCompleteBox.js' */                    l = l[this._labelPath];
/*Line 187 - 'AtomAutoCompleteBox.js' */                }
/*Line 188 - 'AtomAutoCompleteBox.js' */                AtomBinder.setValue(this, "displayLabel", l || "");
/*Line 189 - 'AtomAutoCompleteBox.js' */            },

/*Line 191 - 'AtomAutoCompleteBox.js' */            onWindowClick: function (e) {
/*Line 192 - 'AtomAutoCompleteBox.js' */                var se = this._element;
/*Line 193 - 'AtomAutoCompleteBox.js' */                var p = this._itemsPresenter;
/*Line 194 - 'AtomAutoCompleteBox.js' */                var childElement = e.target;
/*Line 195 - 'AtomAutoCompleteBox.js' */                while (childElement.parentNode != null && childElement != se && childElement != p)
/*Line 196 - 'AtomAutoCompleteBox.js' */                    childElement = childElement.parentNode;
/*Line 197 - 'AtomAutoCompleteBox.js' */                if (childElement == se || childElement == p)
/*Line 198 - 'AtomAutoCompleteBox.js' */                    return;
/*Line 199 - 'AtomAutoCompleteBox.js' */                // close popup....
/*Line 200 - 'AtomAutoCompleteBox.js' */                this.restoreSelection();

/*Line 202 - 'AtomAutoCompleteBox.js' */            },

/*Line 204 - 'AtomAutoCompleteBox.js' */            onInputFocus: function () {
/*Line 205 - 'AtomAutoCompleteBox.js' */                if (!this._autoOpen)
/*Line 206 - 'AtomAutoCompleteBox.js' */                    return;
/*Line 207 - 'AtomAutoCompleteBox.js' */                this._backupValue = this.get_value();
/*Line 208 - 'AtomAutoCompleteBox.js' */                this._backupLabel = this.get_displayLabel();
/*Line 209 - 'AtomAutoCompleteBox.js' */                $(this._inputBox).select();
/*Line 210 - 'AtomAutoCompleteBox.js' */                AtomBinder.setValue(this, "isPopupOpen", true);
/*Line 211 - 'AtomAutoCompleteBox.js' */            },

/*Line 213 - 'AtomAutoCompleteBox.js' */            onInputBlur: function () {
/*Line 214 - 'AtomAutoCompleteBox.js' */                if (this._mouseCapture)
/*Line 215 - 'AtomAutoCompleteBox.js' */                    return;
/*Line 216 - 'AtomAutoCompleteBox.js' */                var caller = this;

/*Line 218 - 'AtomAutoCompleteBox.js' */                setTimeout(function () {
/*Line 219 - 'AtomAutoCompleteBox.js' */                    if (caller._isPopupOpen) {
/*Line 220 - 'AtomAutoCompleteBox.js' */                        AtomBinder.setValue(caller, "isPopupOpen", false);
/*Line 221 - 'AtomAutoCompleteBox.js' */                        caller.restoreSelection();
/*Line 222 - 'AtomAutoCompleteBox.js' */                    }
/*Line 223 - 'AtomAutoCompleteBox.js' */                }, 10);
/*Line 224 - 'AtomAutoCompleteBox.js' */            },

/*Line 226 - 'AtomAutoCompleteBox.js' */            onCreationComplete: function () {

/*Line 228 - 'AtomAutoCompleteBox.js' */                this._itemsPresenter._logicalParent = this._element;

/*Line 230 - 'AtomAutoCompleteBox.js' */                $(this._itemsPresenter).remove();

/*Line 232 - 'AtomAutoCompleteBox.js' */                document.body.appendChild(this._itemsPresenter);

/*Line 234 - 'AtomAutoCompleteBox.js' */                $(this._itemsPresenter).addClass("atom-auto-complete-popup");

/*Line 236 - 'AtomAutoCompleteBox.js' */                base.onCreationComplete.apply(this, arguments);
/*Line 237 - 'AtomAutoCompleteBox.js' */                this.bindEvent(this._itemsPresenter, "mouseover", "onMouseOver");
/*Line 238 - 'AtomAutoCompleteBox.js' */                this.bindEvent(this._itemsPresenter, "mouseout", "onMouseOut");
/*Line 239 - 'AtomAutoCompleteBox.js' */            },

/*Line 241 - 'AtomAutoCompleteBox.js' */            onMouseOver: function () {
/*Line 242 - 'AtomAutoCompleteBox.js' */                this._mouseCapture++;

/*Line 244 - 'AtomAutoCompleteBox.js' */            },

/*Line 246 - 'AtomAutoCompleteBox.js' */            onMouseOut: function () {
/*Line 247 - 'AtomAutoCompleteBox.js' */                var _this = this;
/*Line 248 - 'AtomAutoCompleteBox.js' */                setTimeout(function () {
/*Line 249 - 'AtomAutoCompleteBox.js' */                    _this._mouseCapture--;

/*Line 251 - 'AtomAutoCompleteBox.js' */                }, 1000);
/*Line 252 - 'AtomAutoCompleteBox.js' */            },

/*Line 254 - 'AtomAutoCompleteBox.js' */            initialize: function () {

/*Line 256 - 'AtomAutoCompleteBox.js' */                base.initialize.apply(this, arguments);
/*Line 257 - 'AtomAutoCompleteBox.js' */                this.bindEvent(this._inputBox, "focus", "onInputFocus");
/*Line 258 - 'AtomAutoCompleteBox.js' */                this.bindEvent(this._inputBox, "blur", "onInputBlur");
/*Line 259 - 'AtomAutoCompleteBox.js' */                this.bindEvent(this._inputBox, "keyup", "onKeyUp");
/*Line 260 - 'AtomAutoCompleteBox.js' */            }
/*Line 261 - 'AtomAutoCompleteBox.js' */        }
/*Line 262 - 'AtomAutoCompleteBox.js' */    });
/*Line 263 - 'AtomAutoCompleteBox.js' */})(window, WebAtoms.AtomListBox.prototype);

/*Line 0 - 'AtomCheckBox.js' *////// <reference path="AtomControl.js" />

/*Line 2 - 'AtomCheckBox.js' *///WebAtoms.AtomCheckBox = function (element) {
/*Line 3 - 'AtomCheckBox.js' *///    WebAtoms.AtomCheckBox.initializeBase(this, [element]);
/*Line 4 - 'AtomCheckBox.js' *///    log("AtomCheckBox is depricated, use atom-checked instead on checkbox item");
/*Line 5 - 'AtomCheckBox.js' *///};

/*Line 7 - 'AtomCheckBox.js' *///WebAtoms.AtomCheckBox.prototype = {

/*Line 9 - 'AtomCheckBox.js' *///    get_value: function () {
/*Line 10 - 'AtomCheckBox.js' *///        return this.get_isChecked();
/*Line 11 - 'AtomCheckBox.js' *///    },
/*Line 12 - 'AtomCheckBox.js' *///    set_value: function (v) {
/*Line 13 - 'AtomCheckBox.js' *///        this.set_isChecked(v);
/*Line 14 - 'AtomCheckBox.js' *///    },

/*Line 16 - 'AtomCheckBox.js' *///    get_isChecked: function () {
/*Line 17 - 'AtomCheckBox.js' *///        var element = this._element;
/*Line 18 - 'AtomCheckBox.js' *///        var attr = element.checked || $(element).attr("checked");
       
/*Line 20 - 'AtomCheckBox.js' *///        if (attr)
/*Line 21 - 'AtomCheckBox.js' *///            return true;
/*Line 22 - 'AtomCheckBox.js' *///        return false;
/*Line 23 - 'AtomCheckBox.js' *///    },
/*Line 24 - 'AtomCheckBox.js' *///    set_isChecked: function (v) {
/*Line 25 - 'AtomCheckBox.js' *///        var element = this._element;
/*Line 26 - 'AtomCheckBox.js' *///        if (v && v !== "false") {
/*Line 27 - 'AtomCheckBox.js' *///            $(element).attr("checked", "checked");
/*Line 28 - 'AtomCheckBox.js' *///        } else {
/*Line 29 - 'AtomCheckBox.js' *///            $(element).removeAttr("checked");
/*Line 30 - 'AtomCheckBox.js' *///        }
/*Line 31 - 'AtomCheckBox.js' *///    },

/*Line 33 - 'AtomCheckBox.js' *///    onChange: function () {
/*Line 34 - 'AtomCheckBox.js' *///        AtomBinder.refreshValue(this, "isChecked");
/*Line 35 - 'AtomCheckBox.js' *///    },

/*Line 37 - 'AtomCheckBox.js' *///    initialize: function () {
/*Line 38 - 'AtomCheckBox.js' *///        var _this = this;
/*Line 39 - 'AtomCheckBox.js' *///        this.bindEvent(this._element, "change", function () {
/*Line 40 - 'AtomCheckBox.js' *///            _this.onChange.apply(_this, arguments);
/*Line 41 - 'AtomCheckBox.js' *///        });
/*Line 42 - 'AtomCheckBox.js' *///        WebAtoms.AtomCheckBox.baseType.initialize.apply(this, arguments);
/*Line 43 - 'AtomCheckBox.js' *///    }
/*Line 44 - 'AtomCheckBox.js' *///};

/*Line 46 - 'AtomCheckBox.js' *///WebAtoms.AtomCheckBox.registerClass("WebAtoms.AtomCheckBox", WebAtoms.AtomControl);
/*Line 0 - 'AtomDataPager.js' */

/*Line 2 - 'AtomDataPager.js' */(function (window, name, base) {

/*Line 4 - 'AtomDataPager.js' */    return classCreatorEx(
/*Line 5 - 'AtomDataPager.js' */        {
/*Line 6 - 'AtomDataPager.js' */            name: name,
/*Line 7 - 'AtomDataPager.js' */            base: base,
/*Line 8 - 'AtomDataPager.js' */            properties:{
/*Line 9 - 'AtomDataPager.js' */                itemsPath: "items",
/*Line 10 - 'AtomDataPager.js' */                totalPath: "total",
/*Line 11 - 'AtomDataPager.js' */                pageSize: 25,
/*Line 12 - 'AtomDataPager.js' */                currentPage: 0,
/*Line 13 - 'AtomDataPager.js' */                items: null,
/*Line 14 - 'AtomDataPager.js' */                total: 0,
/*Line 15 - 'AtomDataPager.js' */                pages: []
/*Line 16 - 'AtomDataPager.js' */            },

/*Line 18 - 'AtomDataPager.js' */            start: function () {
/*Line 19 - 'AtomDataPager.js' */                this._presenters = ["pageList"];

/*Line 21 - 'AtomDataPager.js' */                var caller = this;

/*Line 23 - 'AtomDataPager.js' */                var binder = AtomBinder;

/*Line 25 - 'AtomDataPager.js' */                this.goFirstCommand = function () {
/*Line 26 - 'AtomDataPager.js' */                    binder.setValue(caller, "currentPage", 0);
/*Line 27 - 'AtomDataPager.js' */                };

/*Line 29 - 'AtomDataPager.js' */                this.goLastCommand = function () {
/*Line 30 - 'AtomDataPager.js' */                    binder.setValue(caller, "currentPage", caller._pages.length - 1);
/*Line 31 - 'AtomDataPager.js' */                };

/*Line 33 - 'AtomDataPager.js' */                this.goNextCommand = function () {
/*Line 34 - 'AtomDataPager.js' */                    binder.setValue(caller, "currentPage", caller.get_currentPage() + 1);
/*Line 35 - 'AtomDataPager.js' */                };

/*Line 37 - 'AtomDataPager.js' */                this.goPrevCommand = function () {
/*Line 38 - 'AtomDataPager.js' */                    binder.setValue(caller, "currentPage", caller.get_currentPage() - 1);
/*Line 39 - 'AtomDataPager.js' */                };
/*Line 40 - 'AtomDataPager.js' */            },

/*Line 42 - 'AtomDataPager.js' */            methods:{
/*Line 43 - 'AtomDataPager.js' */                preparePages: function () {
/*Line 44 - 'AtomDataPager.js' */                    if (!this._items)
/*Line 45 - 'AtomDataPager.js' */                        return;
/*Line 46 - 'AtomDataPager.js' */                    if (!this._total)
/*Line 47 - 'AtomDataPager.js' */                        return;
/*Line 48 - 'AtomDataPager.js' */                    var l = this._items.length;
/*Line 49 - 'AtomDataPager.js' */                    var t = this._total;
/*Line 50 - 'AtomDataPager.js' */                    var count = Math.ceil(t / this._pageSize);

/*Line 52 - 'AtomDataPager.js' */                    if (count == this._pages.length)
/*Line 53 - 'AtomDataPager.js' */                        return;

/*Line 55 - 'AtomDataPager.js' */                    var ps = this._pageSize;
/*Line 56 - 'AtomDataPager.js' */                    var pages = [];
/*Line 57 - 'AtomDataPager.js' */                    var i;
/*Line 58 - 'AtomDataPager.js' */                    for (i = 0; i < count; i++) {
/*Line 59 - 'AtomDataPager.js' */                        pages.push({
/*Line 60 - 'AtomDataPager.js' */                            value: i,
/*Line 61 - 'AtomDataPager.js' */                            label: i + 1
/*Line 62 - 'AtomDataPager.js' */                        });
/*Line 63 - 'AtomDataPager.js' */                    }
/*Line 64 - 'AtomDataPager.js' */                    AtomBinder.setValue(this, "pages", pages);
/*Line 65 - 'AtomDataPager.js' */                },

/*Line 67 - 'AtomDataPager.js' */                set_items: function (v) {

/*Line 69 - 'AtomDataPager.js' */                    if (v != this._items) {
/*Line 70 - 'AtomDataPager.js' */                        if (this._items) {
/*Line 71 - 'AtomDataPager.js' */                            this.unbindEvent(this._items, "CollectionChanged", "onCollectionChangedInternal");
/*Line 72 - 'AtomDataPager.js' */                        }
/*Line 73 - 'AtomDataPager.js' */                    }

/*Line 75 - 'AtomDataPager.js' */                    if (!v)
/*Line 76 - 'AtomDataPager.js' */                        return;
/*Line 77 - 'AtomDataPager.js' */                    this._items = v;

/*Line 79 - 'AtomDataPager.js' */                    if (v != null && this._created) {
/*Line 80 - 'AtomDataPager.js' */                        this.bindEvent(this._items, "CollectionChanged", "onCollectionChangedInternal");
/*Line 81 - 'AtomDataPager.js' */                        this.onCollectionChangedInternal("refresh", -1, null);
/*Line 82 - 'AtomDataPager.js' */                    }

/*Line 84 - 'AtomDataPager.js' */                },

/*Line 86 - 'AtomDataPager.js' */                onCollectionChangedInternal: function () {
/*Line 87 - 'AtomDataPager.js' */                    var v = this._items;
/*Line 88 - 'AtomDataPager.js' */                    if (v.length === undefined) {
/*Line 89 - 'AtomDataPager.js' */                        var val = v[this._itemsPath];

/*Line 91 - 'AtomDataPager.js' */                        AtomBinder.setValue(this, "total", v[this._totalPath]);
/*Line 92 - 'AtomDataPager.js' */                        AtomBinder.setValue(this, "value", val);
/*Line 93 - 'AtomDataPager.js' */                    } else {
/*Line 94 - 'AtomDataPager.js' */                        if (v.total) {
/*Line 95 - 'AtomDataPager.js' */                            AtomBinder.setValue(this, "total", v.total);
/*Line 96 - 'AtomDataPager.js' */                        } else {
/*Line 97 - 'AtomDataPager.js' */                            AtomBinder.setValue(this, "pages", []);
/*Line 98 - 'AtomDataPager.js' */                        }
/*Line 99 - 'AtomDataPager.js' */                        AtomBinder.setValue(this, "value", v);
/*Line 100 - 'AtomDataPager.js' */                    }

/*Line 102 - 'AtomDataPager.js' */                    this.preparePages();
/*Line 103 - 'AtomDataPager.js' */                },

/*Line 105 - 'AtomDataPager.js' */                onCreationComplete: function () {
/*Line 106 - 'AtomDataPager.js' */                    if (this._items) {
/*Line 107 - 'AtomDataPager.js' */                        this.bindEvent(this._items, "CollectionChanged", "onCollectionChangedInternal");
/*Line 108 - 'AtomDataPager.js' */                        this.onCollectionChangedInternal("refresh", -1, null);
/*Line 109 - 'AtomDataPager.js' */                    }
/*Line 110 - 'AtomDataPager.js' */                },


/*Line 113 - 'AtomDataPager.js' */                set_currentPage: function (v) {
/*Line 114 - 'AtomDataPager.js' */                    this._currentPage = v;
/*Line 115 - 'AtomDataPager.js' */                    AtomBinder.refreshValue(this, "pageStart");
/*Line 116 - 'AtomDataPager.js' */                },

/*Line 118 - 'AtomDataPager.js' */                get_pageStart: function () {
/*Line 119 - 'AtomDataPager.js' */                    return this._currentPage * this._pageSize;
/*Line 120 - 'AtomDataPager.js' */                },

/*Line 122 - 'AtomDataPager.js' */                set_pageSize: function (v) {
/*Line 123 - 'AtomDataPager.js' */                    this._pageSize = v;
/*Line 124 - 'AtomDataPager.js' */                    this.preparePages();
/*Line 125 - 'AtomDataPager.js' */                },
/*Line 126 - 'AtomDataPager.js' */                set_total: function (v) {
/*Line 127 - 'AtomDataPager.js' */                    if (this._total == v)
/*Line 128 - 'AtomDataPager.js' */                        return;
/*Line 129 - 'AtomDataPager.js' */                    this._total = v;
/*Line 130 - 'AtomDataPager.js' */                },
/*Line 131 - 'AtomDataPager.js' */                initialize: function () {

/*Line 133 - 'AtomDataPager.js' */                    $(this._element).addClass("atom-data-pager");

/*Line 135 - 'AtomDataPager.js' */                    base.initialize.apply(this, arguments);
/*Line 136 - 'AtomDataPager.js' */                }
/*Line 137 - 'AtomDataPager.js' */            }

/*Line 139 - 'AtomDataPager.js' */    }
/*Line 140 - 'AtomDataPager.js' */);

/*Line 142 - 'AtomDataPager.js' */})(window, "WebAtoms.AtomDataPager", WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomDateControl.js' */

/*Line 2 - 'AtomDateControl.js' */// Date Month Year

/*Line 4 - 'AtomDateControl.js' */(function (window, base) {
/*Line 5 - 'AtomDateControl.js' */    return classCreatorEx({
/*Line 6 - 'AtomDateControl.js' */        name: "WebAtoms.AtomDateControl",
/*Line 7 - 'AtomDateControl.js' */        base: base,
/*Line 8 - 'AtomDateControl.js' */        start: function () {
/*Line 9 - 'AtomDateControl.js' */        },
/*Line 10 - 'AtomDateControl.js' */        properties: {
/*Line 11 - 'AtomDateControl.js' */            startYear: -1,
/*Line 12 - 'AtomDateControl.js' */            endYear: +10
/*Line 13 - 'AtomDateControl.js' */        },
/*Line 14 - 'AtomDateControl.js' */        methods: {
/*Line 15 - 'AtomDateControl.js' */            resetYears: function () {
/*Line 16 - 'AtomDateControl.js' */                var years = this._year;
/*Line 17 - 'AtomDateControl.js' */                var dt = new Date();
/*Line 18 - 'AtomDateControl.js' */                var start = dt.getFullYear();
/*Line 19 - 'AtomDateControl.js' */                start += this._startYear;
/*Line 20 - 'AtomDateControl.js' */                var end = dt.getFullYear() + this._endYear;
/*Line 21 - 'AtomDateControl.js' */                var val = this._value;
/*Line 22 - 'AtomDateControl.js' */                if (!val)
/*Line 23 - 'AtomDateControl.js' */                    val = dt;
/*Line 24 - 'AtomDateControl.js' */                years.options.length = 0;
/*Line 25 - 'AtomDateControl.js' */                var j = 1;
/*Line 26 - 'AtomDateControl.js' */                years.options[0] = new Option("Select", "", false, false);
/*Line 27 - 'AtomDateControl.js' */                for (var i = start; i <= end; i++) {
/*Line 28 - 'AtomDateControl.js' */                    years.options[j] = new Option(i, i, false, false);
/*Line 29 - 'AtomDateControl.js' */                    j++;
/*Line 30 - 'AtomDateControl.js' */                }
/*Line 31 - 'AtomDateControl.js' */            },
/*Line 32 - 'AtomDateControl.js' */            set_value: function (v) {
/*Line 33 - 'AtomDateControl.js' */                if (v && v.constructor == String) {
/*Line 34 - 'AtomDateControl.js' */                    // date format??
/*Line 35 - 'AtomDateControl.js' */                    v = new Date(parseInt(v.substr(6)));
/*Line 36 - 'AtomDateControl.js' */                }
/*Line 37 - 'AtomDateControl.js' */                this._value = v;
/*Line 38 - 'AtomDateControl.js' */                this.setDate();
/*Line 39 - 'AtomDateControl.js' */            },
/*Line 40 - 'AtomDateControl.js' */            setDate: function () {
/*Line 41 - 'AtomDateControl.js' */                if (!this._value)
/*Line 42 - 'AtomDateControl.js' */                    return;
/*Line 43 - 'AtomDateControl.js' */                var dt = this._value;
/*Line 44 - 'AtomDateControl.js' */                var m = dt.getMonth() + 1;
/*Line 45 - 'AtomDateControl.js' */                var d = dt.getDate();
/*Line 46 - 'AtomDateControl.js' */                var y = dt.getFullYear();

/*Line 48 - 'AtomDateControl.js' */                this.setComboValue(this._month, m);
/*Line 49 - 'AtomDateControl.js' */                this.setComboValue(this._year, y);
/*Line 50 - 'AtomDateControl.js' */                this.setComboValue(this._date, d);

/*Line 52 - 'AtomDateControl.js' */            },

/*Line 54 - 'AtomDateControl.js' */            setComboValue: function (cb, v) {
/*Line 55 - 'AtomDateControl.js' */                var ae = new AtomEnumerator(cb.options);
/*Line 56 - 'AtomDateControl.js' */                while (ae.next()) {
/*Line 57 - 'AtomDateControl.js' */                    if (ae.current().value == v) {
/*Line 58 - 'AtomDateControl.js' */                        cb.selectedIndex = ae.currentIndex();
/*Line 59 - 'AtomDateControl.js' */                        break;
/*Line 60 - 'AtomDateControl.js' */                    }
/*Line 61 - 'AtomDateControl.js' */                }
/*Line 62 - 'AtomDateControl.js' */            },

/*Line 64 - 'AtomDateControl.js' */            set_startYear: function (v) {
/*Line 65 - 'AtomDateControl.js' */                this._startYear = v;
/*Line 66 - 'AtomDateControl.js' */                this.resetYears();
/*Line 67 - 'AtomDateControl.js' */            },
/*Line 68 - 'AtomDateControl.js' */            set_endYear: function (v) {
/*Line 69 - 'AtomDateControl.js' */                this._endYear = v;
/*Line 70 - 'AtomDateControl.js' */                this.resetYears();
/*Line 71 - 'AtomDateControl.js' */            },
/*Line 72 - 'AtomDateControl.js' */            onDataChange: function () {
/*Line 73 - 'AtomDateControl.js' */                var year = $(this._year).val();
/*Line 74 - 'AtomDateControl.js' */                var month = $(this._month).val();
/*Line 75 - 'AtomDateControl.js' */                var date = $(this._date).val();
/*Line 76 - 'AtomDateControl.js' */                try {
/*Line 77 - 'AtomDateControl.js' */                    if (year && month && date) {
/*Line 78 - 'AtomDateControl.js' */                        var dt = new Date(year, month - 1, date, 9, 0, 0);
/*Line 79 - 'AtomDateControl.js' */                        this._value = dt;
/*Line 80 - 'AtomDateControl.js' */                    }
/*Line 81 - 'AtomDateControl.js' */                } catch (error) {
/*Line 82 - 'AtomDateControl.js' */                    alert(error);
/*Line 83 - 'AtomDateControl.js' */                }
/*Line 84 - 'AtomDateControl.js' */                AtomBinder.refreshValue(this, "value");
/*Line 85 - 'AtomDateControl.js' */            },

/*Line 87 - 'AtomDateControl.js' */            setMonths: function () {

/*Line 89 - 'AtomDateControl.js' */                var r = AtomDate.monthList;

/*Line 91 - 'AtomDateControl.js' */                var options = this._month.options;
/*Line 92 - 'AtomDateControl.js' */                options.length = 0;
/*Line 93 - 'AtomDateControl.js' */                var ae = new AtomEnumerator(r);
/*Line 94 - 'AtomDateControl.js' */                options[0] = new Option("Select", "", false, false);
/*Line 95 - 'AtomDateControl.js' */                while (ae.next()) {
/*Line 96 - 'AtomDateControl.js' */                    var item = ae.current();
/*Line 97 - 'AtomDateControl.js' */                    options[ae.currentIndex() + 1] = new Option(item.label, item.value, false, false);
/*Line 98 - 'AtomDateControl.js' */                }
/*Line 99 - 'AtomDateControl.js' */                this.setDate();
/*Line 100 - 'AtomDateControl.js' */                AtomBinder.refreshValue(this, "value");
/*Line 101 - 'AtomDateControl.js' */            },
/*Line 102 - 'AtomDateControl.js' */            initialize: function () {

/*Line 104 - 'AtomDateControl.js' */                var element = this._element;

/*Line 106 - 'AtomDateControl.js' */                this._date = document.createElement("SELECT");
/*Line 107 - 'AtomDateControl.js' */                this._month = document.createElement("SELECT");
/*Line 108 - 'AtomDateControl.js' */                this._year = document.createElement("SELECT");

/*Line 110 - 'AtomDateControl.js' */                element.style.height = "25px";

/*Line 112 - 'AtomDateControl.js' */                element.appendChild(this._date);
/*Line 113 - 'AtomDateControl.js' */                element.appendChild(this._month);
/*Line 114 - 'AtomDateControl.js' */                element.appendChild(this._year);

/*Line 116 - 'AtomDateControl.js' */                // add days...
/*Line 117 - 'AtomDateControl.js' */                var options = this._date.options;
/*Line 118 - 'AtomDateControl.js' */                var i;
/*Line 119 - 'AtomDateControl.js' */                options[0] = new Option("Select", "", false, false);
/*Line 120 - 'AtomDateControl.js' */                for (i = 1; i < 32; i++) {
/*Line 121 - 'AtomDateControl.js' */                    options[i] = new Option(i, i, false, false);
/*Line 122 - 'AtomDateControl.js' */                }



/*Line 126 - 'AtomDateControl.js' */                this.resetYears();

/*Line 128 - 'AtomDateControl.js' */                this.bindEvent(this._date, "change", "onDataChange");
/*Line 129 - 'AtomDateControl.js' */                this.bindEvent(this._month, "change", "onDataChange");
/*Line 130 - 'AtomDateControl.js' */                this.bindEvent(this._year, "change", "onDataChange");

/*Line 132 - 'AtomDateControl.js' */                this.setMonths();


/*Line 135 - 'AtomDateControl.js' */                base.initialize.apply(this, arguments);


/*Line 138 - 'AtomDateControl.js' */            }
/*Line 139 - 'AtomDateControl.js' */        }
/*Line 140 - 'AtomDateControl.js' */    });
/*Line 141 - 'AtomDateControl.js' */})(window, WebAtoms.AtomControl.prototype);

/*Line 0 - 'AtomDateField.js' */
/*Line 1 - 'AtomDateField.js' */

/*Line 3 - 'AtomDateField.js' */(function (window, base) {
/*Line 4 - 'AtomDateField.js' */    return classCreatorEx({
/*Line 5 - 'AtomDateField.js' */        name: "WebAtoms.AtomDateField",
/*Line 6 - 'AtomDateField.js' */        base: base,
/*Line 7 - 'AtomDateField.js' */        start: function (e) {
/*Line 8 - 'AtomDateField.js' */            this._presenters = ["calendarPresenter", "itemsPresenter"];
/*Line 9 - 'AtomDateField.js' */            $(e).addClass("atom-date-field");
/*Line 10 - 'AtomDateField.js' */        },
/*Line 11 - 'AtomDateField.js' */        properties: {
/*Line 12 - 'AtomDateField.js' */            isOpen: false
/*Line 13 - 'AtomDateField.js' */        },
/*Line 14 - 'AtomDateField.js' */        methods: {
/*Line 15 - 'AtomDateField.js' */            onPopupRemoved: function (e) {
/*Line 16 - 'AtomDateField.js' */                AtomBinder.setValue(this, "isOpen", false);
/*Line 17 - 'AtomDateField.js' */            },

/*Line 19 - 'AtomDateField.js' */            set_isOpen: function (v) {
/*Line 20 - 'AtomDateField.js' */                this._isOpen = v;
/*Line 21 - 'AtomDateField.js' */                if (v) {
/*Line 22 - 'AtomDateField.js' */                    this.getTemplate("popupTemplate");

/*Line 24 - 'AtomDateField.js' */                    this.popup = AtomUI.cloneNode(this._popupTemplate);
/*Line 25 - 'AtomDateField.js' */                    //this.popup._logicalParent = this._element;
/*Line 26 - 'AtomDateField.js' */                    this.popup._templateParent = this;
/*Line 27 - 'AtomDateField.js' */                    //this.popup.style.visibility = "hidden";
/*Line 28 - 'AtomDateField.js' */                    //document.body.appendChild(this.popup);
/*Line 29 - 'AtomDateField.js' */                    this._element.appendChild(this.popup);
/*Line 30 - 'AtomDateField.js' */                    this.onCreateChildren(this.popup);
/*Line 31 - 'AtomDateField.js' */                    this.setProperties(this.popup);
/*Line 32 - 'AtomDateField.js' */                    this.initializeChildren(this.popup);
/*Line 33 - 'AtomDateField.js' */                    //var _this = this;
/*Line 34 - 'AtomDateField.js' */                    //WebAtoms.dispatcher.callLater(function () {
/*Line 35 - 'AtomDateField.js' */                    //    AtomPopup.show(_this._element, _this.popup, 0, function () {
/*Line 36 - 'AtomDateField.js' */                    //        _this.onPopupRemoved(_this.popup);
/*Line 37 - 'AtomDateField.js' */                    //    });
/*Line 38 - 'AtomDateField.js' */                    //});
/*Line 39 - 'AtomDateField.js' */                } else {
/*Line 40 - 'AtomDateField.js' */                    //AtomPopup.hide(this.popup);
/*Line 41 - 'AtomDateField.js' */                    this.disposeChildren(this.popup);
/*Line 42 - 'AtomDateField.js' */                    $(this.popup).remove();
/*Line 43 - 'AtomDateField.js' */                }
/*Line 44 - 'AtomDateField.js' */            },
/*Line 45 - 'AtomDateField.js' */            get_isOpen: function () {
/*Line 46 - 'AtomDateField.js' */                return this._isOpen;
/*Line 47 - 'AtomDateField.js' */            },

/*Line 49 - 'AtomDateField.js' */            get_selectedItem: function () {
/*Line 50 - 'AtomDateField.js' */                if (this._selectedItems.length)
/*Line 51 - 'AtomDateField.js' */                    return this._selectedItems[0];
/*Line 52 - 'AtomDateField.js' */                return null;
/*Line 53 - 'AtomDateField.js' */            },

/*Line 55 - 'AtomDateField.js' */            set_value: function (v) {
/*Line 56 - 'AtomDateField.js' */                v = AtomDate.parse(v);
/*Line 57 - 'AtomDateField.js' */                this._value = v;
/*Line 58 - 'AtomDateField.js' */                this._selectedItems.length = 0;
/*Line 59 - 'AtomDateField.js' */                if (v) {

/*Line 61 - 'AtomDateField.js' */                    this._selectedItems.push({ date: v, dateLabel: AtomDate.toShortDateString(v), value: AtomDate.toMMDDYY(v), label: v.getDate() });
/*Line 62 - 'AtomDateField.js' */                    this.set_visibleDate(v);
/*Line 63 - 'AtomDateField.js' */                }
/*Line 64 - 'AtomDateField.js' */                if (this._created) {
/*Line 65 - 'AtomDateField.js' */                    AtomBinder.refreshItems(this._selectedItems);
/*Line 66 - 'AtomDateField.js' */                    AtomBinder.refreshValue(this, "value");
/*Line 67 - 'AtomDateField.js' */                    AtomBinder.refreshValue(this, "selectedItem");
/*Line 68 - 'AtomDateField.js' */                    AtomBinder.refreshValue(this, "selectedItems");
/*Line 69 - 'AtomDateField.js' */                }
/*Line 70 - 'AtomDateField.js' */            },
/*Line 71 - 'AtomDateField.js' */            get_value: function (v) {
/*Line 72 - 'AtomDateField.js' */                if (this._selectedItems.length)
/*Line 73 - 'AtomDateField.js' */                    return this._selectedItems[0].date;
/*Line 74 - 'AtomDateField.js' */                return this._value;
/*Line 75 - 'AtomDateField.js' */            },

/*Line 77 - 'AtomDateField.js' */            toggleDate: function (scope, sender) {
/*Line 78 - 'AtomDateField.js' */                var item = sender.get_data();
/*Line 79 - 'AtomDateField.js' */                this._selectedItems.length = 0;
/*Line 80 - 'AtomDateField.js' */                AtomBinder.addItem(this._selectedItems, item);
/*Line 81 - 'AtomDateField.js' */                AtomBinder.refreshValue(this, "value");
/*Line 82 - 'AtomDateField.js' */                AtomBinder.refreshValue(this, "selectedItem");
/*Line 83 - 'AtomDateField.js' */                AtomBinder.refreshValue(this, "selectedItems");
/*Line 84 - 'AtomDateField.js' */                AtomBinder.setValue(this, "isOpen", false);
/*Line 85 - 'AtomDateField.js' */            }


/*Line 88 - 'AtomDateField.js' */        }
/*Line 89 - 'AtomDateField.js' */    });
/*Line 90 - 'AtomDateField.js' */})(window, WebAtoms.AtomDateListBox.prototype);
/*Line 0 - 'AtomDeleteButton.js' */

/*Line 2 - 'AtomDeleteButton.js' */(function (window, base) {
/*Line 3 - 'AtomDeleteButton.js' */    return classCreatorEx({
/*Line 4 - 'AtomDeleteButton.js' */        name: "WebAtoms.AtomDeleteButton",
/*Line 5 - 'AtomDeleteButton.js' */        base: base,
/*Line 6 - 'AtomDeleteButton.js' */        start: function () {
/*Line 7 - 'AtomDeleteButton.js' */            this._confirm = true;
/*Line 8 - 'AtomDeleteButton.js' */            this._confirmMessage = "Are you sure you want to delete this item?";
/*Line 9 - 'AtomDeleteButton.js' */        },
/*Line 10 - 'AtomDeleteButton.js' */        methods: {

/*Line 12 - 'AtomDeleteButton.js' */        },
/*Line 13 - 'AtomDeleteButton.js' */        properties: {

/*Line 15 - 'AtomDeleteButton.js' */        }
/*Line 16 - 'AtomDeleteButton.js' */    });
/*Line 17 - 'AtomDeleteButton.js' */})(window, WebAtoms.AtomPostButton.prototype);

/*Line 0 - 'AtomFileUploader.js' */

/*Line 2 - 'AtomFileUploader.js' */function __waFlashUploadEvent(id, name, a1,a2)
/*Line 3 - 'AtomFileUploader.js' */{
/*Line 4 - 'AtomFileUploader.js' */    var af = allControls[id];
/*Line 5 - 'AtomFileUploader.js' */    af.onFlashEvent(name, a1,a2);
/*Line 6 - 'AtomFileUploader.js' */}

/*Line 8 - 'AtomFileUploader.js' */window.__waFlashUploadEvent = __waFlashUploadEvent;

/*Line 10 - 'AtomFileUploader.js' */(function (window, baseType) {
/*Line 11 - 'AtomFileUploader.js' */    return classCreatorEx({
/*Line 12 - 'AtomFileUploader.js' */        name: "WebAtoms.AtomFileUploader",
/*Line 13 - 'AtomFileUploader.js' */        base: baseType,
/*Line 14 - 'AtomFileUploader.js' */        start: function () {
/*Line 15 - 'AtomFileUploader.js' */            this._presenters = ["viewStack", "filePresenter", "flashPresenter", "flashButtonPresenter"];
/*Line 16 - 'AtomFileUploader.js' */        },
/*Line 17 - 'AtomFileUploader.js' */        properties: {
/*Line 18 - 'AtomFileUploader.js' */            url: null,
/*Line 19 - 'AtomFileUploader.js' */            fileTypes: null,
/*Line 20 - 'AtomFileUploader.js' */            filters: null,
/*Line 21 - 'AtomFileUploader.js' */            value: null,
/*Line 22 - 'AtomFileUploader.js' */            uploadOnUrlSet: false,
/*Line 23 - 'AtomFileUploader.js' */            progress: 0,
/*Line 24 - 'AtomFileUploader.js' */            lockProgress: false,
/*Line 25 - 'AtomFileUploader.js' */            state: '',
/*Line 26 - 'AtomFileUploader.js' */            error: '',
/*Line 27 - 'AtomFileUploader.js' */            displayMode: 0,
/*Line 28 - 'AtomFileUploader.js' */            processUrl: '',
/*Line 29 - 'AtomFileUploader.js' */            processData: null,
/*Line 30 - 'AtomFileUploader.js' */            processMaxTries: 100,
/*Line 31 - 'AtomFileUploader.js' */            processInterval: 5000,
/*Line 32 - 'AtomFileUploader.js' */            proccessResult: {},
/*Line 33 - 'AtomFileUploader.js' */            processDone: false,
/*Line 34 - 'AtomFileUploader.js' */            onSelect: null,
/*Line 35 - 'AtomFileUploader.js' */            accept: "*/*",
/*Line 36 - 'AtomFileUploader.js' */            capture: ""
/*Line 37 - 'AtomFileUploader.js' */        },
/*Line 38 - 'AtomFileUploader.js' */        methods: {
/*Line 39 - 'AtomFileUploader.js' */            set_accept: function (v) {
/*Line 40 - 'AtomFileUploader.js' */                this._accept = v;
/*Line 41 - 'AtomFileUploader.js' */                if (v) {
/*Line 42 - 'AtomFileUploader.js' */                    if (this._filePresenter) {
/*Line 43 - 'AtomFileUploader.js' */                        $(this._filePresenter).attr("accept", v);
/*Line 44 - 'AtomFileUploader.js' */                    }
/*Line 45 - 'AtomFileUploader.js' */                }
/*Line 46 - 'AtomFileUploader.js' */            },

/*Line 48 - 'AtomFileUploader.js' */            set_capture: function (v) {
/*Line 49 - 'AtomFileUploader.js' */                this._capture = v;
/*Line 50 - 'AtomFileUploader.js' */                if (v) {
/*Line 51 - 'AtomFileUploader.js' */                    if (this._filePresenter) {
/*Line 52 - 'AtomFileUploader.js' */                        $(this._filePresenter).attr("capture", v);
/*Line 53 - 'AtomFileUploader.js' */                    }
/*Line 54 - 'AtomFileUploader.js' */                }
/*Line 55 - 'AtomFileUploader.js' */            },
/*Line 56 - 'AtomFileUploader.js' */            set_progress: function (v) {
/*Line 57 - 'AtomFileUploader.js' */                this._progress = v;
/*Line 58 - 'AtomFileUploader.js' */                if (this._lockProgress && v) {
/*Line 59 - 'AtomFileUploader.js' */                    if (v > 99) {
/*Line 60 - 'AtomFileUploader.js' */                        AtomBinder.setValue(atomApplication, "busyMessage", "Converting...");
/*Line 61 - 'AtomFileUploader.js' */                    }
/*Line 62 - 'AtomFileUploader.js' */                    AtomBinder.setValue(atomApplication, "progress", v);
/*Line 63 - 'AtomFileUploader.js' */                }
/*Line 64 - 'AtomFileUploader.js' */            },
/*Line 65 - 'AtomFileUploader.js' */            set_value: function (v) {
/*Line 66 - 'AtomFileUploader.js' */                this._value = v;
/*Line 67 - 'AtomFileUploader.js' */                var caller = this;
/*Line 68 - 'AtomFileUploader.js' */                this.dispatcher.callLater(function () {
/*Line 69 - 'AtomFileUploader.js' */                    if (caller._value) {
/*Line 70 - 'AtomFileUploader.js' */                        if (caller._onSelect) {
/*Line 71 - 'AtomFileUploader.js' */                            caller.invokeAction(caller._onSelect);
/*Line 72 - 'AtomFileUploader.js' */                        }
/*Line 73 - 'AtomFileUploader.js' */                    }
/*Line 74 - 'AtomFileUploader.js' */                });
/*Line 75 - 'AtomFileUploader.js' */            },
/*Line 76 - 'AtomFileUploader.js' */            set_url: function (v) {
/*Line 77 - 'AtomFileUploader.js' */                this._url = v;
/*Line 78 - 'AtomFileUploader.js' */                if (!v)
/*Line 79 - 'AtomFileUploader.js' */                    return;
/*Line 80 - 'AtomFileUploader.js' */                if (this._uploadOnUrlSet) {
/*Line 81 - 'AtomFileUploader.js' */                    this.uploadFile();
/*Line 82 - 'AtomFileUploader.js' */                }

/*Line 84 - 'AtomFileUploader.js' */            },

/*Line 86 - 'AtomFileUploader.js' */            isFlashSupported: function () {
/*Line 87 - 'AtomFileUploader.js' */                return AtomBrowser.supportsFlash && !AtomBrowser.supportsUpload;
/*Line 88 - 'AtomFileUploader.js' */            },

/*Line 90 - 'AtomFileUploader.js' */            onFileSelected: function (f) {
/*Line 91 - 'AtomFileUploader.js' */                this._files = f.target.files;
/*Line 92 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "value", this._files[0].name);
/*Line 93 - 'AtomFileUploader.js' */            },


/*Line 96 - 'AtomFileUploader.js' */            uploadFile: function () {
/*Line 97 - 'AtomFileUploader.js' */                if (!this._url) {

/*Line 99 - 'AtomFileUploader.js' */                    // process next???
/*Line 100 - 'AtomFileUploader.js' */                    return;
/*Line 101 - 'AtomFileUploader.js' */                }

/*Line 103 - 'AtomFileUploader.js' */                if (this._isFlash) {
/*Line 104 - 'AtomFileUploader.js' */                    var fp = this.get_player();
/*Line 105 - 'AtomFileUploader.js' */                    var r = fp.upload(this._url);
/*Line 106 - 'AtomFileUploader.js' */                } else {
/*Line 107 - 'AtomFileUploader.js' */                    var xhr = this._xhr;
/*Line 108 - 'AtomFileUploader.js' */                    if (!xhr) {
/*Line 109 - 'AtomFileUploader.js' */                        xhr = new XMLHttpRequest();
/*Line 110 - 'AtomFileUploader.js' */                        var upload = xhr.upload;
/*Line 111 - 'AtomFileUploader.js' */                        try {
/*Line 112 - 'AtomFileUploader.js' */                            xhr.timeout = 3600000;
/*Line 113 - 'AtomFileUploader.js' */                        } catch (e) {
/*Line 114 - 'AtomFileUploader.js' */                            // IE 10 has some issue with this code..
/*Line 115 - 'AtomFileUploader.js' */                        }

/*Line 117 - 'AtomFileUploader.js' */                        this.bindEvent(upload, "progress", "onProgress");
/*Line 118 - 'AtomFileUploader.js' */                        this.bindEvent(upload, "timeout", "onError");
/*Line 119 - 'AtomFileUploader.js' */                        this.bindEvent(upload, "error", "onError");
/*Line 120 - 'AtomFileUploader.js' */                        this.bindEvent(xhr, "load", "onComplete");
/*Line 121 - 'AtomFileUploader.js' */                        this.bindEvent(xhr, "error", "onError");
/*Line 122 - 'AtomFileUploader.js' */                        this.bindEvent(xhr, "timeout", "onError");
/*Line 123 - 'AtomFileUploader.js' */                        this._xhr = xhr;
/*Line 124 - 'AtomFileUploader.js' */                    }

/*Line 126 - 'AtomFileUploader.js' */                    var fd = new FormData();
/*Line 127 - 'AtomFileUploader.js' */                    fd.append("fileToUpload", this._files[0]);

/*Line 129 - 'AtomFileUploader.js' */                    xhr.open("POST", this._url);
/*Line 130 - 'AtomFileUploader.js' */                    //xhr.setRequestHeader("Content-Type", "multipart/form-data");
/*Line 131 - 'AtomFileUploader.js' */                    xhr.send(fd);

/*Line 133 - 'AtomFileUploader.js' */                }

/*Line 135 - 'AtomFileUploader.js' */                if (this._lockProgress) {
/*Line 136 - 'AtomFileUploader.js' */                    atomApplication.setBusy(true, "Uploading...");
/*Line 137 - 'AtomFileUploader.js' */                }

/*Line 139 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "displayMode", 2);
/*Line 140 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "state", "uploading");
/*Line 141 - 'AtomFileUploader.js' */            },

/*Line 143 - 'AtomFileUploader.js' */            invokeNext: function () {
/*Line 144 - 'AtomFileUploader.js' */                if (this._next) {
/*Line 145 - 'AtomFileUploader.js' */                    if (this._isFlash) {
/*Line 146 - 'AtomFileUploader.js' */                        var fp = this.get_player();
/*Line 147 - 'AtomFileUploader.js' */                        fp.reset();
/*Line 148 - 'AtomFileUploader.js' */                        AtomBinder.setValue(this, "displayMode", 1);
/*Line 149 - 'AtomFileUploader.js' */                    } else {
/*Line 150 - 'AtomFileUploader.js' */                        AtomBinder.setValue(this, "displayMode", 0);
/*Line 151 - 'AtomFileUploader.js' */                    }
/*Line 152 - 'AtomFileUploader.js' */                    AtomBinder.setValue(this, "value", "");
/*Line 153 - 'AtomFileUploader.js' */                    this.invokeAction(this._next);
/*Line 154 - 'AtomFileUploader.js' */                }
/*Line 155 - 'AtomFileUploader.js' */            },

/*Line 157 - 'AtomFileUploader.js' */            refresh: function () {
/*Line 158 - 'AtomFileUploader.js' */                if (this.get_value()) {
/*Line 159 - 'AtomFileUploader.js' */                    this.uploadFile();
/*Line 160 - 'AtomFileUploader.js' */                } else {
/*Line 161 - 'AtomFileUploader.js' */                    this.invokeNext();
/*Line 162 - 'AtomFileUploader.js' */                }
/*Line 163 - 'AtomFileUploader.js' */            },

/*Line 165 - 'AtomFileUploader.js' */            onUploadFinished: function () {
/*Line 166 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "displayMode", 4);
/*Line 167 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "state", "uploaded");
/*Line 168 - 'AtomFileUploader.js' */                if (this._lockProgress) {
/*Line 169 - 'AtomFileUploader.js' */                    AtomBinder.setValue(atomApplication, "progress", 0);
/*Line 170 - 'AtomFileUploader.js' */                    atomApplication.setBusy(false, "Uploading...");
/*Line 171 - 'AtomFileUploader.js' */                }

/*Line 173 - 'AtomFileUploader.js' */                if (this._processUrl) {
/*Line 174 - 'AtomFileUploader.js' */                    var caller = this;
/*Line 175 - 'AtomFileUploader.js' */                    this.tries = this._processMaxTries;
/*Line 176 - 'AtomFileUploader.js' */                    if (this.tries && this.tries.constructor == String)
/*Line 177 - 'AtomFileUploader.js' */                        this.tries = parseInt(this.tries, 10);
/*Line 178 - 'AtomFileUploader.js' */                    this.timer = setInterval(function () {
/*Line 179 - 'AtomFileUploader.js' */                        caller.queryProcessUrl();
/*Line 180 - 'AtomFileUploader.js' */                    }, this._processInterval);
/*Line 181 - 'AtomFileUploader.js' */                    atomApplication.setBusy(true, "Converting...");
/*Line 182 - 'AtomFileUploader.js' */                } else {
/*Line 183 - 'AtomFileUploader.js' */                    this.invokeNext();
/*Line 184 - 'AtomFileUploader.js' */                }
/*Line 185 - 'AtomFileUploader.js' */            },

/*Line 187 - 'AtomFileUploader.js' */            queryProcessUrl: function () {
/*Line 188 - 'AtomFileUploader.js' */                var caller = this;
/*Line 189 - 'AtomFileUploader.js' */                var res = function (r) { caller.onQueryResult(r); };

/*Line 191 - 'AtomFileUploader.js' */                var data = this._processData;

/*Line 193 - 'AtomFileUploader.js' */                this.invokeAjax(this._processUrl, { success: res, error: res, data: data });
/*Line 194 - 'AtomFileUploader.js' */            },

/*Line 196 - 'AtomFileUploader.js' */            onQueryResult: function (r) {
/*Line 197 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "processResult", r);

/*Line 199 - 'AtomFileUploader.js' */                this.tries = this.tries - 1;
/*Line 200 - 'AtomFileUploader.js' */                if (this.tries <= 0 || this._processDone) {
/*Line 201 - 'AtomFileUploader.js' */                    // stop..

/*Line 203 - 'AtomFileUploader.js' */                    var caller = this;
/*Line 204 - 'AtomFileUploader.js' */                    clearInterval(this.timer);
/*Line 205 - 'AtomFileUploader.js' */                    delete this.timer;

/*Line 207 - 'AtomFileUploader.js' */                    setTimeout(function () {
/*Line 208 - 'AtomFileUploader.js' */                        atomApplication.setBusy(false, "Converting...");
/*Line 209 - 'AtomFileUploader.js' */                        caller.invokeNext();
/*Line 210 - 'AtomFileUploader.js' */                    }, caller._processInterval);

/*Line 212 - 'AtomFileUploader.js' */                }
/*Line 213 - 'AtomFileUploader.js' */            },

/*Line 215 - 'AtomFileUploader.js' */            onError: function (evt) {
/*Line 216 - 'AtomFileUploader.js' */                this._lastError = evt;
/*Line 217 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "displayMode", 3);
/*Line 218 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "state", "error");
/*Line 219 - 'AtomFileUploader.js' */            },
/*Line 220 - 'AtomFileUploader.js' */            onProgress: function (evt) {
/*Line 221 - 'AtomFileUploader.js' */                //evt = evt.originalEvent;
/*Line 222 - 'AtomFileUploader.js' */                if (evt.lengthComputable) {
/*Line 223 - 'AtomFileUploader.js' */                    var percentComplete = Math.round(evt.loaded * 100 / evt.total);
/*Line 224 - 'AtomFileUploader.js' */                    AtomBinder.setValue(this, "progress", percentComplete);
/*Line 225 - 'AtomFileUploader.js' */                }
/*Line 226 - 'AtomFileUploader.js' */            },
/*Line 227 - 'AtomFileUploader.js' */            onComplete: function (evt) {
/*Line 228 - 'AtomFileUploader.js' */                var result = null;
/*Line 229 - 'AtomFileUploader.js' */                if (evt.target) {
/*Line 230 - 'AtomFileUploader.js' */                    result = evt.target.responseText;
/*Line 231 - 'AtomFileUploader.js' */                } else {
/*Line 232 - 'AtomFileUploader.js' */                    result = evt.result;
/*Line 233 - 'AtomFileUploader.js' */                }
/*Line 234 - 'AtomFileUploader.js' */                this.onUploadFinished();
/*Line 235 - 'AtomFileUploader.js' */            },

/*Line 237 - 'AtomFileUploader.js' */            get_player: function () {
/*Line 238 - 'AtomFileUploader.js' */                var appName = this._fpID;
/*Line 239 - 'AtomFileUploader.js' */                if (navigator.appName.indexOf("Microsoft") != -1) {
/*Line 240 - 'AtomFileUploader.js' */                    return window[appName];
/*Line 241 - 'AtomFileUploader.js' */                } else {
/*Line 242 - 'AtomFileUploader.js' */                    return document[appName];
/*Line 243 - 'AtomFileUploader.js' */                }
/*Line 244 - 'AtomFileUploader.js' */            },



/*Line 248 - 'AtomFileUploader.js' */            playerUpdated: function () {
/*Line 249 - 'AtomFileUploader.js' */                // load status..
/*Line 250 - 'AtomFileUploader.js' */                if (!this._playerReady) {
/*Line 251 - 'AtomFileUploader.js' */                    this._playerReady = true;
/*Line 252 - 'AtomFileUploader.js' */                    var fp = this.get_player();
/*Line 253 - 'AtomFileUploader.js' */                    fp.setProperty("filters", JSON.stringify(this._filters));
/*Line 254 - 'AtomFileUploader.js' */                    if (this._uploadOnUrlSet && this._url) {
/*Line 255 - 'AtomFileUploader.js' */                        fp.uploadFile(this._url);
/*Line 256 - 'AtomFileUploader.js' */                    }
/*Line 257 - 'AtomFileUploader.js' */                }
/*Line 258 - 'AtomFileUploader.js' */                var p = this.get_player();
/*Line 259 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "state", p.getProperty("currentState").toLowerCase());
/*Line 260 - 'AtomFileUploader.js' */                if (this._state == 'uploaded') {
/*Line 261 - 'AtomFileUploader.js' */                    // yes.. do next...
/*Line 262 - 'AtomFileUploader.js' */                    this.invokeAction(this.get_next());
/*Line 263 - 'AtomFileUploader.js' */                }
/*Line 264 - 'AtomFileUploader.js' */                if (this._state == 'ready') {
/*Line 265 - 'AtomFileUploader.js' */                    AtomBinder.setValue(this, "value", "selected");
/*Line 266 - 'AtomFileUploader.js' */                }
/*Line 267 - 'AtomFileUploader.js' */            },

/*Line 269 - 'AtomFileUploader.js' */            onFlashEvent: function (name, a1, a2) {
/*Line 270 - 'AtomFileUploader.js' */                switch (name) {
/*Line 271 - 'AtomFileUploader.js' */                    case "playerReady":
/*Line 272 - 'AtomFileUploader.js' */                        var ft = AtomBinder.getValue(this, "fileTypes");
/*Line 273 - 'AtomFileUploader.js' */                        if (ft) {
/*Line 274 - 'AtomFileUploader.js' */                            var fp = this.get_player();
/*Line 275 - 'AtomFileUploader.js' */                            fp.clearFileTypes();
/*Line 276 - 'AtomFileUploader.js' */                            var ae = new AtomEnumerator(ft);
/*Line 277 - 'AtomFileUploader.js' */                            while (ae.next()) {
/*Line 278 - 'AtomFileUploader.js' */                                var fti = ae.current();
/*Line 279 - 'AtomFileUploader.js' */                                fp.addFileType(fti.description, fti.extensions);
/*Line 280 - 'AtomFileUploader.js' */                            }
/*Line 281 - 'AtomFileUploader.js' */                        }
/*Line 282 - 'AtomFileUploader.js' */                        break;
/*Line 283 - 'AtomFileUploader.js' */                    case "progress":
/*Line 284 - 'AtomFileUploader.js' */                        this.onFlashProgress(a1, a2);
/*Line 285 - 'AtomFileUploader.js' */                        break;
/*Line 286 - 'AtomFileUploader.js' */                    case "complete":
/*Line 287 - 'AtomFileUploader.js' */                        this.onFlashSuccess(null);
/*Line 288 - 'AtomFileUploader.js' */                        break;
/*Line 289 - 'AtomFileUploader.js' */                    case "selected":
/*Line 290 - 'AtomFileUploader.js' */                        AtomBinder.setValue(this, "value", a1);
/*Line 291 - 'AtomFileUploader.js' */                        break;
/*Line 292 - 'AtomFileUploader.js' */                    case "httpError":
/*Line 293 - 'AtomFileUploader.js' */                    case "ioError":
/*Line 294 - 'AtomFileUploader.js' */                    case "securityError":
/*Line 295 - 'AtomFileUploader.js' */                        this.onFlashError(name, a1);
/*Line 296 - 'AtomFileUploader.js' */                        break;
/*Line 297 - 'AtomFileUploader.js' */                    default:
/*Line 298 - 'AtomFileUploader.js' */                }
/*Line 299 - 'AtomFileUploader.js' */            },

/*Line 301 - 'AtomFileUploader.js' */            onFlashProgress: function (bytesLoaded, bytesTotal) {
/*Line 302 - 'AtomFileUploader.js' */                var percent = Math.ceil((bytesLoaded / bytesTotal) * 100);
/*Line 303 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "progress", percent);
/*Line 304 - 'AtomFileUploader.js' */            },
/*Line 305 - 'AtomFileUploader.js' */            onFlashError: function (errorCode, message) {
/*Line 306 - 'AtomFileUploader.js' */                this._lastError = { file: file, errorCode: errorCode, message: message };
/*Line 307 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "displayMode", 3);
/*Line 308 - 'AtomFileUploader.js' */                AtomBinder.setValue(this, "state", "error");
/*Line 309 - 'AtomFileUploader.js' */            },
/*Line 310 - 'AtomFileUploader.js' */            onFlashSuccess: function (serverData) {
/*Line 311 - 'AtomFileUploader.js' */                this.onUploadFinished();
/*Line 312 - 'AtomFileUploader.js' */            },
/*Line 313 - 'AtomFileUploader.js' */            onFlashDialogComplete: function (numFilesSelected, numFilesQueued) {
/*Line 314 - 'AtomFileUploader.js' */                if (numFilesQueued > 0)
/*Line 315 - 'AtomFileUploader.js' */                    AtomBinder.setValue(this, "value", "selected");
/*Line 316 - 'AtomFileUploader.js' */            },

/*Line 318 - 'AtomFileUploader.js' */            onFlashLoaded: function () {
/*Line 319 - 'AtomFileUploader.js' */                this.swfUploader.setButtonDimensions(100, 25);
/*Line 320 - 'AtomFileUploader.js' */            },

/*Line 322 - 'AtomFileUploader.js' */            useFlash: function () {
/*Line 323 - 'AtomFileUploader.js' */                if (AtomBrowser.isIE && AtomBrowser.majorVersion <= 9)
/*Line 324 - 'AtomFileUploader.js' */                    return true;
/*Line 325 - 'AtomFileUploader.js' */                if (AtomBrowser.isSafari) {

/*Line 327 - 'AtomFileUploader.js' */                    if (AtomBrowser.isMac && AtomBrowser.majorVersion < 6) {
/*Line 328 - 'AtomFileUploader.js' */                        return true;
/*Line 329 - 'AtomFileUploader.js' */                    }
/*Line 330 - 'AtomFileUploader.js' */                }
/*Line 331 - 'AtomFileUploader.js' */                return false;
/*Line 332 - 'AtomFileUploader.js' */            },

/*Line 334 - 'AtomFileUploader.js' */            initialize: function () {
/*Line 335 - 'AtomFileUploader.js' */                var element = this._element;

/*Line 337 - 'AtomFileUploader.js' */                allControls[element.id] = this;

/*Line 339 - 'AtomFileUploader.js' */                baseType.initialize.apply(this, arguments);
/*Line 340 - 'AtomFileUploader.js' */                element.style.height = "25px";
/*Line 341 - 'AtomFileUploader.js' */                element.style.minWidth = "240px";
/*Line 342 - 'AtomFileUploader.js' */                if (this.useFlash()) {
/*Line 343 - 'AtomFileUploader.js' */                    AtomBinder.setValue(this, "displayMode", 1);
/*Line 344 - 'AtomFileUploader.js' */                    var fp = this._flashPresenter;
/*Line 345 - 'AtomFileUploader.js' */                    AtomUI.assignID(fp);
/*Line 346 - 'AtomFileUploader.js' */                    this._fpID = fp.id + "_flash";

/*Line 348 - 'AtomFileUploader.js' */                    createFlashUploader(element.id, fp.id, this._fpID);
/*Line 349 - 'AtomFileUploader.js' */                    this._isFlash = true;
/*Line 350 - 'AtomFileUploader.js' */                } else {
/*Line 351 - 'AtomFileUploader.js' */                    AtomBinder.setValue(this, "displayMode", 0);
/*Line 352 - 'AtomFileUploader.js' */                    var f = this._filePresenter;
/*Line 353 - 'AtomFileUploader.js' */                    this.bindEvent(f, "change", "onFileSelected");
/*Line 354 - 'AtomFileUploader.js' */                    this.clickCommand = function () {
/*Line 355 - 'AtomFileUploader.js' */                        $(f).trigger('click');
/*Line 356 - 'AtomFileUploader.js' */                    };
/*Line 357 - 'AtomFileUploader.js' */                }

/*Line 359 - 'AtomFileUploader.js' */            }
/*Line 360 - 'AtomFileUploader.js' */        }
/*Line 361 - 'AtomFileUploader.js' */    });
/*Line 362 - 'AtomFileUploader.js' */})(window, WebAtoms.AtomDockPanel.prototype);


/*Line 0 - 'AtomLinkBar.js' */

/*Line 2 - 'AtomLinkBar.js' */(function (window, base) {
/*Line 3 - 'AtomLinkBar.js' */    return classCreatorEx({
/*Line 4 - 'AtomLinkBar.js' */        name: "WebAtoms.AtomLinkBar",
/*Line 5 - 'AtomLinkBar.js' */        base: base,
/*Line 6 - 'AtomLinkBar.js' */        start: function () {
/*Line 7 - 'AtomLinkBar.js' */            this._allowSelectFirst = false;

/*Line 9 - 'AtomLinkBar.js' */            var _this = this;
/*Line 10 - 'AtomLinkBar.js' */            this.openMenuCommand = function () {
/*Line 11 - 'AtomLinkBar.js' */                _this.openMenu.apply(_this, arguments);
/*Line 12 - 'AtomLinkBar.js' */            };

/*Line 14 - 'AtomLinkBar.js' */        },
/*Line 15 - 'AtomLinkBar.js' */        properties: {
/*Line 16 - 'AtomLinkBar.js' */            itemsPath: "items",
/*Line 17 - 'AtomLinkBar.js' */            selectCurrent: true,
/*Line 18 - 'AtomLinkBar.js' */            targetPath: "",
/*Line 19 - 'AtomLinkBar.js' */            menuTemplate: null,
/*Line 20 - 'AtomLinkBar.js' */            menuDirection: "horizontal"
/*Line 21 - 'AtomLinkBar.js' */        },
/*Line 22 - 'AtomLinkBar.js' */        methods: {

/*Line 24 - 'AtomLinkBar.js' */            onClick: function () {
/*Line 25 - 'AtomLinkBar.js' */            },



/*Line 29 - 'AtomLinkBar.js' */            openMenu: function (e) {

/*Line 31 - 'AtomLinkBar.js' */                var target = e.target;

/*Line 33 - 'AtomLinkBar.js' */                var ap = this.get_atomParent(target);

/*Line 35 - 'AtomLinkBar.js' */                if (ap == null)
/*Line 36 - 'AtomLinkBar.js' */                    return;

/*Line 38 - 'AtomLinkBar.js' */                var data = ap.get_data();

/*Line 40 - 'AtomLinkBar.js' */                if (!data[this._itemsPath])
/*Line 41 - 'AtomLinkBar.js' */                    return;

/*Line 43 - 'AtomLinkBar.js' */                var menu = this._subMenu;

/*Line 45 - 'AtomLinkBar.js' */                if (menu) {
/*Line 46 - 'AtomLinkBar.js' */                    AtomPopup.hide(menu._element);
/*Line 47 - 'AtomLinkBar.js' */                }
/*Line 48 - 'AtomLinkBar.js' */                else {

/*Line 50 - 'AtomLinkBar.js' */                    var mt = this.getTemplate("menuTemplate");

/*Line 52 - 'AtomLinkBar.js' */                    menu = AtomUI.cloneNode(mt);
/*Line 53 - 'AtomLinkBar.js' */                    menu._templateParent = this;
/*Line 54 - 'AtomLinkBar.js' */                    menu.style.position = "absolute";
/*Line 55 - 'AtomLinkBar.js' */                    //menu.style.zOrder = 
/*Line 56 - 'AtomLinkBar.js' */                    document.body.appendChild(menu);

/*Line 58 - 'AtomLinkBar.js' */                    var mt = $(menu).attr("atom-type") || WebAtoms.AtomControl;

/*Line 60 - 'AtomLinkBar.js' */                    menu = AtomUI.createControl(menu, mt, data);

/*Line 62 - 'AtomLinkBar.js' */                    this._subMenu = menu;
/*Line 63 - 'AtomLinkBar.js' */                }

/*Line 65 - 'AtomLinkBar.js' */                AtomBinder.setValue(menu, "data", data);

/*Line 67 - 'AtomLinkBar.js' */                AtomPopup.show(ap._element, menu._element, 0);

/*Line 69 - 'AtomLinkBar.js' */                AtomUI.cancelEvent(e);
/*Line 70 - 'AtomLinkBar.js' */            },


/*Line 73 - 'AtomLinkBar.js' */            selectDefault: function () {
/*Line 74 - 'AtomLinkBar.js' */                if (!this._items)
/*Line 75 - 'AtomLinkBar.js' */                    return;

/*Line 77 - 'AtomLinkBar.js' */                if (!this._selectCurrent)
/*Line 78 - 'AtomLinkBar.js' */                    return;

/*Line 80 - 'AtomLinkBar.js' */                if (this._value) {
/*Line 81 - 'AtomLinkBar.js' */                    return;
/*Line 82 - 'AtomLinkBar.js' */                }
/*Line 83 - 'AtomLinkBar.js' */                AtomBinder.setValue(this, "value", location.pathname);

/*Line 85 - 'AtomLinkBar.js' */                if (this.get_selectedIndex() == -1) {
/*Line 86 - 'AtomLinkBar.js' */                    this.selectItem(this._items);
/*Line 87 - 'AtomLinkBar.js' */                }

/*Line 89 - 'AtomLinkBar.js' */                this.updateSelectionBindings();
/*Line 90 - 'AtomLinkBar.js' */            },

/*Line 92 - 'AtomLinkBar.js' */            selectItem: function (a, t) {
/*Line 93 - 'AtomLinkBar.js' */                var ae = new AtomEnumerator(a);
/*Line 94 - 'AtomLinkBar.js' */                var vp = this._valuePath;
/*Line 95 - 'AtomLinkBar.js' */                var lp = location.pathname.toLowerCase();
/*Line 96 - 'AtomLinkBar.js' */                while (ae.next()) {
/*Line 97 - 'AtomLinkBar.js' */                    var item = ae.current();
/*Line 98 - 'AtomLinkBar.js' */                    var l = item;
/*Line 99 - 'AtomLinkBar.js' */                    if (vp)
/*Line 100 - 'AtomLinkBar.js' */                        l = l[vp];
/*Line 101 - 'AtomLinkBar.js' */                    if (!l)
/*Line 102 - 'AtomLinkBar.js' */                        continue;
/*Line 103 - 'AtomLinkBar.js' */                    if (lp == l.toLowerCase()) {
/*Line 104 - 'AtomLinkBar.js' */                        if (!t) {
/*Line 105 - 'AtomLinkBar.js' */                            AtomBinder.setValue(this, "selectedItem", item);
/*Line 106 - 'AtomLinkBar.js' */                        }
/*Line 107 - 'AtomLinkBar.js' */                        return true;
/*Line 108 - 'AtomLinkBar.js' */                    }

/*Line 110 - 'AtomLinkBar.js' */                    if (item.links) {
/*Line 111 - 'AtomLinkBar.js' */                        if (this.selectItem(item.links, true)) {
/*Line 112 - 'AtomLinkBar.js' */                            AtomBinder.setValue(this, "selectedItem", item);
/*Line 113 - 'AtomLinkBar.js' */                            return true;
/*Line 114 - 'AtomLinkBar.js' */                        }
/*Line 115 - 'AtomLinkBar.js' */                    }
/*Line 116 - 'AtomLinkBar.js' */                }
/*Line 117 - 'AtomLinkBar.js' */                return false;
/*Line 118 - 'AtomLinkBar.js' */            },

/*Line 120 - 'AtomLinkBar.js' */            dispose: function () {

/*Line 122 - 'AtomLinkBar.js' */                if (this._subMenu) {
/*Line 123 - 'AtomLinkBar.js' */                    this._subMenu.dispose();
/*Line 124 - 'AtomLinkBar.js' */                    this._subMenu = null;
/*Line 125 - 'AtomLinkBar.js' */                }
/*Line 126 - 'AtomLinkBar.js' */                base.dispose.apply(this, arguments);
/*Line 127 - 'AtomLinkBar.js' */            },

/*Line 129 - 'AtomLinkBar.js' */            initialize: function () {
/*Line 130 - 'AtomLinkBar.js' */                base.initialize.apply(this, arguments);

/*Line 132 - 'AtomLinkBar.js' */                //this.bindEvent(this._element, "mouseover", "openMenuCommand");
/*Line 133 - 'AtomLinkBar.js' */                this.bindEvent(this._element, "click", "openMenuCommand");
/*Line 134 - 'AtomLinkBar.js' */                this.setValue("class", "[$owner.showTabs ? 'atom-tab-button-bar' : 'atom-link-bar']", true, this._element);
/*Line 135 - 'AtomLinkBar.js' */            }

/*Line 137 - 'AtomLinkBar.js' */        }
/*Line 138 - 'AtomLinkBar.js' */    });
/*Line 139 - 'AtomLinkBar.js' */})(window, WebAtoms.AtomToggleButtonBar.prototype);

/*Line 0 - 'AtomMultiButtonList.js' */

/*Line 2 - 'AtomMultiButtonList.js' */(function (window, base) {
/*Line 3 - 'AtomMultiButtonList.js' */    return classCreatorEx({
/*Line 4 - 'AtomMultiButtonList.js' */        name: "WebAtoms.AtomMultiButtonList",
/*Line 5 - 'AtomMultiButtonList.js' */        base: base,
/*Line 6 - 'AtomMultiButtonList.js' */        start: function () {
/*Line 7 - 'AtomMultiButtonList.js' */            this._dataElements = [];
/*Line 8 - 'AtomMultiButtonList.js' */        },
/*Line 9 - 'AtomMultiButtonList.js' */        properties: {
/*Line 10 - 'AtomMultiButtonList.js' */            labelPath: "label",
/*Line 11 - 'AtomMultiButtonList.js' */            valuePath: "value",
/*Line 12 - 'AtomMultiButtonList.js' */            options: null,
/*Line 13 - 'AtomMultiButtonList.js' */            isRadio: false,
/*Line 14 - 'AtomMultiButtonList.js' */            items:null
/*Line 15 - 'AtomMultiButtonList.js' */        },
/*Line 16 - 'AtomMultiButtonList.js' */        methods: {
/*Line 17 - 'AtomMultiButtonList.js' */            set_options: function (v) {
/*Line 18 - 'AtomMultiButtonList.js' */                this._options = v;
/*Line 19 - 'AtomMultiButtonList.js' */                if (v) {
/*Line 20 - 'AtomMultiButtonList.js' */                    this.onCollectionChangedInternal("refresh", -1, null);
/*Line 21 - 'AtomMultiButtonList.js' */                }
/*Line 22 - 'AtomMultiButtonList.js' */            },
/*Line 23 - 'AtomMultiButtonList.js' */            set_value: function (v) {
/*Line 24 - 'AtomMultiButtonList.js' */                this._value = v;
/*Line 25 - 'AtomMultiButtonList.js' */                this.updateSelections();
/*Line 26 - 'AtomMultiButtonList.js' */            },
/*Line 27 - 'AtomMultiButtonList.js' */            set_items: function (v) {
/*Line 28 - 'AtomMultiButtonList.js' */                if (this._items) {
/*Line 29 - 'AtomMultiButtonList.js' */                    this.unbindEvent(this._items, "CollectionChanged", "onCollectionChangedInternal");
/*Line 30 - 'AtomMultiButtonList.js' */                }
/*Line 31 - 'AtomMultiButtonList.js' */                this._items = v;

/*Line 33 - 'AtomMultiButtonList.js' */                // try starting observing....
/*Line 34 - 'AtomMultiButtonList.js' */                if (v != null) {
/*Line 35 - 'AtomMultiButtonList.js' */                    this.bindEvent(this._items, "CollectionChanged", "onCollectionChangedInternal");
/*Line 36 - 'AtomMultiButtonList.js' */                    this.onCollectionChangedInternal("refresh", -1, null);
/*Line 37 - 'AtomMultiButtonList.js' */                }
/*Line 38 - 'AtomMultiButtonList.js' */            },

/*Line 40 - 'AtomMultiButtonList.js' */            onCollectionChangedInternal: function (mode, index, item) {
/*Line 41 - 'AtomMultiButtonList.js' */                var value = this.get_value();

/*Line 43 - 'AtomMultiButtonList.js' */                this.onCollectionChanged(mode, index, item);

/*Line 45 - 'AtomMultiButtonList.js' */                // update selections !!!
/*Line 46 - 'AtomMultiButtonList.js' */                this.set_value(value);
/*Line 47 - 'AtomMultiButtonList.js' */            },
/*Line 48 - 'AtomMultiButtonList.js' */            onCollectionChanged: function (mode, index, item) {
/*Line 49 - 'AtomMultiButtonList.js' */                if (!this._items || !this._options)
/*Line 50 - 'AtomMultiButtonList.js' */                    return;
/*Line 51 - 'AtomMultiButtonList.js' */                this._dataElements = [];
/*Line 52 - 'AtomMultiButtonList.js' */                this.unbindEvent(null, "change", "onDataChange");
/*Line 53 - 'AtomMultiButtonList.js' */                var ae = new AtomEnumerator(this._items);
/*Line 54 - 'AtomMultiButtonList.js' */                while (ae.next()) {
/*Line 55 - 'AtomMultiButtonList.js' */                    var data = ae.current();
/*Line 56 - 'AtomMultiButtonList.js' */                    this.createChildElement(this._element, data);
/*Line 57 - 'AtomMultiButtonList.js' */                }

/*Line 59 - 'AtomMultiButtonList.js' */                this.updateUI();
/*Line 60 - 'AtomMultiButtonList.js' */            },

/*Line 62 - 'AtomMultiButtonList.js' */            updateSelections: function () {

/*Line 64 - 'AtomMultiButtonList.js' */                if (!this._dataElements || this._dataElements.length == 0)
/*Line 65 - 'AtomMultiButtonList.js' */                    return;

/*Line 67 - 'AtomMultiButtonList.js' */                ace = new AtomEnumerator(this._dataElements);
/*Line 68 - 'AtomMultiButtonList.js' */                while (ace.next()) {
/*Line 69 - 'AtomMultiButtonList.js' */                    $(ace.current()).attr("checked", false);
/*Line 70 - 'AtomMultiButtonList.js' */                }

/*Line 72 - 'AtomMultiButtonList.js' */                if (!this._value)
/*Line 73 - 'AtomMultiButtonList.js' */                    return;

/*Line 75 - 'AtomMultiButtonList.js' */                var ae;
/*Line 76 - 'AtomMultiButtonList.js' */                var ace;
/*Line 77 - 'AtomMultiButtonList.js' */                var item;
/*Line 78 - 'AtomMultiButtonList.js' */                var selections = this._value.split(",");

/*Line 80 - 'AtomMultiButtonList.js' */                ace.reset();

/*Line 82 - 'AtomMultiButtonList.js' */                var cb;
/*Line 83 - 'AtomMultiButtonList.js' */                while (ace.next()) {
/*Line 84 - 'AtomMultiButtonList.js' */                    cb = ace.current();
/*Line 85 - 'AtomMultiButtonList.js' */                    ae = new AtomEnumerator(selections);
/*Line 86 - 'AtomMultiButtonList.js' */                    while (ae.next()) {
/*Line 87 - 'AtomMultiButtonList.js' */                        item = ae.current();
/*Line 88 - 'AtomMultiButtonList.js' */                        item = $.trim(item);
/*Line 89 - 'AtomMultiButtonList.js' */                        if ($(cb).val() == item) {
/*Line 90 - 'AtomMultiButtonList.js' */                            $(cb).attr("checked", "true");
/*Line 91 - 'AtomMultiButtonList.js' */                        }
/*Line 92 - 'AtomMultiButtonList.js' */                    }
/*Line 93 - 'AtomMultiButtonList.js' */                }
/*Line 94 - 'AtomMultiButtonList.js' */            },

/*Line 96 - 'AtomMultiButtonList.js' */            onDataChange: function () {
/*Line 97 - 'AtomMultiButtonList.js' */                var ae = new AtomEnumerator(this._dataElements);
/*Line 98 - 'AtomMultiButtonList.js' */                var add = [];
/*Line 99 - 'AtomMultiButtonList.js' */                while (ae.next()) {
/*Line 100 - 'AtomMultiButtonList.js' */                    var item = ae.current();
/*Line 101 - 'AtomMultiButtonList.js' */                    var dataItem = $(item).val();
/*Line 102 - 'AtomMultiButtonList.js' */                    var checked = $(item).attr("checked");
/*Line 103 - 'AtomMultiButtonList.js' */                    if (checked) {
/*Line 104 - 'AtomMultiButtonList.js' */                        add.push(dataItem);
/*Line 105 - 'AtomMultiButtonList.js' */                    }
/*Line 106 - 'AtomMultiButtonList.js' */                }
/*Line 107 - 'AtomMultiButtonList.js' */                this._value = add.join(", ");
/*Line 108 - 'AtomMultiButtonList.js' */                AtomBinder.refreshValue(this, "value");
/*Line 109 - 'AtomMultiButtonList.js' */            },

/*Line 111 - 'AtomMultiButtonList.js' */            createChildElement: function (parentElement, data) {
/*Line 112 - 'AtomMultiButtonList.js' */                var span = document.createElement("SPAN");
/*Line 113 - 'AtomMultiButtonList.js' */                parentElement.appendChild(span);

/*Line 115 - 'AtomMultiButtonList.js' */                parentElement = span;
/*Line 116 - 'AtomMultiButtonList.js' */                span = document.createElement("SPAN");
/*Line 117 - 'AtomMultiButtonList.js' */                var lp = this.get_labelPath();
/*Line 118 - 'AtomMultiButtonList.js' */                var vp = this.get_valuePath();
/*Line 119 - 'AtomMultiButtonList.js' */                l = data;
/*Line 120 - 'AtomMultiButtonList.js' */                v = data;
/*Line 121 - 'AtomMultiButtonList.js' */                if (lp)
/*Line 122 - 'AtomMultiButtonList.js' */                    l = data[lp];
/*Line 123 - 'AtomMultiButtonList.js' */                if (vp)
/*Line 124 - 'AtomMultiButtonList.js' */                    v = data[vp];


/*Line 127 - 'AtomMultiButtonList.js' */                var gpName = null;
/*Line 128 - 'AtomMultiButtonList.js' */                if (this._isRadio) {
/*Line 129 - 'AtomMultiButtonList.js' */                    gpName = "_g" + AtomUI.getNewIndex();
/*Line 130 - 'AtomMultiButtonList.js' */                }

/*Line 132 - 'AtomMultiButtonList.js' */                parentElement.appendChild(span);

/*Line 134 - 'AtomMultiButtonList.js' */                var options = new AtomEnumerator(this._options);
/*Line 135 - 'AtomMultiButtonList.js' */                while (options.next()) {
/*Line 136 - 'AtomMultiButtonList.js' */                    var op = options.current();
/*Line 137 - 'AtomMultiButtonList.js' */                    if (vp) {
/*Line 138 - 'AtomMultiButtonList.js' */                        op = op[vp];
/*Line 139 - 'AtomMultiButtonList.js' */                    }

/*Line 141 - 'AtomMultiButtonList.js' */                    var val = v + "." + op;

/*Line 143 - 'AtomMultiButtonList.js' */                    var cb = document.createElement("INPUT");
/*Line 144 - 'AtomMultiButtonList.js' */                    if (this._isRadio) {
/*Line 145 - 'AtomMultiButtonList.js' */                        $(cb).attr("type", "radio");
/*Line 146 - 'AtomMultiButtonList.js' */                        $(cb).attr("name", gpName);
/*Line 147 - 'AtomMultiButtonList.js' */                    } else {
/*Line 148 - 'AtomMultiButtonList.js' */                        $(cb).attr("type", "checkbox");
/*Line 149 - 'AtomMultiButtonList.js' */                    }
/*Line 150 - 'AtomMultiButtonList.js' */                    $(cb).val(val);
/*Line 151 - 'AtomMultiButtonList.js' */                    span.appendChild(cb);
/*Line 152 - 'AtomMultiButtonList.js' */                    this.bindEvent(cb, "change", "onDataChange");
/*Line 153 - 'AtomMultiButtonList.js' */                    this._dataElements.push(cb);
/*Line 154 - 'AtomMultiButtonList.js' */                }

/*Line 156 - 'AtomMultiButtonList.js' */                span = document.createElement("SPAN");
/*Line 157 - 'AtomMultiButtonList.js' */                parentElement.appendChild(span);
/*Line 158 - 'AtomMultiButtonList.js' */                // Create Label First..
/*Line 159 - 'AtomMultiButtonList.js' */                var txt = document.createTextNode(l);
/*Line 160 - 'AtomMultiButtonList.js' */                span.appendChild(txt);
/*Line 161 - 'AtomMultiButtonList.js' */                //span.style.float = "left";

/*Line 163 - 'AtomMultiButtonList.js' */            }
/*Line 164 - 'AtomMultiButtonList.js' */        }
/*Line 165 - 'AtomMultiButtonList.js' */    });
/*Line 166 - 'AtomMultiButtonList.js' */})(window, WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomNavigatorList.js' */

/*Line 2 - 'AtomNavigatorList.js' */(function (window, base) {
/*Line 3 - 'AtomNavigatorList.js' */    return classCreatorEx({
/*Line 4 - 'AtomNavigatorList.js' */        name: "WebAtoms.AtomNavigatorList",
/*Line 5 - 'AtomNavigatorList.js' */        base: base,
/*Line 6 - 'AtomNavigatorList.js' */        start: function () {
/*Line 7 - 'AtomNavigatorList.js' */            // 0 = items, 1 = selection, 2 = new item..
/*Line 8 - 'AtomNavigatorList.js' */            this._displayMode = 0;

/*Line 10 - 'AtomNavigatorList.js' */            this._presenters =
/*Line 11 - 'AtomNavigatorList.js' */                [
/*Line 12 - 'AtomNavigatorList.js' */                    "gridPanel",
/*Line 13 - 'AtomNavigatorList.js' */                    "gridPresenter",
/*Line 14 - 'AtomNavigatorList.js' */                    "itemsPresenter",
/*Line 15 - 'AtomNavigatorList.js' */                    "detailHeaderPresenter",
/*Line 16 - 'AtomNavigatorList.js' */                    "newHeaderPresenter",
/*Line 17 - 'AtomNavigatorList.js' */                    "detailPresenter",
/*Line 18 - 'AtomNavigatorList.js' */                    "newPresenter",
/*Line 19 - 'AtomNavigatorList.js' */                    "newView",
/*Line 20 - 'AtomNavigatorList.js' */                    "detailView",
/*Line 21 - 'AtomNavigatorList.js' */                    "newHeaderToolbar",
/*Line 22 - 'AtomNavigatorList.js' */                    "detailHeaderToolbar"];

/*Line 24 - 'AtomNavigatorList.js' */            this._layout = new WebAtoms.AtomViewBoxLayout();

/*Line 26 - 'AtomNavigatorList.js' */            this._newItem = {};

/*Line 28 - 'AtomNavigatorList.js' */        },
/*Line 29 - 'AtomNavigatorList.js' */        properties: {
/*Line 30 - 'AtomNavigatorList.js' */            autoShowDetail: true,
/*Line 31 - 'AtomNavigatorList.js' */            currentPage: null,
/*Line 32 - 'AtomNavigatorList.js' */            pageSize: undefined,
/*Line 33 - 'AtomNavigatorList.js' */            newItem: null,
/*Line 34 - 'AtomNavigatorList.js' */            newUrl: null,
/*Line 35 - 'AtomNavigatorList.js' */            detailUrl: null,
/*Line 36 - 'AtomNavigatorList.js' */            displayMode: null
/*Line 37 - 'AtomNavigatorList.js' */        },
/*Line 38 - 'AtomNavigatorList.js' */        methods: {
/*Line 39 - 'AtomNavigatorList.js' */            get_newItemCopy: function () {
/*Line 40 - 'AtomNavigatorList.js' */                return this._newItemCopy;
/*Line 41 - 'AtomNavigatorList.js' */            },


/*Line 44 - 'AtomNavigatorList.js' */            onBackCommand: function () {
/*Line 45 - 'AtomNavigatorList.js' */                AtomBinder.setValue(this, "displayMode", 0);
/*Line 46 - 'AtomNavigatorList.js' */                AtomBinder.setValue(this, "selectedIndex", -1);
/*Line 47 - 'AtomNavigatorList.js' */            },

/*Line 49 - 'AtomNavigatorList.js' */            onCancelAddNewCommand: function () {
/*Line 50 - 'AtomNavigatorList.js' */                this.onBackCommand();
/*Line 51 - 'AtomNavigatorList.js' */                AtomBinder.refreshValue(this, "newItemCopy");
/*Line 52 - 'AtomNavigatorList.js' */                this.refresh();
/*Line 53 - 'AtomNavigatorList.js' */            },

/*Line 55 - 'AtomNavigatorList.js' */            onAddCommand: function () {
/*Line 56 - 'AtomNavigatorList.js' */                AtomBinder.setValue(this, "selectedIndex", -1);
/*Line 57 - 'AtomNavigatorList.js' */                AtomBinder.setValue(this, "displayMode", 2);
/*Line 58 - 'AtomNavigatorList.js' */                var item = this._newItem || {};
/*Line 59 - 'AtomNavigatorList.js' */                this._newItemCopy = AtomBinder.getClone(item);
/*Line 60 - 'AtomNavigatorList.js' */                AtomBinder.refreshValue(this, "newItemCopy");
/*Line 61 - 'AtomNavigatorList.js' */            },

/*Line 63 - 'AtomNavigatorList.js' */            onSelectedItemsChanged: function () {
/*Line 64 - 'AtomNavigatorList.js' */                base.onSelectedItemsChanged.apply(this, arguments);

/*Line 66 - 'AtomNavigatorList.js' */                if (this._autoShowDetail) {
/*Line 67 - 'AtomNavigatorList.js' */                    this.showDetailCommand();
/*Line 68 - 'AtomNavigatorList.js' */                }
/*Line 69 - 'AtomNavigatorList.js' */            },

/*Line 71 - 'AtomNavigatorList.js' */            addTemplate: function (p, e) {
/*Line 72 - 'AtomNavigatorList.js' */                p.appendChild(e);
/*Line 73 - 'AtomNavigatorList.js' */                e._templateParent = this;
/*Line 74 - 'AtomNavigatorList.js' */                this.onCreateChildren(p);
/*Line 75 - 'AtomNavigatorList.js' */            },

/*Line 77 - 'AtomNavigatorList.js' */            createChildren: function () {
/*Line 78 - 'AtomNavigatorList.js' */                base.createChildren.call(this);

/*Line 80 - 'AtomNavigatorList.js' */                this.getTemplate("gridTemplate");
/*Line 81 - 'AtomNavigatorList.js' */                this.getTemplate("detailTemplate");
/*Line 82 - 'AtomNavigatorList.js' */                this.getTemplate("searchTemplate");
/*Line 83 - 'AtomNavigatorList.js' */                this.getTemplate("detailHeaderTemplate");
/*Line 84 - 'AtomNavigatorList.js' */                this.getTemplate("newHeaderTemplate");
/*Line 85 - 'AtomNavigatorList.js' */                this.getTemplate("headerTemplate");
/*Line 86 - 'AtomNavigatorList.js' */                this.getTemplate("footerTemplate");





/*Line 92 - 'AtomNavigatorList.js' */                var p = this.get_scope();

/*Line 94 - 'AtomNavigatorList.js' */                this._newView.atomControl._scope = new AtomScope(this, p);
/*Line 95 - 'AtomNavigatorList.js' */                this._detailView.atomControl._scope = new AtomScope(this, p);

/*Line 97 - 'AtomNavigatorList.js' */                var g = AtomUI.cloneNode(this._gridTemplate);
/*Line 98 - 'AtomNavigatorList.js' */                this.addTemplate(this._gridPresenter, g);

/*Line 100 - 'AtomNavigatorList.js' */                if (this._detailPresenter) {
/*Line 101 - 'AtomNavigatorList.js' */                    $(this._detailPresenter).remove();
/*Line 102 - 'AtomNavigatorList.js' */                }
/*Line 103 - 'AtomNavigatorList.js' */                if (this._newPresenter) {
/*Line 104 - 'AtomNavigatorList.js' */                    $(this._newPresenter).remove();
/*Line 105 - 'AtomNavigatorList.js' */                }

/*Line 107 - 'AtomNavigatorList.js' */                if (!($(this._detailTemplate).attr("atom-dock"))) {
/*Line 108 - 'AtomNavigatorList.js' */                    $(this._detailTemplate).attr("atom-dock", "Fill");
/*Line 109 - 'AtomNavigatorList.js' */                }

/*Line 111 - 'AtomNavigatorList.js' */                this._detailPresenter = AtomUI.cloneNode(this._detailTemplate);
/*Line 112 - 'AtomNavigatorList.js' */                this._newPresenter = AtomUI.cloneNode(this._detailTemplate);

/*Line 114 - 'AtomNavigatorList.js' */                this.addTemplate(this._detailView, this._detailPresenter);
/*Line 115 - 'AtomNavigatorList.js' */                this.addTemplate(this._newView, this._newPresenter);

/*Line 117 - 'AtomNavigatorList.js' */                if (this._headerTemplate) {
/*Line 118 - 'AtomNavigatorList.js' */                    var hd = AtomUI.cloneNode(this._headerTemplate);
/*Line 119 - 'AtomNavigatorList.js' */                    hd.setAttribute("atom-dock", "Top");
/*Line 120 - 'AtomNavigatorList.js' */                    $(hd).addClass("atom-navigator-list-header");
/*Line 121 - 'AtomNavigatorList.js' */                    this.addTemplate(this._gridPanel, hd);
/*Line 122 - 'AtomNavigatorList.js' */                }

/*Line 124 - 'AtomNavigatorList.js' */                if (this._footerTemplate) {
/*Line 125 - 'AtomNavigatorList.js' */                    var fd = AtomUI.cloneNode(this._footerTemplate);
/*Line 126 - 'AtomNavigatorList.js' */                    fd.setAttribute("atom-dock", "Bottom");
/*Line 127 - 'AtomNavigatorList.js' */                    $(hd).addClass("atom-navigator-list-footer");
/*Line 128 - 'AtomNavigatorList.js' */                    this.addTemplate(this._gridPanel, fd);
/*Line 129 - 'AtomNavigatorList.js' */                }

/*Line 131 - 'AtomNavigatorList.js' */                if (this._detailHeaderTemplate) {
/*Line 132 - 'AtomNavigatorList.js' */                    $(this._detailHeaderToolbar).addClass("atom-navigator-list-detail-header");
/*Line 133 - 'AtomNavigatorList.js' */                    if (!this._newHeaderTemplate) {
/*Line 134 - 'AtomNavigatorList.js' */                        this._newHeaderTemplate = AtomUI.cloneNode(this._detailHeaderTemplate);
/*Line 135 - 'AtomNavigatorList.js' */                    }
/*Line 136 - 'AtomNavigatorList.js' */                    this.addTemplate(this._detailHeaderPresenter, this._detailHeaderTemplate);
/*Line 137 - 'AtomNavigatorList.js' */                }
/*Line 138 - 'AtomNavigatorList.js' */                if (this._newHeaderTemplate) {
/*Line 139 - 'AtomNavigatorList.js' */                    $(this._newHeaderToolbar).addClass("atom-navigator-list-detail-header");
/*Line 140 - 'AtomNavigatorList.js' */                    this.addTemplate(this._newHeaderPresenter, this._newHeaderTemplate);
/*Line 141 - 'AtomNavigatorList.js' */                }

/*Line 143 - 'AtomNavigatorList.js' */            },

/*Line 145 - 'AtomNavigatorList.js' */            initialize: function () {
/*Line 146 - 'AtomNavigatorList.js' */                base.initialize.call(this);

/*Line 148 - 'AtomNavigatorList.js' */                var _this = this;

/*Line 150 - 'AtomNavigatorList.js' */                this.backCommand = function () {
/*Line 151 - 'AtomNavigatorList.js' */                    _this.onBackCommand.apply(_this, arguments);
/*Line 152 - 'AtomNavigatorList.js' */                };

/*Line 154 - 'AtomNavigatorList.js' */                this.addCommand = function () {
/*Line 155 - 'AtomNavigatorList.js' */                    _this.onAddCommand.apply(_this, arguments);
/*Line 156 - 'AtomNavigatorList.js' */                };

/*Line 158 - 'AtomNavigatorList.js' */                this.cancelAddCommand = function () {
/*Line 159 - 'AtomNavigatorList.js' */                    _this.onCancelAddNewCommand.apply(_this, arguments);
/*Line 160 - 'AtomNavigatorList.js' */                };

/*Line 162 - 'AtomNavigatorList.js' */                this.showDetailCommand = function () {
/*Line 163 - 'AtomNavigatorList.js' */                    var s = _this.get_selectedItem();
/*Line 164 - 'AtomNavigatorList.js' */                    if (s) {
/*Line 165 - 'AtomNavigatorList.js' */                        AtomBinder.setValue(_this, "displayMode", 1);
/*Line 166 - 'AtomNavigatorList.js' */                    }
/*Line 167 - 'AtomNavigatorList.js' */                };
/*Line 168 - 'AtomNavigatorList.js' */            }
/*Line 169 - 'AtomNavigatorList.js' */        }
/*Line 170 - 'AtomNavigatorList.js' */    });
/*Line 171 - 'AtomNavigatorList.js' */})(window, WebAtoms.AtomListBox.prototype);

/*Line 0 - 'AtomNumberComboBox.js' */

/*Line 2 - 'AtomNumberComboBox.js' */(function (window, base) {

/*Line 4 - 'AtomNumberComboBox.js' */    var AtomUI = window.AtomUI;

/*Line 6 - 'AtomNumberComboBox.js' */    return classCreatorEx({
/*Line 7 - 'AtomNumberComboBox.js' */        name: "WebAtoms.AtomNumberComboBox",
/*Line 8 - 'AtomNumberComboBox.js' */        base: base,
/*Line 9 - 'AtomNumberComboBox.js' */        start: function () { },
/*Line 10 - 'AtomNumberComboBox.js' */        properties: {
/*Line 11 - 'AtomNumberComboBox.js' */            showPrompt: false,
/*Line 12 - 'AtomNumberComboBox.js' */            startNumber: undefined,
/*Line 13 - 'AtomNumberComboBox.js' */            endNumber: undefined,
/*Line 14 - 'AtomNumberComboBox.js' */            step:1
/*Line 15 - 'AtomNumberComboBox.js' */        },
/*Line 16 - 'AtomNumberComboBox.js' */        methods: {
/*Line 17 - 'AtomNumberComboBox.js' */            set_startNumber: function (v) {
/*Line 18 - 'AtomNumberComboBox.js' */                this._startNumber = v;
/*Line 19 - 'AtomNumberComboBox.js' */                this.resetNumbers();
/*Line 20 - 'AtomNumberComboBox.js' */            },

/*Line 22 - 'AtomNumberComboBox.js' */            set_endNumber: function (v) {
/*Line 23 - 'AtomNumberComboBox.js' */                this._endNumber = v;
/*Line 24 - 'AtomNumberComboBox.js' */                this.resetNumbers();
/*Line 25 - 'AtomNumberComboBox.js' */            },

/*Line 27 - 'AtomNumberComboBox.js' */            set_step: function (v) {
/*Line 28 - 'AtomNumberComboBox.js' */                if (!v)
/*Line 29 - 'AtomNumberComboBox.js' */                    return;
/*Line 30 - 'AtomNumberComboBox.js' */                this._step = v;
/*Line 31 - 'AtomNumberComboBox.js' */                this.resetNumbers();
/*Line 32 - 'AtomNumberComboBox.js' */            },

/*Line 34 - 'AtomNumberComboBox.js' */            onLoaded: function () {
/*Line 35 - 'AtomNumberComboBox.js' */                this.resetNumbers();
/*Line 36 - 'AtomNumberComboBox.js' */            },

/*Line 38 - 'AtomNumberComboBox.js' */            resetNumbers: function () {
/*Line 39 - 'AtomNumberComboBox.js' */                if (!this._created)
/*Line 40 - 'AtomNumberComboBox.js' */                    return;
/*Line 41 - 'AtomNumberComboBox.js' */                if ((this._startNumber === undefined) || (this._endNumber === undefined))
/*Line 42 - 'AtomNumberComboBox.js' */                    return;
/*Line 43 - 'AtomNumberComboBox.js' */                var sn = AtomUI.toNumber(this._startNumber);
/*Line 44 - 'AtomNumberComboBox.js' */                var en = AtomUI.toNumber(this._endNumber);
/*Line 45 - 'AtomNumberComboBox.js' */                var step = AtomUI.toNumber(this._step);
/*Line 46 - 'AtomNumberComboBox.js' */                var numbers = [];
/*Line 47 - 'AtomNumberComboBox.js' */                if (this._showPrompt) {
/*Line 48 - 'AtomNumberComboBox.js' */                    numbers.push({ label: "Select", value: 0 });
/*Line 49 - 'AtomNumberComboBox.js' */                }
/*Line 50 - 'AtomNumberComboBox.js' */                for (; sn <= en; sn += step) {
/*Line 51 - 'AtomNumberComboBox.js' */                    numbers.push({ label: sn, value: sn });
/*Line 52 - 'AtomNumberComboBox.js' */                }

/*Line 54 - 'AtomNumberComboBox.js' */                this.set_items(numbers);
/*Line 55 - 'AtomNumberComboBox.js' */            }
/*Line 56 - 'AtomNumberComboBox.js' */        }
/*Line 57 - 'AtomNumberComboBox.js' */    });
/*Line 58 - 'AtomNumberComboBox.js' */})(window, WebAtoms.AtomComboBox.prototype);

/*Line 0 - 'AtomPhoneControl.js' */

/*Line 2 - 'AtomPhoneControl.js' */(function (window, base) {

/*Line 4 - 'AtomPhoneControl.js' */    var document = window.document;
/*Line 5 - 'AtomPhoneControl.js' */    var $ = window.$;

/*Line 7 - 'AtomPhoneControl.js' */    return classCreatorEx({
/*Line 8 - 'AtomPhoneControl.js' */        name: "WebAtoms.AtomPhoneControl",
/*Line 9 - 'AtomPhoneControl.js' */        base: base,
/*Line 10 - 'AtomPhoneControl.js' */        start: function () {
/*Line 11 - 'AtomPhoneControl.js' */            this._value = "";
/*Line 12 - 'AtomPhoneControl.js' */        },
/*Line 13 - 'AtomPhoneControl.js' */        properties: {

/*Line 15 - 'AtomPhoneControl.js' */        },
/*Line 16 - 'AtomPhoneControl.js' */        methods: {
/*Line 17 - 'AtomPhoneControl.js' */            set_value: function (v) {
/*Line 18 - 'AtomPhoneControl.js' */                this._value = v;
/*Line 19 - 'AtomPhoneControl.js' */                if (this._countries) {
/*Line 20 - 'AtomPhoneControl.js' */                    this.setupValues();
/*Line 21 - 'AtomPhoneControl.js' */                }
/*Line 22 - 'AtomPhoneControl.js' */            },

/*Line 24 - 'AtomPhoneControl.js' */            setupValues: function () {
/*Line 25 - 'AtomPhoneControl.js' */                if (!this._value) {
/*Line 26 - 'AtomPhoneControl.js' */                    $(this.num).val("");
/*Line 27 - 'AtomPhoneControl.js' */                    $(this.ext).val("");
/*Line 28 - 'AtomPhoneControl.js' */                    $(this.msg).val("");
/*Line 29 - 'AtomPhoneControl.js' */                    return;
/*Line 30 - 'AtomPhoneControl.js' */                }
/*Line 31 - 'AtomPhoneControl.js' */                var tokens = this._value.split(":", 6);

/*Line 33 - 'AtomPhoneControl.js' */                var cc = tokens[1];

/*Line 35 - 'AtomPhoneControl.js' */                var ae = new AtomEnumerator(this._countries);
/*Line 36 - 'AtomPhoneControl.js' */                while (ae.next()) {
/*Line 37 - 'AtomPhoneControl.js' */                    var ci = ae.current();
/*Line 38 - 'AtomPhoneControl.js' */                    if (ci.country == cc) {
/*Line 39 - 'AtomPhoneControl.js' */                        this.cs.selectedIndex = ae.currentIndex();
/*Line 40 - 'AtomPhoneControl.js' */                        break;
/*Line 41 - 'AtomPhoneControl.js' */                    }
/*Line 42 - 'AtomPhoneControl.js' */                }

/*Line 44 - 'AtomPhoneControl.js' */                var num = tokens[3].split(".").join("-");
/*Line 45 - 'AtomPhoneControl.js' */                if (num == "--")
/*Line 46 - 'AtomPhoneControl.js' */                    num = "";
/*Line 47 - 'AtomPhoneControl.js' */                $(this.num).val(num);
/*Line 48 - 'AtomPhoneControl.js' */                $(this.ext).val(tokens[4]);
/*Line 49 - 'AtomPhoneControl.js' */                $(this.msg).val(tokens[5]);
/*Line 50 - 'AtomPhoneControl.js' */                this.onFormat();
/*Line 51 - 'AtomPhoneControl.js' */            },

/*Line 53 - 'AtomPhoneControl.js' */            onDataChange: function () {
/*Line 54 - 'AtomPhoneControl.js' */                var value = "v2:";
/*Line 55 - 'AtomPhoneControl.js' */                var si = this.cs.selectedIndex;
/*Line 56 - 'AtomPhoneControl.js' */                var ci = this._countries[si];
/*Line 57 - 'AtomPhoneControl.js' */                value += ci.country + ":" + ci.code;
/*Line 58 - 'AtomPhoneControl.js' */                var num = (($(this.num).val()).split("-").join("."));
/*Line 59 - 'AtomPhoneControl.js' */                value += ":" + num;
/*Line 60 - 'AtomPhoneControl.js' */                value += ":" + $(this.ext).val();
/*Line 61 - 'AtomPhoneControl.js' */                value += ":" + $(this.msg).val();

/*Line 63 - 'AtomPhoneControl.js' */                if (num) {
/*Line 64 - 'AtomPhoneControl.js' */                    this._value = value;
/*Line 65 - 'AtomPhoneControl.js' */                } else {
/*Line 66 - 'AtomPhoneControl.js' */                    this._value = "";
/*Line 67 - 'AtomPhoneControl.js' */                }

/*Line 69 - 'AtomPhoneControl.js' */                AtomBinder.refreshValue(this, "value");
/*Line 70 - 'AtomPhoneControl.js' */            },

/*Line 72 - 'AtomPhoneControl.js' */            setCountries: function (r) {
/*Line 73 - 'AtomPhoneControl.js' */                this._countries = r;
/*Line 74 - 'AtomPhoneControl.js' */                var options = this.cs.options;
/*Line 75 - 'AtomPhoneControl.js' */                options.length = 0;
/*Line 76 - 'AtomPhoneControl.js' */                var ae = new AtomEnumerator(r);
/*Line 77 - 'AtomPhoneControl.js' */                while (ae.next()) {
/*Line 78 - 'AtomPhoneControl.js' */                    var ci = ae.current();
/*Line 79 - 'AtomPhoneControl.js' */                    if (!ci.valueIndex) {
/*Line 80 - 'AtomPhoneControl.js' */                        ci.label = ci.label;
/*Line 81 - 'AtomPhoneControl.js' */                        ci.valueIndex = ae.currentIndex();
/*Line 82 - 'AtomPhoneControl.js' */                        var obj = eval("(" + ci.value + ")");
/*Line 83 - 'AtomPhoneControl.js' */                        ci.country = obj.country;
/*Line 84 - 'AtomPhoneControl.js' */                        ci.code = obj.code;
/*Line 85 - 'AtomPhoneControl.js' */                        ci.format = obj.format;
/*Line 86 - 'AtomPhoneControl.js' */                    }
/*Line 87 - 'AtomPhoneControl.js' */                    options[ae.currentIndex()] = new Option(ci.label, ci.valueIndex, false, false);
/*Line 88 - 'AtomPhoneControl.js' */                }

/*Line 90 - 'AtomPhoneControl.js' */                this.setupValues();
/*Line 91 - 'AtomPhoneControl.js' */                this.onFormat();
/*Line 92 - 'AtomPhoneControl.js' */            },


/*Line 95 - 'AtomPhoneControl.js' */            onCountryChange: function () {
/*Line 96 - 'AtomPhoneControl.js' */                this.onDataChange();
/*Line 97 - 'AtomPhoneControl.js' */                this.onFormat();
/*Line 98 - 'AtomPhoneControl.js' */            },

/*Line 100 - 'AtomPhoneControl.js' */            onFormat: function () {
/*Line 101 - 'AtomPhoneControl.js' */                var cs = this.cs;
/*Line 102 - 'AtomPhoneControl.js' */                if (cs.selectedIndex == -1)
/*Line 103 - 'AtomPhoneControl.js' */                    return;
/*Line 104 - 'AtomPhoneControl.js' */                var ci = this._countries[cs.selectedIndex];

/*Line 106 - 'AtomPhoneControl.js' */                if (ci.format && ci.format.length && ci.format.length > 0) {
/*Line 107 - 'AtomPhoneControl.js' */                    this._currentFormat = [];
/*Line 108 - 'AtomPhoneControl.js' */                    var last = 0;
/*Line 109 - 'AtomPhoneControl.js' */                    var ae = new AtomEnumerator(ci.format);
/*Line 110 - 'AtomPhoneControl.js' */                    while (ae.next()) {
/*Line 111 - 'AtomPhoneControl.js' */                        last += ae.current();
/*Line 112 - 'AtomPhoneControl.js' */                        this._currentFormat.push(last);
/*Line 113 - 'AtomPhoneControl.js' */                    }
/*Line 114 - 'AtomPhoneControl.js' */                }
/*Line 115 - 'AtomPhoneControl.js' */            },

/*Line 117 - 'AtomPhoneControl.js' */            onKeyUp: function (eventObject) {
/*Line 118 - 'AtomPhoneControl.js' */                if (!this._currentFormat)
/*Line 119 - 'AtomPhoneControl.js' */                    return;
/*Line 120 - 'AtomPhoneControl.js' */                var s = this.num.value;
/*Line 121 - 'AtomPhoneControl.js' */                s = s.replace(/\D/g, '');
/*Line 122 - 'AtomPhoneControl.js' */                var ns = "";
/*Line 123 - 'AtomPhoneControl.js' */                for (var i = 0; i < s.length; i++) {
/*Line 124 - 'AtomPhoneControl.js' */                    ns += s[i];
/*Line 125 - 'AtomPhoneControl.js' */                    if (i < s.length - 1 && ($.inArray(i + 1, this._currentFormat) != -1)) {
/*Line 126 - 'AtomPhoneControl.js' */                        ns += "-";
/*Line 127 - 'AtomPhoneControl.js' */                    }
/*Line 128 - 'AtomPhoneControl.js' */                }
/*Line 129 - 'AtomPhoneControl.js' */                this.num.value = ns;
/*Line 130 - 'AtomPhoneControl.js' */            },

/*Line 132 - 'AtomPhoneControl.js' */            initialize: function () {
/*Line 133 - 'AtomPhoneControl.js' */                this.cs = document.createElement("SELECT");
/*Line 134 - 'AtomPhoneControl.js' */                //this.cs.style['float'] = "left";
/*Line 135 - 'AtomPhoneControl.js' */                this.num = document.createElement("INPUT");
/*Line 136 - 'AtomPhoneControl.js' */                this.num.type = "text";
/*Line 137 - 'AtomPhoneControl.js' */                //this.num.style.width = "150px";
/*Line 138 - 'AtomPhoneControl.js' */                //this.num.style['float'] = "left";
/*Line 139 - 'AtomPhoneControl.js' */                //this.num.style.marginLeft = "2px";
/*Line 140 - 'AtomPhoneControl.js' */                this.ext = document.createElement("INPUT");
/*Line 141 - 'AtomPhoneControl.js' */                //this.num = [this.num1, this.num2, this.num3, this.ext];
/*Line 142 - 'AtomPhoneControl.js' */                this.ext.type = "text";
/*Line 143 - 'AtomPhoneControl.js' */                //this.ext.style.width = "30px";
/*Line 144 - 'AtomPhoneControl.js' */                //this.ext.style['float'] = "left";
/*Line 145 - 'AtomPhoneControl.js' */                //this.ext.style.marginLeft = "2px";
/*Line 146 - 'AtomPhoneControl.js' */                $(this.ext).attr("placeholder", "Ext.");
/*Line 147 - 'AtomPhoneControl.js' */                this.msg = document.createElement("INPUT");
/*Line 148 - 'AtomPhoneControl.js' */                this.msg.type = "text";
/*Line 149 - 'AtomPhoneControl.js' */                //this.msg.style.width = "100px";
/*Line 150 - 'AtomPhoneControl.js' */                //this.msg.style['float'] = "left";
/*Line 151 - 'AtomPhoneControl.js' */                //this.msg.style.marginLeft = "2px";
/*Line 152 - 'AtomPhoneControl.js' */                $(this.msg).attr("placeholder", "Message");

/*Line 154 - 'AtomPhoneControl.js' */                var element = this.get_element();
/*Line 155 - 'AtomPhoneControl.js' */                //element.style.width = "450px";
/*Line 156 - 'AtomPhoneControl.js' */                element.appendChild(this.cs);
/*Line 157 - 'AtomPhoneControl.js' */                element.appendChild(this.num);
/*Line 158 - 'AtomPhoneControl.js' */                element.appendChild(this.ext);
/*Line 159 - 'AtomPhoneControl.js' */                element.appendChild(this.msg);

/*Line 161 - 'AtomPhoneControl.js' */                var caller = this;

/*Line 163 - 'AtomPhoneControl.js' */                this.onKeyUpLater = function (e) {
/*Line 164 - 'AtomPhoneControl.js' */                    var evt = e;
/*Line 165 - 'AtomPhoneControl.js' */                    caller.onKeyUp(evt);
/*Line 166 - 'AtomPhoneControl.js' */                    caller.onDataChange(evt);
/*Line 167 - 'AtomPhoneControl.js' */                };

/*Line 169 - 'AtomPhoneControl.js' */                this.bindEvent(this.cs, "change", "onCountryChange");
/*Line 170 - 'AtomPhoneControl.js' */                this.bindEvent(this.num, "change", "onDataChange");
/*Line 171 - 'AtomPhoneControl.js' */                this.bindEvent(this.num, "keyup", "onKeyUpLater");
/*Line 172 - 'AtomPhoneControl.js' */                this.bindEvent(this.num, "keypress", "onKeyUpLater");
/*Line 173 - 'AtomPhoneControl.js' */                this.bindEvent(this.ext, "change", "onDataChange");
/*Line 174 - 'AtomPhoneControl.js' */                this.bindEvent(this.msg, "change", "onDataChange");

/*Line 176 - 'AtomPhoneControl.js' */                $(this._element).addClass("atom-phone-control");
/*Line 177 - 'AtomPhoneControl.js' */                $(this.num).addClass("atom-pc-num");
/*Line 178 - 'AtomPhoneControl.js' */                $(this.msg).addClass("atom-pc-msg");
/*Line 179 - 'AtomPhoneControl.js' */                $(this.cs).addClass("atom-pc-cs");
/*Line 180 - 'AtomPhoneControl.js' */                $(this.ext).addClass("atom-pc-ext");


/*Line 183 - 'AtomPhoneControl.js' */                var phone = this;

/*Line 185 - 'AtomPhoneControl.js' */                AtomPromise.cachedJson("/config/phonecountries").then(function (r) {
/*Line 186 - 'AtomPhoneControl.js' */                    phone.setCountries(r.value());
/*Line 187 - 'AtomPhoneControl.js' */                }).invoke();


/*Line 190 - 'AtomPhoneControl.js' */                base.initialize.call(this);
/*Line 191 - 'AtomPhoneControl.js' */            }
/*Line 192 - 'AtomPhoneControl.js' */        }
/*Line 193 - 'AtomPhoneControl.js' */    });
/*Line 194 - 'AtomPhoneControl.js' */})(window, WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomRadioButtonList.js' */

/*Line 2 - 'AtomRadioButtonList.js' */(function (window, baseType) {
/*Line 3 - 'AtomRadioButtonList.js' */    return classCreatorEx({
/*Line 4 - 'AtomRadioButtonList.js' */        name: "WebAtoms.AtomRadioButtonList",
/*Line 5 - 'AtomRadioButtonList.js' */        base: baseType,
/*Line 6 - 'AtomRadioButtonList.js' */        start: function () {
/*Line 7 - 'AtomRadioButtonList.js' */            this._allowMultipleSelection = false;
/*Line 8 - 'AtomRadioButtonList.js' */        },
/*Line 9 - 'AtomRadioButtonList.js' */        properties: {

/*Line 11 - 'AtomRadioButtonList.js' */        },
/*Line 12 - 'AtomRadioButtonList.js' */        methods: {
/*Line 13 - 'AtomRadioButtonList.js' */            updateChildSelections: function () {
/*Line 14 - 'AtomRadioButtonList.js' */                var dataItems = this.get_dataItems();
/*Line 15 - 'AtomRadioButtonList.js' */                var ae = new AtomEnumerator(dataItems);
/*Line 16 - 'AtomRadioButtonList.js' */                var children = this._dataElements;
/*Line 17 - 'AtomRadioButtonList.js' */                while (ae.next()) {
/*Line 18 - 'AtomRadioButtonList.js' */                    var dataItem = ae.current();
/*Line 19 - 'AtomRadioButtonList.js' */                    var item = children[ae.currentIndex()];
/*Line 20 - 'AtomRadioButtonList.js' */                    if (this.isSelected(dataItem)) {
/*Line 21 - 'AtomRadioButtonList.js' */                        $(item).attr("checked", "true");
/*Line 22 - 'AtomRadioButtonList.js' */                    } else {
/*Line 23 - 'AtomRadioButtonList.js' */                        $(item).removeAttr("checked");
/*Line 24 - 'AtomRadioButtonList.js' */                    }
/*Line 25 - 'AtomRadioButtonList.js' */                }
/*Line 26 - 'AtomRadioButtonList.js' */            },


/*Line 29 - 'AtomRadioButtonList.js' */            onDataChange: function (event) {
/*Line 30 - 'AtomRadioButtonList.js' */                this._onUIChanged = true;

/*Line 32 - 'AtomRadioButtonList.js' */                var item = event.target;
/*Line 33 - 'AtomRadioButtonList.js' */                var dataItem = item;
/*Line 34 - 'AtomRadioButtonList.js' */                if (this.hasItems())
/*Line 35 - 'AtomRadioButtonList.js' */                    dataItem = $(item).data("atom-data-item");
/*Line 36 - 'AtomRadioButtonList.js' */                var checked = $(item).attr("checked");

/*Line 38 - 'AtomRadioButtonList.js' */                AtomBinder.clear(this._selectedItems);

/*Line 40 - 'AtomRadioButtonList.js' */                if (this.isSelected(dataItem)) {
/*Line 41 - 'AtomRadioButtonList.js' */                    if (!checked) {
/*Line 42 - 'AtomRadioButtonList.js' */                        AtomBinder.removeItem(this._selectedItems, dataItem);
/*Line 43 - 'AtomRadioButtonList.js' */                    }
/*Line 44 - 'AtomRadioButtonList.js' */                }
/*Line 45 - 'AtomRadioButtonList.js' */                else {
/*Line 46 - 'AtomRadioButtonList.js' */                    if (checked) {
/*Line 47 - 'AtomRadioButtonList.js' */                        AtomBinder.addItem(this._selectedItems, dataItem);
/*Line 48 - 'AtomRadioButtonList.js' */                    }
/*Line 49 - 'AtomRadioButtonList.js' */                }

/*Line 51 - 'AtomRadioButtonList.js' */                this._onUIChanged = false;

/*Line 53 - 'AtomRadioButtonList.js' */            },

/*Line 55 - 'AtomRadioButtonList.js' */            createChildElement: function (parentElement, data) {
/*Line 56 - 'AtomRadioButtonList.js' */                var span = document.createElement("SPAN");
/*Line 57 - 'AtomRadioButtonList.js' */                var cb = document.createElement("INPUT");
/*Line 58 - 'AtomRadioButtonList.js' */                $(cb).attr("type", "radio");
/*Line 59 - 'AtomRadioButtonList.js' */                $(cb).attr("name", this._groupName);
/*Line 60 - 'AtomRadioButtonList.js' */                var lp = this.get_labelPath();
/*Line 61 - 'AtomRadioButtonList.js' */                var vp = this.get_valuePath();
/*Line 62 - 'AtomRadioButtonList.js' */                l = data;
/*Line 63 - 'AtomRadioButtonList.js' */                v = data;
/*Line 64 - 'AtomRadioButtonList.js' */                if (lp)
/*Line 65 - 'AtomRadioButtonList.js' */                    l = data[lp];
/*Line 66 - 'AtomRadioButtonList.js' */                if (vp)
/*Line 67 - 'AtomRadioButtonList.js' */                    v = data[vp];
/*Line 68 - 'AtomRadioButtonList.js' */                $(cb).data("atom-data", v);
/*Line 69 - 'AtomRadioButtonList.js' */                $(cb).data("atom-data-item", data);
/*Line 70 - 'AtomRadioButtonList.js' */                $(cb).val(l);
/*Line 71 - 'AtomRadioButtonList.js' */                span.appendChild(cb);
/*Line 72 - 'AtomRadioButtonList.js' */                var txt = document.createTextNode(l);
/*Line 73 - 'AtomRadioButtonList.js' */                span.appendChild(txt);
/*Line 74 - 'AtomRadioButtonList.js' */                parentElement.appendChild(span);
/*Line 75 - 'AtomRadioButtonList.js' */                this.bindEvent(cb, "change", "onDataChange");
/*Line 76 - 'AtomRadioButtonList.js' */                return cb;
/*Line 77 - 'AtomRadioButtonList.js' */            },

/*Line 79 - 'AtomRadioButtonList.js' */            initialize: function () {
/*Line 80 - 'AtomRadioButtonList.js' */                this._groupName = "__g" + AtomUI.getNewIndex();
/*Line 81 - 'AtomRadioButtonList.js' */                baseType.initialize.call(this);
/*Line 82 - 'AtomRadioButtonList.js' */            }
/*Line 83 - 'AtomRadioButtonList.js' */        }
/*Line 84 - 'AtomRadioButtonList.js' */    });
/*Line 85 - 'AtomRadioButtonList.js' */})(window, WebAtoms.AtomCheckBoxList.prototype);

/*Line 0 - 'AtomSortableColumn.js' */

/*Line 2 - 'AtomSortableColumn.js' */(function (window, baseType) {
/*Line 3 - 'AtomSortableColumn.js' */    return classCreatorEx({
/*Line 4 - 'AtomSortableColumn.js' */        name: "WebAtoms.AtomSortableColumn",
/*Line 5 - 'AtomSortableColumn.js' */        base: baseType,
/*Line 6 - 'AtomSortableColumn.js' */        start: function () {
/*Line 7 - 'AtomSortableColumn.js' */        },
/*Line 8 - 'AtomSortableColumn.js' */        properties: {
/*Line 9 - 'AtomSortableColumn.js' */            direction: "",
/*Line 10 - 'AtomSortableColumn.js' */            defaultDirection: "",
/*Line 11 - 'AtomSortableColumn.js' */            label: "",
/*Line 12 - 'AtomSortableColumn.js' */            sortField: null
/*Line 13 - 'AtomSortableColumn.js' */        },
/*Line 14 - 'AtomSortableColumn.js' */        methods: {
/*Line 15 - 'AtomSortableColumn.js' */            set_direction: function (v) {
/*Line 16 - 'AtomSortableColumn.js' */                this._direction = v;
/*Line 17 - 'AtomSortableColumn.js' */                $(this._element).removeClass("atom-sort-asc");
/*Line 18 - 'AtomSortableColumn.js' */                $(this._element).removeClass("atom-sort-desc");
/*Line 19 - 'AtomSortableColumn.js' */                if (v) {
/*Line 20 - 'AtomSortableColumn.js' */                    $(this._element).addClass("atom-sort-" + v.toLowerCase());
/*Line 21 - 'AtomSortableColumn.js' */                }
/*Line 22 - 'AtomSortableColumn.js' */            },

/*Line 24 - 'AtomSortableColumn.js' */            set_value: function (v) {
/*Line 25 - 'AtomSortableColumn.js' */                this._value = v;
/*Line 26 - 'AtomSortableColumn.js' */                this.refreshUI();
/*Line 27 - 'AtomSortableColumn.js' */            },

/*Line 29 - 'AtomSortableColumn.js' */            refreshUI: function () {
/*Line 30 - 'AtomSortableColumn.js' */                if (!this._value)
/*Line 31 - 'AtomSortableColumn.js' */                    return;
/*Line 32 - 'AtomSortableColumn.js' */                if (this._value.indexOf(this._sortField) == -1) {
/*Line 33 - 'AtomSortableColumn.js' */                    AtomBinder.setValue(this, "direction", "");
/*Line 34 - 'AtomSortableColumn.js' */                    return;
/*Line 35 - 'AtomSortableColumn.js' */                }

/*Line 37 - 'AtomSortableColumn.js' */                if (this._value.lastIndexOf("desc") != this._value.length - 4) {
/*Line 38 - 'AtomSortableColumn.js' */                    AtomBinder.setValue(this, "direction", "asc");
/*Line 39 - 'AtomSortableColumn.js' */                } else {
/*Line 40 - 'AtomSortableColumn.js' */                    AtomBinder.setValue(this, "direction", "desc");
/*Line 41 - 'AtomSortableColumn.js' */                }
/*Line 42 - 'AtomSortableColumn.js' */            },

/*Line 44 - 'AtomSortableColumn.js' */            onClick: function (e) {
/*Line 45 - 'AtomSortableColumn.js' */                if (!this._direction) {
/*Line 46 - 'AtomSortableColumn.js' */                    AtomBinder.setValue(this, "direction", this._defaultDirection);
/*Line 47 - 'AtomSortableColumn.js' */                } else {
/*Line 48 - 'AtomSortableColumn.js' */                    if (this._direction == "asc") {
/*Line 49 - 'AtomSortableColumn.js' */                        AtomBinder.setValue(this, "direction", "desc");
/*Line 50 - 'AtomSortableColumn.js' */                    } else {
/*Line 51 - 'AtomSortableColumn.js' */                        AtomBinder.setValue(this, "direction", "asc");
/*Line 52 - 'AtomSortableColumn.js' */                    }
/*Line 53 - 'AtomSortableColumn.js' */                }
/*Line 54 - 'AtomSortableColumn.js' */                AtomBinder.setValue(this, "value", this._sortField + " " + this._direction);
/*Line 55 - 'AtomSortableColumn.js' */            },

/*Line 57 - 'AtomSortableColumn.js' */            initialize: function () {
/*Line 58 - 'AtomSortableColumn.js' */                baseType.initialize.call(this);

/*Line 60 - 'AtomSortableColumn.js' */                this.bindEvent(this._element, "click", "onClick");
/*Line 61 - 'AtomSortableColumn.js' */                $(this._element).addClass("atom-column");

/*Line 63 - 'AtomSortableColumn.js' */            },

/*Line 65 - 'AtomSortableColumn.js' */            onUpdateUI: function () {
/*Line 66 - 'AtomSortableColumn.js' */                this.refreshUI();
/*Line 67 - 'AtomSortableColumn.js' */            }
/*Line 68 - 'AtomSortableColumn.js' */        }
/*Line 69 - 'AtomSortableColumn.js' */    });
/*Line 70 - 'AtomSortableColumn.js' */})(window, WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomTabButtonBar.js' */

/*Line 2 - 'AtomTabButtonBar.js' */(function (baseType) {
/*Line 3 - 'AtomTabButtonBar.js' */    return classCreatorEx({
/*Line 4 - 'AtomTabButtonBar.js' */        name: "WebAtoms.AtomTabButtonBar",
/*Line 5 - 'AtomTabButtonBar.js' */        base: baseType,
/*Line 6 - 'AtomTabButtonBar.js' */        start: function () {
/*Line 7 - 'AtomTabButtonBar.js' */            this._allowMultipleSelection = false;
/*Line 8 - 'AtomTabButtonBar.js' */            this._showTabs = true;
/*Line 9 - 'AtomTabButtonBar.js' */        },
/*Line 10 - 'AtomTabButtonBar.js' */        methods: {

/*Line 12 - 'AtomTabButtonBar.js' */        }
/*Line 13 - 'AtomTabButtonBar.js' */    });
/*Line 14 - 'AtomTabButtonBar.js' */})(WebAtoms.AtomLinkBar.prototype);
/*Line 0 - 'AtomTabControl.js' */

/*Line 2 - 'AtomTabControl.js' */(function (window, baseType) {
/*Line 3 - 'AtomTabControl.js' */    return classCreatorEx({
/*Line 4 - 'AtomTabControl.js' */        name: "WebAtoms.AtomTabControl",
/*Line 5 - 'AtomTabControl.js' */        base: baseType,
/*Line 6 - 'AtomTabControl.js' */        start: function () {
/*Line 7 - 'AtomTabControl.js' */            this._presenters = ["itemsPresenter"];

/*Line 9 - 'AtomTabControl.js' */            this._layout = WebAtoms.AtomViewBoxLayout.defaultInstnace;

/*Line 11 - 'AtomTabControl.js' */            this.selectedIndex = 0;
/*Line 12 - 'AtomTabControl.js' */            this.labelPath = "label";

/*Line 14 - 'AtomTabControl.js' */        },
/*Line 15 - 'AtomTabControl.js' */        properties: {
/*Line 16 - 'AtomTabControl.js' */            items: null
/*Line 17 - 'AtomTabControl.js' */        },
/*Line 18 - 'AtomTabControl.js' */        methods: {
/*Line 19 - 'AtomTabControl.js' */            createChildren: function () {
/*Line 20 - 'AtomTabControl.js' */               baseType.createChildren.call(this);

/*Line 22 - 'AtomTabControl.js' */                if (this._itemsPresenter != this._element) {


/*Line 25 - 'AtomTabControl.js' */                    var children = [];

/*Line 27 - 'AtomTabControl.js' */                    var ae = new ChildEnumerator(this._element);
/*Line 28 - 'AtomTabControl.js' */                    while (ae.next()) {
/*Line 29 - 'AtomTabControl.js' */                        var c = ae.current();
/*Line 30 - 'AtomTabControl.js' */                        this._element.removeChild(c);
/*Line 31 - 'AtomTabControl.js' */                        children.push(c);
/*Line 32 - 'AtomTabControl.js' */                    }

/*Line 34 - 'AtomTabControl.js' */                    if (this._template) {
/*Line 35 - 'AtomTabControl.js' */                        var t = AtomUI.cloneNode(this._template);
/*Line 36 - 'AtomTabControl.js' */                        t._templateParent = this;
/*Line 37 - 'AtomTabControl.js' */                        this._element.appendChild(t);
/*Line 38 - 'AtomTabControl.js' */                        this.onCreateChildren(this._element);
/*Line 39 - 'AtomTabControl.js' */                    }

/*Line 41 - 'AtomTabControl.js' */                    ae = new AtomEnumerator(children);
/*Line 42 - 'AtomTabControl.js' */                    while (ae.next()) {
/*Line 43 - 'AtomTabControl.js' */                        this._itemsPresenter.appendChild(ae.current());
/*Line 44 - 'AtomTabControl.js' */                    }
/*Line 45 - 'AtomTabControl.js' */                    if (this._template) {
/*Line 46 - 'AtomTabControl.js' */                        this.onCreateChildren(this._itemsPresenter);
/*Line 47 - 'AtomTabControl.js' */                    }

/*Line 49 - 'AtomTabControl.js' */                }

/*Line 51 - 'AtomTabControl.js' */            }
/*Line 52 - 'AtomTabControl.js' */        }
/*Line 53 - 'AtomTabControl.js' */    });
/*Line 54 - 'AtomTabControl.js' */})(window, WebAtoms.AtomControl.prototype);

/*Line 0 - 'AtomUploadButton.js' */

/*Line 2 - 'AtomUploadButton.js' */(function (baseType) {
/*Line 3 - 'AtomUploadButton.js' */    return classCreatorEx({
/*Line 4 - 'AtomUploadButton.js' */        name: "WebAtoms.AtomUploadButton",
/*Line 5 - 'AtomUploadButton.js' */        base: baseType,
/*Line 6 - 'AtomUploadButton.js' */        start: function (e) {
/*Line 7 - 'AtomUploadButton.js' */            if (/input/gi.test(e.nodeName) && /file/gi.test($(e).attr("type"))) {
/*Line 8 - 'AtomUploadButton.js' */                this._filePresenter = e;
/*Line 9 - 'AtomUploadButton.js' */                return;
/*Line 10 - 'AtomUploadButton.js' */            }

/*Line 12 - 'AtomUploadButton.js' */            this._filePresenter = document.createElement("input");
/*Line 13 - 'AtomUploadButton.js' */            $(this._filePresenter).attr("type", "file");
/*Line 14 - 'AtomUploadButton.js' */            $(this._filePresenter).css("left", "-500px");
/*Line 15 - 'AtomUploadButton.js' */            $(this._filePresenter).css("position", "absolute");
/*Line 16 - 'AtomUploadButton.js' */            $(this._filePresenter).css("top", "-0px");
/*Line 17 - 'AtomUploadButton.js' */            document.body.appendChild(this._filePresenter);
/*Line 18 - 'AtomUploadButton.js' */        },
/*Line 19 - 'AtomUploadButton.js' */        properties: {
/*Line 20 - 'AtomUploadButton.js' */            fileTypes: undefined,
/*Line 21 - 'AtomUploadButton.js' */            accept: "*/*",
/*Line 22 - 'AtomUploadButton.js' */            capture: "",
/*Line 23 - 'AtomUploadButton.js' */            progress: 0
/*Line 24 - 'AtomUploadButton.js' */        },
/*Line 25 - 'AtomUploadButton.js' */        methods: {
/*Line 26 - 'AtomUploadButton.js' */            set_accept: function (v) {
/*Line 27 - 'AtomUploadButton.js' */                this._accept = v;
/*Line 28 - 'AtomUploadButton.js' */                if (v) {
/*Line 29 - 'AtomUploadButton.js' */                    if (this._filePresenter) {
/*Line 30 - 'AtomUploadButton.js' */                        $(this._filePresenter).attr("accept", v);
/*Line 31 - 'AtomUploadButton.js' */                    }
/*Line 32 - 'AtomUploadButton.js' */                }
/*Line 33 - 'AtomUploadButton.js' */            },

/*Line 35 - 'AtomUploadButton.js' */            set_capture: function (v) {
/*Line 36 - 'AtomUploadButton.js' */                this._capture = v;
/*Line 37 - 'AtomUploadButton.js' */                if (v) {
/*Line 38 - 'AtomUploadButton.js' */                    if (this._filePresenter) {
/*Line 39 - 'AtomUploadButton.js' */                        $(this._filePresenter).attr("capture", v);
/*Line 40 - 'AtomUploadButton.js' */                    }
/*Line 41 - 'AtomUploadButton.js' */                }
/*Line 42 - 'AtomUploadButton.js' */            },
/*Line 43 - 'AtomUploadButton.js' */            onClickHandler: function (e) {

/*Line 45 - 'AtomUploadButton.js' */                if (this._confirm) {
/*Line 46 - 'AtomUploadButton.js' */                    if (!confirm(this._confirmMessage))
/*Line 47 - 'AtomUploadButton.js' */                        return;
/*Line 48 - 'AtomUploadButton.js' */                }

/*Line 50 - 'AtomUploadButton.js' */                if (!this._postUrl) {
/*Line 51 - 'AtomUploadButton.js' */                    //WebAtoms.AtomUploadButton.callBaseMethod(this, "onClickHandler", [e]);
/*Line 52 - 'AtomUploadButton.js' */                    return;
/*Line 53 - 'AtomUploadButton.js' */                }

/*Line 55 - 'AtomUploadButton.js' */                if (this._filePresenter == this._element) {
/*Line 56 - 'AtomUploadButton.js' */                    return;
/*Line 57 - 'AtomUploadButton.js' */                }

/*Line 59 - 'AtomUploadButton.js' */                $(this._filePresenter).trigger("click");
/*Line 60 - 'AtomUploadButton.js' */                AtomUI.cancelEvent(e);
/*Line 61 - 'AtomUploadButton.js' */            },

/*Line 63 - 'AtomUploadButton.js' */            onFileSelected: function () {
/*Line 64 - 'AtomUploadButton.js' */                var data = this.get_postData();

/*Line 66 - 'AtomUploadButton.js' */                if (data === null || data === undefined)
/*Line 67 - 'AtomUploadButton.js' */                    return;

/*Line 69 - 'AtomUploadButton.js' */                var m = this._mergeData;
/*Line 70 - 'AtomUploadButton.js' */                if (m) {
/*Line 71 - 'AtomUploadButton.js' */                    for (var i in m) {
/*Line 72 - 'AtomUploadButton.js' */                        data[i] = m[i];
/*Line 73 - 'AtomUploadButton.js' */                    }
/*Line 74 - 'AtomUploadButton.js' */                }
/*Line 75 - 'AtomUploadButton.js' */                var xhr = this._xhr;
/*Line 76 - 'AtomUploadButton.js' */                if (!xhr) {
/*Line 77 - 'AtomUploadButton.js' */                    xhr = new XMLHttpRequest();
/*Line 78 - 'AtomUploadButton.js' */                    var upload = xhr.upload;
/*Line 79 - 'AtomUploadButton.js' */                    try {
/*Line 80 - 'AtomUploadButton.js' */                        xhr.timeout = 3600000;
/*Line 81 - 'AtomUploadButton.js' */                    } catch (e) {
/*Line 82 - 'AtomUploadButton.js' */                        // IE 10 has some issue with this code..
/*Line 83 - 'AtomUploadButton.js' */                    }

/*Line 85 - 'AtomUploadButton.js' */                    this.bindEvent(upload, "progress", "onProgress");
/*Line 86 - 'AtomUploadButton.js' */                    this.bindEvent(upload, "timeout", "onError");
/*Line 87 - 'AtomUploadButton.js' */                    this.bindEvent(upload, "error", "onError");
/*Line 88 - 'AtomUploadButton.js' */                    this.bindEvent(xhr, "load", "onComplete");
/*Line 89 - 'AtomUploadButton.js' */                    this.bindEvent(xhr, "error", "onError");
/*Line 90 - 'AtomUploadButton.js' */                    this.bindEvent(xhr, "timeout", "onError");
/*Line 91 - 'AtomUploadButton.js' */                    this._xhr = xhr;
/*Line 92 - 'AtomUploadButton.js' */                }

/*Line 94 - 'AtomUploadButton.js' */                var fd = new FormData();

/*Line 96 - 'AtomUploadButton.js' */                var ae = new AtomEnumerator(this._filePresenter.files);
/*Line 97 - 'AtomUploadButton.js' */                while (ae.next()) {
/*Line 98 - 'AtomUploadButton.js' */                    fd.append("file" + ae.currentIndex(), ae.current());
/*Line 99 - 'AtomUploadButton.js' */                }

/*Line 101 - 'AtomUploadButton.js' */                fd.append("formModel", JSON.stringify(AtomBinder.getClone(data)));

/*Line 103 - 'AtomUploadButton.js' */                xhr.open("POST", this._postUrl);
/*Line 104 - 'AtomUploadButton.js' */                xhr.send(fd);

/*Line 106 - 'AtomUploadButton.js' */                atomApplication.setBusy(true, "Uploading...");
/*Line 107 - 'AtomUploadButton.js' */            },

/*Line 109 - 'AtomUploadButton.js' */            set_progress: function (v) {
/*Line 110 - 'AtomUploadButton.js' */                this._progress = v;
/*Line 111 - 'AtomUploadButton.js' */                if (v) {
/*Line 112 - 'AtomUploadButton.js' */                    AtomBinder.setValue(atomApplication, "progress", v);
/*Line 113 - 'AtomUploadButton.js' */                }
/*Line 114 - 'AtomUploadButton.js' */            },

/*Line 116 - 'AtomUploadButton.js' */            onError: function (evt) {
/*Line 117 - 'AtomUploadButton.js' */                atomApplication.setBusy(false, "Uploading...");
/*Line 118 - 'AtomUploadButton.js' */                this.unbindEvent(this._xhr);
/*Line 119 - 'AtomUploadButton.js' */                this._xhr = null;
/*Line 120 - 'AtomUploadButton.js' */                this._lastError = evt;
/*Line 121 - 'AtomUploadButton.js' */                alert('Upload failed');
/*Line 122 - 'AtomUploadButton.js' */            },
/*Line 123 - 'AtomUploadButton.js' */            onProgress: function (evt) {
/*Line 124 - 'AtomUploadButton.js' */                //evt = evt.originalEvent;
/*Line 125 - 'AtomUploadButton.js' */                if (evt.lengthComputable) {
/*Line 126 - 'AtomUploadButton.js' */                    var percentComplete = Math.round(evt.loaded * 100 / evt.total);
/*Line 127 - 'AtomUploadButton.js' */                    AtomBinder.setValue(this, "progress", percentComplete);
/*Line 128 - 'AtomUploadButton.js' */                }
/*Line 129 - 'AtomUploadButton.js' */            },
/*Line 130 - 'AtomUploadButton.js' */            onComplete: function (evt) {
/*Line 131 - 'AtomUploadButton.js' */                atomApplication.setBusy(false, "Uploading...");
/*Line 132 - 'AtomUploadButton.js' */                var result = null;
/*Line 133 - 'AtomUploadButton.js' */                if (evt.target) {
/*Line 134 - 'AtomUploadButton.js' */                    if (evt.target.status == 200) {
/*Line 135 - 'AtomUploadButton.js' */                        this._value = evt.target.responseText;
/*Line 136 - 'AtomUploadButton.js' */                    } else {
/*Line 137 - 'AtomUploadButton.js' */                        alert(evt.target.statusText);
/*Line 138 - 'AtomUploadButton.js' */                        return;
/*Line 139 - 'AtomUploadButton.js' */                    }
/*Line 140 - 'AtomUploadButton.js' */                } else {
/*Line 141 - 'AtomUploadButton.js' */                    this._value = evt.result;
/*Line 142 - 'AtomUploadButton.js' */                }

/*Line 144 - 'AtomUploadButton.js' */                this.unbindEvent(this._xhr);
/*Line 145 - 'AtomUploadButton.js' */                this._xhr = null;

/*Line 147 - 'AtomUploadButton.js' */                AtomBinder.refreshValue(this, "value");

/*Line 149 - 'AtomUploadButton.js' */                this.invokeAction(this._next, evt);
/*Line 150 - 'AtomUploadButton.js' */            },

/*Line 152 - 'AtomUploadButton.js' */            initialize: function () {
/*Line 153 - 'AtomUploadButton.js' */                baseType.initialize.call(this);

/*Line 155 - 'AtomUploadButton.js' */                var f = this._filePresenter;

/*Line 157 - 'AtomUploadButton.js' */                this.bindEvent(f, "change", "onFileSelected");

/*Line 159 - 'AtomUploadButton.js' */            }
/*Line 160 - 'AtomUploadButton.js' */        }
/*Line 161 - 'AtomUploadButton.js' */    });
/*Line 162 - 'AtomUploadButton.js' */})(WebAtoms.AtomPostButton.prototype);
/*Line 0 - 'AtomViewBox.js' */

/*Line 2 - 'AtomViewBox.js' */(function (WebAtoms, baseType) {
/*Line 3 - 'AtomViewBox.js' */    return classCreatorEx({
/*Line 4 - 'AtomViewBox.js' */        name: "WebAtoms.AtomViewBox",
/*Line 5 - 'AtomViewBox.js' */        base: baseType,
/*Line 6 - 'AtomViewBox.js' */        start: function () {
/*Line 7 - 'AtomViewBox.js' */            this._layout = WebAtoms.AtomViewBoxLayout.defaultInstnace;
/*Line 8 - 'AtomViewBox.js' */        },
/*Line 9 - 'AtomViewBox.js' */        methods: {

/*Line 11 - 'AtomViewBox.js' */        }
/*Line 12 - 'AtomViewBox.js' */    });
/*Line 13 - 'AtomViewBox.js' */})(WebAtoms, WebAtoms.AtomControl.prototype);

/*Line 0 - 'AtomViewStack.js' */

/*Line 2 - 'AtomViewStack.js' */var AtomAnimations = {
/*Line 3 - 'AtomViewStack.js' */    swapLeft: function (elements, width, caller, queue) {
/*Line 4 - 'AtomViewStack.js' */        var first = elements[0];
/*Line 5 - 'AtomViewStack.js' */        var last = elements[1];
/*Line 6 - 'AtomViewStack.js' */        last.style.left = width + "px";
/*Line 7 - 'AtomViewStack.js' */        last.style.visibility = 'inherit';
/*Line 8 - 'AtomViewStack.js' */        last.style.zIndex = 0;
/*Line 9 - 'AtomViewStack.js' */        if (caller) {
/*Line 10 - 'AtomViewStack.js' */            caller._animating = true;
/*Line 11 - 'AtomViewStack.js' */        }
/*Line 12 - 'AtomViewStack.js' */        $(elements).animate(
/*Line 13 - 'AtomViewStack.js' */            {
/*Line 14 - 'AtomViewStack.js' */                left: '-=' + width
/*Line 15 - 'AtomViewStack.js' */            },
/*Line 16 - 'AtomViewStack.js' */            {
/*Line 17 - 'AtomViewStack.js' */                easing: 'swing',
/*Line 18 - 'AtomViewStack.js' */                queue: false,
/*Line 19 - 'AtomViewStack.js' */                complete: function () {
/*Line 20 - 'AtomViewStack.js' */                    first.style.visibility = 'hidden';
/*Line 21 - 'AtomViewStack.js' */                    first.style.zIndex = -5;
/*Line 22 - 'AtomViewStack.js' */                    if (caller) {
/*Line 23 - 'AtomViewStack.js' */                        caller._animating = false;
/*Line 24 - 'AtomViewStack.js' */                    }
/*Line 25 - 'AtomViewStack.js' */                    if (queue) {
/*Line 26 - 'AtomViewStack.js' */                        queue.start();
/*Line 27 - 'AtomViewStack.js' */                    }
/*Line 28 - 'AtomViewStack.js' */                }
/*Line 29 - 'AtomViewStack.js' */            }
/*Line 30 - 'AtomViewStack.js' */        );
/*Line 31 - 'AtomViewStack.js' */    },
/*Line 32 - 'AtomViewStack.js' */    swapRight: function (elements, width, caller, queue) {
/*Line 33 - 'AtomViewStack.js' */        var first = elements[0];
/*Line 34 - 'AtomViewStack.js' */        var last = elements[1];
/*Line 35 - 'AtomViewStack.js' */        last.style.left = (-width) + "px";
/*Line 36 - 'AtomViewStack.js' */        last.style.visibility = 'inherit';
/*Line 37 - 'AtomViewStack.js' */        last.style.zIndex = 0;
/*Line 38 - 'AtomViewStack.js' */        if (caller) {
/*Line 39 - 'AtomViewStack.js' */            caller._animating = true;
/*Line 40 - 'AtomViewStack.js' */        }
/*Line 41 - 'AtomViewStack.js' */        $(elements).animate(
/*Line 42 - 'AtomViewStack.js' */        {
/*Line 43 - 'AtomViewStack.js' */            left: '+=' + width
/*Line 44 - 'AtomViewStack.js' */        },
/*Line 45 - 'AtomViewStack.js' */        {
/*Line 46 - 'AtomViewStack.js' */            easing: 'swing',
/*Line 47 - 'AtomViewStack.js' */            queue: false,
/*Line 48 - 'AtomViewStack.js' */            complete: function () {
/*Line 49 - 'AtomViewStack.js' */                first.style.visibility = 'hidden';
/*Line 50 - 'AtomViewStack.js' */                first.style.zIndex = -5;
/*Line 51 - 'AtomViewStack.js' */                if (caller) {
/*Line 52 - 'AtomViewStack.js' */                    caller._animating = false;
/*Line 53 - 'AtomViewStack.js' */                }
/*Line 54 - 'AtomViewStack.js' */                if (queue) {
/*Line 55 - 'AtomViewStack.js' */                    queue.start();
/*Line 56 - 'AtomViewStack.js' */                }
/*Line 57 - 'AtomViewStack.js' */            }
/*Line 58 - 'AtomViewStack.js' */        }
/*Line 59 - 'AtomViewStack.js' */        );
/*Line 60 - 'AtomViewStack.js' */    },
/*Line 61 - 'AtomViewStack.js' */    swapUp: function (elements, width, caller, queue) {
/*Line 62 - 'AtomViewStack.js' */        var first = elements[0];
/*Line 63 - 'AtomViewStack.js' */        var last = elements[1];
/*Line 64 - 'AtomViewStack.js' */        last.style.top = width + "px";
/*Line 65 - 'AtomViewStack.js' */        last.style.visibility = 'inherit';
/*Line 66 - 'AtomViewStack.js' */        last.style.zIndex = 0;
/*Line 67 - 'AtomViewStack.js' */        if (caller) {
/*Line 68 - 'AtomViewStack.js' */            caller._animating = true;
/*Line 69 - 'AtomViewStack.js' */        }
/*Line 70 - 'AtomViewStack.js' */        $(elements).animate(
/*Line 71 - 'AtomViewStack.js' */                {
/*Line 72 - 'AtomViewStack.js' */                    top: '-=' + width
/*Line 73 - 'AtomViewStack.js' */                },
/*Line 74 - 'AtomViewStack.js' */                {
/*Line 75 - 'AtomViewStack.js' */                    easing: 'swing',
/*Line 76 - 'AtomViewStack.js' */                    queue: false,
/*Line 77 - 'AtomViewStack.js' */                    complete: function () {
/*Line 78 - 'AtomViewStack.js' */                        first.style.visibility = 'hidden';
/*Line 79 - 'AtomViewStack.js' */                        first.style.zIndex = -5;
/*Line 80 - 'AtomViewStack.js' */                        if (caller) {
/*Line 81 - 'AtomViewStack.js' */                            caller._animating = false;
/*Line 82 - 'AtomViewStack.js' */                        }
/*Line 83 - 'AtomViewStack.js' */                        if (queue) {
/*Line 84 - 'AtomViewStack.js' */                            queue.start();
/*Line 85 - 'AtomViewStack.js' */                        }
/*Line 86 - 'AtomViewStack.js' */                    }
/*Line 87 - 'AtomViewStack.js' */                }
/*Line 88 - 'AtomViewStack.js' */            );
/*Line 89 - 'AtomViewStack.js' */    },
/*Line 90 - 'AtomViewStack.js' */    swapDown: function (elements, width, caller, queue) {
/*Line 91 - 'AtomViewStack.js' */        var first = elements[0];
/*Line 92 - 'AtomViewStack.js' */        var last = elements[1];
/*Line 93 - 'AtomViewStack.js' */        last.style.top = (-width) + "px";
/*Line 94 - 'AtomViewStack.js' */        last.style.visibility = 'inherit';
/*Line 95 - 'AtomViewStack.js' */        last.style.zIndex = 0;
/*Line 96 - 'AtomViewStack.js' */        if (caller) {
/*Line 97 - 'AtomViewStack.js' */            caller._animating = true;
/*Line 98 - 'AtomViewStack.js' */        }
/*Line 99 - 'AtomViewStack.js' */        $(elements).animate(
/*Line 100 - 'AtomViewStack.js' */            {
/*Line 101 - 'AtomViewStack.js' */                top: '+=' + width
/*Line 102 - 'AtomViewStack.js' */            },
/*Line 103 - 'AtomViewStack.js' */            {
/*Line 104 - 'AtomViewStack.js' */                easing: 'swing',
/*Line 105 - 'AtomViewStack.js' */                queue: false,
/*Line 106 - 'AtomViewStack.js' */                complete: function () {
/*Line 107 - 'AtomViewStack.js' */                    first.style.visibility = 'hidden';
/*Line 108 - 'AtomViewStack.js' */                    first.style.zIndex = -5;
/*Line 109 - 'AtomViewStack.js' */                    if (caller) {
/*Line 110 - 'AtomViewStack.js' */                        caller._animating = false;
/*Line 111 - 'AtomViewStack.js' */                    }
/*Line 112 - 'AtomViewStack.js' */                    if (queue) {
/*Line 113 - 'AtomViewStack.js' */                        queue.start();
/*Line 114 - 'AtomViewStack.js' */                    }
/*Line 115 - 'AtomViewStack.js' */                }
/*Line 116 - 'AtomViewStack.js' */            }
/*Line 117 - 'AtomViewStack.js' */            );
/*Line 118 - 'AtomViewStack.js' */    }
/*Line 119 - 'AtomViewStack.js' */};

/*Line 121 - 'AtomViewStack.js' */window.AtomAnimations = AtomAnimations;

/*Line 123 - 'AtomViewStack.js' */(function (window, baseType) {

/*Line 125 - 'AtomViewStack.js' */    return classCreatorEx({
/*Line 126 - 'AtomViewStack.js' */        name: "WebAtoms.AtomViewStack",
/*Line 127 - 'AtomViewStack.js' */        base: baseType,
/*Line 128 - 'AtomViewStack.js' */        start: function () {
/*Line 129 - 'AtomViewStack.js' */            this._source = null;
/*Line 130 - 'AtomViewStack.js' */            this._indexChangedHandler = null;
/*Line 131 - 'AtomViewStack.js' */            this._swipeDirection = 'left-right';
/*Line 132 - 'AtomViewStack.js' */        },
/*Line 133 - 'AtomViewStack.js' */        properties: {
/*Line 134 - 'AtomViewStack.js' */            swipeDirection: 'left-right'
/*Line 135 - 'AtomViewStack.js' */        },
/*Line 136 - 'AtomViewStack.js' */        methods: {
/*Line 137 - 'AtomViewStack.js' */            onUpdateUI: function () {
/*Line 138 - 'AtomViewStack.js' */                var element = this.get_element();

/*Line 140 - 'AtomViewStack.js' */                if (!element.parentNode.atomControl) {
/*Line 141 - 'AtomViewStack.js' */                    // try occupying full height...
/*Line 142 - 'AtomViewStack.js' */                    var height = $(element.parentNode).height();
/*Line 143 - 'AtomViewStack.js' */                    var width = $(element.parentNode).width();
/*Line 144 - 'AtomViewStack.js' */                    element.style.width = width + "px";
/*Line 145 - 'AtomViewStack.js' */                    element.style.height = height + "px";
/*Line 146 - 'AtomViewStack.js' */                }

/*Line 148 - 'AtomViewStack.js' */                var childEn = new ChildEnumerator(this._element);

/*Line 150 - 'AtomViewStack.js' */                var selectedChild = this.get_selectedChild();

/*Line 152 - 'AtomViewStack.js' */                var oldElement;
/*Line 153 - 'AtomViewStack.js' */                var oldIndex = -1;
/*Line 154 - 'AtomViewStack.js' */                var newElement;
/*Line 155 - 'AtomViewStack.js' */                var newIndex = -1;

/*Line 157 - 'AtomViewStack.js' */                var animate = this._swipeDirection != "none" && this._lastSelectedChild && selectedChild != this._lastSelectedChild;

/*Line 159 - 'AtomViewStack.js' */                var s = $(element).css("visibility");
/*Line 160 - 'AtomViewStack.js' */                animate = animate && s == "visible";

/*Line 162 - 'AtomViewStack.js' */                var queue = new WebAtoms.AtomDispatcher();
/*Line 163 - 'AtomViewStack.js' */                queue.pause();

/*Line 165 - 'AtomViewStack.js' */                var i = -1;

/*Line 167 - 'AtomViewStack.js' */                while (childEn.next()) {
/*Line 168 - 'AtomViewStack.js' */                    i = i + 1;
/*Line 169 - 'AtomViewStack.js' */                    var item = childEn.current();


/*Line 172 - 'AtomViewStack.js' */                    if (item == selectedChild) {

/*Line 174 - 'AtomViewStack.js' */                        AtomUI.setItemRect(item, { width: $(element).width(), height: $(element).height() });

/*Line 176 - 'AtomViewStack.js' */                        if (animate) {
/*Line 177 - 'AtomViewStack.js' */                            newElement = item;
/*Line 178 - 'AtomViewStack.js' */                            newIndex = i;
/*Line 179 - 'AtomViewStack.js' */                        } else {
/*Line 180 - 'AtomViewStack.js' */                            if (!this._animating) {
/*Line 181 - 'AtomViewStack.js' */                                item.style.visibility = "inherit";
/*Line 182 - 'AtomViewStack.js' */                                item.style.left = "0px";
/*Line 183 - 'AtomViewStack.js' */                                item.style.top = "0px";
/*Line 184 - 'AtomViewStack.js' */                                item.style.zIndex = 0;
/*Line 185 - 'AtomViewStack.js' */                            }
/*Line 186 - 'AtomViewStack.js' */                        }

/*Line 188 - 'AtomViewStack.js' */                        this._lastSelectedChild = item;

/*Line 190 - 'AtomViewStack.js' */                        //item.style.width = element.style.width;
/*Line 191 - 'AtomViewStack.js' */                        //item.style.height = element.style.height;

/*Line 193 - 'AtomViewStack.js' */                        //AtomUI.setItemRect(item, { width: parseInt(element.style.width), height: parseInt(element.style.height) });

/*Line 195 - 'AtomViewStack.js' */                        {
/*Line 196 - 'AtomViewStack.js' */                            var x = item;
/*Line 197 - 'AtomViewStack.js' */                            queue.callLater(function () {

/*Line 199 - 'AtomViewStack.js' */                                if (x.atomControl) {
/*Line 200 - 'AtomViewStack.js' */                                    x.atomControl.updateUI();
/*Line 201 - 'AtomViewStack.js' */                                }

/*Line 203 - 'AtomViewStack.js' */                                $(x).find(".atom-video-player").each(function () {
/*Line 204 - 'AtomViewStack.js' */                                    var ctrl = this.atomControl;
/*Line 205 - 'AtomViewStack.js' */                                    if (ctrl != null && ctrl != undefined) {
/*Line 206 - 'AtomViewStack.js' */                                        ctrl.playIfQueued();
/*Line 207 - 'AtomViewStack.js' */                                    }
/*Line 208 - 'AtomViewStack.js' */                                });
/*Line 209 - 'AtomViewStack.js' */                            });
/*Line 210 - 'AtomViewStack.js' */                        }

/*Line 212 - 'AtomViewStack.js' */                    } else {


/*Line 215 - 'AtomViewStack.js' */                        if (item.style.visibility != "hidden") {
/*Line 216 - 'AtomViewStack.js' */                            if (animate) {
/*Line 217 - 'AtomViewStack.js' */                                oldElement = item;
/*Line 218 - 'AtomViewStack.js' */                                oldIndex = i;
/*Line 219 - 'AtomViewStack.js' */                            } else {
/*Line 220 - 'AtomViewStack.js' */                                if (!this._animating) {
/*Line 221 - 'AtomViewStack.js' */                                    item.style.visibility = "hidden";
/*Line 222 - 'AtomViewStack.js' */                                    item.style.zIndex = -5;
/*Line 223 - 'AtomViewStack.js' */                                }
/*Line 224 - 'AtomViewStack.js' */                            }

/*Line 226 - 'AtomViewStack.js' */                            $(item).find(".atom-video-player").each(function () {
/*Line 227 - 'AtomViewStack.js' */                                var ctrl = this.atomControl;
/*Line 228 - 'AtomViewStack.js' */                                if (ctrl != null && ctrl != undefined) {
/*Line 229 - 'AtomViewStack.js' */                                    ctrl.stop();
/*Line 230 - 'AtomViewStack.js' */                                }
/*Line 231 - 'AtomViewStack.js' */                            });
/*Line 232 - 'AtomViewStack.js' */                        }
/*Line 233 - 'AtomViewStack.js' */                    }
/*Line 234 - 'AtomViewStack.js' */                }

/*Line 236 - 'AtomViewStack.js' */                if (animate) {
/*Line 237 - 'AtomViewStack.js' */                    //var width = parseInt(element.style.width, 10);
/*Line 238 - 'AtomViewStack.js' */                    //var height = parseInt(element.style.width, 10);
/*Line 239 - 'AtomViewStack.js' */                    var width = $(element).width();
/*Line 240 - 'AtomViewStack.js' */                    var height = $(element).height();
/*Line 241 - 'AtomViewStack.js' */                    if (this._swipeDirection == 'up-down') {
/*Line 242 - 'AtomViewStack.js' */                        if (newIndex > oldIndex) {
/*Line 243 - 'AtomViewStack.js' */                            AtomAnimations.swapUp([oldElement, newElement], height, this, queue);
/*Line 244 - 'AtomViewStack.js' */                        } else {
/*Line 245 - 'AtomViewStack.js' */                            AtomAnimations.swapDown([oldElement, newElement], height, this, queue);
/*Line 246 - 'AtomViewStack.js' */                        }
/*Line 247 - 'AtomViewStack.js' */                    } else {
/*Line 248 - 'AtomViewStack.js' */                        if (newIndex > oldIndex) {
/*Line 249 - 'AtomViewStack.js' */                            AtomAnimations.swapLeft([oldElement, newElement], width, this, queue);
/*Line 250 - 'AtomViewStack.js' */                        } else {
/*Line 251 - 'AtomViewStack.js' */                            AtomAnimations.swapRight([oldElement, newElement], width, this, queue);
/*Line 252 - 'AtomViewStack.js' */                        }
/*Line 253 - 'AtomViewStack.js' */                    }
/*Line 254 - 'AtomViewStack.js' */                } else {
/*Line 255 - 'AtomViewStack.js' */                    queue.start();
/*Line 256 - 'AtomViewStack.js' */                }

/*Line 258 - 'AtomViewStack.js' */            },
/*Line 259 - 'AtomViewStack.js' */            initialize: function () {
/*Line 260 - 'AtomViewStack.js' */                var element = this.get_element();
/*Line 261 - 'AtomViewStack.js' */                $(element).addClass("atom-view-stack");
/*Line 262 - 'AtomViewStack.js' */                //this._indexChangedHandler = Function.createDelegate(this, this.onSourceIndexChanged);
/*Line 263 - 'AtomViewStack.js' */                var _this = this;
/*Line 264 - 'AtomViewStack.js' */                this._indexChangedHandler = function () {
/*Line 265 - 'AtomViewStack.js' */                    _this.onSourceIndexChanged.apply(_this, arguments);
/*Line 266 - 'AtomViewStack.js' */                };
/*Line 267 - 'AtomViewStack.js' */                baseType.initialize.call(this);
/*Line 268 - 'AtomViewStack.js' */                //this.updateUI();
/*Line 269 - 'AtomViewStack.js' */            }
/*Line 270 - 'AtomViewStack.js' */        }
/*Line 271 - 'AtomViewStack.js' */    });
/*Line 272 - 'AtomViewStack.js' */})(window, WebAtoms.AtomItemsControl.prototype);

/*Line 0 - 'AtomWizard.js' */

/*Line 2 - 'AtomWizard.js' */(function (window, baseType) {
/*Line 3 - 'AtomWizard.js' */    return classCreatorEx({
/*Line 4 - 'AtomWizard.js' */        name: "WebAtoms.AtomWizard",
/*Line 5 - 'AtomWizard.js' */        base: baseType,
/*Line 6 - 'AtomWizard.js' */        start: function () {
/*Line 7 - 'AtomWizard.js' */            this._presenters = ["viewPresenter"];
/*Line 8 - 'AtomWizard.js' */        },
/*Line 9 - 'AtomWizard.js' */        properties: {
/*Line 10 - 'AtomWizard.js' */            currentStep: 0,
/*Line 11 - 'AtomWizard.js' */            nextLabel: "Next",
/*Line 12 - 'AtomWizard.js' */            prevLabel: "Back",
/*Line 13 - 'AtomWizard.js' */            finishLabel: "Finish",
/*Line 14 - 'AtomWizard.js' */            canMoveBack: true,
/*Line 15 - 'AtomWizard.js' */            canMoveNext: true,
/*Line 16 - 'AtomWizard.js' */            steps: 0,
/*Line 17 - 'AtomWizard.js' */            currentStep: null,
/*Line 18 - 'AtomWizard.js' */            isLastStep: false
/*Line 19 - 'AtomWizard.js' */        },
/*Line 20 - 'AtomWizard.js' */        methods: {
/*Line 21 - 'AtomWizard.js' */            set_currentStep: function (v) {
/*Line 22 - 'AtomWizard.js' */                this._currentStep = v;
/*Line 23 - 'AtomWizard.js' */                AtomBinder.refreshValue(this, "isLastStep");
/*Line 24 - 'AtomWizard.js' */            },

/*Line 26 - 'AtomWizard.js' */            get_isLastStep: function () {
/*Line 27 - 'AtomWizard.js' */                return this._currentStep == (this._steps - 1);
/*Line 28 - 'AtomWizard.js' */            },



/*Line 32 - 'AtomWizard.js' */            initialize: function () {
/*Line 33 - 'AtomWizard.js' */                $(this._element).addClass('atom-wizard');

/*Line 35 - 'AtomWizard.js' */                baseType.initialize.call(this);

/*Line 37 - 'AtomWizard.js' */                var _this = this;


/*Line 40 - 'AtomWizard.js' */                this.goNextCommand = function (scope, sender, evt) {
/*Line 41 - 'AtomWizard.js' */                    if (_this.get_isLastStep()) {
/*Line 42 - 'AtomWizard.js' */                        _this.invokeAction(_this._next, evt);
/*Line 43 - 'AtomWizard.js' */                        AtomBinder.setValue(_this, "canMoveBack", false);
/*Line 44 - 'AtomWizard.js' */                    } else {
/*Line 45 - 'AtomWizard.js' */                        AtomBinder.setValue(_this, "currentStep", _this._currentStep + 1);
/*Line 46 - 'AtomWizard.js' */                    }
/*Line 47 - 'AtomWizard.js' */                };

/*Line 49 - 'AtomWizard.js' */                this.goPrevCommand = function () {
/*Line 50 - 'AtomWizard.js' */                    AtomBinder.setValue(_this, "currentStep", _this._currentStep - 1);
/*Line 51 - 'AtomWizard.js' */                };

/*Line 53 - 'AtomWizard.js' */                this.resetCommand = function () {
/*Line 54 - 'AtomWizard.js' */                    AtomBinder.setValue(_this, "currentStep", 0);
/*Line 55 - 'AtomWizard.js' */                    AtomBinder.setValue(_this, "canMoveBack", true);
/*Line 56 - 'AtomWizard.js' */                };

/*Line 58 - 'AtomWizard.js' */                // create children...

/*Line 60 - 'AtomWizard.js' */                var vs = this._viewPresenter;

/*Line 62 - 'AtomWizard.js' */                var vt = this._viewTemplate;

/*Line 64 - 'AtomWizard.js' */                var i = 0;

/*Line 66 - 'AtomWizard.js' */                var ae = new ChildEnumerator(vt);
/*Line 67 - 'AtomWizard.js' */                while (ae.next()) {
/*Line 68 - 'AtomWizard.js' */                    i++;
/*Line 69 - 'AtomWizard.js' */                    var item = ae.current();
/*Line 70 - 'AtomWizard.js' */                    //$(vs).append(item);
/*Line 71 - 'AtomWizard.js' */                    vs.appendChild(item);
/*Line 72 - 'AtomWizard.js' */                    var type = $(item).attr("atom-type");
/*Line 73 - 'AtomWizard.js' */                    if (!type) {
/*Line 74 - 'AtomWizard.js' */                        type = "AtomViewBox";
/*Line 75 - 'AtomWizard.js' */                        $(item).attr("atom-type", type);
/*Line 76 - 'AtomWizard.js' */                    }

/*Line 78 - 'AtomWizard.js' */                    //var s = new AtomScope(this, this.get_scope(), atomApplication);

/*Line 80 - 'AtomWizard.js' */                    var ct = $(item).attr("atom-type") || WebAtoms.AtomControl;
/*Line 81 - 'AtomWizard.js' */                    var cc = AtomUI.createControl(item, ct);
/*Line 82 - 'AtomWizard.js' */                    cc.initialize();
/*Line 83 - 'AtomWizard.js' */                }
/*Line 84 - 'AtomWizard.js' */                AtomBinder.setValue(this, "steps", i);

/*Line 86 - 'AtomWizard.js' */                if (i) {
/*Line 87 - 'AtomWizard.js' */                    AtomBinder.setValue(this, "currentStep", 0);
/*Line 88 - 'AtomWizard.js' */                }

/*Line 90 - 'AtomWizard.js' */                this.nextCommand = function (scope, sender, evt) {
/*Line 91 - 'AtomWizard.js' */                    var child = vs.atomControl.get_selectedChild().atomControl;
/*Line 92 - 'AtomWizard.js' */                    if (child._next) {
/*Line 93 - 'AtomWizard.js' */                        child.invokeAction(child._next);
/*Line 94 - 'AtomWizard.js' */                        return;
/*Line 95 - 'AtomWizard.js' */                    } else {
/*Line 96 - 'AtomWizard.js' */                        _this.goNextCommand(scope, sender, evt);
/*Line 97 - 'AtomWizard.js' */                    }
/*Line 98 - 'AtomWizard.js' */                };

/*Line 100 - 'AtomWizard.js' */            }
/*Line 101 - 'AtomWizard.js' */        }
/*Line 102 - 'AtomWizard.js' */    });
/*Line 103 - 'AtomWizard.js' */})(window, WebAtoms.AtomDockPanel.prototype);

/*Line 0 - 'AtomYesNoControl.js' */

/*Line 2 - 'AtomYesNoControl.js' */(function (baseType) {
/*Line 3 - 'AtomYesNoControl.js' */    return classCreatorEx({
/*Line 4 - 'AtomYesNoControl.js' */        name: "WebAtoms.AtomYesNoControl",
/*Line 5 - 'AtomYesNoControl.js' */        base: baseType,
/*Line 6 - 'AtomYesNoControl.js' */        start: function () {
/*Line 7 - 'AtomYesNoControl.js' */            this._allowSelectFirst = false;
/*Line 8 - 'AtomYesNoControl.js' */            this._items = [
/*Line 9 - 'AtomYesNoControl.js' */                { label: "Yes", value: true },
/*Line 10 - 'AtomYesNoControl.js' */                { label: "No", value: false }
/*Line 11 - 'AtomYesNoControl.js' */            ];
/*Line 12 - 'AtomYesNoControl.js' */        },
/*Line 13 - 'AtomYesNoControl.js' */        methods: {
/*Line 14 - 'AtomYesNoControl.js' */            initialize: function () {
/*Line 15 - 'AtomYesNoControl.js' */                this._element.style.height = "26px";
/*Line 16 - 'AtomYesNoControl.js' */                baseType.initialize.call(this);
/*Line 17 - 'AtomYesNoControl.js' */            }
/*Line 18 - 'AtomYesNoControl.js' */        }
/*Line 19 - 'AtomYesNoControl.js' */    });
/*Line 20 - 'AtomYesNoControl.js' */})(WebAtoms.AtomToggleButtonBar.prototype);
/*Line 0 - 'AtomYesNoCustom.js' */

/*Line 2 - 'AtomYesNoCustom.js' */(function (window, baseType) {
/*Line 3 - 'AtomYesNoCustom.js' */    return classCreatorEx({
/*Line 4 - 'AtomYesNoCustom.js' */        name: "WebAtoms.AtomYesNoCustom",
/*Line 5 - 'AtomYesNoCustom.js' */        base: baseType,
/*Line 6 - 'AtomYesNoCustom.js' */        start: function () {
/*Line 7 - 'AtomYesNoCustom.js' */            this._presenters = ["yesNo", "input"];
/*Line 8 - 'AtomYesNoCustom.js' */            this._hasValue = false;
/*Line 9 - 'AtomYesNoCustom.js' */        },
/*Line 10 - 'AtomYesNoCustom.js' */        properties:{
/*Line 11 - 'AtomYesNoCustom.js' */            hasValue: false,
/*Line 12 - 'AtomYesNoCustom.js' */            placeholder: null
/*Line 13 - 'AtomYesNoCustom.js' */        },
/*Line 14 - 'AtomYesNoCustom.js' */        methods: {
/*Line 15 - 'AtomYesNoCustom.js' */            set_hasValue: function (v) {
/*Line 16 - 'AtomYesNoCustom.js' */                this._hasValue = v;
/*Line 17 - 'AtomYesNoCustom.js' */                if (!v) {
/*Line 18 - 'AtomYesNoCustom.js' */                    AtomBinder.setValue(this, "value", "");
/*Line 19 - 'AtomYesNoCustom.js' */                }
/*Line 20 - 'AtomYesNoCustom.js' */            },

/*Line 22 - 'AtomYesNoCustom.js' */            set_value: function (v) {
/*Line 23 - 'AtomYesNoCustom.js' */                this._value = v;
/*Line 24 - 'AtomYesNoCustom.js' */                AtomBinder.setValue(this, "hasValue", v ? true : false);
/*Line 25 - 'AtomYesNoCustom.js' */                if (!this._onUIChanged) {
/*Line 26 - 'AtomYesNoCustom.js' */                    $(this._input).val(v);
/*Line 27 - 'AtomYesNoCustom.js' */                }
/*Line 28 - 'AtomYesNoCustom.js' */            },
/*Line 29 - 'AtomYesNoCustom.js' */            onValueChange: function () {
/*Line 30 - 'AtomYesNoCustom.js' */                this._onUIChanged = true;
/*Line 31 - 'AtomYesNoCustom.js' */                var val = $(this._input).val();
/*Line 32 - 'AtomYesNoCustom.js' */                AtomBinder.setValue(this, "value", val);
/*Line 33 - 'AtomYesNoCustom.js' */                this._onUIChanged = false;
/*Line 34 - 'AtomYesNoCustom.js' */            },

/*Line 36 - 'AtomYesNoCustom.js' */            onUpdateUI: function () {
/*Line 37 - 'AtomYesNoCustom.js' */                $(this._input).addClass("atom-yes-no-custom-input");
/*Line 38 - 'AtomYesNoCustom.js' */                if (this._placeholder) {
/*Line 39 - 'AtomYesNoCustom.js' */                    $(this._input).attr(this._placeholder);
/*Line 40 - 'AtomYesNoCustom.js' */                    placeHolderFixer.refresh();
/*Line 41 - 'AtomYesNoCustom.js' */                }
/*Line 42 - 'AtomYesNoCustom.js' */            },

/*Line 44 - 'AtomYesNoCustom.js' */            initialize: function () {

/*Line 46 - 'AtomYesNoCustom.js' */                baseType.initialize.call(this);

/*Line 48 - 'AtomYesNoCustom.js' */                this._yesNo = this._yesNo.atomControl;

/*Line 50 - 'AtomYesNoCustom.js' */                var input = this._input;
/*Line 51 - 'AtomYesNoCustom.js' */                this.bindEvent(input, "change", "onValueChange");
/*Line 52 - 'AtomYesNoCustom.js' */                //this.bindEvent(this._yesNo, "selectionChanged", "onSelectionChanged");
/*Line 53 - 'AtomYesNoCustom.js' */            }
/*Line 54 - 'AtomYesNoCustom.js' */        }
/*Line 55 - 'AtomYesNoCustom.js' */    });
/*Line 56 - 'AtomYesNoCustom.js' */})(window, WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomSkinnedApplication.js' */

/*Line 2 - 'AtomSkinnedApplication.js' */(function (window, name, baseType) {
/*Line 3 - 'AtomSkinnedApplication.js' */    return classCreatorEx({
/*Line 4 - 'AtomSkinnedApplication.js' */        name: "WebAtoms.AtomSkinnedApplication",
/*Line 5 - 'AtomSkinnedApplication.js' */        base: baseType,
/*Line 6 - 'AtomSkinnedApplication.js' */        start:function () {
/*Line 7 - 'AtomSkinnedApplication.js' */            this._presenters = ["appPresenter"];
/*Line 8 - 'AtomSkinnedApplication.js' */        },
/*Line 9 - 'AtomSkinnedApplication.js' */        methods: {
/*Line 10 - 'AtomSkinnedApplication.js' */            setup: function () {

/*Line 12 - 'AtomSkinnedApplication.js' */                var e = this._element;

/*Line 14 - 'AtomSkinnedApplication.js' */                var skin = $(e).attr("atom-skin");
/*Line 15 - 'AtomSkinnedApplication.js' */                if (!skin)
/*Line 16 - 'AtomSkinnedApplication.js' */                    throw new Error("Skin is missing");

/*Line 18 - 'AtomSkinnedApplication.js' */                this._skinTemplate = e.innerHTML;
/*Line 19 - 'AtomSkinnedApplication.js' */                e.innerHTML = "";

/*Line 21 - 'AtomSkinnedApplication.js' */                var _this = this;

/*Line 23 - 'AtomSkinnedApplication.js' */                var a = AtomPromise.get(skin).then(
/*Line 24 - 'AtomSkinnedApplication.js' */                    function () {
/*Line 25 - 'AtomSkinnedApplication.js' */                        _this.skinLoaded(a);
/*Line 26 - 'AtomSkinnedApplication.js' */                    }
/*Line 27 - 'AtomSkinnedApplication.js' */                );
/*Line 28 - 'AtomSkinnedApplication.js' */                a.invoke();
/*Line 29 - 'AtomSkinnedApplication.js' */            },

/*Line 31 - 'AtomSkinnedApplication.js' */            skinLoaded: function (p) {
/*Line 32 - 'AtomSkinnedApplication.js' */                this._element.innerHTML = p.value();
/*Line 33 - 'AtomSkinnedApplication.js' */                baseType.setup.call(this);
/*Line 34 - 'AtomSkinnedApplication.js' */            },

/*Line 36 - 'AtomSkinnedApplication.js' */            createChildren: function () {

/*Line 38 - 'AtomSkinnedApplication.js' */                var s = this._skinTemplate;

/*Line 40 - 'AtomSkinnedApplication.js' */                this._appPresenter = $(this._element).find("[atom-presenter=appPresenter]").first()[0];

/*Line 42 - 'AtomSkinnedApplication.js' */                //$(this._appPresenter).replaceWith(s);

/*Line 44 - 'AtomSkinnedApplication.js' */                var t = this._element.innerHTML;

/*Line 46 - 'AtomSkinnedApplication.js' */                t = t.replace(this._appPresenter.innerHTML, s);

/*Line 48 - 'AtomSkinnedApplication.js' */                this._element.innerHTML = t;

/*Line 50 - 'AtomSkinnedApplication.js' */                base.createChildren.call(this);
/*Line 51 - 'AtomSkinnedApplication.js' */            }
/*Line 52 - 'AtomSkinnedApplication.js' */        }

/*Line 54 - 'AtomSkinnedApplication.js' */    });
/*Line 55 - 'AtomSkinnedApplication.js' */})(window, "WebAtoms.AtomSkinnedApplication", WebAtoms.AtomApplication.prototype);

/*Line 0 - 'AtomAutoPostForm.js' */

/*Line 2 - 'AtomAutoPostForm.js' */(function (window, baseType) {
/*Line 3 - 'AtomAutoPostForm.js' */    return classCreatorEx({
/*Line 4 - 'AtomAutoPostForm.js' */        name: "WebAtoms.AtomAutoPostForm",
/*Line 5 - 'AtomAutoPostForm.js' */        base: baseType,
/*Line 6 - 'AtomAutoPostForm.js' */        start: function () {
/*Line 7 - 'AtomAutoPostForm.js' */        },
/*Line 8 - 'AtomAutoPostForm.js' */        properties: {
/*Line 9 - 'AtomAutoPostForm.js' */            isBusy: false,
/*Line 10 - 'AtomAutoPostForm.js' */            postError: null
/*Line 11 - 'AtomAutoPostForm.js' */        },
/*Line 12 - 'AtomAutoPostForm.js' */        methods: {
/*Line 13 - 'AtomAutoPostForm.js' */            pushPost: function (n) {
/*Line 14 - 'AtomAutoPostForm.js' */                if (this._isBusy)
/*Line 15 - 'AtomAutoPostForm.js' */                    return;
/*Line 16 - 'AtomAutoPostForm.js' */                if (this._pushPostTimeout) {
/*Line 17 - 'AtomAutoPostForm.js' */                    clearTimeout(this._pushPostTimeout);
/*Line 18 - 'AtomAutoPostForm.js' */                }
/*Line 19 - 'AtomAutoPostForm.js' */                if (!n)
/*Line 20 - 'AtomAutoPostForm.js' */                    n = 1000;
/*Line 21 - 'AtomAutoPostForm.js' */                var _this = this;
/*Line 22 - 'AtomAutoPostForm.js' */                this._pushPostTimeout = setTimeout(function () {
/*Line 23 - 'AtomAutoPostForm.js' */                    WebAtoms.dispatcher.callLater(function () {
/*Line 24 - 'AtomAutoPostForm.js' */                        _this.onSubmit();
/*Line 25 - 'AtomAutoPostForm.js' */                    });
/*Line 26 - 'AtomAutoPostForm.js' */                }, n);
/*Line 27 - 'AtomAutoPostForm.js' */            },

/*Line 29 - 'AtomAutoPostForm.js' */            onSubmit: function () {

/*Line 31 - 'AtomAutoPostForm.js' */                this._pushPostTimeout = 0;

/*Line 33 - 'AtomAutoPostForm.js' */                // already submitted?
/*Line 34 - 'AtomAutoPostForm.js' */                if (this._isBusy)
/*Line 35 - 'AtomAutoPostForm.js' */                    return;

/*Line 37 - 'AtomAutoPostForm.js' */                // for all nested children...
/*Line 38 - 'AtomAutoPostForm.js' */                if (!this.isValid()) {
/*Line 39 - 'AtomAutoPostForm.js' */                    //alert("Invalid Form");
/*Line 40 - 'AtomAutoPostForm.js' */                    return;
/*Line 41 - 'AtomAutoPostForm.js' */                }

/*Line 43 - 'AtomAutoPostForm.js' */                var data = this.preparePostData();
/*Line 44 - 'AtomAutoPostForm.js' */                if (!data)
/*Line 45 - 'AtomAutoPostForm.js' */                    return;

/*Line 47 - 'AtomAutoPostForm.js' */                var str = JSON.stringify(AtomBinder.getClone(data));
/*Line 48 - 'AtomAutoPostForm.js' */                if (this._cachedData) {
/*Line 49 - 'AtomAutoPostForm.js' */                    if (str == this._cachedData)
/*Line 50 - 'AtomAutoPostForm.js' */                        return;
/*Line 51 - 'AtomAutoPostForm.js' */                }
/*Line 52 - 'AtomAutoPostForm.js' */                this._cachedData = str;

/*Line 54 - 'AtomAutoPostForm.js' */                var self = this;

/*Line 56 - 'AtomAutoPostForm.js' */                var url = AtomPromise.getUrl(this._postUrl);

/*Line 58 - 'AtomAutoPostForm.js' */                //data = AtomBinder.getClone(data);

/*Line 60 - 'AtomAutoPostForm.js' */                //this.invokeAjax(url, { type: "POST", data: data, success: self._success });
/*Line 61 - 'AtomAutoPostForm.js' */                var ap = AtomPromise.json(url, null, { type: "POST", data: data }).then(self._success);
/*Line 62 - 'AtomAutoPostForm.js' */                ap.failed(function () {
/*Line 63 - 'AtomAutoPostForm.js' */                    self._isBusy = false;
/*Line 64 - 'AtomAutoPostForm.js' */                    self._postError = ap.error.msg;
/*Line 65 - 'AtomAutoPostForm.js' */                    AtomBinder.refreshValue(self, "isBusy");
/*Line 66 - 'AtomAutoPostForm.js' */                    AtomBinder.refreshValue(self, "postError");
/*Line 67 - 'AtomAutoPostForm.js' */                });
/*Line 68 - 'AtomAutoPostForm.js' */                ap.showProgress(false);
/*Line 69 - 'AtomAutoPostForm.js' */                ap.showError(false);
/*Line 70 - 'AtomAutoPostForm.js' */                ap.invoke();
/*Line 71 - 'AtomAutoPostForm.js' */            },

/*Line 73 - 'AtomAutoPostForm.js' */            onCreationComplete: function () {
/*Line 74 - 'AtomAutoPostForm.js' */                baseType.onCreationComplete.apply(this, arguments);
/*Line 75 - 'AtomAutoPostForm.js' */                var data = this.preparePostData();
/*Line 76 - 'AtomAutoPostForm.js' */                if (!data)
/*Line 77 - 'AtomAutoPostForm.js' */                    return;
/*Line 78 - 'AtomAutoPostForm.js' */                this._cachedData = JSON.stringify(AtomBinder.getClone(data));
/*Line 79 - 'AtomAutoPostForm.js' */            },

/*Line 81 - 'AtomAutoPostForm.js' */            onSuccess: function (p) {

/*Line 83 - 'AtomAutoPostForm.js' */                baseType.onSuccess.apply(this, arguments);

/*Line 85 - 'AtomAutoPostForm.js' */                this._isBusy = false;
/*Line 86 - 'AtomAutoPostForm.js' */                AtomBinder.refreshValue(this, "isBusy");
/*Line 87 - 'AtomAutoPostForm.js' */            },

/*Line 89 - 'AtomAutoPostForm.js' */            onKeyUp: function (e) {

/*Line 91 - 'AtomAutoPostForm.js' */                this.pushPost();

/*Line 93 - 'AtomAutoPostForm.js' */                if (e.target && e.target.nodeName && /textarea/gi.test(e.target.nodeName))
/*Line 94 - 'AtomAutoPostForm.js' */                    return;
/*Line 95 - 'AtomAutoPostForm.js' */                if (e.keyCode == 13) {
/*Line 96 - 'AtomAutoPostForm.js' */                    this.onSubmit();
/*Line 97 - 'AtomAutoPostForm.js' */                }
/*Line 98 - 'AtomAutoPostForm.js' */            },

/*Line 100 - 'AtomAutoPostForm.js' */            initialize: function () {
/*Line 101 - 'AtomAutoPostForm.js' */                baseType.initialize.call(this);

/*Line 103 - 'AtomAutoPostForm.js' */                var _this = this;
/*Line 104 - 'AtomAutoPostForm.js' */                this.pushPostHandler = function () {
/*Line 105 - 'AtomAutoPostForm.js' */                    _this.pushPost(1000);
/*Line 106 - 'AtomAutoPostForm.js' */                };
/*Line 107 - 'AtomAutoPostForm.js' */                this.bindEvent(this._element, 'click', this.pushPostHandler);

/*Line 109 - 'AtomAutoPostForm.js' */                $(this._element).find('input,select,textarea').bind('change', null, this.pushPostHandler)
/*Line 110 - 'AtomAutoPostForm.js' */            }
/*Line 111 - 'AtomAutoPostForm.js' */        }
/*Line 112 - 'AtomAutoPostForm.js' */    });
/*Line 113 - 'AtomAutoPostForm.js' */})(window, WebAtoms.AtomForm.prototype);


/*Line 0 - 'AtomDataGrid.js' *////// <reference path="../controls/AtomListBox.js" />

/*Line 2 - 'AtomDataGrid.js' *///WebAtoms.AtomDataGridColumn = function (e) {
/*Line 3 - 'AtomDataGrid.js' *///    WebAtoms.AtomDataGridColumn.initializeBase(this, arguments);
/*Line 4 - 'AtomDataGrid.js' *///};

/*Line 6 - 'AtomDataGrid.js' *///WebAtoms.AtomDataGridColumn.prototype = {

/*Line 8 - 'AtomDataGrid.js' *///};

/*Line 10 - 'AtomDataGrid.js' *///WebAtoms.AtomDataGridColumn.registerClass("WebAtoms.AtomDataGridColumn", WebAtoms.AtomControl);

/*Line 12 - 'AtomDataGrid.js' *///WebAtoms.AtomDataGrid = function (e) {
/*Line 13 - 'AtomDataGrid.js' *///    WebAtoms.AtomDataGrid.initializeBase(this, arguments);

/*Line 15 - 'AtomDataGrid.js' *///};

/*Line 17 - 'AtomDataGrid.js' *///WebAtoms.AtomDataGrid.prototype = {



/*Line 21 - 'AtomDataGrid.js' *///};

/*Line 23 - 'AtomDataGrid.js' *///WebAtoms.AtomDataGrid.registerClass("WebAtoms.DataGrid", WebAtoms.AtomListBox);
/*Line 0 - 'AtomFormField.js' */

/*Line 2 - 'AtomFormField.js' */(function (window, baseType) {
/*Line 3 - 'AtomFormField.js' */    return classCreatorEx({
/*Line 4 - 'AtomFormField.js' */        name: "WebAtoms.AtomFormField",
/*Line 5 - 'AtomFormField.js' */        base: baseType,
/*Line 6 - 'AtomFormField.js' */        start: function () {
/*Line 7 - 'AtomFormField.js' */            this._presenters = ["contentPresenter"];
/*Line 8 - 'AtomFormField.js' */        },
/*Line 9 - 'AtomFormField.js' */        properties: {
/*Line 10 - 'AtomFormField.js' */            error: undefined,
/*Line 11 - 'AtomFormField.js' */            dataType: null,
/*Line 12 - 'AtomFormField.js' */            label: undefined,
/*Line 13 - 'AtomFormField.js' */            fieldClass: undefined,
/*Line 14 - 'AtomFormField.js' */            required: false,
/*Line 15 - 'AtomFormField.js' */            isValid: undefined,
/*Line 16 - 'AtomFormField.js' */            regex: null,
/*Line 17 - 'AtomFormField.js' */            fieldValue: undefined,
/*Line 18 - 'AtomFormField.js' */            field: null,
/*Line 19 - 'AtomFormField.js' */            requiredMessage: "Required",
/*Line 20 - 'AtomFormField.js' */            invalidMessage: "Invalid",
/*Line 21 - 'AtomFormField.js' */            fieldVisible: true,
/*Line 22 - 'AtomFormField.js' */            validate: false,
/*Line 23 - 'AtomFormField.js' */            isValidSet: false
/*Line 24 - 'AtomFormField.js' */        },
/*Line 25 - 'AtomFormField.js' */        methods: {
/*Line 26 - 'AtomFormField.js' */            set_dataType: function (v) {
/*Line 27 - 'AtomFormField.js' */                this._dataType = v;
/*Line 28 - 'AtomFormField.js' */                this.setup();
/*Line 29 - 'AtomFormField.js' */            },

/*Line 31 - 'AtomFormField.js' */            set_fieldValue: function (v) {
/*Line 32 - 'AtomFormField.js' */                this._fieldValue = v;
/*Line 33 - 'AtomFormField.js' */                if (!this._validate)
/*Line 34 - 'AtomFormField.js' */                    return;
/*Line 35 - 'AtomFormField.js' */                this.validate();
/*Line 36 - 'AtomFormField.js' */            },
/*Line 37 - 'AtomFormField.js' */            set_isValid: function (v) {
/*Line 38 - 'AtomFormField.js' */                this._isValid = v;
/*Line 39 - 'AtomFormField.js' */                this._isValidSet = true;
/*Line 40 - 'AtomFormField.js' */                if (!this._validate)
/*Line 41 - 'AtomFormField.js' */                    return;
/*Line 42 - 'AtomFormField.js' */                this.validate();
/*Line 43 - 'AtomFormField.js' */            },
/*Line 44 - 'AtomFormField.js' */            set_regex: function (v) {
/*Line 45 - 'AtomFormField.js' */                this._regex = v;
/*Line 46 - 'AtomFormField.js' */                this.setup();
/*Line 47 - 'AtomFormField.js' */            },
/*Line 48 - 'AtomFormField.js' */            set_required: function (v) {
/*Line 49 - 'AtomFormField.js' */                this._required = v;
/*Line 50 - 'AtomFormField.js' */                this.setup();
/*Line 51 - 'AtomFormField.js' */            },
/*Line 52 - 'AtomFormField.js' */            validateChildren: function (e) {
/*Line 53 - 'AtomFormField.js' */                var ae = new ChildEnumerator(e);
/*Line 54 - 'AtomFormField.js' */                while (ae.next()) {
/*Line 55 - 'AtomFormField.js' */                    var child = ae.current();

/*Line 57 - 'AtomFormField.js' */                    if (child.atomControl) {
/*Line 58 - 'AtomFormField.js' */                        this.validateValue(AtomBinder.getValue(child.atomControl, "value"));
/*Line 59 - 'AtomFormField.js' */                    } else {
/*Line 60 - 'AtomFormField.js' */                        if (/input|select|textarea/gi.test(child.nodeName)) {
/*Line 61 - 'AtomFormField.js' */                            this.validateValue($(child).val());
/*Line 62 - 'AtomFormField.js' */                        } else {
/*Line 63 - 'AtomFormField.js' */                            this.validateChildren(child);
/*Line 64 - 'AtomFormField.js' */                        }
/*Line 65 - 'AtomFormField.js' */                    }
/*Line 66 - 'AtomFormField.js' */                }
/*Line 67 - 'AtomFormField.js' */            },
/*Line 68 - 'AtomFormField.js' */            validateValue: function (v) {
/*Line 69 - 'AtomFormField.js' */                if (this._required) {
/*Line 70 - 'AtomFormField.js' */                    if (!v) {
/*Line 71 - 'AtomFormField.js' */                        AtomBinder.setValue(this, "error", this._requiredMessage);
/*Line 72 - 'AtomFormField.js' */                        this._isValid = false;
/*Line 73 - 'AtomFormField.js' */                        return;
/*Line 74 - 'AtomFormField.js' */                    }
/*Line 75 - 'AtomFormField.js' */                } else {
/*Line 76 - 'AtomFormField.js' */                    // if value is not required
/*Line 77 - 'AtomFormField.js' */                    // and if value is empty
/*Line 78 - 'AtomFormField.js' */                    // it is a valid value
/*Line 79 - 'AtomFormField.js' */                    if (!v) {
/*Line 80 - 'AtomFormField.js' */                        this._isValid = true;
/*Line 81 - 'AtomFormField.js' */                        return;
/*Line 82 - 'AtomFormField.js' */                    }
/*Line 83 - 'AtomFormField.js' */                }

/*Line 85 - 'AtomFormField.js' */                var re = null;

/*Line 87 - 'AtomFormField.js' */                if (/email/gi.test(this._dataType)) {
/*Line 88 - 'AtomFormField.js' */                    re = /^(([^<>()\[\]\\.,;:\s@\"]+(\.[^<>()\[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
/*Line 89 - 'AtomFormField.js' */                } else {
/*Line 90 - 'AtomFormField.js' */                    if (this._regex) {
/*Line 91 - 'AtomFormField.js' */                        re = eval("(" + this._regex + ")");
/*Line 92 - 'AtomFormField.js' */                    }
/*Line 93 - 'AtomFormField.js' */                }

/*Line 95 - 'AtomFormField.js' */                if (re) {
/*Line 96 - 'AtomFormField.js' */                    if (!re.test(v)) {
/*Line 97 - 'AtomFormField.js' */                        AtomBinder.setValue(this, "error", this._invalidMessage);
/*Line 98 - 'AtomFormField.js' */                        this._isValid = false;
/*Line 99 - 'AtomFormField.js' */                        return;
/*Line 100 - 'AtomFormField.js' */                    }
/*Line 101 - 'AtomFormField.js' */                }
/*Line 102 - 'AtomFormField.js' */            },
/*Line 103 - 'AtomFormField.js' */            validate: function () {
/*Line 104 - 'AtomFormField.js' */                this._validate = true;
/*Line 105 - 'AtomFormField.js' */                if (!(this._required || this._regex || this._dataType))
/*Line 106 - 'AtomFormField.js' */                    return this._isValid === undefined ? true : this._isValid;



/*Line 110 - 'AtomFormField.js' */                if (this._isValid) {
/*Line 111 - 'AtomFormField.js' */                    AtomBinder.setValue(this, "error", "");
/*Line 112 - 'AtomFormField.js' */                    if (this._isValidSet) {
/*Line 113 - 'AtomFormField.js' */                        return true;
/*Line 114 - 'AtomFormField.js' */                    }
/*Line 115 - 'AtomFormField.js' */                }

/*Line 117 - 'AtomFormField.js' */                this._isValid = true;

/*Line 119 - 'AtomFormField.js' */                if (this._fieldValue !== undefined) {
/*Line 120 - 'AtomFormField.js' */                    this.validateValue(this._fieldValue);
/*Line 121 - 'AtomFormField.js' */                } else {
/*Line 122 - 'AtomFormField.js' */                    // check validity..
/*Line 123 - 'AtomFormField.js' */                    this.validateChildren(this._element);
/*Line 124 - 'AtomFormField.js' */                }
/*Line 125 - 'AtomFormField.js' */                if (this._isValid) {
/*Line 126 - 'AtomFormField.js' */                    AtomBinder.setValue(this, "error", "");
/*Line 127 - 'AtomFormField.js' */                }
/*Line 128 - 'AtomFormField.js' */                return this._isValid;
/*Line 129 - 'AtomFormField.js' */            },
/*Line 130 - 'AtomFormField.js' */            onCreationComplete: function () {
/*Line 131 - 'AtomFormField.js' */                this.setup();
/*Line 132 - 'AtomFormField.js' */            },
/*Line 133 - 'AtomFormField.js' */            onFocusOut: function () {
/*Line 134 - 'AtomFormField.js' */                this._validate = true;
/*Line 135 - 'AtomFormField.js' */                this.validate();
/*Line 136 - 'AtomFormField.js' */            },
/*Line 137 - 'AtomFormField.js' */            setup: function () {
/*Line 138 - 'AtomFormField.js' */                if (!this._created)
/*Line 139 - 'AtomFormField.js' */                    return;

/*Line 141 - 'AtomFormField.js' */                // find two way bindings...
/*Line 142 - 'AtomFormField.js' */                var e = this._element;

/*Line 144 - 'AtomFormField.js' */                if (this._contentPresenter) {
/*Line 145 - 'AtomFormField.js' */                    this._contentPresenter.appendChild(this._element.contentElement);
/*Line 146 - 'AtomFormField.js' */                }

/*Line 148 - 'AtomFormField.js' */                var ae = new AtomEnumerator($(e).find("input,select,textarea"));
/*Line 149 - 'AtomFormField.js' */                while (ae.next()) {
/*Line 150 - 'AtomFormField.js' */                    var item = ae.current();
/*Line 151 - 'AtomFormField.js' */                    this.bindEvent(item, "blur", "onFocusOut");
/*Line 152 - 'AtomFormField.js' */                    this.bindEvent(item, "change", "onFocusOut");
/*Line 153 - 'AtomFormField.js' */                }

/*Line 155 - 'AtomFormField.js' */                AtomBinder.refreshValue(this, "fieldClass");
/*Line 156 - 'AtomFormField.js' */            }
/*Line 157 - 'AtomFormField.js' */        }
/*Line 158 - 'AtomFormField.js' */    });
/*Line 159 - 'AtomFormField.js' */})(window, WebAtoms.AtomControl.prototype);
/*Line 0 - 'AtomFormGrid.js' */

/*Line 2 - 'AtomFormGrid.js' */// http://jsfiddle.net/2yqQF/

/*Line 4 - 'AtomFormGrid.js' */(function (window, baseType) {
/*Line 5 - 'AtomFormGrid.js' */    return classCreatorEx({
/*Line 6 - 'AtomFormGrid.js' */        name: "WebAtoms.AtomFormGridLayout",
/*Line 7 - 'AtomFormGrid.js' */        base: baseType,
/*Line 8 - 'AtomFormGrid.js' */        start: function () { },
/*Line 9 - 'AtomFormGrid.js' */        properties: {
/*Line 10 - 'AtomFormGrid.js' */            minLabelWidth: 100,
/*Line 11 - 'AtomFormGrid.js' */            cellSpacing: 5,
/*Line 12 - 'AtomFormGrid.js' */            label: ""
/*Line 13 - 'AtomFormGrid.js' */        },
/*Line 14 - 'AtomFormGrid.js' */        methods: {
/*Line 15 - 'AtomFormGrid.js' */            onUpdateUI: function () {
/*Line 16 - 'AtomFormGrid.js' */                AtomBinder.refreshValue(this, "controlWidth");
/*Line 17 - 'AtomFormGrid.js' */                AtomBinder.refreshValue(this, "controlHeight");
/*Line 18 - 'AtomFormGrid.js' */                baseType.onUpdateUI.apply(this, arguments);
/*Line 19 - 'AtomFormGrid.js' */            },

/*Line 21 - 'AtomFormGrid.js' */            get_controlWidth: function () {
/*Line 22 - 'AtomFormGrid.js' */                return $(this._element.parentNode).innerWidth();
/*Line 23 - 'AtomFormGrid.js' */            },

/*Line 25 - 'AtomFormGrid.js' */            get_controlHeight: function () {
/*Line 26 - 'AtomFormGrid.js' */                return $(this._element.parentNode).innerHeight();
/*Line 27 - 'AtomFormGrid.js' */            },

/*Line 29 - 'AtomFormGrid.js' */            createChildren: function () {
/*Line 30 - 'AtomFormGrid.js' */                var element = this._element;
/*Line 31 - 'AtomFormGrid.js' */                $(element).addClass("atom-form-grid");

/*Line 33 - 'AtomFormGrid.js' */                var children = $(element).children();

/*Line 35 - 'AtomFormGrid.js' */                var ae = new AtomEnumerator(children);

/*Line 37 - 'AtomFormGrid.js' */                AtomUI.removeAllChildren(element);

/*Line 39 - 'AtomFormGrid.js' */                var container = document.createElement("DIV");
/*Line 40 - 'AtomFormGrid.js' */                //container.setAttribute("style-width", "[$owner.controlWidth]");
/*Line 41 - 'AtomFormGrid.js' */                $(container).addClass("atom-form-grid-container");

/*Line 43 - 'AtomFormGrid.js' */                element.appendChild(container);

/*Line 45 - 'AtomFormGrid.js' */                var minLabelWidth = $(this._element).attr("atom-min-label-width");

/*Line 47 - 'AtomFormGrid.js' */                this.getTemplate("fieldTemplate");

/*Line 49 - 'AtomFormGrid.js' */                while (ae.next()) {
/*Line 50 - 'AtomFormGrid.js' */                    var item = ae.current();

/*Line 52 - 'AtomFormGrid.js' */                    var at = AtomUI.attributeMap(item, /^(atom\-type)$/gi)["atom-type"];
/*Line 53 - 'AtomFormGrid.js' */                    if (at && at.value == "AtomFormRow") {
/*Line 54 - 'AtomFormGrid.js' */                        var table = document.createElement("TABLE");
/*Line 55 - 'AtomFormGrid.js' */                        container.appendChild(table);
/*Line 56 - 'AtomFormGrid.js' */                        $(table).addClass("atom-form-grid-row");
/*Line 57 - 'AtomFormGrid.js' */                        var tbody = document.createElement("TBODY");
/*Line 58 - 'AtomFormGrid.js' */                        table.appendChild(tbody);

/*Line 60 - 'AtomFormGrid.js' */                        var tr = document.createElement("TR");
/*Line 61 - 'AtomFormGrid.js' */                        tbody.appendChild(tr);

/*Line 63 - 'AtomFormGrid.js' */                        var children = $(item).children();
/*Line 64 - 'AtomFormGrid.js' */                        var ce = new AtomEnumerator(children);
/*Line 65 - 'AtomFormGrid.js' */                        while (ce.next()) {
/*Line 66 - 'AtomFormGrid.js' */                            var td = document.createElement("TD");
/*Line 67 - 'AtomFormGrid.js' */                            tr.appendChild(td);
/*Line 68 - 'AtomFormGrid.js' */                            this.createField(td, ce.current());
/*Line 69 - 'AtomFormGrid.js' */                        }

/*Line 71 - 'AtomFormGrid.js' */                        continue;
/*Line 72 - 'AtomFormGrid.js' */                    }
/*Line 73 - 'AtomFormGrid.js' */                    if (at && (at.value == "AtomFormTabControl" || at.value == "AtomTabControl")) {


/*Line 76 - 'AtomFormGrid.js' */                        var tabBar = document.createElement("DIV");
/*Line 77 - 'AtomFormGrid.js' */                        tabBar.setAttribute("atom-type", "AtomToggleButtonBar");
/*Line 78 - 'AtomFormGrid.js' */                        var tabBarID = AtomUI.assignID(tabBar);
/*Line 79 - 'AtomFormGrid.js' */                        tabBar.setAttribute("atom-name", tabBarID);
/*Line 80 - 'AtomFormGrid.js' */                        tabBar.setAttribute("atom-show-tabs", "true");
/*Line 81 - 'AtomFormGrid.js' */                        var te = document.createElement("SPAN");
/*Line 82 - 'AtomFormGrid.js' */                        tabBar.appendChild(te);
/*Line 83 - 'AtomFormGrid.js' */                        te.setAttribute("atom-text", "{$data.label}");
/*Line 84 - 'AtomFormGrid.js' */                        te.setAttribute("atom-template", "itemTemplate");
/*Line 85 - 'AtomFormGrid.js' */                        //td.appendChild(tabBar);
/*Line 86 - 'AtomFormGrid.js' */                        this.createField(container, tabBar);

/*Line 88 - 'AtomFormGrid.js' */                        var tbc = allControls[tabBarID];

/*Line 90 - 'AtomFormGrid.js' */                        var ce = new ChildEnumerator(item);
/*Line 91 - 'AtomFormGrid.js' */                        var list = [];
/*Line 92 - 'AtomFormGrid.js' */                        var index = 0;
/*Line 93 - 'AtomFormGrid.js' */                        while (ce.next()) {
/*Line 94 - 'AtomFormGrid.js' */                            var child = ce.current();
/*Line 95 - 'AtomFormGrid.js' */                            $(child).remove();
/*Line 96 - 'AtomFormGrid.js' */                            child.setAttribute("style-display", "[$scope." + tabBarID + ".selectedIndex == " + index + " ? '' : 'none']");
/*Line 97 - 'AtomFormGrid.js' */                            var cf = this.createField(container, child);
/*Line 98 - 'AtomFormGrid.js' */                            list.push(cf);
/*Line 99 - 'AtomFormGrid.js' */                            //if (cf.constructor == WebAtoms.AtomFormGridLayout) {

/*Line 101 - 'AtomFormGrid.js' */                            //}
/*Line 102 - 'AtomFormGrid.js' */                            index++;
/*Line 103 - 'AtomFormGrid.js' */                        }

/*Line 105 - 'AtomFormGrid.js' */                        tbc.set_items(list);
/*Line 106 - 'AtomFormGrid.js' */                        continue;
/*Line 107 - 'AtomFormGrid.js' */                    }
/*Line 108 - 'AtomFormGrid.js' */                    this.createField(container, item);

/*Line 110 - 'AtomFormGrid.js' */                }

/*Line 112 - 'AtomFormGrid.js' */            }
/*Line 113 - 'AtomFormGrid.js' */        }
/*Line 114 - 'AtomFormGrid.js' */    });
/*Line 115 - 'AtomFormGrid.js' */})(window, WebAtoms.AtomFormLayout.prototype);


/*Line 118 - 'AtomFormGrid.js' */(function (baseType) {
/*Line 119 - 'AtomFormGrid.js' */    return classCreatorEx({
/*Line 120 - 'AtomFormGrid.js' */        name: "WebAtoms.AtomFormTab",
/*Line 121 - 'AtomFormGrid.js' */        base: baseType,
/*Line 122 - 'AtomFormGrid.js' */        start: function () {
/*Line 123 - 'AtomFormGrid.js' */        },
/*Line 124 - 'AtomFormGrid.js' */        methods: {

/*Line 126 - 'AtomFormGrid.js' */        }
/*Line 127 - 'AtomFormGrid.js' */    });
/*Line 128 - 'AtomFormGrid.js' */})(WebAtoms.AtomFormGridLayout.prototype);
/*Line 0 - 'AtomFormNoLayout.js' */

/*Line 2 - 'AtomFormNoLayout.js' */(function (baseType) {
/*Line 3 - 'AtomFormNoLayout.js' */    return classCreatorEx({
/*Line 4 - 'AtomFormNoLayout.js' */        name: "WebAtoms.AtomFormNoLayout",
/*Line 5 - 'AtomFormNoLayout.js' */        base: baseType,
/*Line 6 - 'AtomFormNoLayout.js' */        start: function () { },
/*Line 7 - 'AtomFormNoLayout.js' */        methods: {

/*Line 9 - 'AtomFormNoLayout.js' */        }
/*Line 10 - 'AtomFormNoLayout.js' */    });
/*Line 11 - 'AtomFormNoLayout.js' */})(WebAtoms.AtomForm.prototype);

/*Line 0 - 'AtomFormVerticalLayout.js' */

/*Line 2 - 'AtomFormVerticalLayout.js' */(function (baseType) {
/*Line 3 - 'AtomFormVerticalLayout.js' */    return classCreatorEx({
/*Line 4 - 'AtomFormVerticalLayout.js' */        name: "WebAtoms.AtomFormVerticalLayout",
/*Line 5 - 'AtomFormVerticalLayout.js' */        base: baseType,
/*Line 6 - 'AtomFormVerticalLayout.js' */        start: function () { },
/*Line 7 - 'AtomFormVerticalLayout.js' */        methods: {}
/*Line 8 - 'AtomFormVerticalLayout.js' */    });
/*Line 9 - 'AtomFormVerticalLayout.js' */})(WebAtoms.AtomFormLayout.prototype);

/*Line 0 - 'AtomTableLayout.js' */

/*Line 2 - 'AtomTableLayout.js' */(function (baseType) {
/*Line 3 - 'AtomTableLayout.js' */    return classCreatorEx({
/*Line 4 - 'AtomTableLayout.js' */        name: "WebAtoms.AtomTableLayout",
/*Line 5 - 'AtomTableLayout.js' */        base: baseType,
/*Line 6 - 'AtomTableLayout.js' */        start: function (columns, cellWidth, cellHeight) {
/*Line 7 - 'AtomTableLayout.js' */            this._cellWidth = cellWidth;
/*Line 8 - 'AtomTableLayout.js' */            this._cellHeight = cellHeight;
/*Line 9 - 'AtomTableLayout.js' */            this._columns = columns;
/*Line 10 - 'AtomTableLayout.js' */        },
/*Line 11 - 'AtomTableLayout.js' */        methods: {
/*Line 12 - 'AtomTableLayout.js' */            doLayout: function (element) {
/*Line 13 - 'AtomTableLayout.js' */                var ae = new AtomEnumerator($(element).children());
/*Line 14 - 'AtomTableLayout.js' */                var item;

/*Line 16 - 'AtomTableLayout.js' */                var left = 0;
/*Line 17 - 'AtomTableLayout.js' */                var top = 0;

/*Line 19 - 'AtomTableLayout.js' */                var maxRows = Math.ceil(ae._array.length / this._columns) - 1;
/*Line 20 - 'AtomTableLayout.js' */                var rows = maxRows;

/*Line 22 - 'AtomTableLayout.js' */                var width = this._columns * this._cellWidth;
/*Line 23 - 'AtomTableLayout.js' */                var height = this._cellHeight * (maxRows + 1);

/*Line 25 - 'AtomTableLayout.js' */                element.style.position = "relative";
/*Line 26 - 'AtomTableLayout.js' */                element.style.width = width + "px";
/*Line 27 - 'AtomTableLayout.js' */                element.style.height = height + "px";

/*Line 29 - 'AtomTableLayout.js' */                element.maxRows = maxRows;

/*Line 31 - 'AtomTableLayout.js' */                while (ae.next()) {
/*Line 32 - 'AtomTableLayout.js' */                    item = ae.current();

/*Line 34 - 'AtomTableLayout.js' */                    item.style.position = "absolute";
/*Line 35 - 'AtomTableLayout.js' */                    item.style.left = left + "px";
/*Line 36 - 'AtomTableLayout.js' */                    item.style.top = top + "px";

/*Line 38 - 'AtomTableLayout.js' */                    item.style.width = this._cellWidth + "px";

/*Line 40 - 'AtomTableLayout.js' */                    if (rows <= 0) {
/*Line 41 - 'AtomTableLayout.js' */                        rows = maxRows;
/*Line 42 - 'AtomTableLayout.js' */                        left += this._cellWidth + 10;
/*Line 43 - 'AtomTableLayout.js' */                        top = 0;
/*Line 44 - 'AtomTableLayout.js' */                    } else {
/*Line 45 - 'AtomTableLayout.js' */                        rows--;
/*Line 46 - 'AtomTableLayout.js' */                        top += this._cellHeight;
/*Line 47 - 'AtomTableLayout.js' */                    }
/*Line 48 - 'AtomTableLayout.js' */                }
/*Line 49 - 'AtomTableLayout.js' */            }
/*Line 50 - 'AtomTableLayout.js' */        }
/*Line 51 - 'AtomTableLayout.js' */    });
/*Line 52 - 'AtomTableLayout.js' */})(WebAtoms.AtomLayout.prototype);
/*Line 0 - 'AtomViewBoxLayout.js' */

/*Line 2 - 'AtomViewBoxLayout.js' */var AtomViewBoxLayout = (function (baseType) {
/*Line 3 - 'AtomViewBoxLayout.js' */    return classCreatorEx({
/*Line 4 - 'AtomViewBoxLayout.js' */        name: "WebAtoms.AtomViewBoxLayout",
/*Line 5 - 'AtomViewBoxLayout.js' */        base: baseType,
/*Line 6 - 'AtomViewBoxLayout.js' */        start: function () { },
/*Line 7 - 'AtomViewBoxLayout.js' */        methods: {
/*Line 8 - 'AtomViewBoxLayout.js' */            doLayout: function (element) {
/*Line 9 - 'AtomViewBoxLayout.js' */                var style = { width: $(element).innerWidth() + 'px', height: $(element).innerHeight() + 'px' };
/*Line 10 - 'AtomViewBoxLayout.js' */                var ae = new ChildEnumerator(element);
/*Line 11 - 'AtomViewBoxLayout.js' */                var item;
/*Line 12 - 'AtomViewBoxLayout.js' */                while (ae.next()) {
/*Line 13 - 'AtomViewBoxLayout.js' */                    item = ae.current();
/*Line 14 - 'AtomViewBoxLayout.js' */                    item.style.width = style.width;
/*Line 15 - 'AtomViewBoxLayout.js' */                    item.style.height = style.height;
/*Line 16 - 'AtomViewBoxLayout.js' */                    if (item.atomControl) {
/*Line 17 - 'AtomViewBoxLayout.js' */                        item.atomControl.updateUI();
/*Line 18 - 'AtomViewBoxLayout.js' */                    }
/*Line 19 - 'AtomViewBoxLayout.js' */                }
/*Line 20 - 'AtomViewBoxLayout.js' */            }
/*Line 21 - 'AtomViewBoxLayout.js' */        }
/*Line 22 - 'AtomViewBoxLayout.js' */    });
/*Line 23 - 'AtomViewBoxLayout.js' */})(WebAtoms.AtomLayout.prototype);

/*Line 25 - 'AtomViewBoxLayout.js' */AtomViewBoxLayout.defaultInstnace = new AtomViewBoxLayout();
/*Line 0 - 'AtomPhotoPlayer.js' */

/*Line 2 - 'AtomPhotoPlayer.js' */(function (baseType) {
/*Line 3 - 'AtomPhotoPlayer.js' */    return classCreatorEx({
/*Line 4 - 'AtomPhotoPlayer.js' */        name: "WebAtoms.AtomPhotoPlayer",
/*Line 5 - 'AtomPhotoPlayer.js' */        base: baseType,
/*Line 6 - 'AtomPhotoPlayer.js' */        start: function () {
/*Line 7 - 'AtomPhotoPlayer.js' */            this._img = null;
/*Line 8 - 'AtomPhotoPlayer.js' */            this._presenters = ["img", "loading"];
/*Line 9 - 'AtomPhotoPlayer.js' */        },
/*Line 10 - 'AtomPhotoPlayer.js' */        methods: {
/*Line 11 - 'AtomPhotoPlayer.js' */            get_width: function () {
/*Line 12 - 'AtomPhotoPlayer.js' */                return $(this._element).width();
/*Line 13 - 'AtomPhotoPlayer.js' */            },
/*Line 14 - 'AtomPhotoPlayer.js' */            get_height: function () {
/*Line 15 - 'AtomPhotoPlayer.js' */                return $(this._element).height();
/*Line 16 - 'AtomPhotoPlayer.js' */            },
/*Line 17 - 'AtomPhotoPlayer.js' */            play: function (url) {

/*Line 19 - 'AtomPhotoPlayer.js' */                // clear the image...
/*Line 20 - 'AtomPhotoPlayer.js' */                this._img.src = "";
/*Line 21 - 'AtomPhotoPlayer.js' */                if (url) {
/*Line 22 - 'AtomPhotoPlayer.js' */                    this._img.src = url;
/*Line 23 - 'AtomPhotoPlayer.js' */                }
/*Line 24 - 'AtomPhotoPlayer.js' */                $(this._img).hide();
/*Line 25 - 'AtomPhotoPlayer.js' */                if (url) {
/*Line 26 - 'AtomPhotoPlayer.js' */                    $(this._loading).show();
/*Line 27 - 'AtomPhotoPlayer.js' */                } else {
/*Line 28 - 'AtomPhotoPlayer.js' */                    $(this._loading).hide();
/*Line 29 - 'AtomPhotoPlayer.js' */                }

/*Line 31 - 'AtomPhotoPlayer.js' */                AtomBinder.refreshValue(this, "width");
/*Line 32 - 'AtomPhotoPlayer.js' */                AtomBinder.refreshValue(this, "height");
/*Line 33 - 'AtomPhotoPlayer.js' */            },
/*Line 34 - 'AtomPhotoPlayer.js' */            stop: function () {
/*Line 35 - 'AtomPhotoPlayer.js' */            },
/*Line 36 - 'AtomPhotoPlayer.js' */            onImgLoaded: function () {
/*Line 37 - 'AtomPhotoPlayer.js' */                $(this._img).show();
/*Line 38 - 'AtomPhotoPlayer.js' */                $(this._loading).hide();
/*Line 39 - 'AtomPhotoPlayer.js' */            },
/*Line 40 - 'AtomPhotoPlayer.js' */            //onImgProgress: function (e) {
/*Line 41 - 'AtomPhotoPlayer.js' */            //    if (e.lengthComputable) {
/*Line 42 - 'AtomPhotoPlayer.js' */            //        var val = e.loaded / e.total * 100;
/*Line 43 - 'AtomPhotoPlayer.js' */            //        $(this._loading).text("loading.. (" + val + "%)");
/*Line 44 - 'AtomPhotoPlayer.js' */            //    }
/*Line 45 - 'AtomPhotoPlayer.js' */            //},
/*Line 46 - 'AtomPhotoPlayer.js' */            initialize: function () {
/*Line 47 - 'AtomPhotoPlayer.js' */                var element = this.get_element();
/*Line 48 - 'AtomPhotoPlayer.js' */                element.style.textAlign = "center";
/*Line 49 - 'AtomPhotoPlayer.js' */                baseType.initialize.call(this);

/*Line 51 - 'AtomPhotoPlayer.js' */                this.bindEvent(this._img, "load", "onImgLoaded");
/*Line 52 - 'AtomPhotoPlayer.js' */                this.bindEvent(this._img, "error", "onImgLoaded");
/*Line 53 - 'AtomPhotoPlayer.js' */                //this.bindEvent(img, "progress", "onImgProgress");
/*Line 54 - 'AtomPhotoPlayer.js' */            }
/*Line 55 - 'AtomPhotoPlayer.js' */        }
/*Line 56 - 'AtomPhotoPlayer.js' */    });
/*Line 57 - 'AtomPhotoPlayer.js' */})(WebAtoms.AtomPlayer.prototype);
/*Line 0 - 'AtomVideoPlayer.js' */

/*Line 2 - 'AtomVideoPlayer.js' */(function (baseType) {
/*Line 3 - 'AtomVideoPlayer.js' */    return classCreatorEx({
/*Line 4 - 'AtomVideoPlayer.js' */        name: "WebAtoms.AtomVideoPlayer",
/*Line 5 - 'AtomVideoPlayer.js' */        base: baseType,
/*Line 6 - 'AtomVideoPlayer.js' */        start: function () {
/*Line 7 - 'AtomVideoPlayer.js' */            this._isFlash = false;
/*Line 8 - 'AtomVideoPlayer.js' */            this._fpID = null;
/*Line 9 - 'AtomVideoPlayer.js' */            this._divID = null;
/*Line 10 - 'AtomVideoPlayer.js' */            this._playerReady = false;
/*Line 11 - 'AtomVideoPlayer.js' */            this._timeoutCallback = null;
/*Line 12 - 'AtomVideoPlayer.js' */            this._playerID = null;
/*Line 13 - 'AtomVideoPlayer.js' */            this._srcID = null;
/*Line 14 - 'AtomVideoPlayer.js' */            this._video = null;
/*Line 15 - 'AtomVideoPlayer.js' */            this._src = null;
/*Line 16 - 'AtomVideoPlayer.js' */            this._errorHandler = null;
/*Line 17 - 'AtomVideoPlayer.js' */            this._autoCreate = false;
/*Line 18 - 'AtomVideoPlayer.js' */            this._playerCreated = false;
/*Line 19 - 'AtomVideoPlayer.js' */        },
/*Line 20 - 'AtomVideoPlayer.js' */        properties: {
/*Line 21 - 'AtomVideoPlayer.js' */            swfPath: "/content/player.swf",
/*Line 22 - 'AtomVideoPlayer.js' */            autoPlay: true,
/*Line 23 - 'AtomVideoPlayer.js' */            poster: null,
/*Line 24 - 'AtomVideoPlayer.js' */            autoCreate: false
/*Line 25 - 'AtomVideoPlayer.js' */        },
/*Line 26 - 'AtomVideoPlayer.js' */        methods: {
/*Line 27 - 'AtomVideoPlayer.js' */            set_poster: function (v) {
/*Line 28 - 'AtomVideoPlayer.js' */                this._poster = v;
/*Line 29 - 'AtomVideoPlayer.js' */                if (this._isFlash) {
/*Line 30 - 'AtomVideoPlayer.js' */                    jwplayer(this._divID).load({ image: v });
/*Line 31 - 'AtomVideoPlayer.js' */                }
/*Line 32 - 'AtomVideoPlayer.js' */                else {
/*Line 33 - 'AtomVideoPlayer.js' */                    if (this._video) {
/*Line 34 - 'AtomVideoPlayer.js' */                        $(this._video).attr("poster", this._poster);
/*Line 35 - 'AtomVideoPlayer.js' */                    }
/*Line 36 - 'AtomVideoPlayer.js' */                }
/*Line 37 - 'AtomVideoPlayer.js' */            },

/*Line 39 - 'AtomVideoPlayer.js' */            onError: function () {
/*Line 40 - 'AtomVideoPlayer.js' */                alert("something went wrong with video");
/*Line 41 - 'AtomVideoPlayer.js' */            },

/*Line 43 - 'AtomVideoPlayer.js' */            get_player: function (appName) {
/*Line 44 - 'AtomVideoPlayer.js' */                if (navigator.appName.indexOf("Microsoft") != -1) {
/*Line 45 - 'AtomVideoPlayer.js' */                    return window[appName];
/*Line 46 - 'AtomVideoPlayer.js' */                } else {
/*Line 47 - 'AtomVideoPlayer.js' */                    return document[appName];
/*Line 48 - 'AtomVideoPlayer.js' */                }
/*Line 49 - 'AtomVideoPlayer.js' */            },

/*Line 51 - 'AtomVideoPlayer.js' */            playerUpdated: function () {
/*Line 52 - 'AtomVideoPlayer.js' */                this._playerReady = true;
/*Line 53 - 'AtomVideoPlayer.js' */            },

/*Line 55 - 'AtomVideoPlayer.js' */            playIfQueued: function () {
/*Line 56 - 'AtomVideoPlayer.js' */                if (this._queuePlay) {
/*Line 57 - 'AtomVideoPlayer.js' */                    this.play(this._url);
/*Line 58 - 'AtomVideoPlayer.js' */                }
/*Line 59 - 'AtomVideoPlayer.js' */            },

/*Line 61 - 'AtomVideoPlayer.js' */            onUpdateUI: function () {
/*Line 62 - 'AtomVideoPlayer.js' */                baseType.onUpdateUI.call(this);

/*Line 64 - 'AtomVideoPlayer.js' */                var s = $(this._element).css('visibility');
/*Line 65 - 'AtomVideoPlayer.js' */                if (s == "visible") {
/*Line 66 - 'AtomVideoPlayer.js' */                    this.playIfQueued();
/*Line 67 - 'AtomVideoPlayer.js' */                }
/*Line 68 - 'AtomVideoPlayer.js' */            },

/*Line 70 - 'AtomVideoPlayer.js' */            set_options: function (v) {
/*Line 71 - 'AtomVideoPlayer.js' */                if (!v)
/*Line 72 - 'AtomVideoPlayer.js' */                    return;

/*Line 74 - 'AtomVideoPlayer.js' */                this._poster = v.poster;
/*Line 75 - 'AtomVideoPlayer.js' */                if (v.autoPlay !== undefined) {
/*Line 76 - 'AtomVideoPlayer.js' */                    this._autoPlay = v.autoPlay;
/*Line 77 - 'AtomVideoPlayer.js' */                }
/*Line 78 - 'AtomVideoPlayer.js' */                if (v.url !== undefined) {
/*Line 79 - 'AtomVideoPlayer.js' */                    this._url = v.url;
/*Line 80 - 'AtomVideoPlayer.js' */                    this.play(v.url);
/*Line 81 - 'AtomVideoPlayer.js' */                }
/*Line 82 - 'AtomVideoPlayer.js' */            },
/*Line 83 - 'AtomVideoPlayer.js' */            get_options: function () {
/*Line 84 - 'AtomVideoPlayer.js' */                return {};
/*Line 85 - 'AtomVideoPlayer.js' */            },

/*Line 87 - 'AtomVideoPlayer.js' */            play: function (url) {

/*Line 89 - 'AtomVideoPlayer.js' */                if (!url) {
/*Line 90 - 'AtomVideoPlayer.js' */                    this.stop();
/*Line 91 - 'AtomVideoPlayer.js' */                    return;
/*Line 92 - 'AtomVideoPlayer.js' */                }

/*Line 94 - 'AtomVideoPlayer.js' */                this._url = url;

/*Line 96 - 'AtomVideoPlayer.js' */                var s = $(this._element).css('visibility');
/*Line 97 - 'AtomVideoPlayer.js' */                if (s != "visible") {
/*Line 98 - 'AtomVideoPlayer.js' */                    if (!this._queuePlay) {
/*Line 99 - 'AtomVideoPlayer.js' */                        this._queuePlay = true;
/*Line 100 - 'AtomVideoPlayer.js' */                    }
/*Line 101 - 'AtomVideoPlayer.js' */                    return;
/*Line 102 - 'AtomVideoPlayer.js' */                }

/*Line 104 - 'AtomVideoPlayer.js' */                this._queuePlay = false;


/*Line 107 - 'AtomVideoPlayer.js' */                var element = this.get_element();
/*Line 108 - 'AtomVideoPlayer.js' */                this.create();
/*Line 109 - 'AtomVideoPlayer.js' */                if (this._isFlash) {
/*Line 110 - 'AtomVideoPlayer.js' */                    jwplayer(this._divID).load({ file: url, image: this._poster });
/*Line 111 - 'AtomVideoPlayer.js' */                    if (this._autoPlay) {
/*Line 112 - 'AtomVideoPlayer.js' */                        jwplayer(this._divID).play();
/*Line 113 - 'AtomVideoPlayer.js' */                    }
/*Line 114 - 'AtomVideoPlayer.js' */                    return;
/*Line 115 - 'AtomVideoPlayer.js' */                } else {

/*Line 117 - 'AtomVideoPlayer.js' */                    if (this._video) {
/*Line 118 - 'AtomVideoPlayer.js' */                        $(this._video).remove();
/*Line 119 - 'AtomVideoPlayer.js' */                    }

/*Line 121 - 'AtomVideoPlayer.js' */                    this._video = document.createElement("video");
/*Line 122 - 'AtomVideoPlayer.js' */                    this._playerID = this._divID + "_Video";
/*Line 123 - 'AtomVideoPlayer.js' */                    this._video.id = this._playerID;
/*Line 124 - 'AtomVideoPlayer.js' */                    $(this._video).attr("controls", "controls");
/*Line 125 - 'AtomVideoPlayer.js' */                    this._video.style.width = "100%";
/*Line 126 - 'AtomVideoPlayer.js' */                    this._video.style.height = "100%";
/*Line 127 - 'AtomVideoPlayer.js' */                    this._video.autobuffer = true;
/*Line 128 - 'AtomVideoPlayer.js' */                    this._video.autoplay = true;
/*Line 129 - 'AtomVideoPlayer.js' */                    this._video.allowfullscreen = true;
/*Line 130 - 'AtomVideoPlayer.js' */                    if (this._poster) {
/*Line 131 - 'AtomVideoPlayer.js' */                        $(this._video).attr("poster", this._poster);
/*Line 132 - 'AtomVideoPlayer.js' */                    }
/*Line 133 - 'AtomVideoPlayer.js' */                    var src = document.createElement("source");
/*Line 134 - 'AtomVideoPlayer.js' */                    src.type = "video/mp4";
/*Line 135 - 'AtomVideoPlayer.js' */                    src.src = url;
/*Line 136 - 'AtomVideoPlayer.js' */                    this._video.appendChild(src);
/*Line 137 - 'AtomVideoPlayer.js' */                    $(element).append(this._video);
/*Line 138 - 'AtomVideoPlayer.js' */                    this._video.play();
/*Line 139 - 'AtomVideoPlayer.js' */                }
/*Line 140 - 'AtomVideoPlayer.js' */            },

/*Line 142 - 'AtomVideoPlayer.js' */            stop: function () {
/*Line 143 - 'AtomVideoPlayer.js' */                if (!this._playerCreated)
/*Line 144 - 'AtomVideoPlayer.js' */                    return;
/*Line 145 - 'AtomVideoPlayer.js' */                var element = this.get_element();
/*Line 146 - 'AtomVideoPlayer.js' */                if (this._isFlash) {
/*Line 147 - 'AtomVideoPlayer.js' */                    jwplayer(this._divID).pause(true);
/*Line 148 - 'AtomVideoPlayer.js' */                } else {
/*Line 149 - 'AtomVideoPlayer.js' */                    if (this._video) {
/*Line 150 - 'AtomVideoPlayer.js' */                        this._video.pause();
/*Line 151 - 'AtomVideoPlayer.js' */                    }
/*Line 152 - 'AtomVideoPlayer.js' */                }
/*Line 153 - 'AtomVideoPlayer.js' */            },

/*Line 155 - 'AtomVideoPlayer.js' */            supportsMP4: function () {
/*Line 156 - 'AtomVideoPlayer.js' */                var ua = window.navigator.userAgent.toLowerCase();

/*Line 158 - 'AtomVideoPlayer.js' */                if (/msie 10.0|safari|android|iphone|ipad|ios/gi.test(ua)) {
/*Line 159 - 'AtomVideoPlayer.js' */                    if (/chrome/gi.test(ua) && /mac|windows/gi.test(ua)) {
/*Line 160 - 'AtomVideoPlayer.js' */                        return false;
/*Line 161 - 'AtomVideoPlayer.js' */                    }
/*Line 162 - 'AtomVideoPlayer.js' */                    return true;
/*Line 163 - 'AtomVideoPlayer.js' */                }
/*Line 164 - 'AtomVideoPlayer.js' */                return false;
/*Line 165 - 'AtomVideoPlayer.js' */            },

/*Line 167 - 'AtomVideoPlayer.js' */            create: function () {
/*Line 168 - 'AtomVideoPlayer.js' */                if (this._playerCreated)
/*Line 169 - 'AtomVideoPlayer.js' */                    return;
/*Line 170 - 'AtomVideoPlayer.js' */                this._playerCreated = true;
/*Line 171 - 'AtomVideoPlayer.js' */                var element = this.get_element();
/*Line 172 - 'AtomVideoPlayer.js' */                AtomUI.assignID(element);
/*Line 173 - 'AtomVideoPlayer.js' */                allControls[element.id] = this;


/*Line 176 - 'AtomVideoPlayer.js' */                this._divID = element.id + "_Player";


/*Line 179 - 'AtomVideoPlayer.js' */                if (!this.supportsMP4()) {

/*Line 181 - 'AtomVideoPlayer.js' */                    var childDiv = document.createElement("div");
/*Line 182 - 'AtomVideoPlayer.js' */                    childDiv.id = this._divID;

/*Line 184 - 'AtomVideoPlayer.js' */                    $(element).append(childDiv);

/*Line 186 - 'AtomVideoPlayer.js' */                    this._fpID = this._divID + "_Flash";
/*Line 187 - 'AtomVideoPlayer.js' */                    //createVideoPlayer(element.id, this._divID, this._fpID);
/*Line 188 - 'AtomVideoPlayer.js' */                    jwplayer(this._divID).setup({
/*Line 189 - 'AtomVideoPlayer.js' */                        'flashplayer': this._swfPath,
/*Line 190 - 'AtomVideoPlayer.js' */                        'id': this._fpID,
/*Line 191 - 'AtomVideoPlayer.js' */                        'bufferlength': 10,
/*Line 192 - 'AtomVideoPlayer.js' */                        'controlbar.position': 'bottom',
/*Line 193 - 'AtomVideoPlayer.js' */                        'width': '100%',
/*Line 194 - 'AtomVideoPlayer.js' */                        'height': '100%',
/*Line 195 - 'AtomVideoPlayer.js' */                        'events': {
/*Line 196 - 'AtomVideoPlayer.js' */                            'onMeta': function (m) {
/*Line 197 - 'AtomVideoPlayer.js' */                                //log(m);
/*Line 198 - 'AtomVideoPlayer.js' */                            }
/*Line 199 - 'AtomVideoPlayer.js' */                        }
/*Line 200 - 'AtomVideoPlayer.js' */                    });
/*Line 201 - 'AtomVideoPlayer.js' */                    this._isFlash = true;
/*Line 202 - 'AtomVideoPlayer.js' */                }
/*Line 203 - 'AtomVideoPlayer.js' */            },

/*Line 205 - 'AtomVideoPlayer.js' */            initialize: function () {
/*Line 206 - 'AtomVideoPlayer.js' */                var element = this.get_element();
/*Line 207 - 'AtomVideoPlayer.js' */                $(element).addClass("atom-video-player");
/*Line 208 - 'AtomVideoPlayer.js' */                if (this._autoCreate) {
/*Line 209 - 'AtomVideoPlayer.js' */                    this.create();
/*Line 210 - 'AtomVideoPlayer.js' */                }
/*Line 211 - 'AtomVideoPlayer.js' */                baseType.initialize.call(this);
/*Line 212 - 'AtomVideoPlayer.js' */            }
/*Line 213 - 'AtomVideoPlayer.js' */        }
/*Line 214 - 'AtomVideoPlayer.js' */    });
/*Line 215 - 'AtomVideoPlayer.js' */})(WebAtoms.AtomPlayer.prototype);
/*Line 0 - 'AtomWindow.js' */

/*Line 2 - 'AtomWindow.js' */(function (baseType) {
/*Line 3 - 'AtomWindow.js' */    return classCreatorEx({
/*Line 4 - 'AtomWindow.js' */        name: "WebAtoms.AtomWindow",
/*Line 5 - 'AtomWindow.js' */        base: baseType,
/*Line 6 - 'AtomWindow.js' */        start: function () {
/*Line 7 - 'AtomWindow.js' */            this._presenters = ["windowDiv", "windowTitleDiv", "windowCloseButton", "iframe", "windowPlaceholder"];
/*Line 8 - 'AtomWindow.js' */        },
/*Line 9 - 'AtomWindow.js' */        properties: {
/*Line 10 - 'AtomWindow.js' */            opener: null,
/*Line 11 - 'AtomWindow.js' */            openerData: null,
/*Line 12 - 'AtomWindow.js' */            windowTemplate: null,
/*Line 13 - 'AtomWindow.js' */            isOpen: false,
/*Line 14 - 'AtomWindow.js' */            windowHeight: 300,
/*Line 15 - 'AtomWindow.js' */            windowWidth: 500,
/*Line 16 - 'AtomWindow.js' */            url: undefined,
/*Line 17 - 'AtomWindow.js' */            title: undefined
/*Line 18 - 'AtomWindow.js' */        },
/*Line 19 - 'AtomWindow.js' */        methods: {


/*Line 22 - 'AtomWindow.js' */            get_openerData: function () {
/*Line 23 - 'AtomWindow.js' */                var v = this.get_opener();
/*Line 24 - 'AtomWindow.js' */                if (!v)
/*Line 25 - 'AtomWindow.js' */                    return;
/*Line 26 - 'AtomWindow.js' */                return v.get_data();
/*Line 27 - 'AtomWindow.js' */            },

/*Line 29 - 'AtomWindow.js' */            onCloseCommand: function (scope, sender) {
/*Line 30 - 'AtomWindow.js' */                AtomBinder.setValue(this, "isOpen", false);
/*Line 31 - 'AtomWindow.js' */                var val = this._value;
/*Line 32 - 'AtomWindow.js' */                var caller = this;
/*Line 33 - 'AtomWindow.js' */                this._value = null;

/*Line 35 - 'AtomWindow.js' */                this.disposeChildren(this._element);

/*Line 37 - 'AtomWindow.js' */                setTimeout(function () {
/*Line 38 - 'AtomWindow.js' */                    AtomBinder.setValue(caller, "value", val);
/*Line 39 - 'AtomWindow.js' */                    caller.invokeAction(caller._next);
/*Line 40 - 'AtomWindow.js' */                }, 1);
/*Line 41 - 'AtomWindow.js' */            },

/*Line 43 - 'AtomWindow.js' */            refresh: function (scope, sender) {
/*Line 44 - 'AtomWindow.js' */                this.openWindow(scope, sender);
/*Line 45 - 'AtomWindow.js' */            },

/*Line 47 - 'AtomWindow.js' */            openWindow: function (scope, sender) {

/*Line 49 - 'AtomWindow.js' */                var tt = this.getTemplate("frameTemplate");

/*Line 51 - 'AtomWindow.js' */                tt = AtomUI.cloneNode(tt);

/*Line 53 - 'AtomWindow.js' */                var wdiv = $(tt).find("[atom-presenter=windowDiv]").get(0);
/*Line 54 - 'AtomWindow.js' */                var wtitle = $(tt).find("[atom-presenter=windowTitleDiv]").get(0);

/*Line 56 - 'AtomWindow.js' */                var wt = this.getTemplate("windowTemplate");

/*Line 58 - 'AtomWindow.js' */                $(wt).addClass("atom-window-template");

/*Line 60 - 'AtomWindow.js' */                if (!($(wt).attr("atom-dock"))) {
/*Line 61 - 'AtomWindow.js' */                    $(wt).attr("atom-dock", "Fill");
/*Line 62 - 'AtomWindow.js' */                }

/*Line 64 - 'AtomWindow.js' */                wdiv.appendChild(wt);

/*Line 66 - 'AtomWindow.js' */                this.set_innerTemplate(tt);

/*Line 68 - 'AtomWindow.js' */                if (this._iframe) {
/*Line 69 - 'AtomWindow.js' */                    this._iframe.atomWindow = this;
/*Line 70 - 'AtomWindow.js' */                }

/*Line 72 - 'AtomWindow.js' */                if (sender) {
/*Line 73 - 'AtomWindow.js' */                    this._opener = sender;
/*Line 74 - 'AtomWindow.js' */                    AtomBinder.refreshValue(this, "opener");
/*Line 75 - 'AtomWindow.js' */                    AtomBinder.refreshValue(this, "openerData");
/*Line 76 - 'AtomWindow.js' */                }

/*Line 78 - 'AtomWindow.js' */                var _this = this;
/*Line 79 - 'AtomWindow.js' */                WebAtoms.dispatcher.callLater(function () {
/*Line 80 - 'AtomWindow.js' */                    AtomBinder.setValue(_this, "isOpen", true);
/*Line 81 - 'AtomWindow.js' */                    if (!_this._url) {
/*Line 82 - 'AtomWindow.js' */                        var children = $(_this._windowPlaceholder).find("input");
/*Line 83 - 'AtomWindow.js' */                        if (children.length > 0) {
/*Line 84 - 'AtomWindow.js' */                            var item = children.get(0);
/*Line 85 - 'AtomWindow.js' */                            try {
/*Line 86 - 'AtomWindow.js' */                                item.focus();
/*Line 87 - 'AtomWindow.js' */                            } catch (er) {
/*Line 88 - 'AtomWindow.js' */                            }
/*Line 89 - 'AtomWindow.js' */                        }
/*Line 90 - 'AtomWindow.js' */                    }
/*Line 91 - 'AtomWindow.js' */                });
/*Line 92 - 'AtomWindow.js' */            },

/*Line 94 - 'AtomWindow.js' */            initialize: function () {



/*Line 98 - 'AtomWindow.js' */                $(this._element).addClass("atom-window-placeholder");
/*Line 99 - 'AtomWindow.js' */                baseType.initialize.call(this);

/*Line 101 - 'AtomWindow.js' */                var _this = this;
/*Line 102 - 'AtomWindow.js' */                this.closeCommand = function () {
/*Line 103 - 'AtomWindow.js' */                    _this.onCloseCommand.apply(_this, arguments);
/*Line 104 - 'AtomWindow.js' */                };

/*Line 106 - 'AtomWindow.js' */                this.openCommand = function () {
/*Line 107 - 'AtomWindow.js' */                    _this.openWindow.apply(_this, arguments);
/*Line 108 - 'AtomWindow.js' */                };

/*Line 110 - 'AtomWindow.js' */                WebAtoms.dispatcher.callLater(function () {
/*Line 111 - 'AtomWindow.js' */                    _this._element._logicalParent = _this._element.parentNode;
/*Line 112 - 'AtomWindow.js' */                    $(_this._element).remove();
/*Line 113 - 'AtomWindow.js' */                    document.body.appendChild(_this._element);
/*Line 114 - 'AtomWindow.js' */                });
/*Line 115 - 'AtomWindow.js' */            }
/*Line 116 - 'AtomWindow.js' */        }
/*Line 117 - 'AtomWindow.js' */    });
/*Line 118 - 'AtomWindow.js' */})(WebAtoms.AtomControl.prototype);
/*Line 0 - 'ZZZZZInitializer.js' */

/*Line 2 - 'ZZZZZInitializer.js' */// http://jsfiddle.net/bZcth/33/#update


/*Line 5 - 'ZZZZZInitializer.js' */$(window.document).ready(function () {

/*Line 7 - 'ZZZZZInitializer.js' */    // commencing Web Atoms...

/*Line 9 - 'ZZZZZInitializer.js' */    WebAtoms.dispatcher.setupControls();
/*Line 10 - 'ZZZZZInitializer.js' */    WebAtoms.dispatcher.start();
/*Line 11 - 'ZZZZZInitializer.js' */});

	}).apply(window, [WebAtoms]);
